Procedure.i LoadAccounts(List Account.s())
  Protected Directory.i
  
  Directory = ExamineDirectory(#PB_Any, "Accounts\", "*.*")
  If Directory
    While NextDirectoryEntry(Directory)
      If DirectoryEntryType(Directory) = #PB_DirectoryEntry_File
        AddElement(Account())
        Account() = GetFilePart(DirectoryEntryName(Directory))
      EndIf
    Wend
    
    FinishDirectory(Directory)
    ProcedureReturn #True
  Else
    MessageRequester("Error", "Can not load accounts.", #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
EndProcedure
Procedure.i LoadAccount(Name.s)
  Protected File.i
  
  File = ReadFile(#PB_Any, "Accounts\" + Name + ".dat")
  If Not File
    MessageRequester("Error", "Can not load account: " + #Q + Name + #Q, #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  
  Account\Name     = Name
  Account\Password = ReadNTString(File)
  
  CloseFile(File)
  ProcedureReturn #True
EndProcedure
Procedure.i CheckAccountPassword(Password.s, Name.s)
  Protected File.i, CryptedPassword.s
  
  File = ReadFile(#PB_Any, "Accounts\" + Name + ".dat")
  If Not File
    MessageRequester("Error", "Can not load account: " + #Q + Name + #Q, #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  
  CryptedPassword = ReadNTString(File)
  CloseFile(File)
  
  If DESFingerprint(Password, "GM") = CryptedPassword
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

Procedure.i RenameAccount(NewName.s)
  DeleteFile("Accounts\" + Account\Name + ".dat")
  
  RenameHighscoreAccount(*ChallangeFolder, NewName)
  
  Account\Name = NewName
  SaveAccount()
EndProcedure
Procedure.i SaveAccount()
  Protected File.i
  
  File = CreateFile(#PB_Any, "Accounts\" + Account\Name + ".dat")
  If Not File
    MessageRequester("Error", "Can not save account.", #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  
  WriteNTString(File, Account\Password)
  
  CloseFile(File)
  
  ProcedureReturn #True
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 70
; FirstLine = 24
; Folding = -
; EnableXP