Procedure.i CreateAnimation(*Frameset.AnimationFrameset)
  Protected *Animation.Animation
  
  *Animation = _New(Animation)
  
  *Animation\Frameset = *Frameset
  *Animation\Frame    = 0
  *Animation\Set      = 0
  *Animation\Duration = 0
  
  ProcedureReturn *Animation
EndProcedure
Procedure.i LoadAnimationFrameset(Name.s, FrameWidth.i, FrameHeight.i)
  Protected *Frameset.AnimationFrameset, Image.i
  Protected X.i, Y.i, Index.i
  Protected Frame.i, Sprite.i, Sprite3D.i
  Protected *Address.Integer
  
  *Frameset = _New(AnimationFrameset)
  Image     = LoadImage(#PB_Any, GetFile("Graphics\" + Name + ".png"), 32)
  
  *Frameset\FrameWidth   = FrameWidth
  *Frameset\FrameHeight  = FrameHeight
  *Frameset\FramesPerSet = ImageWidth(Image)/FrameWidth
  *Frameset\Sets         = ImageHeight(Image)/FrameHeight
  
  *Address         = _Dim(*Frameset\Sets * *Frameset\FramesPerSet * 2*SizeOf(Integer))
  *Frameset\Frames = *Address
  
  ; Alle Frames auslesen und als 3D-Sprite erstellen:
  For Y = 0 To *Frameset\Sets - 1
    For X = 0 To *Frameset\FramesPerSet - 1
      Frame = GrabImage(Image, #PB_Any, FrameWidth*X, FrameHeight*Y, FrameWidth, FrameHeight)
      SaveImage(Frame, "Graphics\Temp.png", #PB_ImagePlugin_PNG, 0, 32)
      FreeImage(Frame)
      
      Sprite   = LoadSprite(#PB_Any, "Graphics\Temp.png", #PB_Sprite_Texture|#PB_Sprite_Memory|#PB_Sprite_AlphaBlending)
      Sprite3D = CreateSprite3D(#PB_Any, Sprite)
      
      *Address\i = Sprite3D : *Address + SizeOf(Integer)
      *Address\i = Sprite   : *Address + SizeOf(Integer)
    Next
  Next
  
  ProcedureReturn *Frameset
EndProcedure
Procedure.i FreeAnimation(*Animation.Animation)
  _Free(*Animation)
  ProcedureReturn #True
EndProcedure

Procedure.i FramesetSprite(*Frameset.AnimationFrameset, Frame.i, Set.i)
  ProcedureReturn PeekI(*Frameset\Frames + ((Set**Frameset\FramesPerSet) + Frame) * 2*_Sz(Integer))
EndProcedure

Procedure.i ExamineAnimation(*Animation.Animation)
  If *Animation\Duration = 0
    If *Animation\Frame = *Animation\Frameset\FramesPerSet - 1
      *Animation\Frame = 0
    Else
      *Animation\Frame + 1
    EndIf
    ProcedureReturn #True
  Else
    *Animation\Duration - 1
    ProcedureReturn #False
  EndIf
  
  ProcedureReturn #False
EndProcedure
Procedure.i ExamineAnimationBack(*Animation.Animation)
  If *Animation\Duration = 0
    If *Animation\Frame = 0
      *Animation\Frame = *Animation\Frameset\FramesPerSet - 1
    Else
      *Animation\Frame - 1
    EndIf
    ProcedureReturn #True
  Else
    *Animation\Duration - 1
    ProcedureReturn #False
  EndIf
EndProcedure
Procedure.i DisplayAnimation(*Animation.Animation, X.i, Y.i, Transparency.i = 255)
  ProcedureReturn DisplaySprite3D(PeekI(*Animation\Frameset\Frames + ((*Animation\Set**Animation\Frameset\FramesPerSet) + *Animation\Frame) * 2*_Sz(Integer)), X, Y, Transparency)
EndProcedure
Procedure.i DisplayFramesetFrame(*Frameset.AnimationFrameset, Frame.i, Set.i, X.i, Y.i, Transparency.i = 255)
  ProcedureReturn DisplaySprite3D(PeekI(*Frameset\Frames + ((Set**Frameset\FramesPerSet) + Frame) * 2*_Sz(Integer)), X, Y, Transparency)
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 52
; Folding = I+
; EnableXP