Enumeration
  #Attribute_Initialize
  #Attribute_Build
  #Attribute_Apply
  #Attribute_Free
EndEnumeration



Structure Attribute
  Name.s
  *Callback
  StructureUnion
    *Memory
    *Integer.AttributeInteger
    *Float.AttributeFloat
    *String.AttributeString
    *Text.AttributeText
    *Selection.AttributeSelection
  EndStructureUnion
  List Gadget.i()
EndStructure
Structure Attributes
  List Attribute.Attribute()
EndStructure



Procedure.i CreateAttributes()
  Static *Attributes.Attributes
  
  *Attributes = AllocateMemory(SizeOf(Attributes))
  InitializeStructure(*Attributes, Attributes)
  
  ProcedureReturn *Attributes
EndProcedure
Procedure.i AddAttributeInteger(*Attributes.Attributes, Name.s, *Integer.Integer, Min.i, Max.i)
  Static *Attribute.Attribute, *Memory.AttributeInteger
  
  *Attribute = AddElement(*Attributes\Attribute())
  
  *Attribute\Callback = @Attribute_Integer()
  *Attribute\Name     = Name
  
  *Memory           = AllocateMemory(SizeOf(AttributeInteger))
  *Attribute\Memory = *Memory
  
  *Memory\Integer = *Integer
  *Memory\Min     = Min
  *Memory\Max     = Max
  
  ProcedureReturn *Attribute
EndProcedure
Procedure.i AddAttributeFloat(*Attributes.Attributes, Name.s, *Float.Float)
  Static *Attribute.Attribute, *Memory.AttributeFloat
  
  *Attribute = AddElement(*Attributes\Attribute())
  
  *Attribute\Callback = @Attribute_Float()
  *Attribute\Name     = Name
  
  *Memory           = AllocateMemory(SizeOf(AttributeFloat))
  *Attribute\Memory = *Memory
  
  *Memory\Float = *Float
  
  ProcedureReturn *Attribute
EndProcedure
Procedure.i AddAttributeString(*Attributes.Attributes, Name.s, *String.String)
  Static *Attribute.Attribute, *Memory.AttributeString
  
  *Attribute = AddElement(*Attributes\Attribute())
  
  *Attribute\Callback = @Attribute_String()
  *Attribute\Name     = Name
  
  *Memory           = AllocateMemory(SizeOf(AttributeString))
  *Attribute\Memory = *Memory
  
  *Memory\String = *String
  
  ProcedureReturn *Attribute
EndProcedure
Procedure.i AddAttributeText(*Attributes.Attributes, Name.s, *Text.String)
  Static *Attribute.Attribute, *Memory.AttributeString
  
  *Attribute = AddElement(*Attributes\Attribute())
  
  *Attribute\Callback = @Attribute_Text()
  *Attribute\Name     = Name
  
  *Memory           = AllocateMemory(SizeOf(AttributeText))
  *Attribute\Memory = *Memory
  
  *Memory\Text = *Text
  
  ProcedureReturn *Attribute
EndProcedure
Procedure.i AddAttributeSelection(*Attributes.Attributes, Name.s, *Selection.Selection, *Callback)
  Static *Attribute.Attribute, *Memory.AttributeSelection
  
  *Attribute = AddElement(*Attributes\Attribute())
  
  *Attribute\Callback = @Attribute_Selection()
  *Attribute\Name     = Name
  
  *Memory           = AllocateMemory(SizeOf(AttributeSelection))
  *Attribute\Memory = *Memory
  
  *Memory\Selection = *Selection
  *Memory\Callback  = *Callback
  
  ProcedureReturn *Attribute
EndProcedure

Procedure.i AddAttributeGadget(*Attribute.Attribute, Gadget.i)
  AddElement(*Attribute\Gadget())
  *Attribute\Gadget() = Gadget
  
  ProcedureReturn Gadget
EndProcedure
Procedure.i BuildAttributeGadgets(*Attributes.Attributes)
  Protected Y.i
  
  ForEach *Attributes\Attribute()
    Y + _Call(*Attributes\Attribute()\Callback, @*Attributes\Attribute(), #Attribute_Build, Y)
    Y + 5
  Next
EndProcedure

Procedure.i Attribute_Integer(*Attribute.Attribute, Event.i, *Parameter)
  Select Event
    Case #Attribute_Build
      *Attribute\Integer\SpinGadget = AddAttributeGadget(*Attribute, SpinGadget(#PB_Any, 5, *Parameter, 100, 20, *Attribute\Integer\Min, *Attribute\Integer\Max))
      ProcedureReturn 20
    Case #Attribute_Apply
      *Attribute\Integer\Integer\i = GetGadgetState(*Attribute\Integer\SpinGadget)
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i Attribute_Float(*Attribute.Attribute, Event.i, *Parameter)
EndProcedure
Procedure.i Attribute_String(*Attribute.Attribute, Event.i, *Parameter)
EndProcedure
Procedure.i Attribute_Text(*Attribute.Attribute, Event.i, *Parameter)
EndProcedure
Procedure.i Attribute_Selection(*Attribute.Attribute, Event.i, *Parameter)
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 139
; FirstLine = 98
; Folding = ---
; EnableXP