Procedure.i CreateBlur(Length.i, DeltaTime.i)
  Static *Blur.Blur
  
  *Blur = _New(Blur)
  
  *Blur\Frames    = _Dim(Length * _Sz(BlurFrame))
  *Blur\Length    = Length
  *Blur\Frame     = 0
  *Blur\DeltaTime = DeltaTime
  *Blur\Time      = DeltaTime
  
  ProcedureReturn *Blur
EndProcedure

Procedure.i UpdateBlur(*Blur.Blur)
  Static *Frame.BlurFrame, Index.i, DeltaTransparency.i
  
  Index  = *Blur\Length
  *Frame = *Blur\Frames
  
  DeltaTransparency = 255.0 / (*Blur\Length * *Blur\DeltaTime)
  
  While Index
    If *Frame\Sprite And *Frame\Transparency > 0
      *Frame\Transparency - DeltaTransparency
    EndIf
    
    *Frame + _Sz(BlurFrame)
    Index  - 1
  Wend
  
  If *Blur\Time = 0
    *Blur\Time = *Blur\DeltaTime
    ProcedureReturn #True
  Else
    *Blur\Time - 1
    ProcedureReturn #False
  EndIf
EndProcedure
Procedure.i AddBlurFrame(*Blur.Blur, Sprite.i, X.f, Y.f)
  Static *Frame.BlurFrame
  
  *Frame = *Blur\Frames + *Blur\Frame * SizeOf(BlurFrame)
  
  *Frame\Sprite       = Sprite
  *Frame\X            = X
  *Frame\Y            = Y
  *Frame\Transparency = 255
  
  If *Blur\Frame = *Blur\Length - 1
    *Blur\Frame = 0
  Else
    *Blur\Frame + 1
  EndIf
  
  ProcedureReturn *Frame
EndProcedure

Procedure.i DisplayBlur(*Blur.Blur)
  Static *Frame.BlurFrame, Index.i
  
  Index  = *Blur\Length
  *Frame = *Blur\Frames
  
  While Index
    If *Frame\Sprite And *Frame\Transparency > 0
      DisplaySprite3D(*Frame\Sprite, *Frame\X - Camera\X, *Frame\Y - Camera\Y, *Frame\Transparency)
    EndIf
    
    *Frame + _Sz(BlurFrame)
    Index  - 1
  Wend
EndProcedure
Procedure.i ResetBlur(*Blur.Blur)
  Static *Frame.BlurFrame, Index.i
  
  Index  = *Blur\Length
  *Frame = *Blur\Frames
  
  While Index
    *Frame\Sprite       = #Null
    *Frame\Transparency = 0
    
    *Frame + _Sz(BlurFrame)
    Index  - 1
  Wend
EndProcedure

; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 73
; FirstLine = 45
; Folding = -
; EnableXP