Procedure.i UpdateCamera()
  ;{ Bound on borders of the current scene:
    If Camera\XF < 0
      Camera\XF = 0
    ElseIf Camera\XF + #ScreenWidth > Player\Scene\Width * #SceneWidth * #FieldSize
      Camera\XF = Player\Scene\Width * #SceneWidth * #FieldSize - #ScreenWidth
    EndIf
    
    If Camera\YF < 0
      Camera\YF = 0
    ElseIf Camera\YF + #ScreenHeight > Player\Scene\Height * #SceneHeight * #FieldSize
      Camera\YF = Player\Scene\Height * #SceneHeight * #FieldSize - #ScreenHeight
    EndIf
  ;}
  
  ;{ Save integer position for optimal rendering
    Camera\X = Camera\XF
    Camera\Y = Camera\YF
  ;}
EndProcedure

Procedure.i ResetCameraX()
  ; X-Position auf den Spieler zentrieren:
  Camera\XF = Player\X + Player\Width/2  - #ScreenWidth/2
EndProcedure
Procedure.i ResetCameraY()
  ; Y-Position auf den Spieler zentrieren:
  Camera\YF = Player\Y + Player\Height/2 - #ScreenHeight/2
EndProcedure
Procedure.i ResetCamera()
  ; Spieler in das Kamerafeld zentrieren:
  Camera\XF = Player\X + Player\Width/2  - #ScreenWidth/2
  Camera\YF = Player\Y + Player\Height/2 - #ScreenHeight/2
  
  UpdateCamera()
EndProcedure

Procedure.i SetCameraPosition(X.f, Y.f)
  Camera\XF = X
  Camera\YF = Y
  
  UpdateCamera()
EndProcedure
Procedure.i MoveCameraPosition(X.f, Y.f)
  Camera\XF + X
  Camera\YF + Y
  
  UpdateCamera()
EndProcedure

Procedure.i ExamineCamera()
  Protected TargetX.f, TargetY.f
  
  Select Camera\Mode
    Case #Camera_FollowPlayer
      TargetX = Player\X + Player\Width/2  - #ScreenWidth/2
      TargetY = Player\Y + Player\Height/2 - #ScreenHeight/2
      
      Select Player\Action 
        Case #Player_Action_Falling, #Player_Action_Jump, #Player_Action_DoubleJump, #Player_Action_JumpedOff
          ; Fllt der Spieler tief, dann soll die Kamera umso schneller hinterher fliegen:
          Camera\XF + (TargetX - Camera\XF) * #CameraSpeed
          Camera\YF + (TargetY - Camera\YF) * #CameraSpeed * Lim(Player\HeightOfFall / (6.0 * #FieldSize), 1, 8) + Lim((Player\HeightOfFall - 5 * #FieldSize) / (2.5 * #FieldSize), 0, 25 * #FieldSize)
        Case #Player_Action_LumiFlight
          ; Beim LumiFlight soll die Kamera dem Spieler schneller folgen:
          Camera\XF + (TargetX - Camera\XF) * #CameraSpeed * 2
          Camera\YF + (TargetY - Camera\YF) * #CameraSpeed * 2
        Default
          Camera\XF + (TargetX - Camera\XF) * #CameraSpeed
          Camera\YF + (TargetY - Camera\YF) * #CameraSpeed
      EndSelect
    Case #Camera_FollowObject
      ; Ein Objekt wurde als Ziel gewhlt:
      TargetX = Camera\TargetObject\X + Camera\TargetObject\Width/2  - #ScreenWidth/2
      TargetY = Camera\TargetObject\Y + Camera\TargetObject\Height/2 - #ScreenHeight/2
      
      Camera\XF + (TargetX - Camera\XF) * #CameraSpeed
      Camera\YF + (TargetY - Camera\YF) * #CameraSpeed
    Case #Camera_SetOnField
      ; Die Kamera soll auf ein bestimmtes Feld zufliegen:
      TargetX = Camera\TargetFieldX*#FieldSize + #FieldSize/2 - #ScreenWidth/2
      TargetY = Camera\TargetFieldY*#FieldSize + #FieldSize/2 - #ScreenHeight/2
      
      Camera\XF + (TargetX - Camera\XF) * #CameraSpeed * 0.75
      Camera\YF + (TargetY - Camera\YF) * #CameraSpeed * 0.75
  EndSelect
  
  UpdateCamera()
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 62
; FirstLine = 42
; Folding = --
; EnableXP