Procedure.i ShowActWindows()
  HideWindow(#TEWindow, #False)
  HideWindow(#AEWindow, #False)
  SetActiveWindow(#AEWindow)
  SetActiveWindow(#TEWindow)
EndProcedure

Procedure.i UpdateEventViewer(*Folder.Entry, Level.i = 0)
  Protected *Item.QueueItem, *Entry.Entry
  
  *Item = *Folder\Entries\First
  While *Item
    *Entry = *Item\Memory
    Select *Entry\Type
      Case #Entry_File
        AddGadgetItem(#TES_Tree, -1, *Entry\Name, 0, Level)
        SetGadgetItemData(#TES_Tree, CountGadgetItems(#TES_Tree) - 1, *Entry\Memory)
      Case #Entry_Folder
        AddGadgetItem(#TES_Tree, -1, *Entry\Name, 0, Level)
        UpdateEventViewer(*Entry, Level + 1)
    EndSelect
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i OpenEventViewer()
  Protected Event.i, Window.i, Gadget.i, Type.i
  Protected Index.i, *Event.EventEntry
  
  OpenWindow(#TESWindow, #PB_Ignore, #PB_Ignore, 360, 510, "Events", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    ButtonGadget(#TES_Select, 10, 10, 50, 30, "Select")
    TreeGadget(#TES_Tree, 10, 50, 340, 330)
    ButtonGadget(#TES_Cancel, 300, 10, 50, 30, "Cancel")
    Frame3DGadget(#TES_InfoFrame, 10, 390, 340, 110, "Info")
    EditorGadget(#TES_Info, 20, 410, 320, 80)
    
  UpdateEventViewer(*EventFolder)
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    Type   = EventType()
    
    If Window = #TESWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #TES_Select
              If *Event
                CloseWindow(#TESWindow)
                ProcedureReturn *Event
              EndIf
            Case #TES_Cancel
              Break
            Case #TES_Tree
              If Type = #PB_EventType_LeftClick
                Index = GetGadgetState(#TES_Tree)
                If Index <> #None
                  *Event = GetGadgetItemData(#TES_Tree, Index)
                  If *Event
                    SetGadgetText(#TES_Info, EventDescription(*Event))
                  Else
                    SetGadgetText(#TES_Info, "")
                  EndIf
                Else
                  SetGadgetText(#TES_Info, "")
                EndIf
              ElseIf Type = #PB_EventType_LeftDoubleClick
                If *Event
                  CloseWindow(#TESWindow)
                  Editor\LeftClickAllowed = #False
                  ProcedureReturn *Event
                EndIf
              EndIf
          EndSelect
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(#TESWindow)
  ProcedureReturn #Null
EndProcedure

Procedure.i UpdateEffectViewer(*Folder.Entry, Level.i = 0)
  Protected *Item.QueueItem, *Entry.Entry
  
  *Item = *Folder\Entries\First
  While *Item
    *Entry = *Item\Memory
    Select *Entry\Type
      Case #Entry_File
        AddGadgetItem(#TES_Tree, -1, *Entry\Name, 0, Level)
        SetGadgetItemData(#TES_Tree, CountGadgetItems(#TES_Tree) - 1, *Entry\Memory)
      Case #Entry_Folder
        AddGadgetItem(#TES_Tree, -1, *Entry\Name, 0, Level)
        UpdateEffectViewer(*Entry, Level + 1)
    EndSelect
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i OpenEffectViewer()
  Protected Event.i, Window.i, Gadget.i, Type.i
  Protected Index.i, *Effect.EffectEntry
  
  OpenWindow(#TESWindow, #PB_Ignore, #PB_Ignore, 360, 510, "Effects", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar)
    ButtonGadget(#TES_Select, 10, 10, 50, 30, "Select")
    TreeGadget(#TES_Tree, 10, 50, 340, 330)
    ButtonGadget(#TES_Cancel, 300, 10, 50, 30, "Cancel")
    Frame3DGadget(#TES_InfoFrame, 10, 390, 340, 110, "Info")
    EditorGadget(#TES_Info, 20, 410, 320, 80)
    
  UpdateEffectViewer(*EffectFolder)
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    Type   = EventType()
    
    If Window = #TESWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #TES_Select
              If *Effect
                CloseWindow(#TESWindow)
                ProcedureReturn *Effect
              EndIf
            Case #TES_Cancel
              Break
            Case #TES_Tree
              If Type = #PB_EventType_LeftClick
                Index = GetGadgetState(#TES_Tree)
                If Index <> #None
                  *Effect = GetGadgetItemData(#TES_Tree, Index)
                  If *Effect
                    SetGadgetText(#TES_Info, EffectDescription(*Effect))
                  Else
                    SetGadgetText(#TES_Info, "")
                  EndIf
                Else
                  SetGadgetText(#TES_Info, "")
                EndIf
              ElseIf Type = #PB_EventType_LeftDoubleClick
                If *Effect
                  CloseWindow(#TESWindow)
                  Editor\LeftClickAllowed = #False
                  ProcedureReturn *Effect
                EndIf
              EndIf
          EndSelect
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(#TESWindow)
  ProcedureReturn #Null
EndProcedure

Procedure.i UpdateEffectList(*Event.Event)
  Protected *Item.QueueItem, *Effect.Effect
  
  ClearGadgetItems(#EE_Effects)
  
  *Item = *Event\Effects\First
  While *Item
    *Effect = *Item\Memory
    AddGadgetItem(#EE_Effects, -1, EffectText(*Effect))
    SetGadgetItemData(#EE_Effects, CountGadgetItems(#EE_Effects) - 1, *Effect)
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i OpenEventEditor(*Act.Act)
  Protected Event.i, Window.i, Gadget.i, Type.i
  Protected *Item.QueueItem
  Protected *Event.Event, *EventEntry.EventEntry, EventIndex.i
  Protected *Effect.Effect, *EffectEntry.EffectEntry, EffectIndex.i
  
  OpenWindow(#TEWindow, #PB_Ignore, #PB_Ignore, 680, 460, "Event Editor (" + *Act\Name + ")", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    ButtonGadget(#EE_Add, 10, 10, 50, 30, "Add")
    ButtonGadget(#EE_Delete, 60, 10, 50, 30, "Delete")
    ButtonGadget(#EE_Edit, 110, 10, 50, 30, "...")
    ButtonGadget(#EE_OK, 260, 10, 70, 30, "OK")
    ListIconGadget(#EE_Events, 10, 50, 320, 300, "Event", 316, #PB_ListIcon_AlwaysShowSelection)
    ButtonGadget(#EE_Up, 170, 10, 40, 30, "Up")
    ButtonGadget(#EE_Down, 210, 10, 40, 30, "Down")
    EditorGadget(#EE_Comment, 10, 360, 320, 90)
    
    ButtonGadget(#EE_AddEffect, 350, 10, 50, 30, "Add")
    ButtonGadget(#EE_DeleteEffect, 400, 10, 50, 30, "Delete")
    ButtonGadget(#EE_EditEffect, 450, 10, 50, 30, "...")
    ListIconGadget(#EE_Effects, 350, 50, 320, 300, "Effect", 316, #PB_ListIcon_AlwaysShowSelection)
    ButtonGadget(#EE_EffectUp, 510, 10, 40, 30, "Up")
    ButtonGadget(#EE_EffectDown, 550, 10, 40, 30, "Down")
    EditorGadget(#EE_EffectComment, 350, 360, 320, 90)
  
  *Item = *Act\Events\First
  While *Item
    *Event = *Item\Memory
    AddGadgetItem(#EE_Events, -1, EventText(*Event))
    SetGadgetItemData(#EE_Events, CountGadgetItems(#EE_Events) - 1, *Event)
    _Move(*Item, N)
  Wend
  *Event = #Null
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    Type   = EventType()
    
    If Window = #TEWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #EE_Add ;{
              ;Neues Event soll hinzugefgt werden:
              *EventEntry = OpenEventViewer() ;Auswhlen
              If *EventEntry
                *Event = CreateEvent(*Act, *EventEntry)
                EditEvent(*Event)
                ShowActWindows()
                AddGadgetItem(#EE_Events, -1, EventText(*Event))
                EventIndex = CountGadgetItems(#EE_Events) - 1
                SetGadgetItemData(#EE_Events, EventIndex, *Event)
                SetGadgetState(#EE_Events, EventIndex)
                *Effect = #Null
                ClearGadgetItems(#EE_Effects)
              EndIf
              ;}
            Case #EE_Delete ;{
              If *Event
                RemoveEvent(*Event)
                RemoveGadgetItem(#EE_Events, EventIndex)
                *Event     = #Null
                EventIndex = #None
                *Effect     = #Null
                ClearGadgetItems(#EE_Effects)
                SetGadgetText(#EE_EffectFrame, "Effects")
                SetGadgetText(#EE_Comment, "")
                SetGadgetText(#EE_EffectComment, "")
              EndIf
              ;}
            Case #EE_Edit ;{
              If *Event
                EditEvent(*Event)
                SetGadgetItemText(#EE_Events, EventIndex, EventText(*Event))
              EndIf
              ;}
            Case #EE_Events ;{
              If Type = #PB_EventType_LeftClick
                EventIndex = GetGadgetState(#EE_Events)
                If EventIndex <> #None
                  *Event = GetGadgetItemData(#EE_Events, EventIndex)
                  UpdateEffectList(*Event)
                  SetGadgetText(#EE_Comment, *Event\Comment)
                Else
                  *Event  = #Null
                  *Effect = #Null
                  ClearGadgetItems(#EE_Effects)
                EndIf
              ElseIf Type = #PB_EventType_LeftDoubleClick
                ; Auch ein Doppelklick dient zur Bearbeitung eines Events:
                If *Event
                  Editor\LeftClickAllowed = #False
                    EditEvent(*Event)
                    ShowActWindows()
                    SetGadgetItemText(#EE_Events, EventIndex, EventText(*Event))
                  Editor\LeftClickAllowed = #True
                EndIf
              EndIf
              ;}
            Case #EE_Comment ;{
              If *Event
                *Event\Comment = GetGadgetText(#EE_Comment)
              EndIf
              ;}
            Case #EE_AddEffect ;{
              If *Event
                *EffectEntry = OpenEffectViewer()
                If *EffectEntry
                  *Effect = CreateEffect(*Event, *EffectEntry)
                    EditEffect(*Effect)
                    ShowActWindows()
                  AddGadgetItem(#EE_Effects, -1, EffectText(*Effect))
                  EffectIndex = CountGadgetItems(#EE_Effects) - 1
                  SetGadgetItemData(#EE_Effects, EffectIndex, *Effect)
                EndIf
              EndIf
              ;}
            Case #EE_DeleteEffect ;{
              If *Effect
                RemoveEffect(*Effect)
                RemoveGadgetItem(#EE_Effects, EffectIndex)
                *Effect     = #Null
                EffectIndex = #None
                SetGadgetText(#EE_EffectComment, "")
              EndIf
              ;}
            Case #EE_EditEffect ;{
              If *Effect
                EditEffect(*Effect)
                ShowActWindows()
                SetGadgetItemText(#EE_Effects, EffectIndex, EffectText(*Effect))
              EndIf
              ;}
            Case #EE_EffectUp ;{
              If *Effect
                MoveEffectUp(*Effect)
                UpdateEffectList(*Event)
              EndIf
              ;}
            Case #EE_EffectDown ;{
              If *Effect
                MoveEffectDown(*Effect)
                UpdateEffectList(*Event)
              EndIf
              ;}
            Case #EE_Effects ;{
              If Type = #PB_EventType_LeftClick
                EffectIndex = GetGadgetState(#EE_Effects)
                If EffectIndex <> #None
                  *Effect = GetGadgetItemData(#EE_Effects, EffectIndex)
                  SetGadgetText(#EE_EffectComment, *Effect\Comment)
                Else
                  *Effect = #Null
                EndIf
              ElseIf Type = #PB_EventType_LeftDoubleClick
                If *Effect
                  Editor\LeftClickAllowed = #False
                    EditEffect(*Effect)
                    ShowActWindows()
                    SetGadgetItemText(#EE_Effects, EffectIndex, EffectText(*Effect))
                  Editor\LeftClickAllowed = #True
                EndIf
              EndIf
              ;}
            Case #EE_EffectComment ;{
              If *Effect
                *Effect\Comment = GetGadgetText(#EE_EffectComment)
              EndIf
              ;}
            Case #EE_OK ;{
              Break
              ;}
          EndSelect
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(#TEWindow)
EndProcedure

Procedure.i OpenActEditor()
  Protected Event.i, Window.i, Gadget.i, Type.i
  Protected *Item.QueueItem, *Act.Act, Index.i, String.s
  
  OpenWindow(#AEWindow, #PB_Ignore, #PB_Ignore, 410, 480, "Story Editor", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    ButtonGadget(#AE_Add, 10, 10, 50, 30, "Add")
    ButtonGadget(#AE_Delete, 60, 10, 50, 30, "Delete")
    ButtonGadget(#AE_Edit, 110, 10, 50, 30, "...")
    ListIconGadget(#AE_Acts, 10, 50, 390, 240, "Act", 385, #PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
    TextGadget(#AE_NameText, 10, 300, 40, 20, "Name:")
    StringGadget(#AE_Name, 50, 300, 350, 20, "")
    Frame3DGadget(#AE_DescriptionFrame, 10, 320, 390, 110, "Description")
    EditorGadget(#AE_Description, 20, 340, 370, 80)
    ButtonGadget(#AE_OK, 350, 10, 50, 30, "OK")
    ButtonGadget(#AE_Apply, 10, 440, 100, 30, "Apply")
  
  *Item = *Acts\First
  While *Item
    *Act = *Item\Memory
    AddGadgetItem(#AE_Acts, -1, *Act\Name)
    SetGadgetItemData(#AE_Acts, CountGadgetItems(#AE_Acts) - 1, *Act)
    _Move(*Item, N)
  Wend
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    Type   = EventType()
    
    If Window = #AEWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #AE_Add
              String = InputRequester("New act", "Enter name, please:", "")
              If String
                *Act = CreateAct(String)
                
                AddGadgetItem(#AE_Acts, -1, *Act\Name)
                Index = CountGadgetItems(#AE_Acts) - 1
                SetGadgetItemData(#AE_Acts, Index, *Act)
                SetGadgetState(#AE_Acts, Index)
                
                SetGadgetText(#AE_Name, *Act\Name)
                SetGadgetText(#AE_Description, *Act\Description)
              EndIf
            Case #AE_Delete
              If *Act
                If RemoveAct(*Act)
                  RemoveGadgetItem(#AE_Acts, Index)
                  
                  Index = #None
                  *Act  = #Null
                  SetGadgetText(#AE_Name, "")
                  SetGadgetText(#AE_Description, "")
                EndIf
              EndIf
            Case #AE_Edit
              If *Act
                OpenEventEditor(*Act)
              EndIf
            Case #AE_Acts
              If Type = #PB_EventType_LeftClick
                Index = GetGadgetState(#AE_Acts)
                If Index <> #None
                  *Act = GetGadgetItemData(#AE_Acts, Index)
                  SetGadgetText(#AE_Name, *Act\Name)
                  SetGadgetText(#AE_Description, *Act\Description)
                Else
                  Index = #None
                  *Act  = #Null
                  SetGadgetText(#AE_Name, "")
                  SetGadgetText(#AE_Description, "")
                EndIf
              ElseIf Type = #PB_EventType_LeftDoubleClick
                If *Act
                  OpenEventEditor(*Act)
                EndIf
              EndIf
            Case #AE_Apply
              If *Act
                If *Act\Name <> GetGadgetText(#AE_Name) And Trim(GetGadgetText(#AE_Name))
                  RenameAct(*Act, GetGadgetText(#AE_Name))
                  SetGadgetItemText(#AE_Acts, Index, *Act\Name)
                EndIf
                *Act\Description = GetGadgetText(#AE_Description)
              EndIf
            Case #AE_OK
              Break
          EndSelect
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(#AEWindow)
  ProcedureReturn *Act
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 195
; FirstLine = 86
; Folding = HBA5
; EnableXP