#BackgroundViewer_ImageWidth  = 324
#BackgroundViewer_ImageHeight = 156



Global BackgroundViewer_Image.i
Global *BackgroundViewer_Background.BackgroundEntry



Procedure.i UpdateBackgroundViewerBackgrounds(*Parent.Entry, Level.i = 0)
  Protected *Item.QueueItem, *Entry.Entry, *Background.BackgroundEntry
  
  *Item = *Parent\Entries\First
  While *Item
    *Entry = *Item\Memory
    
    AddGadgetItem(#BV_Backgrounds, -1, *Entry\Name, 0, Level)
    SetGadgetItemData(#BV_Backgrounds, CountGadgetItems(#BV_Backgrounds) - 1, *Entry)
    
    If *Entry\Type = #Entry_Folder
      UpdateBackgroundViewerBackgrounds(*Entry, Level + 1)
    Else
      *Background = *Entry\Memory
      If *Background\Registered
        SetGadgetItemColor(#BV_Backgrounds, CountGadgetItems(#BV_Backgrounds) - 1, #PB_Gadget_BackColor, $C0C0C0)
      EndIf
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i BackgroundViewerPreview()
  Protected *Background.RegisteredBackground, *OldBackground.BackgroundEntry
  
  ; Aktuellen Hintergrund merken:
  *Background = Editor\CurrentScene\Background
  If *Background
    *OldBackground = *Background\Entry
  EndIf
  
  ChangeBackground(Editor\CurrentScene, LoadRegBackground(*BackgroundViewer_Background))
  RenderEditor() ;Vorschau anzeigen
  
  ; Vorherigen Hintergrund wieder einsetzen:
  If *Background
    ChangeBackground(Editor\CurrentScene, LoadRegBackground(*OldBackground))
  Else
    ; Hintergrund war blankes Weis (kein Hintergrund):
    ChangeBackground(Editor\CurrentScene, #Null)
  EndIf
EndProcedure
Procedure.i SelectBackgroundViewerBackground(*Background.BackgroundEntry)
  Protected Image.i
  
  *BackgroundViewer_Background = *Background
  
  If BackgroundViewer_Image
    FreeImage(BackgroundViewer_Image)
  EndIf
  
  If *Background
    Image = LoadImage(#PB_Any, BackgroundFilename(*Background))
    GetBackgroundFormat(*Background, Image)
    
    BackgroundViewer_Image = CreateImage(#PB_Any, #SceneWidth * #FieldSize, #SceneHeight * #FieldSize, 24)
    StartDrawing(ImageOutput(BackgroundViewer_Image))
      DrawBackground(*Background, Image)
    StopDrawing()
    
    ResizeImage(BackgroundViewer_Image, #BackgroundViewer_ImageWidth, #BackgroundViewer_ImageHeight)
  Else
    BackgroundViewer_Image = CreateImage(#PB_Any, #BackgroundViewer_ImageWidth, #BackgroundViewer_ImageHeight, 24)
    StartDrawing(ImageOutput(BackgroundViewer_Image))
      Box(0, 0, #BackgroundViewer_ImageWidth, #BackgroundViewer_ImageHeight, $FFFFFF)
    StopDrawing()
  EndIf
  
  SetGadgetState(#BV_Image, ImageID(BackgroundViewer_Image))
EndProcedure
Procedure.i OpenBackgroundViewer()
  Protected Event.i, Window.i, Gadget.i, Type.i
  Protected *Entry.Entry, Index.i
  
  OpenWindow(#BVWindow, #PB_Ignore, #PB_Ignore, 610, 240, "Backgrounds", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    Frame3DGadget(#BV_Frame, 10, 0, 350, 190, "Background")
    ImageGadget(#BV_Image, 20, 20, 324, 156, #Null)
    TreeGadget(#BV_Backgrounds, 370, 10, 230, 180)
    ButtonGadget(#BV_OK, 370, 200, 70, 30, "OK")
    ButtonGadget(#BV_Cancel, 550, 200, 50, 30, "Cancel")
    ButtonGadget(#BV_ChangeAll, 440, 200, 70, 30, "Change all")
    ButtonGadget(#BV_Preview, 290, 200, 70, 30, "Preview")
  
  UpdateBackgroundViewerBackgrounds(*BackgroundFolder)
  
  If Editor\CurrentScene\Background
    SelectBackgroundViewerBackground(Editor\CurrentScene\Background\Entry)
  Else
    SelectBackgroundViewerBackground(#Null)
  EndIf
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    Type   = EventType()
    
    If Window = #BVWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #BV_Backgrounds
              If Type = #PB_EventType_LeftClick
                Index = GetGadgetState(#BV_Backgrounds)
                If Index <> #None
                  *Entry = GetGadgetItemData(#BV_Backgrounds, Index)
                  If *Entry\Type = #Entry_File
                    SelectBackgroundViewerBackground(*Entry\Memory)
                  EndIf
                Else
                  SelectBackgroundViewerBackground(#Null)
                EndIf
              EndIf
            Case #BV_OK
              If *BackgroundViewer_Background
                Break
              Else
                CloseWindow(#BVWindow)
                ProcedureReturn #Null
              EndIf
            Case #BV_ChangeAll
              If *BackgroundViewer_Background
                If MessageRequester("Question", "Do you really want to change all backgrounds to " + #Q + *BackgroundViewer_Background\Entry\Name + #Q + "?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
                  ChangeAllBackgrounds(LoadRegBackground(*BackgroundViewer_Background))
                  CloseWindow(#BVWindow)
                  ProcedureReturn #Null
                EndIf
              EndIf
            Case #BV_Preview
              If *BackgroundViewer_Background
                BackgroundViewerPreview()
              EndIf
            Case #BV_Cancel
              CloseWindow(#BVWindow)
              ProcedureReturn #Null
          EndSelect
        Case #PB_Event_CloseWindow
          CloseWindow(#BVWindow)
          ProcedureReturn #Null
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(#BVWindow)
  ProcedureReturn *BackgroundViewer_Background
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 84
; FirstLine = 72
; Folding = -
; EnableXP