;**************************************************************
;     Challange Properties
;**************************************************************
;   Copyright (c) 2010 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i ResetChallangeProperties()
  With Editor\Challange
  
  ;{ Header
    SetGadgetText(#EditorCP_Folder, \Folder)
    
    SetGadgetText(#EditorCP_Name    , \Name)
    SetGadgetText(#EditorCP_Author  , \Author)
    SetGadgetText(#EditorCP_Password, \Password)
    SetGadgetText(#EditorCP_Comment , \Comment)
  ;}
  
  ;{ Score
    SetGadgetText(#EditorCP_AuthorsHighscore, Str(\AuthorsHighscore))
  ;}
  
  ;{ Energy & Lives
    SetGadgetText(#EditorCP_Lives    , Str(\Lives))
    SetGadgetText(#EditorCP_MaxEnergy, Str(\MaxEnergy))
    SetGadgetText(#EditorCP_Energy   , Str(\Energy))
  ;}
  
  ;{ Powers
    SetGadgetState(#EditorCP_CanDoubleJump, \CanDoubleJump)
    SetGadgetState(#EditorCP_CanClimb     , \CanClimb)
    SetGadgetState(#EditorCP_CanLumiFlight, \CanLumiFlight)
    
    If \CanFly
      SetGadgetState(#EditorCP_CanFly1 + \CanFly - 1, #True)
    EndIf
    
    If \CanShoot
      SetGadgetState(#EditorCP_CanShoot1 + \CanShoot - 1, #True)
    EndIf
    SetGadgetState(#EditorCP_CanLoadShot, \CanLoadShot)
  ;}
  
  ;{ Categories
    SetGadgetState(#EditorCP_Genre     , \Genre)
    SetGadgetState(#EditorCP_Difficulty, \Difficulty)
    SetGadgetState(#EditorCP_Size      , \Size)
  ;}
  
  EndWith
EndProcedure
Procedure.i UseDefaultChallangeProperties()
EndProcedure
Procedure.i GetChallangeProperties()
  Protected Name.s, Index.i
  
  With Editor\Challange
  
  ;{ Header
    If GetGadgetState(#EditorCP_Folder) = -1
      Name = GetGadgetText(#EditorCP_Folder)
      If Name
        \Folder = Name
      Else
        \Folder = "Temp\"
      EndIf
    Else
      \Folder = GetGadgetText(#EditorCP_Folder)
    EndIf
    
    \Name     = GetGadgetText(#EditorCP_Name)
    \Author   = GetGadgetText(#EditorCP_Author)
    \Password = GetGadgetText(#EditorCP_Password)
    \Comment  = GetGadgetText(#EditorCP_Comment)
  ;}
  
  ;{ Energy & Lives
    \Lives = Val(GetGadgetText(#EditorCP_Lives))
    If \Lives <= 0
      \Lives = 3
    EndIf
    \MaxEnergy = Val(GetGadgetText(#EditorCP_MaxEnergy))
    If \MaxEnergy <= 0
      \MaxEnergy = 5
    EndIf
    \Energy = Val(GetGadgetText(#EditorCP_Energy))
    If \Energy <= 0
      \Energy = \MaxEnergy
    EndIf
  ;}
  
  ;{ Powers
    \CanDoubleJump = GetGadgetState(#EditorCP_CanDoubleJump)
    \CanClimb      = GetGadgetState(#EditorCP_CanClimb)
    \CanLumiFlight = GetGadgetState(#EditorCP_CanLumiFlight)
    
    \CanFly = 0
    For Index = 0 To 2
      If GetGadgetState(#EditorCP_CanFly1 + Index)
        \CanFly = Index + 1
      EndIf
    Next
    
    \CanShoot = 0
    For Index = 0 To 2
      If GetGadgetState(#EditorCP_CanShoot1 + Index)
        \CanShoot = Index + 1
      EndIf
    Next
    \CanLoadShot   = GetGadgetState(#EditorCP_CanLoadShot)
  ;}
  
  ;{ Categories
    \Genre      = GetGadgetState(#EditorCP_Genre)
    \Difficulty = GetGadgetState(#EditorCP_Difficulty)
    \Size       = GetGadgetState(#EditorCP_Size)
  ;}
  
  EndWith
EndProcedure
Procedure.i UpdateChallangePropertiesFolders(*Parent.Entry)
  Protected *Item.QueueItem, *Entry.Entry
  
  *Item = *Parent\Entries\First
  While *Item
    *Entry = *Item\Memory
    
    If *Entry\Type = #Entry_Folder
      AddGadgetItem(#EditorCP_Folder, -1, SStr(EntryPath(*Entry), -Len("Challanges\")))
      UpdateChallangePropertiesFolders(*Entry)
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure

Procedure.i OpenChallangeProperties()
  With Editor\Challange
  
  Protected Window.i, Event.i, Gadget.i
  Protected Index.i
  Protected Program.i, String.s
  
  OpenWindow(#EditorCPWindow, #PB_Ignore, #PB_Ignore, 420, 270, "Challange properties", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_TitleBar|#PB_Window_ScreenCentered, WindowID(#ScreenWindow))
    ButtonGadget(#EditorCP_OK, 340, 230, 70, 30, "OK")
    ButtonGadget(#EditorCP_Play, 340, 180, 70, 50, "Play")
    CheckBoxGadget(#EditorCP_Locked, 340, 10, 70, 20, "Locked")
    
    PanelGadget(#EditorCP_Panel, 10, 10, 320, 250)
    
      AddGadgetItem(#EditorCP_Panel, -1, "General")
        TextGadget(#EditorCP_FolderText, 8, 10, 50, 16, "Folder:")
        ComboBoxGadget(#EditorCP_Folder, 68, 8, 240, 20, #PB_ComboBox_Editable)
        TextGadget(#EditorCP_NameText, 8, 40, 40, 16, "Name:")
        StringGadget(#EditorCP_Name, 68, 38, 240, 20, "")
        TextGadget(#EditorCP_AuthorText, 8, 70, 40, 16, "Author:")
        StringGadget(#EditorCP_Author, 68, 68, 240, 20, "")
        TextGadget(#EditorCP_PasswordText, 8, 100, 50, 16, "Password:")
        StringGadget(#EditorCP_Password, 68, 98, 240, 20, "", #PB_String_Password)
        Frame3DGadget(#EditorCP_CommentFrame, 8, 118, 300, 100, "Comment")
        EditorGadget(#EditorCP_Comment, 18, 138, 280, 70)
      
      AddGadgetItem(#EditorCP_Panel, -1, "Score")
        TextGadget(#EditorCP_AuthorsHighscoreText, 8, 10, 100, 16, "Author's Highscore:")
        StringGadget(#EditorCP_AuthorsHighscore, 108, 8, 200, 20, "", #PB_String_ReadOnly)
        
      AddGadgetItem(#EditorCP_Panel, -1, "Player")
        Frame3DGadget(#EditorCP_PowersFrame, 8, 68, 300, 110, "Powers")
        CheckBoxGadget(#EditorCP_CanDoubleJump, 18, 88, 80, 20, "Double Jump")
        CheckBoxGadget(#EditorCP_CanFly1, 118, 88, 40, 20, "Fly I")
        CheckBoxGadget(#EditorCP_CanShoot1, 218, 88, 60, 20, "Shoot I")
        CheckBoxGadget(#EditorCP_CanShoot2, 218, 108, 60, 20, "Shoot II")
        CheckBoxGadget(#EditorCP_CanShoot3, 218, 128, 60, 20, "Shoot III")
        CheckBoxGadget(#EditorCP_CanClimb, 18, 108, 50, 20, "Climb")
        TextGadget(#EditorCP_LivesText, 8, 10, 40, 16, "Lives:")
        StringGadget(#EditorCP_Lives, 78, 8, 70, 20, "", #PB_String_Numeric)
        TextGadget(#EditorCP_MaxEnergyText, 8, 40, 70, 16, "Max. Energy:")
        CheckBoxGadget(#EditorCP_CanFly2, 118, 108, 40, 20, "Fly II")
        CheckBoxGadget(#EditorCP_CanFly3, 118, 128, 50, 20, "Fly III")
        StringGadget(#EditorCP_MaxEnergy, 78, 38, 70, 20, "", #PB_String_Numeric)
        TextGadget(#EditorCP_EnergyText, 168, 40, 70, 16, "Energy:")
        StringGadget(#EditorCP_Energy, 238, 38, 70, 20, "", #PB_String_Numeric)
        CheckBoxGadget(#EditorCP_CanLumiFlight, 18, 128, 70, 20, "Lumi Flight")
        CheckBoxGadget(#EditorCP_CanLoadShot, 218, 148, 70, 20, "Load Shot")
      
      AddGadgetItem(#EditorCP_Panel, -1, "Categories")
        TextGadget(#EditorCP_DifficultyText, 8, 40, 50, 16, "Difficulty:")
        TextGadget(#EditorCP_GenreText, 8, 10, 40, 16, "Genre:")
        ComboBoxGadget(#EditorCP_Genre, 78, 8, 230, 20)
        ComboBoxGadget(#EditorCP_Difficulty, 78, 38, 230, 20)
        TextGadget(#EditorCP_SizeText, 8, 70, 60, 16, "Size:")
        ComboBoxGadget(#EditorCP_Size, 78, 68, 230, 20)
      
    CloseGadgetList()
  
  
  ;{ Initializations
    ; Alle vorhandenen Folders in die ComboBox "#EditorCP_Folder" einfgen:
    ClearGadgetItems(#EditorCP_Folder)
    UpdateChallangePropertiesFolders(*ChallangeFolder)
    
    ; Weitere ComboBoxen im Panel "Categories" fllen:
    AddGadgetItem(#EditorCP_Genre, -1, "Adventure")
    AddGadgetItem(#EditorCP_Genre, -1, "Collecting")
    AddGadgetItem(#EditorCP_Genre, -1, "Fight")
    AddGadgetItem(#EditorCP_Genre, -1, "Maze")
    AddGadgetItem(#EditorCP_Genre, -1, "Puzzle")
    AddGadgetItem(#EditorCP_Genre, -1, "Obstacle")
    AddGadgetItem(#EditorCP_Genre, -1, "Race")
    AddGadgetItem(#EditorCP_Genre, -1, "Environmental")
    
    AddGadgetItem(#EditorCP_Difficulty, -1, "Easy")
    AddGadgetItem(#EditorCP_Difficulty, -1, "Normal")
    AddGadgetItem(#EditorCP_Difficulty, -1, "Hard")
    
    AddGadgetItem(#EditorCP_Size, -1, "Tiny")
    AddGadgetItem(#EditorCP_Size, -1, "Small")
    AddGadgetItem(#EditorCP_Size, -1, "Medium")
    AddGadgetItem(#EditorCP_Size, -1, "Large")
    AddGadgetItem(#EditorCP_Size, -1, "Huge")
  ;}
  
  
  ResetChallangeProperties()
  
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    
    If Window = #EditorCPWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #EditorCP_OK
              Break
            Case #EditorCP_Play
              GetChallangeProperties()
              SaveEditorChallange()
              
              Program = RunProgram("Engine.exe", "load " + #Q + \Folder + \Name + #Q, GetCurrentDirectory(), #PB_Program_Open)
              While ProgramRunning(Program)
                WindowEvent()
                Delay(1)
              Wend
              KillProgram(Program)
              CloseProgram(Program)
              
              SetActiveWindow(#EditorCPWindow)
          EndSelect
        Case #PB_Event_CloseWindow
          CloseWindow(#EditorCPWindow)
          ProcedureReturn #False
      EndSelect
    EndIf
  ForEver
  
  
  GetChallangeProperties()
  
  
  CloseWindow(#EditorCPWindow)
  ProcedureReturn #True
  
  EndWith
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 50
; FirstLine = 25
; Folding = ---
; EnableXP