Procedure.i ReadTilesets()
  Protected TilesetCount.i, TileCount.i, *Tileset.TilesetEntry
  Protected Index.i, Index2.i, Position.i, TileIndex.i, Number.i
  
  TilesetCount = ReadInteger(IO_InputFile)
  TileCount    = ReadInteger(IO_InputFile)
  
  If TileCount
    ReDim *IO_Tile.RegisteredTile(TileCount - 1)
    
    For Index = 1 To TilesetCount
      *Tileset  = GetTileset(ReadNTString(IO_InputFile))
      TileCount = ReadCharacter(IO_InputFile) ;Anzahl an verwendeten Tiles im jeweiligen Tileset
      LoadRegTileset(*Tileset)
      
      For Index2 = 1 To TileCount
        Position = ReadWord(IO_InputFile)
        *IO_Tile(Number) = LoadRegTile(Position % *Tileset\Registered\Width, Position / *Tileset\Registered\Width, *Tileset\Registered)
        Number + 1
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadBanks()
  Protected BankCount.i, ObjectCount.i, *Bank.Bank
  Protected Index.i, Index2.i, Number.i
  
  BankCount   = ReadInteger(IO_InputFile)
  ObjectCount = ReadInteger(IO_InputFile)
  
  If ObjectCount
    ReDim *IO_Object.RegisteredObject(ObjectCount - 1)
    
    For Index = 1 To BankCount
      *Bank       = GetBank(ReadNTString(IO_InputFile))
      ObjectCount = ReadCharacter(IO_InputFile)
      
      For Index2 = 1 To ObjectCount
        *IO_Object(Number) = LoadRegObject(GetObjectByCallbackName(*Bank, ReadNTString(IO_InputFile)))
        _Call(*IO_Object(Number)\Entry\Callback, #Null, #Object_GlobalEditorLoad, #Null)
        Number + 1
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadBackgrounds()
  Protected BackgroundCount.i
  Protected Index.i, Number.i
  
  BackgroundCount = ReadInteger(IO_InputFile)
  
  If BackgroundCount
    ReDim *IO_Background.RegisteredBackground(BackgroundCount - 1)
    
    For Index = 1 To BackgroundCount
      *IO_Background(Number) = LoadRegBackground(GetBackground(ReadNTString(IO_InputFile)))
      Number + 1
    Next
  EndIf
EndProcedure
Procedure.i ReadScene(X.i, Y.i, *Main.Scene = #Null)
  Protected Type.i, Integer.i, *Scene.Scene
  Protected SubX.i, SubY.i
  
  With Editor
  
  Type = ReadByte(IO_InputFile)
  If Type
    *Scene = CreateScene(X, Y)
    
    If Not *Main
      ; Hhe und Breite wird ermittelt:
      *Scene\Width  = ReadCharacter(IO_InputFile)
      *Scene\Height = ReadCharacter(IO_InputFile)
    EndIf
    
    If Type = 2
      \StartScene   = *Scene
      \StartX       = ReadCharacter(IO_InputFile)
      \StartY       = ReadCharacter(IO_InputFile)
      
      \CurrentScene = *Scene
      \SceneX       = *Scene\X
      \SceneY       = *Scene\Y
    EndIf
    
    ReadTileGroup(*Scene, #BackgroundTile1)
    ReadTileGroup(*Scene, #BackgroundTile2)
    ReadTileGroup(*Scene, #BackgroundTile3)
    ReadTileGroup(*Scene, #Tile)
    ReadTileGroup(*Scene, #Ground)
    ReadTileGroup(*Scene, #ForegroundTile)
    
    ReadObjectGroup   (*Scene, #BackgroundObject1)
    ReadObjectGroup   (*Scene, #BackgroundObject2)
    ReadFixObjectGroup(*Scene, #Object)
    ReadObjectGroup   (*Scene, #ForegroundObject1)
    ReadObjectGroup   (*Scene, #ForegroundObject2)
    
    If Not *Main
      ; Hintergrund lesen:
      *Scene\Background = *IO_Background(ReadCharacter(IO_InputFile))
      UseRegBackground(*Scene\Background)
      
      ; Erlaubte Fhigkeiten:
      *Scene\AllowFly3       = ReadByte(IO_InputFile)
      *Scene\AllowLumiFlight = ReadByte(IO_InputFile)
      
      ; Side-Wraping ermitteln:
      Integer                = ReadByte(IO_InputFile)
      *Scene\HorinzontalLoop = Is(Integer & %01)
      *Scene\VerticalLoop    = Is(Integer & %10)
      *Scene\UnpassableTop   = ReadByte(IO_InputFile)
      
      ; Zugewiesenes Act laden:
      *Scene\Act = ReadInteger(IO_InputFile)
      
      *Scene\Main = *Scene
      
      ; Angehngte Szenen lesen, die miteinander verbunden sind
      ; (im Spiel verursacht dies ein Scroll-Effekt):
      If *Scene\Width * *Scene\Height > 1
        For SubY = Y To Y + *Scene\Height - 1
          For SubX = X To X + *Scene\Width - 1
            If SubX <> X Or SubY <> Y
              ReadScene(SubX, SubY, *Scene)
            EndIf
          Next
        Next
      EndIf
    Else
      ; Folgende Daten werden aus der Hauptszene (immer oben links von einer Gruppe) bernommen:
      *Scene\Background = *Main\Background
      UseRegBackground(*Scene\Background)
      
      *Scene\AllowFly3       = *Main\AllowFly3
      *Scene\AllowLumiFlight = *Main\AllowLumiFlight
      
      *Scene\HorinzontalLoop = *Main\HorinzontalLoop
      *Scene\VerticalLoop    = *Main\VerticalLoop
      *Scene\VerticalLoop    = *Main\UnpassableTop
      
      *Scene\Act = #None
      
      *Scene\Width  = 1
      *Scene\Height = 1
      
      *Scene\Main = *Main
    EndIf
  EndIf
  
  EndWith
EndProcedure
Procedure.i ReadTileGroup(*Scene.Scene, Layer.i)
  Protected *Tile.Tile, Count.i, *Cell.Integer
  
  Count = ReadInteger(IO_InputFile)
  *Cell = AllocateMemory((Count + 1) * SizeOf(Integer))
  PokeI(*Scene + Layer * SizeOf(Integer), *Cell)
  
  While Count
    *Tile = _New(Tile)
    *Cell\i = *Tile
    
    *Tile\X          = ReadCharacter(IO_InputFile)
    *Tile\Y          = ReadCharacter(IO_InputFile)
    *Tile\Registered = *IO_Tile(ReadWord(IO_InputFile))
    
    UseRegTile(*Tile\Registered)
    *Tile\Registered\LastLayer = Layer
    
    *Cell + SizeOf(Integer)
    Count - 1
  Wend
EndProcedure
Procedure.i ReadObjectGroup(*Scene.Scene, Layer.i)
  Protected *Object.Object, Count.i, *Cell.Integer
  
  Count = ReadInteger(IO_InputFile)
  *Cell = AllocateMemory((Count + 1) * SizeOf(Integer))
  PokeI(*Scene + Layer * SizeOf(Integer), *Cell)
  
  While Count
    *Object = _New(Object)
    *Cell\i = *Object
    
    *Object\Scene = *Scene
    *Object\Layer = Layer
    
    *Object\Registered = *IO_Object(ReadWord(IO_InputFile))
    UseRegObject(*Object\Registered)
    
    _Call(*Object\Registered\Entry\Callback, #Null, #Object_EditorLoad, *Object)
    
    *IO_SceneObject(IO_SceneObjectNumber) = *Object
    IO_SceneObjectNumber + 1
    
    *Cell + SizeOf(Integer)
    Count - 1
  Wend
EndProcedure
Procedure.i ReadFixObjectGroup(*Scene.Scene, Layer.i)
  Protected *Object.Object, Count.i, *Cell.Integer
  
  Count = ReadInteger(IO_InputFile)
  *Cell = AllocateMemory((Count + 1) * SizeOf(Integer))
  PokeI(*Scene + Layer * SizeOf(Integer), *Cell)
  
  While Count
    *Object = _New(Object)
    *Cell\i = *Object
    
    *Object\Scene = *Scene
    *Object\Layer = Layer
    
    *Object\Registered = *IO_Object(ReadWord(IO_InputFile))
    *Object\X          = ReadCharacter(IO_InputFile)
    *Object\Y          = ReadCharacter(IO_InputFile)
    UseRegObject(*Object\Registered)
    
    _Call(*Object\Registered\Entry\Callback, #Null, #Object_EditorLoad, *Object)
    
    *IO_SceneObject(IO_SceneObjectNumber) = *Object
    IO_SceneObjectNumber + 1
    
    *Cell + SizeOf(Integer)
    Count - 1
  Wend
EndProcedure
Procedure.i ReadScenes()
  Protected Width.i, Height.i, X.i, Y.i, Count.i
  
  Width  = ReadInteger(IO_InputFile) - 1
  Height = ReadInteger(IO_InputFile) - 1
  
  IO_SceneObjectCount = ReadInteger(IO_InputFile)
  If IO_SceneObjectCount
    ReDim *IO_SceneObject(IO_SceneObjectCount - 1)
    
    IO_SceneObjectNumber = 0
  EndIf
  
  IO_SceneX = #SceneMap_Width / 2 - Width / 2
  IO_SceneY = #SceneMap_Height / 2 - Height / 2
  
  For Y = 0 To Height
    For X = 0 To Width
      If Not GetScene(IO_SceneX + X, IO_SceneY + Y)
        ReadScene(IO_SceneX + X, IO_SceneY + Y)
      EndIf
    Next
  Next
EndProcedure
Procedure.i ReadEvents()
  Protected *EventBank.EventBank, EventBankCount.i, EventCount.i
  Protected Index.i, Index2.i, Number.i
  
  EventBankCount = ReadWord(IO_InputFile)
  EventCount     = ReadWord(IO_InputFile)
  
  If EventCount
    ReDim *IO_Event(EventCount - 1)
    
    Number = 0
    For Index = 1 To EventBankCount
      *EventBank = GetEventBank(ReadNTString(IO_InputFile))
      EventCount = ReadWord(IO_InputFile)
      
      For Index2 = 1 To EventCount
        *IO_Event(Number) = GetEventByCallbackName(*EventBank, ReadNTString(IO_InputFile))
        _Call(*IO_Event(Number)\Callback, #Null, #Event_GlobalEditorLoad, #Null)
        Number + 1
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadEffects()
  Protected *EffectBank.EffectBank, EffectBankCount.i, EffectCount.i
  Protected Index.i, Index2.i, Number.i
  
  EffectBankCount = ReadWord(IO_InputFile)
  EffectCount     = ReadWord(IO_InputFile)
  
  If EffectCount
    ReDim *IO_Effect(EffectCount - 1)
    
    Number = 0
    For Index = 1 To EffectBankCount
      *EffectBank = GetEffectBank(ReadNTString(IO_InputFile))
      EffectCount = ReadWord(IO_InputFile)
      
      For Index2 = 1 To EffectCount
        *IO_Effect(Number) = GetEffectByCallbackName(*EffectBank, ReadNTString(IO_InputFile))
        _Call(*IO_Effect(Number)\Callback, #Null, #Effect_GlobalEditorLoad, #Null)
        Number + 1
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadActs()
  Protected *Act.Act, *Event.Event, *Effect.Effect, ActCount.i, EventCount.i, EffectCount.i
  Protected Index.i, Index2.i, Index3.i
  
  ActCount = ReadWord(IO_InputFile)
  If ActCount
    ReDim *IO_Act(ActCount - 1)
    
    For Index = 1 To ActCount
      *Act               = CreateAct(ReadNTString(IO_InputFile))
      *IO_Act(Index - 1) = *Act
      *Act\Description   = ReadNTString(IO_InputFile)
      EventCount         = ReadWord(IO_InputFile)
      
      For Index2 = 1 To EventCount
        *Event = CreateEvent(*Act, *IO_Event(ReadWord(IO_InputFile)), #False)
        EffectCount    = ReadWord(IO_InputFile)
        *Event\Comment = ReadNTString(IO_InputFile)
        _Call(*Event\Entry\Callback, #Null, #Event_EditorLoad, *Event)
        
        For Index3 = 1 To EffectCount
          *Effect = CreateEffect(*Event, *IO_Effect(ReadWord(IO_InputFile)), #False)
          *Effect\Comment = ReadNTString(IO_InputFile)
          _Call(*Effect\Entry\Callback, #Null, #Effect_EditorLoad, *Effect)
        Next
      Next
    Next
  EndIf
EndProcedure

Procedure.i InitializeScenes()
  Protected *Item.QueueItem, *Scene.Scene
  
  *Item = Editor\UsedScenes\First
  While *Item
    *Scene = *Item\Memory
    
    If *Scene\Act <> #None
      *Scene\Act = *IO_Act(*Scene\Act)
      UseAct(*Scene\Act)
    Else
      *Scene\Act = #Null
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i InitializeObjects()
  Protected Index.i
  
  For Index = 0 To IO_SceneObjectCount - 1
    _Call(*IO_SceneObject(Index)\Registered\Entry\Callback, #Null, #Object_EditorInitialize, *IO_SceneObject(Index))
  Next
EndProcedure
Procedure.i InitializeActs()
  Protected *Item.QueueItem, *EventItem.QueueItem, *EffectItem.QueueItem
  Protected *Act.Act, *Event.Event, *Effect.Effect
  
  *Item = *Acts\First
  While *Item
    *Act = *Item\Memory
    
    *EventItem = *Act\Events\First
    While *EventItem
      *Event = *EventItem\Memory
      
      _Call(*Event\Entry\Callback, #Null, #Event_EditorInitialize, *Event)
      
      *EffectItem = *Event\Effects\First
      While *EffectItem
        *Effect = *EffectItem\Memory
        
        _Call(*Effect\Entry\Callback, #Null, #Effect_EditorInitialize, *Effect)
        
        _Move(*EffectItem, N)
      Wend
      
      _Move(*EventItem, N)
    Wend
    
    _Move(*Item, N)
  Wend
EndProcedure

; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 314
; FirstLine = 120
; Folding = Iy+
; EnableXP