Procedure.i PassTilesets()
  Protected *Item.QueueItem, *Tileset.TilesetEntry, *TileItem.QueueItem, *Tile.RegisteredTile
  
  IO_TilesetNumber = 0
  IO_TileNumber    = 0
  
  *Item = *Tilesets\First
  While *Item
    *Tileset = *Item\Memory
    
    If *Tileset\Registered
      *Tileset\Number = IO_TilesetNumber
      IO_TilesetNumber + 1
      
      *TileItem = *Tileset\Registered\RegisteredTiles\First
      While *TileItem
        *Tile = *TileItem\Memory
        
        *Tile\Number = IO_TileNumber
        IO_TileNumber + 1
        
        _Move(*TileItem, N)
      Wend
    EndIf
    
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #True
EndProcedure
Procedure.i PassObjects()
  Protected *Item.QueueItem, *Bank.Bank, *ObjectItem.QueueItem, *Object.RegisteredObject
  
  IO_BankNumber   = 0
  IO_ObjectNumber = 0
  
  *Item = *Banks\First
  While *Item
    *Bank = *Item\Memory
    
    If *Bank\RegisteredObjects\Count
      *Bank\Number = IO_BankNumber
      IO_BankNumber + 1
      
      *ObjectItem = *Bank\RegisteredObjects\First
      While *ObjectItem
        *Object = *ObjectItem\Memory
        
        *Object\Number = IO_ObjectNumber
        IO_ObjectNumber + 1
        
        _Move(*ObjectItem, N)
      Wend
    EndIf
    
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #True
EndProcedure
Procedure.i PassBackgrounds()
  Protected *Item.QueueItem, *Background.BackgroundEntry
  
  IO_BackgroundNumber = 0
  
  *Item = *Backgrounds\First
  While *Item
    *Background = *Item\Memory
    
    If *Background\Registered
      *Background\Registered\Number = IO_BackgroundNumber
      IO_BackgroundNumber + 1
    EndIf
    
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #True
EndProcedure
Procedure.i PassSceneObjects(*Scene.Scene)
  Protected Layer.i, *Cell.Integer, *Object.Object
  
  For Layer = #BackgroundObject1 To #ForegroundObject2
    *Cell = LayerArray(*Scene, Layer)
    While *Cell\i
      *Object = *Cell\i
      *Object\Number = IO_SceneObjectNumber
      IO_SceneObjectNumber + 1
      *Cell + SizeOf(Integer)
    Wend
  Next
  
  ProcedureReturn #True
EndProcedure
Procedure.i PassScene(*Scene.Scene)
  Protected X.i, Y.i
  
  If Not *Scene\Background
    MessageRequester("Error", "The following scene does not have a background.", #MB_ICONERROR)
    ChangeScene(*Scene\X, *Scene\Y)
    ProcedureReturn #False
  EndIf
  
  If *Scene\Main = *Scene And *Scene\Width * *Scene\Height > 1
    For Y = *Scene\Y To *Scene\Y + *Scene\Height - 1
      For X = *Scene\X To *Scene\X + *Scene\Width - 1
        PassSceneObjects(GetScene(X, Y))
      Next
    Next
  Else
    PassSceneObjects(*Scene)
  EndIf
  
  *Scene\Number = IO_SceneNumber
  IO_SceneNumber + 1
  
  ProcedureReturn #True
EndProcedure
Procedure.i PassScenes()
  Protected *Scene.Scene, X.i, Y.i
  
  IO_SceneNumber       = 0
  IO_SceneObjectNumber = 0
  
  GetMapBorders(@IO_SceneMap_Left, @IO_SceneMap_Top, @IO_SceneMap_Right, @IO_SceneMap_Bottom)
  IO_SceneMap_Width  = IO_SceneMap_Right  - IO_SceneMap_Left + 1
  IO_SceneMap_Height = IO_SceneMap_Bottom - IO_SceneMap_Top  + 1
  
  ; Nun werden alle Szenen geprft:
  For Y = IO_SceneMap_Top To IO_SceneMap_Bottom
    For X = IO_SceneMap_Left To IO_SceneMap_Right
      *Scene = GetScene(X, Y)
      If *Scene And *Scene\Main = *Scene
        If Not PassScene(*Scene)
          ProcedureReturn #False
        EndIf
      EndIf
    Next
  Next
  
  ProcedureReturn #True
EndProcedure
Procedure.i PassEvents()
  Protected *Item.QueueItem, *EventBank.EventBank, *EventItem.QueueItem, *Event.EventEntry
  
  IO_EventBankNumber = 0
  IO_EventNumber     = 0
  
  *Item = *EventBanks\First
  While *Item
    *EventBank = *Item\Memory
    
    If *EventBank\UsedEvents
      *EventBank\Number = IO_EventBankNumber
      IO_EventBankNumber + 1
      
      *EventItem = *EventBank\Entries\First
      While *EventItem
        *Event = *EventItem\Memory
        
        If *Event\References
          *Event\Number = IO_EventNumber
          IO_EventNumber + 1
        EndIf
        
        _Move(*EventItem, N)
      Wend
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i PassEffects()
  Protected *Item.QueueItem, *EffectBank.EffectBank, *EffectItem.QueueItem, *Effect.EffectEntry
  
  IO_EffectBankNumber = 0
  IO_EffectNumber     = 0
  
  *Item = *EffectBanks\First
  While *Item
    *EffectBank = *Item\Memory
    
    If *EffectBank\UsedEffects
      *EffectBank\Number = IO_EffectBankNumber
      IO_EffectBankNumber + 1
      
      *EffectItem = *EffectBank\Entries\First
      While *EffectItem
        *Effect = *EffectItem\Memory
        
        If *Effect\References
          *Effect\Number = IO_EffectNumber
          IO_EffectNumber + 1
        EndIf
        
        _Move(*EffectItem, N)
      Wend
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i PassActs()
  Protected *Item.QueueItem, *Act.Act, *EventItem.QueueItem, *Event.Event
  
  IO_ActNumber = 0
  
  *Item = *Acts\First
  While *Item
    *Act = *Item\Memory
    If *Act\Events\Count
      *EventItem = *Act\Events\First
      While *EventItem
        *Event = *EventItem\Memory
        If *Event\Effects\Count = 0
          MessageRequester("Error", "Event do not have any effects in act " + #Q + *Act\Name + #Q + ".", #MB_ICONERROR)
          ProcedureReturn #False
        EndIf
        _Move(*EventItem, N)
      Wend
    Else
      MessageRequester("Error", "Act " + #Q + *Act\Name + #Q + " is empty (no events defined).", #MB_ICONERROR)
      ProcedureReturn #False
    EndIf
    
    ; Alle Acts enummerieren:
    *Act\Number = IO_ActNumber
    IO_ActNumber + 1
    
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #True
EndProcedure

Procedure.i WriteTilesets()
  Protected *Item.QueueItem, *Tileset.TilesetEntry, *TileItem.QueueItem, *Tile.RegisteredTile
  
  WriteInteger(IO_OutputFile, IO_TilesetNumber)
  WriteInteger(IO_OutputFile, IO_TileNumber)
  
  *Item = *Tilesets\First
  While *Item
    *Tileset = *Item\Memory
    
    If *Tileset\Registered And *Tileset\Registered\RegisteredTiles\Count
      ; Name des Tilesets:
      WriteNTString(IO_OutputFile , TilesetPath(*Tileset))
      ; Anzahl an Tiles:
      WriteCharacter(IO_OutputFile, *Tileset\Registered\RegisteredTiles\Count)
      
      *TileItem = *Tileset\Registered\RegisteredTiles\First
      While *TileItem
        *Tile = *TileItem\Memory
        
        ; Index des jeweiligen Tile:
        WriteWord(IO_OutputFile, *Tile\Index)
        
        _Move(*TileItem, N)
      Wend
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i WriteBanks()
  Protected *Item.QueueItem, *Bank.Bank, *ObjectItem.QueueItem, *Object.RegisteredObject
  
  WriteInteger(IO_OutputFile, IO_BankNumber)
  WriteInteger(IO_OutputFile, IO_ObjectNumber)
  
  *Item  = *Banks\First
  While *Item
    *Bank = *Item\Memory
    
    If *Bank\RegisteredObjects\Count
      ; Name der Objekt-Bibliothek:
      WriteNTString(IO_OutputFile, *Bank\Name)
      ; Anzahl an verwendeten Objekten:
      WriteCharacter(IO_OutputFile, *Bank\RegisteredObjects\Count)
      
      *ObjectItem = *Bank\RegisteredObjects\First
      While *ObjectItem
        *Object = *ObjectItem\Memory
        
        ; Callback-Name des jeweiligen Objekts speichern:
        WriteNTString(IO_OutputFile, *Object\Entry\CallbackName)
        ; Globale Daten des Objekts speichern (falls vorhanden):
        _Call(*Object\Entry\Callback, #Null, #Object_GlobalEditorSave, *Object)
        
        _Move(*ObjectItem, N)
      Wend
    EndIf
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i WriteBackgrounds()
  Protected *Item.QueueItem, *Background.BackgroundEntry
  
  WriteInteger(IO_OutputFile, IO_BackgroundNumber)
  
  *Item  = *Backgrounds\First
  While *Item
    *Background = *Item\Memory
    
    If *Background\Registered
      ; Name des Hintergrundes speichern:
      WriteNTString(IO_OutputFile, BackgroundPath(*Background))
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i WriteScene(*Scene.Scene, LocalSettings.i = #True)
  Protected Type.i, IndexX.i, IndexY.i
  
  With Editor
  
  If *Scene = \StartScene
    Type = 2
  Else
    Type = 1
  EndIf
  
  WriteByte(IO_OutputFile, Type)
  
  If *Scene\Main = *Scene
    WriteCharacter(IO_OutputFile, *Scene\Width)
    WriteCharacter(IO_OutputFile, *Scene\Height)
  EndIf
  
  If Type = 2
    WriteCharacter(IO_OutputFile, \StartX)
    WriteCharacter(IO_OutputFile, \StartY)
  EndIf
  
  WriteTileGroup(*Scene\BackgroundTiles1)
  WriteTileGroup(*Scene\BackgroundTiles2)
  WriteTileGroup(*Scene\BackgroundTiles3)
  WriteTileGroup(*Scene\Tiles)
  WriteTileGroup(*Scene\Grounds)
  WriteTileGroup(*Scene\ForegroundTiles)
  
  WriteObjectGroup(*Scene\BackgroundObjects1)
  WriteObjectGroup(*Scene\BackgroundObjects2)
  WriteFixObjectGroup(*Scene\Objects)
  WriteObjectGroup(*Scene\ForegroundObjects1)
  WriteObjectGroup(*Scene\ForegroundObjects2)
  
  If *Scene\Main = *Scene
    WriteCharacter(IO_OutputFile, *Scene\Background\Number)
    
    WriteByte(IO_OutputFile, *Scene\AllowFly3)
    WriteByte(IO_OutputFile, *Scene\AllowLumiFlight)
    
    WriteByte(IO_OutputFile, (*Scene\VerticalLoop << 1) | *Scene\HorinzontalLoop)
    WriteByte(IO_OutputFile, *Scene\UnpassableTop)
    
    If *Scene\Act
      WriteInteger(IO_OutputFile, *Scene\Act\Number)
    Else
      WriteInteger(IO_OutputFile, #None)
    EndIf
    
    If *Scene\Width * *Scene\Height > 1
      For IndexY = *Scene\Y To *Scene\Y + *Scene\Height - 1
        For IndexX = *Scene\X To *Scene\X + *Scene\Width - 1
          If IndexX <> *Scene\X Or IndexY <> *Scene\Y
            WriteScene(GetScene(IndexX, IndexY), #False)
          EndIf
        Next
      Next
    EndIf
  EndIf
  
  EndWith
EndProcedure
Procedure.i WriteTileGroup(*Cell.Integer)
  Protected *Tile.Tile
  
  WriteInteger(IO_OutputFile, MemorySize(*Cell) / SizeOf(Integer) - 1)
  
  While *Cell\i
    *Tile = *Cell\i
    
    WriteCharacter(IO_OutputFile, *Tile\X)
    WriteCharacter(IO_OutputFile, *Tile\Y)
    WriteWord(IO_OutputFile, *Tile\Registered\Number)
    
    *Cell + SizeOf(Integer)
  Wend
EndProcedure
Procedure.i WriteObjectGroup(*Cell.Integer)
  Protected *Object.Object
  
  WriteInteger(IO_OutputFile, MemorySize(*Cell) / SizeOf(Integer) - 1)
  
  While *Cell\i
    *Object = *Cell\i
    
    WriteWord(IO_OutputFile, *Object\Registered\Number)
    _Call(*Object\Registered\Entry\Callback, #Null, #Object_EditorSave, *Object)
    
    *Cell + SizeOf(Integer)
  Wend
EndProcedure
Procedure.i WriteFixObjectGroup(*Cell.Integer)
  Protected *Object.Object
  
  WriteInteger(IO_OutputFile, MemorySize(*Cell) / SizeOf(Integer) - 1)
  
  While *Cell\i
    *Object = *Cell\i
    
    WriteWord(IO_OutputFile, *Object\Registered\Number)
    WriteCharacter(IO_OutputFile, *Object\X)
    WriteCharacter(IO_OutputFile, *Object\Y)
    _Call(*Object\Registered\Entry\Callback, #Null, #Object_EditorSave, *Object)
    
    *Cell + SizeOf(Integer)
  Wend
EndProcedure
Procedure.i WriteScenes()
  Protected X.i, Y.i, *Scene.Scene
  
  WriteInteger(IO_OutputFile, IO_SceneMap_Width)
  WriteInteger(IO_OutputFile, IO_SceneMap_Height)
  
  WriteInteger(IO_OutputFile, IO_SceneObjectNumber)
  
  For Y = IO_SceneMap_Top To IO_SceneMap_Bottom
    For X = IO_SceneMap_Left To IO_SceneMap_Right
      *Scene = GetScene(X, Y)
      If *Scene
        If *Scene\Main = *Scene
          WriteScene(*Scene)
        EndIf
      Else
        WriteByte(IO_OutputFile, 0)
      EndIf
    Next
  Next
  
  ProcedureReturn #True
EndProcedure
Procedure.i WriteEvents()
  Protected *Item.QueueItem, *EventBank.EventBank, *EventItem.QueueItem, *Event.EventEntry
  
  WriteWord(IO_OutputFile, IO_EventBankNumber)
  WriteWord(IO_OutputFile, IO_EventNumber)
  
  *Item = *EventBanks\First
  While *Item
    *EventBank = *Item\Memory
    
    If *EventBank\UsedEvents
      WriteNTString(IO_OutputFile, *EventBank\Name)
      WriteWord(IO_OutputFile, *EventBank\UsedEvents)
      
      *EventItem = *EventBank\Entries\First
      While *EventItem
        *Event = *EventItem\Memory
        
        If *Event\References
          WriteNTString(IO_OutputFile, *Event\CallbackName)
          _Call(*Event\Callback, #Null, #Event_GlobalEditorSave, #Null)
        EndIf
        
        _Move(*EventItem, N)
      Wend
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i WriteEffects()
  Protected *Item.QueueItem, *EffectBank.EffectBank, *EffectItem.QueueItem, *Effect.EffectEntry
  
  WriteWord(IO_OutputFile, IO_EffectBankNumber)
  WriteWord(IO_OutputFile, IO_EffectNumber)
  
  *Item = *EffectBanks\First
  While *Item
    *EffectBank = *Item\Memory
    
    If *EffectBank\UsedEffects
      WriteNTString(IO_OutputFile, *EffectBank\Name)
      WriteWord(IO_OutputFile, *EffectBank\UsedEffects)
      
      *EffectItem = *EffectBank\Entries\First
      While *EffectItem
        *Effect = *EffectItem\Memory
        
        If *Effect\References
          WriteNTString(IO_OutputFile, *Effect\CallbackName)
          _Call(*Effect\Callback, #Null, #Effect_GlobalEditorSave, #Null)
        EndIf
        
        _Move(*EffectItem, N)
      Wend
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i WriteActs()
  Protected *Item.QueueItem, *Act.Act, *EventItem.QueueItem, *Event.Event, *EffectItem.QueueItem, *Effect.Effect
  
  WriteWord(IO_OutputFile, IO_ActNumber)
  
  *Item = *Acts\First
  While *Item
    *Act = *Item\Memory
    
    ; Name, Beschreibung und Anzahl an Events speichern:
    WriteNTString(IO_OutputFile, *Act\Name)
    WriteNTString(IO_OutputFile, *Act\Description)
    WriteWord(IO_OutputFile, *Act\Events\Count)
    
    *EventItem = *Act\Events\First
    While *EventItem
      *Event = *EventItem\Memory
      
      ; Event-Nummer speichern:
      WriteWord(IO_OutputFile, *Event\Entry\Number)
      ; Anzahl an Effekten des jeweiligen Events:
      WriteWord(IO_OutputFile, *Event\Effects\Count)
      ; Kommentar speichern:
      WriteNTString(IO_OutputFile, *Event\Comment)
      ; Daten des Events speichern (falls vorhanden):
      _Call(*Event\Entry\Callback, #Null, #Event_EditorSave, *Event)
      
      *EffectItem = *Event\Effects\First
      While *EffectItem
        *Effect = *EffectItem\Memory
        
        ; Nummer des Effekts speichern:
        WriteWord(IO_OutputFile, *Effect\Entry\Number)
        ; Kommentar speichern:
        WriteNTString(IO_OutputFile, *Effect\Comment)
        ; Daten des Effekts speichern:
        _Call(*Effect\Entry\Callback, #Null, #Effect_EditorSave, *Effect)
        
        _Move(*EffectItem, N)
      Wend
      
      _Move(*EventItem, N)
    Wend
    
    _Move(*Item, N)
  Wend
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 86
; Folding = IAA9
; EnableXP