;**************************************************************
;     Scene Menu
;**************************************************************
;   Copyright (c) 2010 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i SceneMenu()
  Protected CameraX.f, CameraY.f, Difference.f
  Protected SceneX.i, SceneY.i, OverX.i, OverY.i
  Protected StartX.i, StartY.i, EndX.i, EndY.i, X.i, Y.i
  Protected *CurrentScene.Scene, Event.i, SceneChanged.i
  Protected Text.s, Sprite.i, *Scene.Scene, *Main.Scene
  
  ;TODO: Kamera durch die mittlere Maustaste bewegen:
  
  With Editor
  
  CameraX      = \SceneX * #FieldSize + #FieldSize/2 - #ScreenWidth/2
  CameraY      = \SceneY * #FieldSize + #FieldSize/2 - #ScreenHeight/2
  SceneChanged = #True
  
  Repeat
    Event = WindowEvent()
    
    If SceneChanged
      *CurrentScene = GetScene(\SceneX, \SceneY)
      SceneChanged  = #False
    EndIf
    
    ; Folgende Anweisungen sorgen fr eine flssige Fhrung der Kamera:
    If GetMouseX() <> -1 Or GetMouseY() <> -1
      Difference = (-\SceneX * #FieldSize - #FieldSize/2 + #ScreenWidth/2 - #MouseCameraInfluence*(GetMouseX() - #ScreenWidth/2)) + CameraX
      CameraX    - Difference * #SceneMap_CameraSpeed
      Difference = (-\SceneY * #FieldSize - #FieldSize/2 + #ScreenHeight/2 - #MouseCameraInfluence*(GetMouseY() - #ScreenHeight/2)) + CameraY
      CameraY    - Difference * #SceneMap_CameraSpeed
    Else
      Difference = (-\SceneX * #FieldSize - #FieldSize/2 + #ScreenWidth/2) + CameraX
      CameraX    - Difference * #SceneMap_CameraSpeed
      Difference = (-\SceneY * #FieldSize - #FieldSize/2 + #ScreenHeight/2) + CameraY
      CameraY    - Difference * #SceneMap_CameraSpeed
    EndIf
    
    StartX = CameraX / #FieldSize - 1             : _Min(StartX, 0)
    StartY = CameraY / #FieldSize - 1             : _Min(StartY, 0)
    EndX   = (CameraX + #ScreenWidth)/#FieldSize  : _Max(EndX, #SceneMapWidth - 1)
    EndY   = (CameraY + #ScreenHeight)/#FieldSize : _Max(EndY, #SceneMapHeight - 1)
    
    SceneX = (CameraX + GetMouseX() - #FieldSize/2)/ #FieldSize : _Lim(SceneX, 0, #SceneMapWidth - 1)
    SceneY = (CameraY + GetMouseY() - #FieldSize/2)/ #FieldSize : _Lim(SceneY, 0, #SceneMapHeight - 1)
    
    OverX = GetMouseX()/#FieldSize : _Lim(OverX, 0, #SceneWidth)
    OverY = GetMouseY()/#FieldSize : _Lim(OverY, 0, #SceneHeight + 2)
    
    ClearScreen(#White)
      For Y = StartY To EndY
        For X = StartX To EndX
          *Scene = GetScene(X, Y)
          If X = \SceneX And Y = \SceneY
            DisplaySprite(Editor\SceneSprite[#SceneSprite_Selected], X * #FieldSize - CameraX, Y * #FieldSize - CameraY)
          ElseIf *Scene
            *Main = *Scene\Main
            
            ;{ Binding
              If *Main\Width > 1 Or *Main\Height > 1
                If IsMainSceneEqual(X - 1, Y, *Main) And IsMainSceneEqual(X + 1, Y, *Main) And IsMainSceneEqual(X, Y - 1, *Main) And IsMainSceneEqual(X, Y + 1, *Main)
                  Sprite = #SceneSprite_Full
                ElseIf IsMainSceneEqual(X - 1, Y, *Main)
                  If IsMainSceneEqual(X + 1, Y, *Main)
                    If IsMainSceneEqual(X, Y - 1, *Main)
                      Sprite = #SceneSprite_LeftRightTop
                    ElseIf IsMainSceneEqual(X, Y + 1, *Main)
                      Sprite = #SceneSprite_LeftRightBottom
                    Else
                      Sprite = #SceneSprite_LeftRight
                    EndIf
                  ElseIf IsMainSceneEqual(X, Y - 1, *Main)
                    If IsMainSceneEqual(X, Y + 1, *Main)
                      Sprite = #SceneSprite_LeftTopBottom
                    Else
                      Sprite = #SceneSprite_LeftTop
                    EndIf
                  ElseIf IsMainSceneEqual(X, Y + 1, *Main)
                    Sprite = #SceneSprite_LeftBottom
                  Else
                    Sprite = #SceneSprite_Left
                  EndIf
                ElseIf IsMainSceneEqual(X + 1, Y, *Main)
                  If IsMainSceneEqual(X, Y - 1, *Main)
                    If IsMainSceneEqual(X, Y + 1, *Main)
                      Sprite = #SceneSprite_RightTopBottom
                    Else
                      Sprite = #SceneSprite_RightTop
                    EndIf
                  ElseIf IsMainSceneEqual(X, Y + 1, *Main)
                    Sprite = #SceneSprite_RightBottom
                  Else
                    Sprite = #SceneSprite_Right
                  EndIf
                ElseIf IsMainSceneEqual(X, Y - 1, *Main)
                  If IsMainSceneEqual(X, Y + 1, *Main)
                    Sprite = #SceneSprite_TopBottom
                  Else
                    Sprite = #SceneSprite_Top
                  EndIf
                ElseIf IsMainSceneEqual(X, Y + 1, *Main)
                  Sprite = #SceneSprite_Bottom
                Else
                  Sprite = #SceneSprite_Normal
                EndIf
              Else
                Sprite = #SceneSprite_Normal
              EndIf
            ;}
            
            If X = SceneX And Y = SceneY
              DisplayTranslucentSprite(Editor\SceneSprite[Sprite], X * #FieldSize - CameraX, Y * #FieldSize - CameraY, 200)
            Else
              DisplaySprite(Editor\SceneSprite[Sprite], X * #FieldSize - CameraX, Y * #FieldSize - CameraY)
            EndIf
          Else
            If X = SceneX And Y = SceneY
              DisplayTranslucentSprite(Editor\SceneSprite[#SceneSprite_Unused], X * #FieldSize - CameraX, Y * #FieldSize - CameraY, 200)
            Else
              DisplaySprite(Editor\SceneSprite[#SceneSprite_Unused], X * #FieldSize - CameraX, Y * #FieldSize - CameraY)
            EndIf
          EndIf
        Next
      Next
      
      If \StartScene
        DisplayTransparentSprite(Editor\StartSceneSprite, \StartScene\X * #FieldSize - CameraX, \StartScene\Y * #FieldSize - CameraY)
      EndIf
      
      If *CurrentScene
        DisplayTilesetBackground(*CurrentScene)
      EndIf
      
      Start3D()
        DisplaySprite3D(Editor\DisabledBarSprite3D, 0, #SceneHeight * #FieldSize)
        
        If *CurrentScene
          DisplayTilesAndObjects(*CurrentScene, 0, #EditorScreenHeight - 192)
        EndIf
      Stop3D()
      
      StartDrawing(ScreenOutput())
        DrawingMode(#PB_2DDrawing_Transparent)
        DrawText(0, 0, "(" + RSet(Str(\SceneX), 3) + "|" + RSet(Str(\SceneY), 3) + ")", $000000)
        
        If OverY < #ScreenHeight
          DrawText(GetMouseX() + 10, GetMouseY(), "(" + RSet(Str(SceneX), 3) + "|" + RSet(Str(SceneY), 3) + ")", $000000)
        EndIf
      StopDrawing()
    FlipBuffers()
    
    If KeyPressedDown(#VK_LEFT)
      \SceneX - 1
      _Min(\SceneX, 0)
      SceneChanged = #True
    ElseIf KeyPressedDown(#VK_RIGHT)
      \SceneX + 1
      _Max(\SceneX, #SceneMapWidth - 1)
      SceneChanged = #True
    EndIf
    If KeyPressedDown(#VK_UP)
      \SceneY - 1
      _Min(\SceneY, 0)
      SceneChanged = #True
    ElseIf KeyPressedDown(#VK_DOWN)
      \SceneY + 1
      _Max(\SceneY, #SceneMapHeight - 1)
      SceneChanged = #True
    EndIf
    If KeyPressedDown(#VK_HOME)
      \SceneX = \StartScene\X
      \SceneY = \StartScene\Y
      SceneChanged = #True
    EndIf
    
    If OverY < #SceneHeight
      If Event = #WM_LBUTTONDOWN
        \SceneX = SceneX
        \SceneY = SceneY
        SceneChanged = #True
      ElseIf Event = #WM_LBUTTONDBLCLK
        ChangeScene(\SceneX, \SceneY)
        Break
      EndIf
    Else
      If Event = #WM_LBUTTONDOWN
        Select OverX
          Case 26, 25
            Text = "[MOUSE LEFT/ARROW KEYS]" + #T      + "- Select scene" + #N
            Text + "[LEFT DOUBLE CLICK]"     + #T      + "- Open scene"   + #N
            Text + "[HOME (POS 1)]"          + #T + #T + "- Jump to start scene"
            MessageRequester("Help", Text)
        EndSelect
      EndIf
    EndIf
    
    OptimizeFPS()
  ForEver
  
  EndWith
EndProcedure

; IDE Options = PureBasic 4.50 RC 2 (Windows - x86)
; CursorPosition = 155
; FirstLine = 114
; Folding = -
; EnableXP