Procedure.i ResetSceneProperties(*Scene.Scene)
  SetWindowTitle(#SPWindow, "Scene(" + Str(*Scene\X) + "|" + Str(*Scene\Y) + ") properties")
  
  SetGadgetState(#SP_Width , *Scene\Width)
  SetGadgetState(#SP_Height, *Scene\Height)
  
  If *Scene\Main <> *Scene
    DisableGadget(#SP_Width , #True)
    DisableGadget(#SP_Height, #True)
  Else
    DisableGadget(#SP_Width , #False)
    DisableGadget(#SP_Height, #False)
  EndIf
  
  SetGadgetState(#SP_Fly3      , *Scene\AllowFly3)
  SetGadgetState(#SP_LumiFlight, *Scene\AllowLumiFlight)
  
  SetGadgetState(#SP_HLoop, *Scene\HorinzontalLoop)
  SetGadgetState(#SP_VLoop, *Scene\VerticalLoop)
  SetGadgetState(#SP_UTop , *Scene\UnpassableTop)
  
  If *Scene\Act
    SetGadgetText(#SP_Act, *Scene\Act\Name)
  EndIf
EndProcedure
Procedure.i GetSceneProperties(*Scene.Scene)
  Protected *Act.Act
  
  *Scene\AllowFly3       = GetGadgetState(#SP_Fly3)
  *Scene\AllowLumiFlight = GetGadgetState(#SP_LumiFlight)
  
  *Scene\HorinzontalLoop = GetGadgetState(#SP_HLoop)
  *Scene\VerticalLoop    = GetGadgetState(#SP_VLoop)
  *Scene\UnpassableTop   = GetGadgetState(#SP_UTop)
  
  ResizeScene(GetGadgetState(#SP_Width), GetGadgetState(#SP_Height))
  
  *Act = GetAct(GetGadgetText(#SP_Act))
  If *Scene\Act <> *Act
    If *Scene\Act
      ReleaseAct(*Scene\Act)
    EndIf
    If *Act
      UseAct(*Act)
    EndIf
    *Scene\Act = *Act
  EndIf
EndProcedure

Procedure.i OpenSceneProperties(*Scene.Scene)
  Protected Window.i, Event.i, Gadget.i, *Act.Act
  
  OpenWindow(#SPWindow, #PB_Ignore, #PB_Ignore, 420, 240, "Scene properties", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_TitleBar, WindowID(#ScreenWindow))
      ButtonGadget(#SP_OK, 340, 200, 70, 30, "OK")
      ButtonGadget(#SP_Cancel, 340, 170, 70, 30, "Cancel")
      
      TextGadget(#SP_WidthText, 340, 12, 40, 18, "Width:")
        SpinGadget(#SP_Width, 380, 10, 30, 20, 1, 6, #PB_Spin_Numeric)
      TextGadget(#SP_HeightText, 340, 42, 40, 16, "Height:")
        SpinGadget(#SP_Height, 380, 40, 30, 20, 1, 6, #PB_Spin_Numeric)
      
      PanelGadget(#SP_Panel, 10, 10, 320, 220)
        AddGadgetItem(#SP_Panel, -1, "Generic")
          Frame3DGadget(#SP_PowersFrame, 8, 8, 300, 70, "Powers")
            CheckBoxGadget(#SP_Fly3, 18, 28, 70, 20, "Fly (lvl. 3)")
            CheckBoxGadget(#SP_LumiFlight, 18, 48, 70, 20, "Lumi Flight")
          Frame3DGadget(#SP_BordersFrame, 8, 78, 300, 70, "Borders")
            CheckBoxGadget(#SP_HLoop, 18, 98, 100, 20, "Horinzontal Loop")
            CheckBoxGadget(#SP_VLoop, 18, 118, 80, 20, "Vertical Loop")
            CheckBoxGadget(#SP_UTop, 178, 98, 120, 20, "Unpassable Top")
        AddGadgetItem(#SP_Panel, -1, "Act")
          StringGadget(#SP_Act, 8, 8, 260, 20, "", #PB_String_ReadOnly)
          ButtonGadget(#SP_SelectAct, 268, 8, 40, 20, "...")
          OptionGadget(#SP_ParallelAct, 8, 38, 60, 20, "Parallel")
          OptionGadget(#SP_MainAct, 68, 38, 60, 20, "Main")
        CloseGadgetList()
  
  ResetSceneProperties(*Scene)
  
  Repeat
    Event  = WaitWindowEvent()
    Gadget = EventGadget()
    Window = EventWindow()
    
    If Window = #SPWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #SP_SelectAct
              *Act = SelectAct("Acts", "Select act for current scene:", *Scene\Act, #True, #True)
              If *Act
                SetGadgetText(#SP_Act, *Act\Name)
              Else
                SetGadgetText(#SP_Act, "")
              EndIf
            Case #SP_OK
              GetSceneProperties(*Scene)
              Break
            Case #SP_Cancel
              Break
          EndSelect
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(#SPWindow)
  ProcedureReturn #True
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 39
; FirstLine = 35
; Folding = -
; EnableXP