#SceneViewer_Image_Width  = 408
#SceneViewer_Image_Height = 264

#SceneViewer_XMiddle = (#SceneViewer_Image_Width / #FieldSize - 1)/2
#SceneViewer_YMiddle = (#SceneViewer_Image_Height / #FieldSize - 1)/2



Global SceneViewer_X.i, SceneViewer_Y.i, SceneViewer_OverX.i, SceneViewer_OverY.i, *SceneViewer_Scene.Scene
Global SceneViewer_MapImage.i, SceneViewer_Image.i, Dim SceneViewer_SceneImage.i(3, 3), SceneViewer_EmptySceneImage.i



Macro SceneViewer_Add(X, Y, State)
  Combination | ((State) << ((Y) * 3 + (2 - X)))
EndMacro
Macro SceneViewer_Set(X, Y)
  ImageX = X + 1
  ImageY = Y + 1
EndMacro
Macro SceneViewer_Combi(A, B, C)
  %C#B#A
EndMacro



Procedure.i LoadSceneViewerGraphics()
  Protected Image.i, X.i, Y.i
  
  Image = LoadImage(#PB_Any, "Graphics\Editor\Scene.bmp")
  For Y = 0 To 3
    For X = 0 To 3
      SceneViewer_SceneImage(X, Y) = GrabImage(Image, #PB_Any, X * #FieldSize, Y * #FieldSize, #FieldSize, #FieldSize)
    Next
  Next
  FreeImage(Image)
  
  SceneViewer_EmptySceneImage = LoadImage(#PB_Any, "Graphics\Editor\EmptyScene.bmp")
EndProcedure
Procedure.i DrawSceneViewerMap()
  Protected X.i, Y.i, MinX.i, MinY.i, MaxX.i, MaxY.i, Combination.i
  Protected *Scene.Scene, ImageX.i, ImageY.i
  
  MinX = SceneViewer_X - #SceneViewer_XMiddle
  MinY = SceneViewer_Y - #SceneViewer_YMiddle
  MaxX = SceneViewer_X + #SceneViewer_XMiddle
  MaxY = SceneViewer_Y + #SceneViewer_YMiddle
  
  StartDrawing(ImageOutput(SceneViewer_MapImage))
    Box(0, 0, #SceneViewer_Image_Width, #SceneViewer_Image_Height, $FFFFFF)
  
  For Y = MinY To MaxY
    If Not (Y => 0 And Y < #SceneMap_Height)
      Continue
    EndIf
    For X = MinX To MaxX
      If Not (X => 0 And X < #SceneMap_Width)
        Continue
      EndIf
      
      *Scene = GetScene(X, Y)
      If *Scene
        Combination = SceneViewer_Combi(000,010,000)
        
        If X > 0
          SceneViewer_Add(0, 1, Is(IsMainSceneEqual(X - 1, Y, *Scene\Main)))
        EndIf
        If X < #SceneMap_Width - 1
          SceneViewer_Add(2, 1, Is(IsMainSceneEqual(X + 1, Y, *Scene\Main)))
        EndIf
        If Y > 0
          SceneViewer_Add(1, 0, Is(IsMainSceneEqual(X, Y - 1, *Scene\Main)))
        EndIf
        If Y < #SceneMap_Height - 1
          SceneViewer_Add(1, 2, Is(IsMainSceneEqual(X, Y + 1, *Scene\Main)))
        EndIf
        
        Select Combination
          Case SceneViewer_Combi(010,111,010) : SceneViewer_Set( 1,  1) ;berall verbunden
          Case SceneViewer_Combi(010,011,010) : SceneViewer_Set(-1,  0) ;Rechts, Oben und Unten
          Case SceneViewer_Combi(010,110,010) : SceneViewer_Set( 1,  0) ;Links, Oben und Unten
          Case SceneViewer_Combi(000,111,010) : SceneViewer_Set( 0, -1) ;Links, Rechts und Unten
          Case SceneViewer_Combi(010,111,000) : SceneViewer_Set( 0,  1) ;Links, Rechts und Oben
          Case SceneViewer_Combi(000,011,010) : SceneViewer_Set(-1, -1) ;Rechts und Unten
          Case SceneViewer_Combi(000,110,010) : SceneViewer_Set( 1, -1) ;Links und Unten
          Case SceneViewer_Combi(010,011,000) : SceneViewer_Set(-1,  1) ;Rechts und Oben
          Case SceneViewer_Combi(010,110,000) : SceneViewer_Set( 1,  1) ;Links und Oben
          Case SceneViewer_Combi(000,111,000) : SceneViewer_Set( 0,  2) ;Links und Rechts
          Case SceneViewer_Combi(000,011,000) : SceneViewer_Set(-1,  2) ;Rechts
          Case SceneViewer_Combi(000,110,000) : SceneViewer_Set( 1,  2) ;Links
          Case SceneViewer_Combi(010,010,010) : SceneViewer_Set( 2,  0) ;Oben und Unten
          Case SceneViewer_Combi(010,010,000) : SceneViewer_Set( 2,  1) ;Oben
          Case SceneViewer_Combi(000,010,010) : SceneViewer_Set( 2, -1) ;Unten
          Case SceneViewer_Combi(000,010,000) : SceneViewer_Set( 2,  2) ;Garnicht verbunden
        EndSelect
        
        DrawImage(ImageID(SceneViewer_SceneImage(ImageX, ImageY)), (X - MinX) * #FieldSize, (Y - MinY) * #FieldSize)
      Else
        DrawImage(ImageID(SceneViewer_EmptySceneImage), (X - MinX) * #FieldSize, (Y - MinY) * #FieldSize)
      EndIf
    Next
  Next
  
  DrawingMode(#PB_2DDrawing_XOr)
  Box(#SceneViewer_XMiddle * #FieldSize, #SceneViewer_YMiddle * #FieldSize, #FieldSize, #FieldSize, $FFFFFF)
  
  StopDrawing()
EndProcedure
Procedure.i UpdateSceneViewerImage()
  StartDrawing(ImageOutput(SceneViewer_Image))
    DrawImage(ImageID(SceneViewer_MapImage), 0, 0)
    
    If SceneViewer_OverX <> #None And SceneViewer_OverY <> #None
      DrawingMode(#PB_2DDrawing_Outlined)
      Box((SceneViewer_OverX - SceneViewer_X + #SceneViewer_XMiddle) * #FieldSize, (SceneViewer_OverY - SceneViewer_Y + #SceneViewer_YMiddle) * #FieldSize, #FieldSize, #FieldSize, $000000)
      DrawingMode(#PB_2DDrawing_AlphaBlend)
      Box((SceneViewer_OverX - SceneViewer_X + #SceneViewer_XMiddle) * #FieldSize + 1, (SceneViewer_OverY - SceneViewer_Y + #SceneViewer_YMiddle) * #FieldSize + 1, #FieldSize - 2, #FieldSize - 2, RGBA(255, 255, 255, 50))
    EndIf
  StopDrawing()
  
  SetGadgetState(#SV_Image, ImageID(SceneViewer_Image))
EndProcedure
Procedure.i ExamineSceneViewerCursor()
  Protected PreviousOverX.i, PreviousOverY.i
  Protected X.i, Y.i
  
  PreviousOverX = SceneViewer_OverX
  PreviousOverY = SceneViewer_OverY
  
  X = WindowMouseX(#SVWindow) - GadgetX(#SV_Image)
  Y = WindowMouseY(#SVWindow) - GadgetY(#SV_Image)
  
  If X < 0 Or X => #SceneViewer_Image_Width
    SceneViewer_OverX = #None
  Else
    SceneViewer_OverX = SceneViewer_X - #SceneViewer_XMiddle + X/#FieldSize
    If SceneViewer_OverX < 0 Or SceneViewer_OverY => #SceneMap_Width
      SceneViewer_OverX = #None
    EndIf
  EndIf
  If Y < 0 Or Y => #SceneViewer_Image_Height
    SceneViewer_OverY = #None
  Else
    SceneViewer_OverY = SceneViewer_Y - #SceneViewer_YMiddle + Y/#FieldSize
    If SceneViewer_OverY < 0 Or SceneViewer_OverY => #SceneMap_Height
      SceneViewer_OverY = #None
    EndIf
  EndIf
  
  If PreviousOverX <> SceneViewer_OverX Or PreviousOverY <> SceneViewer_OverY
    UpdateSceneViewerImage()
  EndIf
EndProcedure
Procedure.i SelectSceneViewerScene(X.i, Y.i)
  Protected PreviousSceneX.i, PreviousSceneY.i, Text.s
  
  SceneViewer_X = X
  SceneViewer_Y = Y
  
  SetGadgetText(#SV_Frame, "Map - (" + Str(SceneViewer_X) + "|" + Str(SceneViewer_Y) + ")")
  
  DrawSceneViewerMap()
  ExamineSceneViewerCursor()
  UpdateSceneViewerImage()
  
  PreviousSceneX = Editor\SceneX
  PreviousSceneY = Editor\SceneY
  ChangeScene(SceneViewer_X, SceneViewer_Y, #False, #False)
    RenderEditor()
  ChangeScene(PreviousSceneX, PreviousSceneY)
EndProcedure
Procedure.i CloseSceneViewer()
  FreeImage(SceneViewer_MapImage)
  FreeImage(SceneViewer_Image)
  
  CloseWindow(#SVWindow)
EndProcedure
Procedure.i OpenSceneViewer()
  Protected Event.i, Window.i, Gadget.i, Type.i
  Protected *Scene.Scene, *Background.BackgroundEntry, PreviousSceneX.i, PreviousSceneY.i
  
  SceneViewer_MapImage = CreateImage(#PB_Any, #SceneViewer_Image_Width, #SceneViewer_Image_Height, 24)
  SceneViewer_Image    = CreateImage(#PB_Any, #SceneViewer_Image_Width, #SceneViewer_Image_Height, 24)
  
  OpenWindow(#SVWindow, #PB_Ignore, #PB_Ignore, 530, 300, "Challange Map", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    ImageGadget(#SV_Image, 20, 20, 408, 264, #Null)
    Frame3DGadget(#SV_Frame, 10, 0, 430, 290, "Map")
    ButtonGadget(#SV_OK, 450, 260, 70, 30, "OK")
    ButtonGadget(#SV_Cancel, 450, 230, 70, 30, "Cancel")
    ButtonGadget(#SV_Properties, 450, 10, 70, 30, "Properties")
    ButtonGadget(#SV_Background, 450, 40, 70, 30, "Background")
    
  SelectSceneViewerScene(Editor\OverSceneX, Editor\OverSceneY)
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    Type   = EventType()
    
    If Window = #SVWindow
      Select Event
        Case #PB_Event_Gadget
          Select Gadget
            Case #SV_Image
              If SceneViewer_OverX <> #None And SceneViewer_OverY <> #None
                If Type = #PB_EventType_LeftClick
                  SelectSceneViewerScene(SceneViewer_OverX, SceneViewer_OverY)
                ElseIf Type = #PB_EventType_LeftDoubleClick
                  Editor\LeftClickAllowed = #False
                  Break
                EndIf
              EndIf
            Case #SV_Properties
              *Scene = GetScene(SceneViewer_X, SceneViewer_Y)
              If *Scene
                PreviousSceneX = Editor\OverSceneX
                PreviousSceneY = Editor\OverSceneY
                ChangeScene(*Scene\X, *Scene\Y, #False, #False)
                
                HideWindow(#SVWindow, #True)
                
                OpenSceneProperties(*Scene\Main)
                
                HideWindow(#SVWindow, #False)
                
                RenderEditor()
                DrawSceneViewerMap()
                UpdateSceneViewerImage()
                ChangeScene(PreviousSceneX, PreviousSceneY)
              EndIf
            Case #SV_Background
              *Scene = GetScene(SceneViewer_X, SceneViewer_Y)
              If *Scene
                PreviousSceneX = Editor\SceneX
                PreviousSceneY = Editor\SceneY
                ChangeScene(*Scene\X, *Scene\Y, #False, #False)
                
                HideWindow(#SVWindow, #True)
                *Background = OpenBackgroundViewer()
                If *Background
                  ChangeBackground(*Scene, LoadRegBackground(*Background))
                EndIf
                HideWindow(#SVWindow, #False)
                
                RenderEditor()
                ChangeScene(PreviousSceneX, PreviousSceneY)
              EndIf
            Case #SV_Cancel
              CloseSceneViewer()
              ProcedureReturn #Null
            Case #SV_OK
              Break
          EndSelect
        Case #WM_MOUSEMOVE
          ExamineSceneViewerCursor()
        Case #WM_KEYDOWN
          If EventwParam() = #VK_HOME
            SelectSceneViewerScene(Editor\StartScene\X, Editor\StartScene\Y)
          EndIf
        Case #PB_Event_CloseWindow
          CloseSceneViewer()
          ProcedureReturn #Null
      EndSelect
    EndIf
  ForEver
  
  CloseSceneViewer()
  ProcedureReturn #True
EndProcedure

Procedure.i SelectedSceneViewerX()
  ProcedureReturn SceneViewer_X
EndProcedure
Procedure.i SelectedSceneViewerY()
  ProcedureReturn SceneViewer_Y
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 209
; FirstLine = 62
; Folding = AK-
; EnableXP