Structure SelectedObject_Memory
  Number.i
EndStructure



Procedure.i CreateSelection()
  Protected *Selection.Selection
  
  *Selection = _New(Selection)
  
  *Selection\Queue = CreateQueue(#Queue_FreeMemory)
  
  ProcedureReturn *Selection
EndProcedure
Procedure.i FreeSelection(*Selection.Selection)
  FreeQueue(*Selection\Queue)
  _Free(*Selection)
  
  ProcedureReturn #True
EndProcedure

Procedure.i SelectField(*Selection.Selection, *Scene.Scene, Layer.i, X.i, Y.i)
  Protected *Selected.Selected
  
  *Selected = _New(Selected)
  AppendQueueItem(*Selection\Queue, *Selected)
  
  *Selected\SceneX = *Scene\X
  *Selected\SceneY = *Scene\Y
  *Selected\Layer  = Layer
  *Selected\X      = X - (*Scene\X - *Scene\Main\X) * #SceneWidth
  *Selected\Y      = Y - (*Scene\Y - *Scene\Main\Y) * #SceneHeight
  
  ProcedureReturn *Selected
EndProcedure
Procedure.i GetSelected(*Selection.Selection, *Scene.Scene, Layer.i, X.i, Y.i)
  Protected *Selected.Selected, *Item.QueueItem
  Protected SceneX.i, SceneY.i
  
  SceneX = *Scene\X
  SceneY = *Scene\Y
  
  X - (*Scene\X - *Scene\Main\X) * #SceneWidth
  Y - (*Scene\Y - *Scene\Main\Y) * #SceneHeight
  
  *Item = *Selection\Queue\First
  While *Item
    *Selected = *Item\Memory
    If *Selected\SceneX = SceneX And *Selected\SceneY = SceneY And *Selected\Layer = Layer And *Selected\X = X And *Selected\Y = Y
      ProcedureReturn *Selected
    EndIf
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #Null
EndProcedure
Procedure.i RemoveSelected(*Selection.Selection, *Scene.Scene, Layer.i, X.i, Y.i)
  Protected *Selected.Selected, *Item.QueueItem
  Protected SceneX.i, SceneY.i
  
  SceneX = *Scene\X
  SceneY = *Scene\Y
  
  X - (*Scene\X - *Scene\Main\X) * #SceneWidth
  Y - (*Scene\Y - *Scene\Main\Y) * #SceneHeight
  
  *Item = *Selection\Queue\First
  While *Item
    *Selected = *Item\Memory
    If *Selected\SceneX = SceneX And *Selected\SceneY = SceneY And *Selected\Layer = Layer And *Selected\X = X And *Selected\Y = Y
      FreeQueueItem(*Selection\Queue, *Item)
      ProcedureReturn #True
    EndIf
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #False
EndProcedure
Procedure.i GetSelectionBorders(*Selection.Selection)
  Protected *Selected.Selected, X.i, Y.i, *Item.QueueItem
  
  If IsSelectionInSingleScene(*Selection)
    *Item = *Selection\Queue\First
    While *Item
      *Selected = *Item\Memory
      
      If Not *Item\P ;Das erste Element
        *Selection\MinX = AbsoluteX(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\X)
        *Selection\MinY = AbsoluteY(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\Y)
        *Selection\MaxX = *Selection\MinX
        *Selection\MaxY = *Selection\MinY
      Else
        X = AbsoluteX(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\X)
        Y = AbsoluteY(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\Y)
        If *Selection\MinX > X
          *Selection\MinX = X
        ElseIf X > *Selection\MaxX
          *Selection\MaxX = X
        EndIf
        If *Selection\MinY > Y
          *Selection\MinY = Y
        ElseIf Y > *Selection\MaxY
          *Selection\MaxY = Y
        EndIf
      EndIf
      
      _Move(*Item, N)
    Wend
  EndIf
EndProcedure
Procedure.i InsertSelection(*Selection.Selection, *Scene.Scene, X.i, Y.i)
  Protected *Selected.Selected, *Item.QueueItem
  Protected *Tile.Tile, *Object.Object
  Protected MinX.i = 0, MinY.i = 0, SelectedX.i, SelectedY.i, RelativeX.i, RelativeY.i
  Protected DestinationX.i, DestinationY.i
  Protected *OtherScene.Scene
  
  If IsSelectionInSingleScene(*Selection)
    X = AbsoluteX(*Scene, X)
    Y = AbsoluteY(*Scene, Y)
    
    *Item = *Selection\Queue\First
    While *Item
      *Selected = *Item\Memory
      
      ; Absolute Koordinaten ermitteln:
      DestinationX = AbsoluteX(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\X) - *Selection\MinX + X
      DestinationY = AbsoluteY(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\Y) - *Selection\MinY + Y
      
      ; Absolute Koordinaten in relative umwandeln:
      *OtherScene  = GetScene(*Scene\Main\X + DestinationX/#SceneWidth, *Scene\Main\Y + DestinationY/#SceneHeight)
      If *OtherScene
        DestinationX = DestinationX % #SceneWidth
        DestinationY = DestinationY % #SceneHeight
        
        ; Das Objekt/Tile an die passende Stelle kopieren:
        If *Selected\Layer < #BackgroundObject1
          *Tile = GetTile(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\Layer, *Selected\X, *Selected\Y)
          If *Tile And Not GetTile(*OtherScene, *Selected\Layer, DestinationX, DestinationY)
            CopyTile(*Tile, *Selected\Layer, DestinationX, DestinationY)
          EndIf
        Else
          *Object = GetObject(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\Layer, *Selected\X, *Selected\Y)
          If *Object And Not GetObject(*OtherScene, *Selected\Layer, DestinationX, DestinationY)
            CopyObject(*Object, *Selected\Layer, DestinationX, DestinationY)
          EndIf
        EndIf
      EndIf
      
      _Move(*Item, N)
    Wend
    
    ProcedureReturn #True
  Else
    MessageRequester("Error", "You can only paste a selection of a single scene.", #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
EndProcedure
Procedure.i GetSelectedField(*Selected.Selected)
  Protected *Scene.Scene
  
  *Scene = GetScene(*Selected\SceneX, *Selected\SceneY)
  If *Scene
    ProcedureReturn GetField(*Scene\Main, *Selected\Layer, *Selected\X + #SceneWidth * (*Scene\X - *Scene\Main\X), *Selected\Y + #SceneHeight * (*Scene\Y - *Scene\Main\Y))
  EndIf
EndProcedure

Procedure.i SelectedMainScene(*Selected.Selected)
  Protected *Scene.Scene
  
  *Scene = GetScene(*Selected\SceneX, *Selected\SceneY)
  ProcedureReturn *Scene\Main
EndProcedure
Procedure.i IsSelectionInSingleScene(*Selection.Selection)
  Protected *FirstScene.Scene, *Selected.Selected, *Item.QueueItem
  Protected *Scene.Scene
  
  If *Selection\Queue\Count
    *FirstScene = SelectedMainScene(*Selection\Queue\First\Memory)
    
    *Item = *Selection\Queue\First\N
    While *Item
      If *FirstScene <> SelectedMainScene(*Item\Memory)
        ProcedureReturn #False
      EndIf
      _Move(*Item, N)
    Wend
  EndIf
  
  ProcedureReturn #True
EndProcedure

Procedure.i WriteSelection(*Selection.Selection)
  Protected *Item.QueueItem, *Selected.Selected
  
  WriteInteger(IO_OutputFile, *Selection\Queue\Count)
  *Item = *Selection\Queue\First
  While *Item
    *Selected = *Item\Memory
    
    WriteCharacter(IO_OutputFile, *Selected\SceneX - IO_SceneX)
    WriteCharacter(IO_OutputFile, *Selected\SceneY - IO_SceneY)
    WriteCharacter(IO_OutputFile, *Selected\Layer)
    WriteCharacter(IO_OutputFile, *Selected\X)
    WriteCharacter(IO_OutputFile, *Selected\Y)
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i WriteObjectSelection(*Selection.Selection)
  Protected *Item.QueueItem, *Selected.Selected, *Object.Object
  
  WriteInteger(IO_OutputFile, *Selection\Queue\Count)
  *Item = *Selection\Queue\First
  While *Item
    *Selected = *Item\Memory
    
    *Object = GetField(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\Layer, *Selected\X, *Selected\Y)
    WriteInteger(IO_OutputFile, *Object\Number)
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i WriteLayerlessSelection(*Selection.Selection)
  Protected *Item.QueueItem, *Selected.Selected
  
  WriteInteger(IO_OutputFile, *Selection\Queue\Count)
  *Item = *Selection\Queue\First
  While *Item
    *Selected = *Item\Memory
    
    WriteCharacter(IO_OutputFile, *Selected\SceneX - IO_SceneMap_Left)
    WriteCharacter(IO_OutputFile, *Selected\SceneY - IO_SceneMap_Top)
    WriteCharacter(IO_OutputFile, *Selected\X)
    WriteCharacter(IO_OutputFile, *Selected\Y)
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i ReadSelection(*Selection.Selection = #Null)
  Protected Count.i, *Selected.Selected
  
  If Not *Selection
    *Selection = CreateSelection()
  EndIf
  
  Count = ReadInteger(IO_InputFile)
  While Count
    *Selected = _New(Selected)
    AppendQueueItem(*Selection\Queue, *Selected)
    
    *Selected\SceneX = ReadCharacter(IO_InputFile) + IO_SceneX
    *Selected\SceneY = ReadCharacter(IO_InputFile) + IO_SceneY
    *Selected\Layer  = ReadCharacter(IO_InputFile)
    *Selected\X      = ReadCharacter(IO_InputFile)
    *Selected\Y      = ReadCharacter(IO_InputFile)
    
    Count - 1
  Wend
  
  ProcedureReturn *Selection
EndProcedure
Procedure.i ReadObjectSelection(*Selection.Selection = #Null)
  Protected Count.i, *Selected.SelectedObject_Memory
  
  If Not *Selection
    *Selection = CreateSelection()
  EndIf
  
  Count = ReadInteger(IO_InputFile)
  While Count
    *Selected = _New(SelectedObject_Memory)
    AppendQueueItem(*Selection\Queue, *Selected)
    
    *Selected\Number = ReadInteger(IO_InputFile)
    
    Count - 1
  Wend
  
  ProcedureReturn *Selection
EndProcedure
Procedure.i ReadLayerlessSelection(*Selection.Selection = #Null)
  Protected Count.i, *Selected.Selected
  
  If Not *Selection
    *Selection = CreateSelection()
  EndIf
  
  Count = ReadInteger(IO_InputFile)
  While Count
    *Selected = _New(Selected)
    AppendQueueItem(*Selection\Queue, *Selected)
    
    *Selected\SceneX = ReadCharacter(IO_InputFile) + IO_SceneX
    *Selected\SceneY = ReadCharacter(IO_InputFile) + IO_SceneY
    *Selected\X      = ReadCharacter(IO_InputFile)
    *Selected\Y      = ReadCharacter(IO_InputFile)
    
    *Selected\Layer = #Tile
    
    Count - 1
  Wend
  
  ProcedureReturn *Selection
EndProcedure

Procedure.i InitializeObjectSelection(*Selection.Selection)
  Protected *Item.QueueItem, *Memory.SelectedObject_Memory, *Selected.Selected
  Protected *Object.Object
  
  *Item = *Selection\Queue\First
  While *Item
    *Memory   = *Item\Memory
    *Selected = _New(Selected)
    
    *Object = *IO_SceneObject(*Memory\Number)
    
    *Selected\SceneX = *Object\Scene\X
    *Selected\SceneY = *Object\Scene\Y
    *Selected\Layer  = *Object\Layer
    *Selected\X      = *Object\X
    *Selected\Y      = *Object\Y
    
    _Free(*Memory)
    *Item\Memory = *Selected
    
    _Move(*Item, N)
  Wend
  
  ProcedureReturn *Selection
EndProcedure
Procedure.i CheckSelection(*Selection.Selection)
  Protected *Item.QueueItem, *Selected.Selected, *Scene.Scene
  
  *Item = *Selection\Queue\First
  While *Item
    *Selected = *Item\Memory
    
    *Scene = GetScene(*Selected\SceneX, *Selected\SceneY)
    If *Scene
      Select *Selected\Layer
        Case #BackgroundObject2, #BackgroundObject1, #Object, #ForegroundObject1, #ForegroundObject2
          If Not GetField(*Scene, *Selected\Layer, *Selected\X, *Selected\Y)
            MessageRequester("Warning", "Selection contains a field that requires an object.", #MB_ICONWARNING)
            ProcedureReturn #False
          EndIf
      EndSelect
    Else
      MessageRequester("Warning", "Selection contains a field without a scene.", #MB_ICONWARNING)
      ProcedureReturn #False
    EndIf
    
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #True
EndProcedure

Procedure.i SelectionMode(*Selection.Selection, *Callback, Info.s)
  With Editor
  
  Protected *Tile.Tile, *Object.Object, Mode.i
  Protected Tip.s, Transparency.f, PreviousLayer.i, Field.POINT
  Protected EditorLayer.i
  
  
  If IsWindow(#TEWindow)
    HideWindow(#TEWindow, #True)
    HideWindow(#AEWindow, #True)
  EndIf
  
  
  
  If Not *Selection
    *Selection = CreateSelection()
  EndIf
  Mode = _Call(*Callback, *Selection, #Selection_Mode, #Null)
  
  EditorLayer = \Layer
  Select Mode
    Case #Selection_Mode_None, #Selection_Mode_Walls
      \Layer = #Tile
    Case #Selection_Mode_Tiles
      If \Layer => #BackgroundObject1
        \Layer = #Tile
      EndIf
    Case #Selection_Mode_Objects
      If \Layer < #BackgroundObject1
        \Layer = #ForegroundObject1
      EndIf
  EndSelect
  
  Repeat
    ExamineEvents()
    
    If _Call(*Callback, *Selection, #Selection_Frame, #Null)
      Break
    EndIf
    
    StartSpecialFX()
      DisplayBackground()
      
      Start3D()
        DisplayScene()
        DisplaySelection(*Selection, 160 + Sin(Transparency) * 50)
      Stop3D()
      
      DisplayTilesetBackground()
      
      Start3D()
        DisplayCursor()
        DisplayBar()
      Stop3D()
    StopSpecialFX()
    
    Tip = Tip()
    
    StartDrawing(ScreenOutput())
      DrawTip(Tip)
      DrawComment(Info)
    StopDrawing()
    
    FlipBuffers()
    
    
    Transparency + #PI / 8
    If Transparency => 2 * #PI
      Transparency - 2 * #PI
    EndIf
    
    ExamineScreenGadgets(\Event)
    
    If IsCursorInScene()
      If \LeftClickAllowed And (\Event = #WM_LBUTTONDOWN Or (\Event = #WM_MOUSEMOVE And \wParam & 1))
        If Not GetSelected(*Selection, \OverScene, \Layer, \TileX, \TileY)
          Select Mode
            Case #Selection_Mode_Tiles, #Selection_Mode_Objects, #Selection_Mode_Walls, #Selection_Mode_AllLayers
              If \Layer < #BackgroundObject1
                *Tile = GetTile(\CurrentScene, \Layer, \TileX, \TileY)
                If *Tile And _Call(*Callback, *Selection, #Selection_CheckTile, *Tile)
                  SelectField(*Selection, \OverScene, \Layer, \TileX, \TileY)
                EndIf
              Else
                *Object = GetObject(\CurrentScene, \Layer, \TileX, \TileY)
                If *Object And _Call(*Callback, *Selection, #Selection_CheckObject, *Object)
                  SelectField(*Selection, \OverScene, \Layer, \TileX, \TileY)
                EndIf
              EndIf
            Case #Selection_Mode_None
              Field\x = \TileX
              Field\y = \TileY
              If _Call(*Callback, *Selection, #Selection_CheckField, @Field)
                SelectField(*Selection, \OverScene, \Layer, \TileX, \TileY)
              EndIf
          EndSelect
        EndIf
      ElseIf \LeftClickAllowed And (\Event = #WM_RBUTTONDOWN Or (\Event = #WM_MOUSEMOVE And \wParam & 2))
        Select Mode
          Case #Selection_Mode_Tiles, #Selection_Mode_Objects, #Selection_Mode_Walls, #Selection_Mode_AllLayers
            RemoveSelected(*Selection, \OverScene, \Layer, \TileX, \TileY)
          Case #Selection_Mode_None
            RemoveSelected(*Selection, \OverScene, #Tile, \TileX, \TileY)
        EndSelect
      Else
        ExamineSceneEvents()
      EndIf
    ElseIf IsCursorInBar()
      PreviousLayer = \Layer
      ExamineInterfaceEvents()
      ; berprfen, ob das ausgewhlte Layer fr die Selection erlaubt ist:
      If \Layer <> PreviousLayer
        Select Mode
          Case #Selection_Mode_None
            \Layer = #Tile
          Case #Selection_Mode_Tiles
            If \Layer => #BackgroundObject1
              \Layer = PreviousLayer
            EndIf
          Case #Selection_Mode_Objects
            If \Layer < #BackgroundObject1
              \Layer = PreviousLayer
            EndIf
          Case #Selection_Mode_Walls
            \Layer = #Tile
        EndSelect
      EndIf
    EndIf
    
    If \Event = #WM_LBUTTONUP
      \LeftClickAllowed = #True
    EndIf
    
    If \Event = #WM_KEYDOWN
      If KeyPressedDown(#VK_LEFT) And \SceneX > 0
        ChangeScene(\OverSceneX - 1, \OverSceneY, #True)
      ElseIf KeyPressedDown(#VK_RIGHT) And \SceneX < #SceneMap_Width - 1
        ChangeScene(\OverSceneX + 1, \OverSceneY, #True)
      ElseIf KeyPressedDown(#VK_UP) And \SceneY > 0
        ChangeScene(\OverSceneX, \OverSceneY - 1, #True)
      ElseIf KeyPressedDown(#VK_DOWN) And \SceneY < #SceneMap_Height - 1
        ChangeScene(\OverSceneX, \OverSceneY + 1, #True)
      EndIf
    EndIf
    
    OptimizeFPS()
  Until KeyPressedDown(#VK_RETURN) Or KeyPressedDown(#VK_ESCAPE)
  
  \Layer = EditorLayer
  
  GetSelectionBorders(*Selection)
  ProcedureReturn *Selection
  
  EndWith
EndProcedure

Procedure.i Selection_Callback_AllLayers(*Selection.Selection, Event.i, *Parameter)
  Select Event
    Case #Selection_Mode
      ProcedureReturn #Selection_Mode_AllLayers
    Case #Selection_CheckTile, #Selection_CheckObject
      ProcedureReturn #True
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i Selection_Callback_None(*Selection.Selection, Event.i, *Parameter)
  Select Event
    Case #Selection_Mode
      ProcedureReturn #Selection_Mode_None
    Case #Selection_CheckField
      ProcedureReturn #True
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i Selection_Callback_Objects(*Selection.Selection, Event.i, *Parameter)
  Select Event
    Case #Selection_Mode
      ProcedureReturn #Selection_Mode_Objects
    Case #Selection_CheckObject
      ProcedureReturn #True
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i Selection_Callback_SingleObject(*Selection.Selection, Event.i, *Parameter)
  Select Event
    Case #Selection_Mode
      ProcedureReturn #Selection_Mode_Objects
    Case #Selection_CheckObject
      ClearQueue(*Selection\Queue)
      ProcedureReturn #True
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i Selection_Callback_SingleField(*Selection.Selection, Event.i, *Parameter)
  Select Event
    Case #Selection_Mode
      ProcedureReturn #Selection_Mode_None
    Case #Selection_CheckField
      ClearQueue(*Selection\Queue)
      ProcedureReturn #True
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i Selection_Callback_SameObjects(*Selection.Selection, Event.i, *Parameter)
  Static *Item.QueueItem, *Object.Object, *SelectedObject.Object
  Static *Scene.Scene, DX.i, DY.i
  
  Select Event
    Case #Selection_Mode
      ProcedureReturn #Selection_Mode_Objects
    Case #Selection_CheckObject
      *Object = *Parameter
      *Item   = *Selection\Queue\First
      While *Item
        *SelectedObject = GetSelectedField(*Item\Memory)
        If *SelectedObject And *SelectedObject\Registered <> *Object\Registered
          MessageRequester("Warning", "Only objects of the equal type are allowed!", #MB_ICONWARNING)
          ProcedureReturn #False
        EndIf
        _Move(*Item, N)
      Wend
      
      ProcedureReturn #True
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 356
; FirstLine = 28
; Folding = AgAB9
; EnableXP