;**************************************************************
;     Toolbars
;**************************************************************
;   Copyright (c) 2010 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



#ToolbarHeight = 350
#ToolbarWidth  = 180


Procedure.i OpenTilesetToolbar()
  Protected Event.i, Window.i, Gadget.i, Type.i
  Protected ToolbarWindow.i, ToolbarList.i
  Protected *Item.QueueItem, *Tileset.TilesetEntry, Index.i
  
  ToolbarWindow = OpenWindow(#PB_Any, 0, Screen\Height / 2 - #ToolbarHeight / 2, #ToolbarWidth, #ToolbarHeight, "Tilesets", #PB_Window_Tool, WindowID(#ScreenWindow))
    ToolbarList = ListViewGadget(#PB_Any, 2, 2, #ToolbarWidth - 4, #ToolbarHeight - 4)
  
  ; Alle Tilesets eintragen:
  *Item = *Tilesets\First
  While *Item
    *Tileset = *Item\Memory
    
    If *Tileset\Registered
      AddGadgetItem(ToolbarList, -1, *Tileset\Entry\Name)
      SetGadgetItemData(ToolbarList, CountGadgetItems(ToolbarList) - 1, *Tileset)
      If Editor\CurrentTile And Editor\CurrentTile\Tileset\Entry = *Tileset
        ; Aktuelles Tileset des Editors in der Liste auswhlen:
        SetGadgetState(ToolbarList, CountGadgetItems(ToolbarList) - 1)
      EndIf
    EndIf
    
    _Move(*Item, N)
  Wend
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Gadget = EventGadget()
    Type   = EventType()
    
    If Window = ToolbarWindow
      Select Event
        Case #PB_Event_Gadget
          If Gadget = ToolbarList
            If Type = #PB_EventType_LeftClick
              Index = GetGadgetState(ToolbarList)
              If Index <> #None
                *Tileset = GetGadgetItemData(ToolbarList, Index)
                SelectTile(*Tileset\Registered, 0, 0)
                RenderEditor()
              EndIf
            ElseIf Type = #PB_EventType_LeftDoubleClick
              Index = GetGadgetState(ToolbarList)
              If Index <> #None
                *Tileset = GetGadgetItemData(ToolbarList, Index)
                SelectTile(*Tileset\Registered, 0, 0)
                Editor\LeftClickAllowed = #False
                Break
              EndIf
            EndIf
          EndIf
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    ElseIf Window = #ScreenWindow And Event = #WM_MOUSEMOVE
      Break
    EndIf
  ForEver
  
  CloseWindow(ToolbarWindow)
  ProcedureReturn #True
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 70
; FirstLine = 45
; Folding = -
; EnableXP