IncludeFile "..\Import.pbi"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Display")
        GM_File("Message")
        GM_File("BFadeIn")
        GM_File("WFadeIn")
        GM_File("FadeOff")
        GM_End()
      GM_Folder("Camera")
        GM_File("CamPlayer")
        GM_File("CamField")
        GM_File("CamObject")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



ProcedureDLL.i Effect_CamPlayer(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_CameraFollowPlayer()
    Case #GM_Effect_Name
      ProcedureReturn @"Follow Player (default)"
    Case #GM_Effect_Text
      ProcedureReturn @"Camera follows player"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_CamField(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_CameraSetOnField(GM_SelectedX(*Effect\Memory, 0), GM_SelectedY(*Effect\Memory, 0))
    
    Case #GM_Effect_Initialize
      GM_InitializeSelection(*Effect\Memory)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadSelection()
      
    Case #GM_Effect_EditorInitialize
      *EditorEffect = *Parameter
      If Not *EditorEffect\Memory
        *EditorEffect\Memory = GM_CreateSelection()
      EndIf
    Case #GM_Effect_EditorLoad
      *EditorEffect = *Parameter
      *EditorEffect\Memory = GM_LoadSelection()
    Case #GM_Effect_EditorSave
      *EditorEffect = *Parameter
      GM_SaveSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorDelete
      *EditorEffect = *Parameter
      GM_FreeSelection(*EditorEffect\Memory)
      
    Case #GM_Effect_Edit
      *EditorEffect = *Parameter
      Repeat
        GM_SelectField(*EditorEffect\Memory, "Select target field")
        If GM_SelectionSize(*EditorEffect\Memory) = 0
          MessageRequester("Warning", "You must select a target field!", #MB_ICONWARNING)
        Else
          Break
        EndIf
      ForEver
    Case #GM_Effect_Name
      ProcedureReturn @"Set on Field"
    Case #GM_Effect_Text
      ProcedureReturn @"Set camera on field"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_CamObject(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_CameraFollowObject(GM_SelectedObject(*Effect\Memory, 0))
    
    Case #GM_Effect_Initialize
      GM_InitializeObjectSelection(*Effect\Memory)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadObjectSelection()
      
    Case #GM_Effect_EditorInitialize
      *EditorEffect = *Parameter
      If Not *EditorEffect\Memory
        *EditorEffect\Memory = GM_CreateSelection()
      Else
        GM_InitializeObjectSelection(*EditorEffect\Memory)
      EndIf
    Case #GM_Effect_EditorLoad
      *EditorEffect = *Parameter
      *EditorEffect\Memory = GM_LoadObjectSelection()
    Case #GM_Effect_EditorSave
      *EditorEffect = *Parameter
      GM_SaveObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorDelete
      *EditorEffect = *Parameter
      GM_FreeSelection(*EditorEffect\Memory)
      
    Case #GM_Effect_Edit
      *EditorEffect = *Parameter
      Repeat
        GM_SelectSingleObject(*EditorEffect\Memory, "Select target object")
        If GM_SelectionSize(*EditorEffect\Memory) = 0
          MessageRequester("Warning", "You must select a target object!", #MB_ICONWARNING)
        Else
          Break
        EndIf
      ForEver
    Case #GM_Effect_Name
      ProcedureReturn @"Follow Object"
    Case #GM_Effect_Text
      ProcedureReturn @"Camera follows object"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

Structure Message
  Text.s
EndStructure
ProcedureDLL.i Effect_Message(*Effect.GM_Effect, Event.i, *Parameter)
  Static *Memory.Message
  
  If *Effect
    *Memory = *Effect\Memory
  Else
    *EditorEffect = *Parameter
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      If Not GM_IsReplay()
        ; Nachricht nur zeigen, wenn kein Replay gespielt wird:
        GM_ShowMessage("Message", *Memory\Text)
      EndIf
    Case #GM_Effect_Load
      *Memory        = AllocateMemory(SizeOf(Message))
      *Effect\Memory = *Memory
      
      *Memory\Text = GM_LoadText()
      
    Case #GM_Effect_EditorInitialize
      If Not *EditorEffect\Memory
        *EditorEffect\Memory = AllocateMemory(SizeOf(Message))
      EndIf
    Case #GM_Effect_EditorSave
      *Memory = *EditorEffect\Memory
      GM_SaveText(*Memory\Text)
    Case #GM_Effect_EditorLoad
      *Memory              = AllocateMemory(SizeOf(Message))
      *EditorEffect\Memory = *Memory
      
      *Memory\Text = GM_LoadText()
      
    Case #GM_Effect_Edit
      *Memory = *EditorEffect\Memory
      *Memory\Text = GM_EditMessage("Message", *Memory\Text)
    Case #GM_Effect_Name
      ProcedureReturn @"Message"
    Case #GM_Effect_Text
      *Memory = *EditorEffect\Memory
      If Len(*Memory\Text) > 20
        ReturnString("Show message: " + Chr(34) + Left(*Memory\Text, 20) + "..." + Chr(34))
      Else
        ReturnString("Show message: " + Chr(34) + *Memory\Text + Chr(34))
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Effect_BFadeIn(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_FadeIn(#Black)
    Case #GM_Effect_Name
      ProcedureReturn @"Fade in (black)"
    Case #GM_Effect_Text
      ProcedureReturn @"Fade in (black)"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_WFadeIn(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_FadeIn(#White)
    Case #GM_Effect_Name
      ProcedureReturn @"Fade in (white)"
    Case #GM_Effect_Text
      ProcedureReturn @"Fade in (white)"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_FadeOff(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_FadeOff()
    Case #GM_Effect_Name
      ProcedureReturn @"Fade off"
    Case #GM_Effect_Text
      ProcedureReturn @"Fade off"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 107
; FirstLine = 78
; Folding = N5
; EnableXP