IncludeFile "..\Import.pbi"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Generic")
        GM_File("Wait")
        GM_File("QuitGame")
        GM_End()
      GM_Folder("Act")
        GM_File("ChangeAct")
        GM_File("AddParallelAct")
        GM_File("FinishAct")
        GM_File("FinishThisAct")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



ProcedureDLL.i Effect_Wait(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_StopEvent(*Effect\Event, *Effect\Memory)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadInteger()
      
    Case #GM_Effect_EditorSave
      *EditorEffect = *Parameter
      GM_SaveInteger(*EditorEffect\Memory)
    Case #GM_Effect_EditorLoad
      *EditorEffect = *Parameter
      *EditorEffect\Memory = GM_LoadInteger()
    Case #GM_Effect_Edit
      *EditorEffect = *Parameter
      *EditorEffect\Memory = GM_EditInteger("Wait", "Frames to wait:", *EditorEffect\Memory, 1, 1000000)
      
    Case #GM_Effect_Name
      ProcedureReturn @"Wait"
    Case #GM_Effect_Text
      *EditorEffect = *Parameter
      ReturnString("Wait " + Form(*EditorEffect\Memory, "frame", "frames"))
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_QuitGame(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_Quit()
    Case #GM_Effect_Name
      ProcedureReturn @"Quit Game"
    Case #GM_Effect_Text
      ProcedureReturn @"Quit game"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Effect_ChangeAct(*Effect.GM_Effect, Event.i, *Parameter)
  Static *Memory, *Act
  
  If *Effect
    *Memory = *Effect\Memory
  Else
    *EditorEffect = *Parameter
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      GM_ChangeAct(*Memory)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadActNumber()
    Case #GM_Effect_Initialize
      *Effect\Memory = GM_GetActByNumber(*Memory)
      
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_LoadActNumber()
    Case #GM_Effect_EditorSave
      If *EditorEffect\Memory
        GM_SaveActNumber(*EditorEffect\Memory)
      Else
        MessageRequester("Warning", "No act selected for an effect.", #MB_ICONWARNING)
      EndIf
    Case #GM_Effect_EditorInitialize
      If *EditorEffect\Memory
        *EditorEffect\Memory = GM_GetActByNumber(*EditorEffect\Memory)
        GM_UseAct(*EditorEffect\Memory)
      EndIf
    Case #GM_Effect_EditorDelete
      If *EditorEffect\Memory
        GM_ReleaseAct(*EditorEffect\Memory)
      EndIf
    
    Case #GM_Effect_Edit
      *Act = GM_SelectAct("Change Act", "Act to change:", *EditorEffect\Memory, #False, #True)
      If *EditorEffect\Memory <> *Act
        If *EditorEffect\Memory
          GM_ReleaseAct(*EditorEffect\Memory)
        EndIf
        If *Act
          GM_UseAct(*Act)
        EndIf
        *EditorEffect\Memory = *Act
      EndIf
    Case #GM_Effect_Name
      ProcedureReturn @"Change Act"
    Case #GM_Effect_Text
      If *EditorEffect\Memory
        ReturnString("Change act: " + Chr(34) + GM_ActName(*EditorEffect\Memory) + Chr(34))
      Else
        ReturnString("Change act: NOT SELECTED!")
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_AddParallelAct(*Effect.GM_Effect, Event.i, *Parameter)
  Static *Memory, *Act
  
  If *Effect
    *Memory = *Effect\Memory
  Else
    *EditorEffect = *Parameter
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      GM_AddParallelAct(*Memory)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadActNumber()
    Case #GM_Effect_Initialize
      *Effect\Memory = GM_GetActByNumber(*Memory)
      
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_LoadActNumber()
    Case #GM_Effect_EditorSave
      If *EditorEffect\Memory
        GM_SaveActNumber(*EditorEffect\Memory)
      Else
        MessageRequester("Warning", "No act selected for an effect.", #MB_ICONWARNING)
      EndIf
    Case #GM_Effect_EditorInitialize
      If *EditorEffect\Memory
        *EditorEffect\Memory = GM_GetActByNumber(*EditorEffect\Memory)
        GM_UseAct(*EditorEffect\Memory)
      EndIf
    Case #GM_Effect_EditorDelete
      If *Memory
        GM_ReleaseAct(*EditorEffect\Memory)
      EndIf
    
    Case #GM_Effect_Edit
      *Act = GM_SelectAct("Add Parallel Act", "Parallel act to add:", *EditorEffect\Memory, #False, #True)
      If *EditorEffect\Memory <> *Act
        If *EditorEffect\Memory
          GM_ReleaseAct(*EditorEffect\Memory)
        EndIf
        If *Act
          GM_UseAct(*Act)
        EndIf
        *EditorEffect\Memory = *Act
      EndIf
    Case #GM_Effect_Name
      ProcedureReturn @"Add Parallel Act"
    Case #GM_Effect_Text
      If *EditorEffect\Memory
        ReturnString("Add parallel act: " + Chr(34) + GM_ActName(*EditorEffect\Memory) + Chr(34))
      Else
        ReturnString("Add parallel act: NOT SELECTED!")
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_FinishAct(*Effect.GM_Effect, Event.i, *Parameter)
  Static *Memory, *Act
  
  If *Effect
    *Memory = *Effect\Memory
  Else
    *EditorEffect = *Parameter
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      GM_RemoveParallelAct(*Memory)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadActNumber()
    Case #GM_Effect_Initialize
      *Effect\Memory = GM_GetActByNumber(*Memory)
      
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_LoadActNumber()
    Case #GM_Effect_EditorSave
      If *EditorEffect\Memory
        GM_SaveActNumber(*EditorEffect\Memory)
      Else
        MessageRequester("Warning", "No act selected for an effect.", #MB_ICONWARNING)
      EndIf
    Case #GM_Effect_EditorInitialize
      If *EditorEffect\Memory
        *EditorEffect\Memory = GM_GetActByNumber(*EditorEffect\Memory)
        GM_UseAct(*EditorEffect\Memory)
      EndIf
    Case #GM_Effect_EditorDelete
      If *EditorEffect\Memory
        GM_ReleaseAct(*EditorEffect\Memory)
      EndIf
    
    Case #GM_Effect_Edit
      *Act = GM_SelectAct("Finish Act", "Act to finish:", *EditorEffect\Memory, #False, #True)
      If *EditorEffect\Memory <> *Act
        If *EditorEffect\Memory
          GM_ReleaseAct(*EditorEffect\Memory)
        EndIf
        If *Act
          GM_UseAct(*Act)
        EndIf
        *EditorEffect\Memory = *Act
      EndIf
    Case #GM_Effect_Name
      ProcedureReturn @"Finish Act"
    Case #GM_Effect_Text
      If *EditorEffect\Memory
        ReturnString("Finish act: " + Chr(34) + GM_ActName(*EditorEffect\Memory) + Chr(34))
      Else
        ReturnString("Finish act: NOT SELECTED!")
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_FinishThisAct(*Effect.GM_Effect, Event.i, *Parameter)
  Static *Memory, *Act
  
  If *Effect
    *Memory = *Effect\Memory
  Else
    *EditorEffect = *Parameter
    If *EditorEffect
      *Memory = *EditorEffect\Memory
    EndIf
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      GM_RemoveParallelAct(*Memory)
    Case #GM_Effect_Initialize
      *Effect\Memory = GM_EffectAct(*Effect)
    
    Case #GM_Effect_Name
      ProcedureReturn @"Finish This Act"
    Case #GM_Effect_Text
      String = "Finish this act"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 28
; FirstLine = 17
; Folding = H+
; EnableXP