IncludeFile "..\Import.pbi"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Object")
        GM_File("Hide")
        GM_File("HideF")
        GM_File("Unhide")
        GM_File("UnhideF")
        GM_File("Action")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



Procedure.i Effect_UnhideObjects(*Object.GM_Object, Index.i, *Parameter)
  If GM_HideObject(*Object, #False) And *Object\Scene = *GM_Player\Scene
    GM_EmitTinyFlash(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
  EndIf
EndProcedure
Procedure.i Effect_HideObjects(*Object.GM_Object, Index.i, *Parameter)
  If GM_HideObject(*Object, #True) And *Object\Scene = *GM_Player\Scene
    GM_EmitTinyFlash(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
  EndIf
EndProcedure

ProcedureDLL.i Effect_Hide(*Effect.GM_Effect, Event.i, *Parameter)
  If Not *Effect
    *EditorEffect = *Parameter
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      GM_HideSelectedObjects(*Effect\Memory, #True)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadObjectSelection()
    Case #GM_Effect_Initialize
      GM_InitializeObjectSelection(*Effect\Memory)
      
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_CreateSelection()
      GM_LoadObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorSave
      GM_SaveObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorInitialize
      If *EditorEffect\Memory
        GM_InitializeObjectSelection(*EditorEffect\Memory)
      Else
        *EditorEffect\Memory = GM_CreateSelection()
      EndIf
    Case #GM_Effect_EditorDelete
      GM_FreeSelection(*EditorEffect\Memory)
    Case #GM_Effect_Edit
      GM_SelectObjects(*EditorEffect\Memory)
      
    Case #GM_Effect_Name
      ProcedureReturn @"Hide"
    Case #GM_Effect_Text
      ProcedureReturn @"Hide objects"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_HideF(*Effect.GM_Effect, Event.i, *Parameter)
  If Not *Effect
    *EditorEffect = *Parameter
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      GM_HideSelectedObjects(*Effect\Memory, #True)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadObjectSelection()
    Case #GM_Effect_Initialize
      GM_InitializeObjectSelection(*Effect\Memory)
      
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_CreateSelection()
      GM_LoadObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorSave
      GM_SaveObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorInitialize
      If *EditorEffect\Memory
        GM_InitializeObjectSelection(*EditorEffect\Memory)
      Else
        *EditorEffect\Memory = GM_CreateSelection()
      EndIf
    Case #GM_Effect_EditorDelete
      GM_FreeSelection(*EditorEffect\Memory)
    Case #GM_Effect_Edit
      GM_SelectObjects(*EditorEffect\Memory)
      
    Case #GM_Effect_Name
      ProcedureReturn @"Hide (with flashes)"
    Case #GM_Effect_Text
      ProcedureReturn @"Hide objects (with flashes)"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_Unhide(*Effect.GM_Effect, Event.i, *Parameter)
  If Not *Effect
    *EditorEffect = *Parameter
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      GM_HideSelectedObjects(*Effect\Memory, #False)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadObjectSelection()
    Case #GM_Effect_Initialize
      GM_InitializeObjectSelection(*Effect\Memory)
      
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_CreateSelection()
      GM_LoadObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorSave
      GM_SaveObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorInitialize
      If *EditorEffect\Memory
        GM_InitializeObjectSelection(*EditorEffect\Memory)
      Else
        *EditorEffect\Memory = GM_CreateSelection()
      EndIf
    Case #GM_Effect_EditorDelete
      GM_FreeSelection(*EditorEffect\Memory)
    Case #GM_Effect_Edit
      GM_SelectObjects(*EditorEffect\Memory)
      
    Case #GM_Effect_Name
      ProcedureReturn @"Unhide"
    Case #GM_Effect_Text
      ProcedureReturn @"Unhide objects"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Effect_UnhideF(*Effect.GM_Effect, Event.i, *Parameter)
  If Not *Effect
    *EditorEffect = *Parameter
  EndIf
  
  Select Event
    Case #GM_Effect_Call
      GM_ForEachSelectedObject(*Effect\Memory, @Effect_UnhideObjects())
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadObjectSelection()
    Case #GM_Effect_Initialize
      GM_InitializeObjectSelection(*Effect\Memory)
      
    Case #GM_Effect_EditorLoad
      *EditorEffect\Memory = GM_CreateSelection()
      GM_LoadObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorSave
      GM_SaveObjectSelection(*EditorEffect\Memory)
    Case #GM_Effect_EditorInitialize
      If *EditorEffect\Memory
        GM_InitializeObjectSelection(*EditorEffect\Memory)
      Else
        *EditorEffect\Memory = GM_CreateSelection()
      EndIf
    Case #GM_Effect_EditorDelete
      GM_FreeSelection(*EditorEffect\Memory)
    Case #GM_Effect_Edit
      GM_SelectObjects(*EditorEffect\Memory)
      
    Case #GM_Effect_Name
      ProcedureReturn @"Unhide (with flashes)"
    Case #GM_Effect_Text
      ProcedureReturn @"Unhide objects (with flashes)"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Effect_Action(*Effect.GM_Effect, Event.i, *Parameter)
  Select Event
    Case #GM_Effect_Call
      GM_CallObjectAction(*Effect\Memory)
    Case #GM_Effect_Load
      *Effect\Memory = GM_LoadObjectAction()
    Case #GM_Effect_Initialize
      GM_InitializeObjectAction(*Effect\Memory)
    
    Case #GM_Effect_EditorLoad
      *EditorEffect = *Parameter
      *EditorEffect\Memory = GM_LoadObjectAction()
    Case #GM_Effect_EditorSave
      *EditorEffect = *Parameter
      GM_SaveObjectAction(*EditorEffect\Memory)
    Case #GM_Effect_EditorInitialize
      *EditorEffect = *Parameter
      If *EditorEffect\Memory
        GM_InitializeObjectAction(*EditorEffect\Memory)
      Else
        *EditorEffect\Memory = GM_CreateObjectAction()
      EndIf
    Case #GM_Effect_EditorDelete
      *EditorEffect = *Parameter
      GM_FreeObjectAction(*EditorEffect\Memory)
    Case #GM_Effect_Edit
      *EditorEffect = *Parameter
      GM_EditObjectAction(*EditorEffect\Memory)
    
    Case #GM_Effect_Name
      ProcedureReturn @"Call Action"
    Case #GM_Effect_Text
      *EditorEffect = *Parameter
      If GM_ObjectActionID(*EditorEffect\Memory) <> -1
        ReturnString("Call object action: " + Chr(34) + GM_ObjectActionName(*EditorEffect\Memory) + Chr(34))
      Else
        ReturnString("Call object action")
      EndIf
    Case #GM_Effect_Description
      ProcedureReturn @"Calls a specified action of selected objects."
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 21
; FirstLine = 11
; Folding = D+
; EnableXP