Procedure.i CreateEntryFile(Name.s, *Memory, *Parent.Entry = #Null)
  Protected *Entry.Entry
  
  *Entry = _New(Entry)
  If *Parent
    *Entry\Parent = *Parent
    *Entry\Item   = AppendQueueItem(*Parent\Entries, *Entry)
  EndIf
  
  *Entry\Type = #Entry_File
  *Entry\Name = Name
  
  *Entry\Memory = *Memory
  
  ProcedureReturn *Entry
EndProcedure
Procedure.i CreateEntryFolder(Name.s, *Parent.Entry = #Null)
  Protected *Entry.Entry
  
  *Entry = _New(Entry)
  If *Parent
    *Entry\Parent = *Parent
    *Entry\Item   = AppendQueueItem(*Parent\Entries, *Entry)
  EndIf
  
  *Entry\Type = #Entry_Folder
  *Entry\Name = Name
  
  *Entry\Entries = CreateQueue(@FreeEntry())
  
  ProcedureReturn *Entry
EndProcedure
Procedure.i FreeEntry(*Entry.Entry)
  ClearStructure(*Entry, Entry)
  
  If *Entry\Type = #Entry_Folder
    FreeQueue(*Entry\Entries)
  EndIf
  
  _Free(*Entry)
  ProcedureReturn #True
EndProcedure
Procedure.i RemoveEntry(*Entry.Entry)
  If *Entry\Parent
    ProcedureReturn FreeQueueItem(*Entry\Parent\Entries, *Entry\Item)
  Else
    ProcedureReturn FreeEntry(*Entry)
  EndIf
EndProcedure

Procedure.s EntryPath(*Entry.Entry)
  Protected Path.s
  
  Repeat
    If *Entry\Type = #Entry_Folder
      Path = *Entry\Name + "\" + Path
    Else
      Path = *Entry\Name + Path
    EndIf
    If *Entry\Parent
      _Move(*Entry, Parent)
    Else
      Break
    EndIf
  ForEver
  
  ProcedureReturn Path
EndProcedure

Procedure.i GetEntry(*Parent.Entry, Name.s)
  Protected *Entry.Entry, *Item.QueueItem
  
  *Item = *Parent\Entries\First
  While *Item
    *Entry = *Item\Memory
    
    If *Entry\Name = Name
      ProcedureReturn *Entry
    EndIf
    
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #Null
EndProcedure
Procedure.i GetEntryByPath(*Parent.Entry, Path.s)
  Protected Name.s, *Char.Character, *Start.Character
  
  *Char  = @Path
  *Start = @Path
  
  Repeat
    If *Char\c = '\' Or *Char\c = 0
      Name    = PeekS(*Start, *Char - *Start)
      *Parent = GetEntry(*Parent, Name)
      
      If Not *Parent Or *Char\c = 0
        Break
      Else
        *Start = *Char + _Sz(Character)
      EndIf
    EndIf
    *Char + _Sz(Character)
  ForEver
  
  ProcedureReturn *Parent
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 31
; FirstLine = 9
; Folding = --
; EnableXP