IncludeFile "..\Import.pbi"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Generic")
        GM_File("Start")
        GM_File("LostLive")
        GM_File("GameOver")
        GM_File("ScoreAdded")
        GM_File("Timer")
        GM_File("Trigger")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



ProcedureDLL.i Event_Start(*Event.GM_Event, Event.i, *Parameter)
  Select Event
    Case #GM_Event_Name
      ProcedureReturn @"Start"
    Case #GM_Event_Text
      ProcedureReturn @"Start"
    Case #GM_Event_Description
      String = "It's effects will be called at the beginning of the game."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Event_LostLive(*Event.GM_Event, Event.i, *Parameter)
  Select Event
    Case #GM_Event_Name
      ProcedureReturn @"Lost Live"
    Case #GM_Event_Text
      ProcedureReturn @"Lost live"
    Case #GM_Event_Description
      String = "If you lose a life."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Event_GameOver(*Event.GM_Event, Event.i, *Parameter)
  Select Event
    Case #GM_Event_Name
      ProcedureReturn @"Game Over"
    Case #GM_Event_Text
      ProcedureReturn @"Gamer Over"
    Case #GM_Event_Description
      String = "If the player lost all his lives."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Event_ScoreAdded(*Event.GM_Event, Event.i, *Parameter)
  Select Event
    Case #GM_Event_Name
      ProcedureReturn @"Score Added"
    Case #GM_Event_Text
      ProcedureReturn @"Score added"
    Case #GM_Event_Description
      String = "If you get more score."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Event_Timer(*Event.GM_Event, Event.i, *Parameter)
  *EditorEvent = *Parameter
  
  Select Event
    Case #GM_Event_Triggered
      If *Event\Memory <= 0
        ProcedureReturn #True
      Else
        *Event\Memory - 1
      EndIf
    Case #GM_Event_Load
      *Event\Memory = GM_LoadInteger()
      
    Case #GM_Event_EditorSave
      GM_SaveInteger(*EditorEvent\Memory)
    Case #GM_Event_EditorLoad
      *EditorEvent\Memory = GM_LoadInteger()
      
    Case #GM_Event_Edit
      *EditorEvent\Memory = GM_EditInteger("Timer", "Frames to be ellapsed (ca. 60 frames = 1 second):", *EditorEvent\Memory, 1, 100000000)
    Case #GM_Event_Name
      ProcedureReturn @"Timer"
    Case #GM_Event_Text
      String = Form(*EditorEvent\Memory, "frame", "frames") + " ellapsed"
      ProcedureReturn @String
    Case #GM_Event_Description
      String = "A specified time ellapsed."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

Structure Trigger
  *Selection
EndStructure
ProcedureDLL.i Event_Trigger(*Event.GM_Event, Event.i, *Parameter)
  Static *Memory.Trigger
  
  If *Event
    *Memory = *Event\Memory
  Else
    *EditorEvent = *Parameter
  EndIf
  
  Select Event
    Case #GM_Event_Triggered
      If GM_IsPlayerInSelection(*Memory\Selection)
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Event_Load
      *Memory = AllocateMemory(SizeOf(Trigger))
      *Event\Memory = *Memory
      *Memory\Selection = GM_LoadSelection()
    Case #GM_Event_Initialize
       GM_InitializeSelection(*Memory\Selection)
       
    Case #GM_Event_EditorSave
      *Memory = *EditorEvent\Memory
      GM_SaveSelection(*Memory\Selection)
    Case #GM_Event_EditorLoad
      *Memory              = AllocateMemory(SizeOf(Trigger))
      *EditorEvent\Memory = *Memory
      
      *Memory\Selection = GM_CreateSelection()
      GM_LoadSelection(*Memory\Selection)
    Case #GM_Event_EditorInitialize
      If Not *EditorEvent\Memory
        *Memory              = AllocateMemory(SizeOf(Trigger))
        *EditorEvent\Memory = *Memory
        
        *Memory\Selection = GM_CreateSelection()
      EndIf
    Case #GM_Event_EditorDelete
      *Memory = *EditorEvent\Memory
      GM_FreeSelection(*Memory\Selection)
       
    Case #GM_Event_Edit
      *Memory = *EditorEvent\Memory
      GM_EditSelection(*Memory\Selection, "Select trigger zone")
    Case #GM_Event_Name
      ProcedureReturn @"Trigger"
    Case #GM_Event_Text
      ProcedureReturn @"Player in a trigger zone"
    Case #GM_Event_Description
      String = "The player entered specified fields."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 142
; FirstLine = 119
; Folding = --
; EnableXP