IncludeFile "..\Import.pbi"



EnableExplicit



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Object")
        GM_File("Destroyed")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



Structure DestroyedMemory
  *Selection
EndStructure

Global Destroyed_AreAllDestroyed.i

Procedure.i Destroyed_CheckObjects(*Object.GM_Object, Index.i, *Parameter)
  If Not GM_IsObjectDestroyed(*Object)
    Destroyed_AreAllDestroyed = #False
  EndIf
EndProcedure

ProcedureDLL.i Event_Destroyed(*Event.GM_Event, Event.i, *Parameter)
  Static *Memory.DestroyedMemory
  
  If *Event
    *Memory = *Event\Memory
  Else
    *EditorEvent = *Parameter
  EndIf
  
  Select Event
    Case #GM_Event_Triggered
      Destroyed_AreAllDestroyed = #True
      GM_ForEachSelectedObject(*Memory\Selection, @Destroyed_CheckObjects())
      ProcedureReturn Destroyed_AreAllDestroyed
    Case #GM_Event_Initialize
      GM_InitializeObjectSelection(*Memory\Selection)
    Case #GM_Event_Load
      *Memory        = AllocateMemory(SizeOf(DestroyedMemory))
      *Event\Memory = *Memory
      
      *Memory\Selection = GM_LoadObjectSelection()
    
    Case #GM_Event_EditorSave
      *Memory = *EditorEvent\Memory
      GM_SaveObjectSelection(*Memory\Selection)
    Case #GM_Event_EditorLoad
      *Memory              = AllocateMemory(SizeOf(DestroyedMemory))
      *EditorEvent\Memory = *Memory
      
      *Memory\Selection = GM_CreateSelection()
      GM_LoadObjectSelection(*Memory\Selection)
    Case #GM_Event_EditorInitialize
      If Not *EditorEvent\Memory
        *Memory              = AllocateMemory(SizeOf(DestroyedMemory))
        *EditorEvent\Memory = *Memory
        
        *Memory\Selection = GM_CreateSelection()
      Else
        *Memory = *EditorEvent\Memory
        
        GM_InitializeObjectSelection(*Memory\Selection)
      EndIf
    Case #GM_Event_Edit
      *Memory = *EditorEvent\Memory
      GM_SelectObjects(*Memory\Selection, "Select objects to destroy")
    Case #GM_Event_EditorDelete
      *Memory = *EditorEvent\Memory
      GM_FreeSelection(*Memory\Selection)
      
    Case #GM_Event_Name
      ProcedureReturn @"Destroyed"
    Case #GM_Event_Text
      ProcedureReturn @"Objects destroyed"
    Case #GM_Event_Description
      String = "Will call it's effects, if all selected objects are destroyed/collected."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 63
; FirstLine = 39
; Folding = -
; EnableXP