;START:
ProcedureDLL.i GM_FieldCollision(*Object.Object, DX.f, DY.f, DeltaX.i, DeltaY.i, IncludeGrounds.i = #True)
  CompilerIf #Mode = #Mode_Game
  
  Protected *OtherObject.Object, X.i, Y.i, Collision.i, FieldX.i, FieldY.i
  
  FieldX = ((*Object\X - DX) - (#FieldSize - *Object\Width)/2)  / #FieldSize
  FieldY = ((*Object\Y - DY) - (#FieldSize - *Object\Height)/2) / #FieldSize
  
  X = FieldX + DeltaX
  Y = FieldY + DeltaY
  
  If X => 0 And X < *Object\Scene\Width * #SceneWidth And Y => 0 And Y < *Object\Scene\Height * #SceneHeight
    If IncludeGrounds And GetGround(X, Y)
      Collision = Collision(*Object\X, *Object\Y, *Object\Width, *Object\Height, DX, DY, X * #FieldSize, Y * #FieldSize, #FieldSize, #FieldSize)
      If Collision
        Select Collision
          Case #Collision_Top
            If DY => 0 And (*Object\Y - DY + *Object\Height <= Y*#FieldSize)
              *Object\Y = Y * #FieldSize - *Object\Height
            Else
              ProcedureReturn #False
            EndIf
          Default
            ProcedureReturn #False
        EndSelect
      EndIf
    ElseIf GetWall(X, Y)
      Collision = Collision(*Object\X, *Object\Y, *Object\Width, *Object\Height, DX, DY, X * #FieldSize, Y * #FieldSize, #FieldSize, #FieldSize)
      If Collision
        Select Collision
          Case #Collision_Left
            *Object\X = (FieldX + 1) * #FieldSize - *Object\Width
          Case #Collision_Right
            *Object\X = FieldX * #FieldSize
          Case #Collision_Bottom
            *Object\Y = FieldY * #FieldSize
          Case #Collision_Top
            *Object\Y = (FieldY + 1) * #FieldSize - *Object\Height
        EndSelect
      EndIf
    EndIf
    
    ProcedureReturn Collision
  Else
    ProcedureReturn #False
  EndIf
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_PlayerCollision(*Object.Object, DX.f, DY.f)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn Collision(Player\X, Player\Y, Player\Width, Player\Height, Player\MoveX - DX, Player\MoveY - DY, *Object\X, *Object\Y, *Object\Width, *Object\Height)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_PlayerGroundCollision(*Object.Object, DX.f, DY.f)
  CompilerIf #Mode = #Mode_Game
  
  If Collision(Player\X, Player\Y, Player\Width, Player\Height, Player\MoveX - DX, Player\MoveY - DY, *Object\X, *Object\Y, *Object\Width, *Object\Height) = #Collision_Top
    If (Player\MoveY - DY) => 0 And (Player\Y - Player\MoveY + Player\Height - 0.05 <= *Object\Y - DY)
      ProcedureReturn #Collision_Top
    EndIf
  EndIf
  
  ProcedureReturn #False
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_DoWallCollision(*Object.Object, Collision.i)
  ; Simuliert einen Zusammensto mit einer Wand:
  
  CompilerIf #Mode = #Mode_Game
  
  Select Collision
    Case #Collision_Left
      Player\X = *Object\X - Player\Width
    Case #Collision_Right
      Player\X = *Object\X + *Object\Width
    Case #Collision_Top
      Player\BottomObject  = *Object
      Player\Y             = *Object\Y - Player\Height
      Player\PreviousMoveY = 0
      ChangePlayerAction(#Player_Action_Standing)
    Case #Collision_Bottom
      Player\Y             = *Object\Y + *Object\Height
      Player\MoveY         = 0
      Player\PreviousMoveY = 0
  EndSelect
  ExaminePlayerField()
  
  ProcedureReturn #True
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_DoGroundCollision(*Object.Object, Collision.i)
  ; Simuliert einen Zusammensto mit einem Boden:
  
  CompilerIf #Mode = #Mode_Game
  
  Select Collision
    Case #Collision_Top
      Player\BottomObject  = *Object
      Player\Y             = *Object\Y - Player\Height
      Player\PreviousMoveY = 0
      ChangePlayerAction(#Player_Action_Standing)
      
      ExaminePlayerField()
      ProcedureReturn #True
  EndSelect
  
  ProcedureReturn #False
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_DetectNextBarrier(X.i, Y.i, DX.i, DY.i, IncludeGrounds.i = #True)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn DetectNextBarrier(X, Y, DX, DY, IncludeGrounds)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_Damage(*EnergyA.Float, *EnergyB.Float)
  ; Zieht Energie von A sowie von B ab, ohne
  ; fr negative Werte zu sorgen:
  
  If *EnergyA\f > *EnergyB\f
    *EnergyA\f - *EnergyB\f
    *EnergyB\f = 0
  ElseIf *EnergyA\f = *EnergyB\f
    *EnergyA\f = 0
    *EnergyB\f = 0
  Else
    *EnergyB\f - *EnergyA\f
    *EnergyA\f = 0
  EndIf
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 12
; Folding = --
; EnableXP