;START:
ProcedureDLL.i GM_CreateObject(Layer.i, *Callback, X.i, Y.i, *Parameter = #Null, *Scene.Scene = #Null)
  CompilerIf #Mode = #Mode_Game
  
  Protected *Object.Object
  
  If Not *Scene
    *Scene = Table\Scene
  EndIf
  
  *Object       = _New(Object)
  *Object\Scene = *Scene
  *Object\Queue = LayerQueue(*Scene, Layer)
  *Object\Item  = AppendQueueItem(*Object\Queue, *Object)
  
  *Object\Callback     = *Callback
  *Object\X            = X
  *Object\Y            = Y
  *Object\Transparency = 255
  
  *Object\References = 1
  
  _Call(*Callback, *Object, #Object_Initialize, *Parameter)
  ProcedureReturn *Object
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_FreeObject(*Object.Object)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn ReleaseObject(*Object)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_DeleteAllOf(Layer.i, *Callback, *Scene.Scene = #Null)
  ; Lscht alle Objekte, die den selben Callback besitzen:
  
  CompilerIf #Mode = #Mode_Game
  
  Protected *Queue.Queue, *Object.Object, *Item.QueueItem, *NextItem.QueueItem
  Protected Count.i
  
  If Not *Scene
    *Scene = Player\Scene
  EndIf
  
  *Queue = PeekI(*Scene + Layer * _Sz(Integer))
  *Item  = *Queue\First
  
  While *Item
    *Object   = *Item\Memory
    *NextItem = *Item\N
    If *Object\Callback = *Callback
      FreeQueueItem(*Queue, *Object\Item)
      Count + 1
    EndIf
    *Item = *NextItem
  Wend
  
  ProcedureReturn Count
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_IsObjectDestroyed(*Object.Object)
  CompilerIf #Mode = #Mode_Game
  
  If *Object\Hidden = 2
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_StickPlayerOn(*Object.Object)
  CompilerIf #Mode = #Mode_Game
  
  Player\StickedObject = *Object
  Player\StickedX      = *Object\X
  Player\StickedY      = *Object\Y
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_HideObject(*Object.Object, State.i)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn HideObject(*Object, State)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_Bank(Name.s)
  ProcedureReturn GetBank(Name)
EndProcedure
ProcedureDLL.i GM_BankFunction(*Bank.Bank, Name.s)
  GetFunction(*Bank\Library, Name)
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 85
; Folding = g9
; EnableXP