;START:
ProcedureDLL.i GM_CreateSelection()
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn CreateSelection()
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_InitializeSelection(*Selection)
  CompilerIf #Mode = #Mode_Game
  
  InitializeSelection(*Selection)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_InitializeObjectSelection(*Selection)
  CompilerIf #Mode = #Mode_Game Or #Mode = #Mode_Editor
  
  ProcedureReturn InitializeObjectSelection(*Selection)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_FreeSelection(*Selection)
  CompilerIf #Mode = #Mode_Editor
  
  ProcedureReturn FreeSelection(*Selection)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_SelectionSize(*Selection.Selection)
  CompilerSelect #Mode
    CompilerCase #Mode_Game
  
  ProcedureReturn *Selection\Size
  
    CompilerCase #Mode_Editor
    
  ProcedureReturn *Selection\Queue\Count
  
  CompilerEndSelect
EndProcedure
ProcedureDLL.i GM_SelectedScene(*Selection.Selection, Index.i)
  CompilerSelect #Mode
  
    CompilerCase #Mode_Game
  
  Protected *Selected.Selected
  
  *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
  ProcedureReturn *Selected\Scene
  
    CompilerCase #Mode_Editor
  
  Protected *Item.QueueItem, *Selected.Selected
  
  *Item = SelectQueueItem(*Selection\Queue, Index)
  *Selected = *Item\Memory
  ProcedureReturn GetScene(*Selected\SceneX, *Selected\SceneY)
  
  CompilerEndSelect
EndProcedure
ProcedureDLL.i GM_SelectedX(*Selection.Selection, Index.i)
  CompilerSelect #Mode
  
    CompilerCase #Mode_Game
  
  Protected *Selected.Selected
  
  *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
  ProcedureReturn *Selected\X
  
    CompilerCase #Mode_Editor
  
  Protected *Item.QueueItem, *Selected.Selected
  
  *Item = SelectQueueItem(*Selection\Queue, Index)
  *Selected = *Item\Memory
  ProcedureReturn *Selected\X
  
  CompilerEndSelect
EndProcedure
ProcedureDLL.i GM_SelectedY(*Selection.Selection, Index.i)
  CompilerSelect #Mode
  
    CompilerCase #Mode_Game
  
  Protected *Selected.Selected
  
  *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
  ProcedureReturn *Selected\Y
  
    CompilerCase #Mode_Editor
  
  Protected *Item.QueueItem, *Selected.Selected
  
  *Item = SelectQueueItem(*Selection\Queue, Index)
  *Selected = *Item\Memory
  ProcedureReturn *Selected\Y
  
  CompilerEndSelect
EndProcedure
ProcedureDLL.i GM_SelectedObject(*Selection.Selection, Index.i)
  CompilerSelect #Mode
  
    CompilerCase #Mode_Game
  
  Protected *Selected.SelectedObject
  
  *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
  ProcedureReturn *Selected\Object
  
    CompilerCase #Mode_Editor
  
  Protected *Item.QueueItem, *Selected.Selected
  
  *Item = SelectQueueItem(*Selection\Queue, Index)
  *Selected = *Item\Memory
  ProcedureReturn GetField(GetScene(*Selected\SceneX, *Selected\SceneY), *Selected\Layer, *Selected\X, *Selected\Y)
  
  CompilerEndSelect
EndProcedure

ProcedureDLL.i GM_HideSelectedObjects(*Selection, State.i)
  CompilerIf #Mode = #Mode_Game
  
  HideSelectedObjects(*Selection, State)
  
  CompilerEndIf
EndProcedure
ProcedureDLL.i GM_ForEachSelectedObject(*Selection, *Callback, *Parameter = #Null)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn ForEachSelectedObject(*Selection, *Callback, *Parameter)
  
  CompilerEndIf
EndProcedure

ProcedureDLL.i GM_IsPlayerInSelection(*Selection)
  CompilerIf #Mode = #Mode_Game
  
  ProcedureReturn IsPlayerInSelection(*Selection)
  
  CompilerEndIf
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 102
; Folding = AQ-
; EnableXP