Procedure.i LoadEventBank(Name.s)
  Protected *Bank.EventBank
  
  *Bank      = _New(EventBank)
  *Bank\Name = Name
  
  *Bank\Library = OpenLibrary(#PB_Any, GetFile("Events\" + Name + ".dll"))
  If Not *Bank\Library
    MessageRequester("Error", "Can not load target bank: " + #Q + *Bank\Name + #Q, #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  ; Funktionen wrappen:
  CallFunction(*Bank\Library, "GM_Init", ?Functions, RandomSeed)
  
  *Bank\Callbacks = CreateQueue(#Queue_SaveMemory)
  
  ProcedureReturn *Bank
EndProcedure
Procedure.i LoadEvent(*Bank.EventBank, Callback.s, GlobalLoad.i = #False)
  Protected *Item.QueueItem, *Callback.Integer
  
  *Callback = GetFunction(*Bank\Library, "Event_" + Callback)
  If Not *Callback
    MessageRequester("Error", "Can not find event:" + #N + "bank: " + #T + *Bank\Name + #N + "event: " +#T + Callback, #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  
  *Item = *Bank\Callbacks\First
  While *Item
    If *Item\Memory = *Callback
      ProcedureReturn *Callback
    EndIf
    _Move(*Item, N)
  Wend
  
  If GlobalLoad
    _Call(*Callback, #Null, #Event_GlobalLoad, #Null)
  EndIf
  
  AppendQueueItem(*Bank\Callbacks, *Callback)
  ProcedureReturn *Callback
EndProcedure

Procedure.i CreateEvent(*Act.Act, *Callback, *Parameter = #Null)
  Protected *Event.Event
  
  *Event = _New(Event)
  AppendQueueItem(*Act\Events, *Event)
  
  *Event\Act       = *Act
  *Event\Callback  = *Callback
  *Event\Triggered = #False
  *Event\Effects   = CreateQueue()
  *Event\Memory    = #Null
  
  *Act\Remaining + 1
  
  _Call(*Callback, *Event, #Event_Initialize, *Parameter)
  ProcedureReturn *Event
EndProcedure
Procedure.i CreateLoadEvent(*Act.Act, *Callback)
  Protected *Event.Event
  
  *Event = _New(Event)
  AppendQueueItem(*Act\Events, *Event)
  
  *Event\Act       = *Act
  *Event\Callback  = *Callback
  *Event\Triggered = #False
  *Event\Effects   = CreateQueue()
  *Event\Memory    = #Null
  
  *Act\Remaining + 1
  
  ProcedureReturn *Event
EndProcedure
Procedure.i ExamineEvent(*Event.Event)
  If Not *Event\Triggered
    If _Call(*Event\Callback, *Event, #Event_Triggered, #Null)
      *Event\Triggered = #True
      *Event\Act\Remaining - 1
      CallEffects(*Event)
    EndIf
  ElseIf *Event\IdleTime <> #None
    If *Event\IdleTime = 0
      *Event\IdleTime = #None
      ContinueCallingEffects(*Event)
    Else
      *Event\IdleTime - 1
    EndIf
  EndIf
EndProcedure

Procedure.i LoadEffectBank(Name.s)
  Protected *Bank.EffectBank
  
  *Bank      = _New(EffectBank)
  *Bank\Name = Name
  
  *Bank\Library = OpenLibrary(#PB_Any, GetFile("Effects\" + Name + ".dll"))
  If Not *Bank\Library
    MessageRequester("Error", "Can not load effect bank: " + #Q + *Bank\Name + #Q, #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  ; Funktionen wrappen:
  CallFunction(*Bank\Library, "GM_Init", ?Functions, RandomSeed)
  
  *Bank\Callbacks = CreateQueue(#Queue_SaveMemory)
  
  ProcedureReturn *Bank
EndProcedure
Procedure.i LoadEffect(*Bank.EffectBank, Callback.s, GlobalLoad.i = #False)
  Protected *Item.QueueItem, *Callback.Integer
  
  *Callback = GetFunction(*Bank\Library, "Effect_" + Callback)
  If Not *Callback
    MessageRequester("Error", "Can not find effect:" + #N + "bank: " + #T + *Bank\Name + #N + "effect: " +#T + Callback, #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  
  *Item = *Bank\Callbacks\First
  While *Item
    If *Item\Memory = *Callback
      ProcedureReturn *Callback
    EndIf
    _Move(*Item, N)
  Wend
  
  If GlobalLoad
    _Call(*Callback, #Null, #Effect_GlobalLoad, #Null)
  EndIf
  
  AppendQueueItem(*Bank\Callbacks, *Callback)
  ProcedureReturn *Callback
EndProcedure

Procedure.i CheckSpecialEvent(*Act.Act, *Event.Event)
  Protected SpecialEvent.i
  
  For SpecialEvent = 0 To #SpecialEventCount - 1
    If *SpecialEventCallback(SpecialEvent) = *Event\Callback
      *Act\SpecialEvent[SpecialEvent] = *Event
      ProcedureReturn *Event
    EndIf
  Next
  
  ProcedureReturn #False
EndProcedure
Procedure.i SpecialEventID(Name.s)
  Protected Index.i, String.s, *Memory
  
  DataSection
    SpecialEvents:
      Data.s "Start"
      Data.s "LostLive"
      Data.s "GameOver"
      Data.s "ScoreAdded"
      Data.s "CoinCollected"
    EndSpecialEvents:
  EndDataSection
  
  *Memory = ?SpecialEvents
  While *Memory < ?EndSpecialEvents
    String = PeekS(*Memory)
    If String = Name
      ProcedureReturn Index
    Else
      *Memory + (Len(String) + 1) * _Sz(Character)
      Index + 1
    EndIf
  Wend
  
  ProcedureReturn #None
EndProcedure
Procedure.i CallSpecialEventEffects(*Act.Act, ID.i)
  Protected *Event.Event
  
  If *Act And *Act\SpecialEvent[ID]
    ProcedureReturn CallEffects(*Act\SpecialEvent[ID])
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

Procedure.i CreateLoadEffect(*Event.Event, *Callback)
  Protected *Effect.Effect
  
  *Effect = _New(Effect)
  AppendQueueItem(*Event\Effects, *Effect)
  
  *Effect\Event   = *Event
  *Effect\Callback = *Callback
  *Effect\Memory   = #Null
  
  ProcedureReturn *Effect
EndProcedure
Procedure.i CallEffect(*Effect.Effect)
  ProcedureReturn _Call(*Effect\Callback, *Effect, #Effect_Call, #Null)
EndProcedure
Procedure.i CallEffects(*Event.Event)
  Protected *Item.QueueItem
  
  *Item = *Event\Effects\First
  While *Item
    CallEffect(*Item\Memory)
    If *Event\IdleTime <> #None
      *Event\LastEffectItem = *Item
      Break
    EndIf
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #True
EndProcedure
Procedure.i ContinueCallingEffects(*Event.Event)
  Protected *Item.QueueItem
  
  *Item = *Event\LastEffectItem\N
  While *Item
    CallEffect(*Item\Memory)
    If *Event\IdleTime <> #None
      *Event\LastEffectItem = *Item
      Break
    EndIf
    _Move(*Item, N)
  Wend
EndProcedure

Procedure.i CreateAct(Name.s)
  Protected *Act.Act
  
  *Act = _New(Act)
  AppendQueueItem(*Acts, *Act)
  
  *Act\Name    = Name
  *Act\Events = CreateQueue()
  
  ProcedureReturn *Act
EndProcedure
Procedure.i ExamineAct(*Act.Act)
  Protected *Item.QueueItem
  
  *Item = *Act\Events\First
  While *Item
    ExamineEvent(*Item\Memory)
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i ExamineParallelActs()
  Protected *Item.QueueItem, *NextItem.QueueItem
  
  ;"*NextItem" wird verwendet, weil ein paralleles Act
  ;auch gelscht werden kann, wodurch der Zeiger "*Item"
  ;ungltig wird.
  
  *Item = *ParallelActs\First
  While *Item
    *NextItem = *Item\N
    ExamineAct(*Item\Memory)
    *Item = *NextItem
  Wend
EndProcedure
Procedure.i GetAct(Name.s)
  Protected *Item.QueueItem, *Act.Act
  
  *Item = *Acts\First
  While *Item
    *Act = *Item\Memory
    If *Act\Name = Name
      ProcedureReturn *Act
    EndIf
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #Null
EndProcedure

Procedure.i CallStartEvents()
  Protected *Item.QueueItem, *Act.Act
  
  *Item = *Acts\First
  While *Item
    *Act = *Item\Memory
    CallSpecialEventEffects(*Act, #SpecialEvent_Start)
    _Move(*Item, N)
  Wend
EndProcedure

Procedure.i ChangeAct(*Act.Act)
  *CurrentAct = *Act
  StartAct(*Act)
EndProcedure
Procedure.i StartAct(*Act.Act)
  Protected *Item.QueueItem, *Event.Event
  
  *Item = *Act\Events\First
  While *Item
    *Event = *Item\Memory
    _Call(*Event\Callback, *Event, #Event_Start, #Null)
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i AddParallelAct(*Act.Act)
  If Not *Act\ParallelItem
    *Act\ParallelItem = AppendQueueItem(*ParallelActs, *Act)
    StartAct(*Act)
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure
Procedure.i RemoveParallelAct(*Act.Act)
  If *Act\ParallelItem
    FreeQueueItem(*ParallelActs, *Act\ParallelItem)
    *Act\ParallelItem = #Null
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 105
; FirstLine = 3
; Folding = hAAg
; EnableXP