;**************************************************************
;     Highscore
;**************************************************************
;   Copyright (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i NewHighscore(*Challange.Challange, Player.s, Score.i, Medal.i, SuperCoins.i)
  Protected *Item.QueueItem, *Highscore.Highscore
  
  With *Challange
  
  *Item = \Highscores\First
  While *Item
    *Highscore = *Item\Memory
    
    If *Highscore\Player = Player
      Break
    Else
      *Highscore = #Null
    EndIf
    
    _Move(*Item, N)
  Wend
  
  If *Highscore
    ; Bestehende Highscore verbessern:
    If *Highscore\Medal < Medal
      *Highscore\Medal = Medal
    EndIf
    If *Highscore\SuperCoins < SuperCoins
      *Highscore\SuperCoins = SuperCoins
    EndIf
    If *Highscore\Score < Score
      *Highscore\Score = Score
    Else
      ; Keine neue Highscore erreicht:
      ProcedureReturn 0
    EndIf
  Else
    ; Neue Highscore eintragen:
    *Highscore = _New(Highscore)
    AppendQueueItem(\Highscores, *Highscore)
    
    *Highscore\Player     = Player
    *Highscore\Score      = Score
    *Highscore\Medal      = Medal
    *Highscore\SuperCoins = SuperCoins
  EndIf
  
  If (Not \BestHighscore) Or (*Highscore\Score > \BestHighscore\Score)
    \BestHighscore = *Highscore
    ; Neue Best Highscore erreicht:
    ProcedureReturn 2
  Else
    ; Keine neue Best Highscore erreicht, jedoch neue persnliche Highscore:
    ProcedureReturn 1
  EndIf
  
  EndWith
EndProcedure
Procedure.i FreeHighscore(*Highscore.Highscore)
  ClearStructure(*Highscore, Highscore)
  _Free(*Highscore)
  
  ProcedureReturn #True
EndProcedure

Procedure.i GetHighscore(*Challange.Challange, Player.s)
  Protected *Item.QueueItem, *Highscore.Highscore
  
  *Item = *Challange\Highscores\First
  While *Item
    *Highscore = *Item\Memory
    
    If *Highscore\Player = Player
      ProcedureReturn *Highscore
    EndIf
    
    _Move(*Item, N)
  Wend
  
  ProcedureReturn #Null
EndProcedure
Procedure.i HighscoreScore(*Highscore.Highscore)
  ProcedureReturn *Highscore\Score
EndProcedure
Procedure.s HighscorePlayer(*Highscore.Highscore)
  ProcedureReturn *Highscore\Player
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 55
; FirstLine = 30
; Folding = -
; EnableXP