Macro _GM_Import(Function)
  Global Function.Function = *FunctionTable\L : *FunctionTable + 4
EndMacro

Macro GM_Folder(Name)
  Data.c 2 : Data.s Name
EndMacro
Macro GM_File(Name)
  Data.c 1 : Data.s Name
EndMacro
Macro GM_End()
  Data.c 0
EndMacro



#GM_FieldSize    = 24
#GM_SceneWidth   = 27
#GM_SceneHeight  = 13
#GM_ScreenWidth     = #GM_FieldSize * #GM_SceneWidth
#GM_ScreenHeight    = #GM_FieldSize * #GM_SceneHeight

#GM_Player_MultiplilerDuration = 190

Enumeration 1
  #GM_Object_Display
  #GM_Object_Frame
  #GM_Object_Collision
  #GM_Object_Delete
  #GM_Object_PlayerEnteredScene
  #GM_Object_PlayerLeftScene
  #GM_Object_AllowClambering
  #GM_Object_ForbidClimbing
  #GM_Object_Hit
  #GM_Object_Hide
  #GM_Object_Unhide
  
  #GM_Object_Load
  #GM_Object_Save
  #GM_Object_GlobalLoad
  #GM_Object_GlobalSave
  #GM_Object_Initialize
  #GM_Object_GlobalInitialize
  
  #GM_Object_GlobalEditorSave
  #GM_Object_EditorSave
  #GM_Object_GlobalEditorLoad
  #GM_Object_EditorLoad
  #GM_Object_EditorInitialize
  #GM_Object_EditorConfigure
  #GM_Object_EditorCopy
  #GM_Object_EditorFree
  
  #GM_Object_CallAction
  #GM_Object_LoadAction
  #GM_Object_InitializeAction
  #GM_Object_EditorSaveAction
  #GM_Object_EditorLoadAction
  #GM_Object_EditorInitializeAction
  #GM_Object_EditorFreeAction
  #GM_Object_ActionName
  #GM_Object_ActionDescription
  #GM_Object_ActionCount
  
  #GM_Object_PreferedLayer
  #GM_Object_CheckLayer
  #GM_Object_ViewSprite
  #GM_Object_ViewRegion
  #GM_Object_Name
  #GM_Object_Description
EndEnumeration
Enumeration 1
  #GM_Object_DoDelete ;{
  ;  Wird dieser Wert zurckgegeben, wenn "#GM_Object_Frame" oder
  ;  "#GM_Object_Collision" stattfand, dann wird das jeweilige
  ;  Objekt gelscht. Nach der Rckgabe wird automatisch "#GM_Object_Delete"
  ;  an das Objekt gesendet, damit Aufrumarbeiten erledigt werden knnen.
  ;}
  #GM_Object_DoCollision
EndEnumeration

Enumeration
  #GM_Player_Key_Right
  #GM_Player_Key_Left
  #GM_Player_Key_Down
  #GM_Player_Key_Up
  #GM_Player_Key_Shoot
  #GM_Player_Key_Jump
  #GM_Player_Key_Fly
  #GM_Player_Key_ItemA
  #GM_Player_Key_ItemB
  #GM_Player_Key_ItemC
  #GM_Player_Key_Inventory
  #GM_Player_KeyCount
EndEnumeration

Enumeration
  #GM_Player_Action_Standing
  #GM_Player_Action_Falling
  #GM_Player_Action_Jump
  #GM_Player_Action_DoubleJump
  #GM_Player_Action_Climbing
  #GM_Player_Action_Clambering
  #GM_Player_Action_JumpedOff
  #GM_Player_Action_Flying
  #GM_Player_Action_FlyingTruncated
  #GM_Player_Action_LumiFlight
EndEnumeration

Enumeration
  #GM_Layer_BackgroundTile1
  #GM_Layer_BackgroundTile2
  #GM_Layer_BackgroundTile3
  #GM_Layer_Wall ;{
  ;  "Wnde" sind Tiles, die von keiner Seite passiert werden
  ;  knnen. Daher knnen diese Tiles als Wnde, Bden und
  ;  Decken dienen.
  ;}
  #GM_Layer_Ground ;{
  ;  "Grnde" dienen als Tiles, die durch einen Sprung von Unten
  ;  passierbar sind. Ansonsten dienen sie als Boden.
  ;}
  #GM_Layer_ForegroundTile
  #GM_Layer_BackgroundObject1
  #GM_Layer_BackgroundObject2
  #GM_Layer_StaticObject
  #GM_Layer_ForegroundObject1
  #GM_Layer_ForegroundObject2
EndEnumeration

#GM_Collision_Left   = %0001
#GM_Collision_Right  = %0010
#GM_Collision_Top    = %0100
#GM_Collision_Bottom = %1000

#GM_N = Chr(13)+Chr(10)

Enumeration
  #GM_Player_Shot_White
  #GM_Player_Shot_Blue
  #GM_Player_Shot_Green
  #GM_Player_ShotCount
EndEnumeration

Enumeration 1
  #GM_Event_Triggered
  #GM_Event_Initialize
  #GM_Event_GlobalLoad
  #GM_Event_Load
  #GM_Event_Start
  #GM_Event_EditorInitialize
  #GM_Event_EditorLoad
  #GM_Event_EditorSave
  #GM_Event_EditorGlobalLoad
  #GM_Event_EditorGlobalSave
  #GM_Event_Edit
  #GM_Event_EditorDelete
  #GM_Event_Name
  #GM_Event_Description
  #GM_Event_Text
EndEnumeration
Enumeration 1
  #GM_Effect_Call
  #GM_Effect_Initialize
  #GM_Effect_GlobalLoad
  #GM_Effect_Load
  #GM_Effect_EditorInitialize
  #GM_Effect_EditorLoad
  #GM_Effect_EditorSave
  #GM_Effect_EditorGlobalLoad
  #GM_Effect_EditorGlobalSave
  #GM_Effect_Edit
  #GM_Effect_EditorDelete
  #GM_Effect_Name
  #GM_Effect_Description
  #GM_Effect_Text
EndEnumeration

Enumeration 1
  #GM_Item_IsUseable
  #GM_Item_Use
  #GM_Item_NamePlural
  #GM_Item_NameSingular
EndEnumeration

Enumeration
  #GM_Selection_Frame
  #GM_Selection_CheckTile
  #GM_Selection_CheckObject
  #GM_Selection_CheckField
  #GM_Selection_Mode
EndEnumeration
Enumeration
  #GM_Selection_Mode_AllLayers
  #GM_Selection_Mode_Tiles
  #GM_Selection_Mode_Walls
  #GM_Selection_Mode_Objects
  #GM_Selection_Mode_None
EndEnumeration



Structure GM_PlayerInfo
  Width.i
  Height.i
  
  X.f
  Y.f
  MoveX.f
  DoMoveX.f
  MoveY.f
  PreviousX.f
  PreviousY.f
  PreviousMoveX.f
  PreviousMoveY.f
  MoveInfluence.f
  MoveFriction.f
  MaxMoveX.f
  HeightOfFall.f
  
  FieldX.i
  FieldY.i
  *Scene
  *PreviousScene
  
  *SceneToLocate
  FieldXToLocate.i
  FieldYToLocate.i
  
  Speed.f
  Mass.f
  
  KeyPressed.i[#GM_Player_KeyCount]
  KeyPressing.i[#GM_Player_KeyCount]
  KeyReleased.i[#GM_Player_KeyCount]
  
  Action.i
  ActionTime.i
  *Animation
  ClimbSide.i
  *BottomObject.GM_Object

  *StickedObject.GM_Object
  StickedX.f
  StickedY.f
  
  CanFly.i
  CanDoubleJump.i
  CanClimb.i
  CanShoot.i
  CanLoadShot.i
  CanLumiFlight.i
  
  Lives.i
  MaxEnergy.i
  Energy.i
  Coins.i
  
  Score.i
  NewScore.i
  ScoreReason.s
  ScoreReasonDuration.i
  AdditiveScore.i
  
  Multiplier.i
  MultiplierDuration.i
  MultiplierCounter.i
  MultiplierChangedTime.i
  
  Comment.s
  CommentDuration.i
  
  *LastCheckpointScene
  LastCheckpointX.i
  LastCheckpointY.i
  LoseGame.i
  
  HitTime.i
  LostLiveTime.i
  *LostLiveAnimation
  
  ShootMode.i
  ShootByMouse.i
  ShotPower.f
  ShotDuration.i
  *ShotFrameset[#GM_Player_ShotCount]
  *Shots
  
  *UsingItem.GM_Item[3]
  
  LumiLight.f
  Shield.i
  
  GreenEnergySprite.i
  GreenEnergySprite3D.i
  RedEnergySprite.i
  RedEnergySprite3D.i
  
  SignSprite.i
  SignSprite3D.i
EndStructure
Structure GM_Object
  X.f
  Y.f
  Width.i
  Height.i
  Hidden.i
  Transparency.f
  
  *Callback
  
  StructureUnion
    Sprite.i
    *Animation
  EndStructureUnion
  *Memory
  
  References.i
  *Scene
  *Queue
  *Item
EndStructure
Structure GM_EditorObject
  X.i
  Y.i
  *Registered
  
  *Scene
  Layer.i

  *Memory
EndStructure
Structure GM_ObjectAction
  *Selection
  *Callback
  Action.i
  *Memory
EndStructure
Structure GM_EditorObjectAction
  *Selection
  *RegisteredObject
  Action.i
  *Memory
EndStructure
Structure GM_Shot
  X.f
  Y.f
  MoveX.f
  MoveY.f
  *Animation
  
  Power.f
  
  *Item
EndStructure
Structure GM_Item
  Name.s
  *Callback
  Sprite3D.i
  Count.i
  MaxCount.i
EndStructure

Structure GM_EditorEvent
  *Entry
  *Act
  *Item
  *Effects
  *Memory
  References.i
EndStructure
Structure GM_Event
  *Act.GM_Act
  *Callback
  Triggered.i
  *Effects
  
  *LastEffectItem
  IdleTime.i
  
  *Memory
EndStructure

Structure GM_EditorEffect
  *Entry
  *Event.GM_EditorEvent
  *Item
  *Memory
EndStructure
Structure GM_Effect
  *Event.GM_Event
  *Callback
  *Memory
EndStructure

Structure GM_Act
  Name.s
  Description.s
  *Events
EndStructure

Structure GM_ViewRegion
  X.i
  Y.i
  Width.i
  Height.i
EndStructure



Global *GM_Player.GM_PlayerInfo




Prototype.i GM_Player()
Prototype.i GM_AddEnergy(Energy.i)
Prototype.i GM_FillEnergy()
Prototype.i GM_AddLife()
Prototype.i GM_HitPlayer(Energy.i)
Prototype.i GM_LoseLife()

Prototype.i GM_ChangePlayerAction(Action.i)
Prototype.i GM_LocatePlayer(X.i, Y.i, *Scene = #Null)
Prototype.i GM_SetPlayerY(Y.f)
Prototype.i GM_SetPlayerMoveY(Speed.f)
Prototype.i GM_ExaminePlayerCollisions()

Prototype.f GM_DistanceToPlayer(X.f, Y.f)
Prototype.i GM_GetScene(X.i, Y.i)
Prototype.i GM_GetWall(X.i, Y.i)
Prototype.i GM_GetGround(X.i, Y.i)
Prototype.i GM_GetObject(X.i, Y.i)

Prototype.i GM_SceneWidth(*Scene = #Null)
Prototype.i GM_SceneHeight(*Scene = #Null)
Prototype.i GM_ScenePixelWidth(*Scene = #Null)
Prototype.i GM_ScenePixelHeight(*Scene = #Null)

Prototype.i GM_LoadSprite(Name.s)
Prototype.i GM_SpriteWidth(Sprite.i)
Prototype.i GM_SpriteHeight(Sprite.i)
Prototype.i GM_CreateSprite3D(Sprite.i)
Prototype.i GM_DisplaySprite3D(Sprite3D.i, X.i, Y.i, Transparency.i = 255)
Prototype.i GM_FreeSprite3D(Sprite3D.i)
Prototype.i GM_ZoomSprite3D(Sprite3D.i, Width.i, Height.i)
Prototype.i GM_RotateSprite3D(Sprite3D.i, Rotation.i)
Prototype.i GM_EnableBilinearFiltering()
Prototype.i GM_DisableBilinearFiltering()
Prototype.i GM_BlendingMode(Source.i, Destination.i)

Prototype.i GM_LoadAnimationFrameset(Name.s, FrameWidth.i, FrameHeight.i)
Prototype.i GM_CreateAnimation(*Frameset)
Prototype.i GM_FramesetFrames(*Frameset)
Prototype.i GM_FramesetRows(*Frameset)
Prototype.i GM_AnimationFrameset(*Animation)
Prototype.i GM_FreeAnimation(*Animation)

Prototype.i GM_DisplayAnimation(*Animation, X.i, Y.i, Transparency.i = 255)
Prototype.i GM_DisplayFramesetFrame(*Frameset, Frame.i, Row.i, X.i, Y.i, Transparency.i = 255)
Prototype.i GM_FramesetSprite(*Frameset, Frame.i, Row.i)

Prototype.i GM_SetAnimationFrame(*Animation, Frame.i)
Prototype.i GM_SetAnimationDuration(*Animation, Duration.i)
Prototype.i GM_SetAnimationRow(*Animation, Row.i)
Prototype.i GM_AnimationFrame(*Animation)
Prototype.i GM_AnimationRow(*Animation)
Prototype.i GM_PlayAnimation(*Animation)
Prototype.i GM_PlayAnimationBack(*Animation)
Prototype.i GM_SetNextAnimationFrame(*Animation, Frame.i, Duration.i)
Prototype.i GM_AnimationSprite3D(*Animation)

Prototype.i GM_EmitTinyExplosion(X.i, Y.i)
Prototype.i GM_EmitAirExplosion(X.i, Y.i)
Prototype.i GM_EmitKilledEnemyParticle(X.i, Y.i)
Prototype.i GM_EmitTinyFlash(X.i, Y.i)
Prototype.i GM_EmitGlitter(X.i, Y.i)
Prototype.i GM_EmitGhost(X.i, Y.i)

Prototype.i GM_DisplayWhiteLight(X.i, Y.i, Transparency.i = 255)
Prototype.i GM_DisplayYellowLight(X.i, Y.i, Transparency.i = 255)
Prototype.i GM_DisplayCyanLight(X.i, Y.i, Transparency.i = 255)

Prototype.i GM_FieldCollision(*Object, DX.f, DY.f, DeltaX.i, DeltaY.i, IncludeGrounds.i = #True)
Prototype.i GM_PlayerCollision(*Object, DX.f, DY.f)
Prototype.i GM_PlayerGroundCollision(*Object, DX.f, DY.f)
Prototype.i GM_DoWallCollision(*Object, Collision.i)
Prototype.i GM_DoGroundCollision(*Object, Collision.i)
Prototype.i GM_DetectNextBarrier(X.i, Y.i, DX.i, DY.i, IncludeGrounds.i = #True)
Prototype.i GM_Damage(*EnergyA.Float, *EnergyB.Float)

Prototype.i GM_CreateObject(Layer.i, *Callback, X.i, Y.i, *Parameter = #Null, *Scene = #Null)
Prototype.i GM_FreeObject(*Object)
Prototype.i GM_DeleteAllOf(Layer.i, *Callback, *Scene = #Null)
Prototype.i GM_IsObjectDestroyed(*Object)

Prototype.i GM_StickPlayerOn(*Object)
Prototype.i GM_HideObject(*Object, State.i)

Prototype.i GM_Bank(Name.s)
Prototype.i GM_BankFunction(*Bank, Name.s)

Prototype.i GM_CreateObjectAction()
Prototype.i GM_FreeObjectAction(*Action)
Prototype.i GM_InitializeObjectAction(*Action)

Prototype.i GM_ObjectActionSelection(*Action)
Prototype.i GM_ObjectActionID(*Action)
Prototype.i GM_ObjectActionMemory(*Action)
Prototype.i GM_SetObjectActionMemory(*Action, *Memory)
Prototype.i GM_ObjectActionName_(*Action)

Prototype.i GM_CallObjectAction(*Action)
Prototype.i GM_EditObjectAction(*Action)
Prototype.i GM_AddScore(Score.i)
Prototype.i GM_AddScoreTM(Score.i, *Object)
Prototype.i GM_AddScoreNMTM(Score.i, *Object)

Prototype.i GM_EnhanceMultiplier(Times.i, Duration.i = 190)
Prototype.i GM_ShowComment(Comment.s, Duration.i = 100)

Prototype.i GM_AddCoin()
Prototype.i GM_AddSuperCoin()
Prototype.i GM_CountCoin()
Prototype.i GM_CountSuperCoin()
Prototype.i GM_GetItem(Name.s, *Callback = #Null)
Prototype.i GM_AddItem(*Item, Count.i = 1)
Prototype.i GM_ItemCount(*Item)

Prototype.i GM_SaveInteger(Integer.i)
Prototype.i GM_LoadInteger()
Prototype.i GM_SaveFloat(Float.f)
Prototype.f GM_LoadFloat()
Prototype.i GM_SaveText(Text.s)
Prototype.i GM_LoadText_()

Prototype.i GM_SaveFieldPosition(X.i, Y.i)
Prototype.i GM_LoadFieldPosition(*X.Integer, *Y.Integer)
Prototype.i GM_LoadPixelPosition(*X.Float, *Y.Float)

Prototype.i GM_SaveObjectAction(*Action)
Prototype.i GM_LoadObjectAction()

Prototype.i GM_SaveActNumber(*Act)
Prototype.i GM_LoadActNumber()

Prototype.i GM_SaveSelection(*Selection)
Prototype.i GM_LoadSelection(*Selection = #Null)
Prototype.i GM_SaveObjectSelection(*Selection)
Prototype.i GM_LoadObjectSelection(*Selection = #Null)

Prototype.i GM_SaveGame(X.i, Y.i, *Scene = #Null)

Prototype.i GM_ShowMessage(Title.s, Message.s)
Prototype.i GM_EditMessage_(Title.s, Message.s = "")
Prototype.i GM_EditInteger(Title.s, Text.s, Number.i, Min.i, Max.i)
Prototype.i GM_EditString_(Title.s, Text.s, String.s)

Prototype.i GM_Select(*Selection, *Callback, Info.s = "Select")
Prototype.i GM_SelectObjects(*Selection, Info.s = "Select objects")
Prototype.i GM_SelectSingleObject(*Selection, Info.s = "Select object")
Prototype.i GM_EditSelection(*Selection, Info.s = "Select fields")
Prototype.i GM_SelectField(*Selection, Info.s = "Select field")

Prototype.i GM_SelectAct(Title.s, Text.s, *DefaultAct = #Null, AllowNoAct.i = #False, AllowNewAct.i = #False)

Prototype.i GM_CreateSelection()
Prototype.i GM_InitializeSelection(*Selection)
Prototype.i GM_InitializeObjectSelection(*Selection)
Prototype.i GM_FreeSelection(*Selection)

Prototype.i GM_SelectionSize(*Selection)
Prototype.i GM_SelectedScene(*Selection, Index.i)
Prototype.i GM_SelectedX(*Selection, Index.i)
Prototype.i GM_SelectedY(*Selection, Index.i)
Prototype.i GM_SelectedObject(*Selection, Index.i)

Prototype.i GM_HideSelectedObjects(*Selection, State.i)
Prototype.i GM_ForEachSelectedObject(*Selection, *Callback, *Parameter = #Null)

Prototype.i GM_IsPlayerInSelection(*Selection)

Prototype.i GM_ActName_(*Act)
Prototype.i GM_GetAct(Name.s)
Prototype.i GM_GetActByNumber(Number.i)
Prototype.i GM_UseAct(*Act)
Prototype.i GM_ReleaseAct(*Act)

Prototype.i GM_ChangeAct(*Act)
Prototype.i GM_AddParallelAct(*Act)
Prototype.i GM_RemoveParallelAct(*Act)
Prototype.i GM_EventsRemaining(*Act)

Prototype.i GM_EventAct(*Event)
Prototype.i GM_StopEvent(*Event, Frames.i)

Prototype.i GM_EffectEvent(*Effect)
Prototype.i GM_EffectAct(*Effect)

Prototype.i GM_CameraFollowPlayer()
Prototype.i GM_CameraFollowObject(*Object)
Prototype.i GM_CameraSetOnField(X.i, Y.i)

Prototype.i GM_FadeIn(Color.i = #Black)
Prototype.i GM_FadeOff()

Prototype.i GM_Function(Name.s)
Prototype.i GM_Callback(Name.s)

Prototype.i GM_Quit()

Prototype.i GM_IsReplay()

Prototype.i GM_Debug(Text.s)



ProcedureDLL.i GM_Init(*FunctionTable.Long, Seed.i)
  ; RandomSeed festlegen (falls angegeben):
  If Seed <> -1
    RandomSeed(Seed)
  EndIf
  
  ; Funktionen importieren:
  _GM_Import(GM_Player)
  _GM_Import(GM_AddEnergy)
  _GM_Import(GM_FillEnergy)
  _GM_Import(GM_AddLife)
  _GM_Import(GM_HitPlayer)
  _GM_Import(GM_LoseLife)
  
  _GM_Import(GM_ChangePlayerAction)
  _GM_Import(GM_LocatePlayer)
  _GM_Import(GM_SetPlayerY)
  _GM_Import(GM_SetPlayerMoveY)
  _GM_Import(GM_ExaminePlayerCollisions)
  
  _GM_Import(GM_DistanceToPlayer)
  _GM_Import(GM_GetScene)
  _GM_Import(GM_GetWall)
  _GM_Import(GM_GetGround)
  _GM_Import(GM_GetObject)
  
  _GM_Import(GM_SceneWidth)
  _GM_Import(GM_SceneHeight)
  _GM_Import(GM_ScenePixelWidth)
  _GM_Import(GM_ScenePixelHeight)
  
  _GM_Import(GM_LoadSprite)
  _GM_Import(GM_SpriteWidth)
  _GM_Import(GM_SpriteHeight)
  _GM_Import(GM_CreateSprite3D)
  _GM_Import(GM_DisplaySprite3D)
  _GM_Import(GM_FreeSprite3D)
  _GM_Import(GM_ZoomSprite3D)
  _GM_Import(GM_RotateSprite3D)
  _GM_Import(GM_EnableBilinearFiltering)
  _GM_Import(GM_DisableBilinearFiltering)
  _GM_Import(GM_BlendingMode)
  
  _GM_Import(GM_LoadAnimationFrameset)
  _GM_Import(GM_CreateAnimation)
  _GM_Import(GM_FramesetFrames)
  _GM_Import(GM_FramesetRows)
  _GM_Import(GM_AnimationFrameset)
  _GM_Import(GM_FreeAnimation)
  
  _GM_Import(GM_DisplayAnimation)
  _GM_Import(GM_DisplayFramesetFrame)
  _GM_Import(GM_FramesetSprite)
  
  _GM_Import(GM_SetAnimationFrame)
  _GM_Import(GM_SetAnimationDuration)
  _GM_Import(GM_SetAnimationRow)
  _GM_Import(GM_AnimationFrame)
  _GM_Import(GM_AnimationRow)
  _GM_Import(GM_PlayAnimation)
  _GM_Import(GM_PlayAnimationBack)
  _GM_Import(GM_SetNextAnimationFrame)
  _GM_Import(GM_AnimationSprite3D)
  
  _GM_Import(GM_EmitTinyExplosion)
  _GM_Import(GM_EmitAirExplosion)
  _GM_Import(GM_EmitKilledEnemyParticle)
  _GM_Import(GM_EmitTinyFlash)
  _GM_Import(GM_EmitGlitter)
  _GM_Import(GM_EmitGhost)
  
  _GM_Import(GM_DisplayWhiteLight)
  _GM_Import(GM_DisplayYellowLight)
  _GM_Import(GM_DisplayCyanLight)
  
  _GM_Import(GM_FieldCollision)
  _GM_Import(GM_PlayerCollision)
  _GM_Import(GM_PlayerGroundCollision)
  _GM_Import(GM_DoWallCollision)
  _GM_Import(GM_DoGroundCollision)
  _GM_Import(GM_DetectNextBarrier)
  _GM_Import(GM_Damage)
  
  _GM_Import(GM_CreateObject)
  _GM_Import(GM_FreeObject)
  _GM_Import(GM_DeleteAllOf)
  _GM_Import(GM_IsObjectDestroyed)
  
  _GM_Import(GM_StickPlayerOn)
  _GM_Import(GM_HideObject)
  
  _GM_Import(GM_Bank)
  _GM_Import(GM_BankFunction)
  
  _GM_Import(GM_CreateObjectAction)
  _GM_Import(GM_FreeObjectAction)
  _GM_Import(GM_InitializeObjectAction)
  
  _GM_Import(GM_ObjectActionSelection)
  _GM_Import(GM_ObjectActionID)
  _GM_Import(GM_ObjectActionMemory)
  _GM_Import(GM_SetObjectActionMemory)
  _GM_Import(GM_ObjectActionName_)
  
  _GM_Import(GM_CallObjectAction)
  _GM_Import(GM_EditObjectAction)
  _GM_Import(GM_AddScore)
  _GM_Import(GM_AddScoreTM)
  _GM_Import(GM_AddScoreNMTM)
  
  _GM_Import(GM_EnhanceMultiplier)
  _GM_Import(GM_ShowComment)
  
  _GM_Import(GM_AddCoin)
  _GM_Import(GM_AddSuperCoin)
  _GM_Import(GM_CountCoin)
  _GM_Import(GM_CountSuperCoin)
  _GM_Import(GM_GetItem)
  _GM_Import(GM_AddItem)
  _GM_Import(GM_ItemCount)
  
  _GM_Import(GM_SaveInteger)
  _GM_Import(GM_LoadInteger)
  _GM_Import(GM_SaveFloat)
  _GM_Import(GM_LoadFloat)
  _GM_Import(GM_SaveText)
  _GM_Import(GM_LoadText_)
  
  _GM_Import(GM_SaveFieldPosition)
  _GM_Import(GM_LoadFieldPosition)
  _GM_Import(GM_LoadPixelPosition)
  
  _GM_Import(GM_SaveObjectAction)
  _GM_Import(GM_LoadObjectAction)
  
  _GM_Import(GM_SaveActNumber)
  _GM_Import(GM_LoadActNumber)
  
  _GM_Import(GM_SaveSelection)
  _GM_Import(GM_LoadSelection)
  _GM_Import(GM_SaveObjectSelection)
  _GM_Import(GM_LoadObjectSelection)
  
  _GM_Import(GM_SaveGame)
  
  _GM_Import(GM_ShowMessage)
  _GM_Import(GM_EditMessage_)
  _GM_Import(GM_EditInteger)
  _GM_Import(GM_EditString_)
  
  _GM_Import(GM_Select)
  _GM_Import(GM_SelectObjects)
  _GM_Import(GM_SelectSingleObject)
  _GM_Import(GM_EditSelection)
  _GM_Import(GM_SelectField)
  
  _GM_Import(GM_SelectAct)
  
  _GM_Import(GM_CreateSelection)
  _GM_Import(GM_InitializeSelection)
  _GM_Import(GM_InitializeObjectSelection)
  _GM_Import(GM_FreeSelection)
  
  _GM_Import(GM_SelectionSize)
  _GM_Import(GM_SelectedScene)
  _GM_Import(GM_SelectedX)
  _GM_Import(GM_SelectedY)
  _GM_Import(GM_SelectedObject)
  
  _GM_Import(GM_HideSelectedObjects)
  _GM_Import(GM_ForEachSelectedObject)
  
  _GM_Import(GM_IsPlayerInSelection)
  
  _GM_Import(GM_ActName_)
  _GM_Import(GM_GetAct)
  _GM_Import(GM_GetActByNumber)
  _GM_Import(GM_UseAct)
  _GM_Import(GM_ReleaseAct)
  
  _GM_Import(GM_ChangeAct)
  _GM_Import(GM_AddParallelAct)
  _GM_Import(GM_RemoveParallelAct)
  _GM_Import(GM_EventsRemaining)
  
  _GM_Import(GM_EventAct)
  _GM_Import(GM_StopEvent)
  
  _GM_Import(GM_EffectEvent)
  _GM_Import(GM_EffectAct)
  
  _GM_Import(GM_CameraFollowPlayer)
  _GM_Import(GM_CameraFollowObject)
  _GM_Import(GM_CameraSetOnField)
  
  _GM_Import(GM_FadeIn)
  _GM_Import(GM_FadeOff)
  
  _GM_Import(GM_Function)
  _GM_Import(GM_Callback)
  
  _GM_Import(GM_Quit)
  
  _GM_Import(GM_IsReplay)
  
  _GM_Import(GM_Debug)
  
  ; Get addresses:
  *GM_Player = GM_Player()
EndProcedure

;Wrap functions with results of a string:
Procedure.s GM_ObjectActionName(*Action)
  ProcedureReturn PeekS(GM_ObjectActionName_(*Action))
EndProcedure
Procedure.s GM_LoadText()
  ProcedureReturn PeekS(GM_LoadText_())
EndProcedure
Procedure.s GM_EditMessage(Title.s, Message.s = "")
  ProcedureReturn PeekS(GM_EditMessage_(Title, Message))
EndProcedure
Procedure.s GM_EditString(Title.s, Text.s, String.s)
  ProcedureReturn PeekS(GM_EditString_(Title, Text, String))
EndProcedure
Procedure.s GM_ActName(*Act)
  ProcedureReturn PeekS(GM_ActName_(*Act))
EndProcedure




Procedure.s Form(Number.i, Singular.s, Plural.s)
  If Number = 1 Or Number = -1
    ProcedureReturn Str(Number) + " " + Singular
  Else
    ProcedureReturn Str(Number) + " " + Plural
  EndIf
EndProcedure

Macro ReturnViewRegion(FieldX, FieldY, FieldWidth, FieldHeight)
  ViewRegion\X = FieldX * #GM_FieldSize
  ViewRegion\Y = FieldY * #GM_FieldSize
  ViewRegion\Width = FieldWidth * #GM_FieldSize
  ViewRegion\Height = FieldHeight * #GM_FieldSize
  
  ProcedureReturn @ViewRegion
EndMacro
Macro ReturnString(Content)
  String = Content
  ProcedureReturn @String
EndMacro

Global *Shot.GM_Shot, *EditorObject.GM_EditorObject, ViewRegion.GM_ViewRegion, String.s
Global *EditorEvent.GM_EditorEvent, *EditorEffect.GM_EditorEffect
Global *ObjectAction.GM_ObjectAction, *EditorObjectAction.GM_EditorObjectAction