#Message_Width  = 210
#Message_Height = 120



Procedure.i ShowMessage(Title.s, Message.s)
  Protected Window.i, EditorGadget.i, OKButton.i
  Protected Event.i, EventWindow.i, EventGadget.i
  
  Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, #Message_Width, #Message_Height + 30, Title, #PB_Window_ScreenCentered|#PB_Window_SystemMenu, WindowID(#ScreenWindow))
    EditorGadget = EditorGadget(#PB_Any, 0, 0, #Message_Width, #Message_Height, #PB_Editor_ReadOnly)
    OKButton     = ButtonGadget(#PB_Any, 5, #Message_Height + 5, #Message_Width - 10, 20, "OK")
  
  SetGadgettext(EditorGadget, Message)
  EditorGadgetEnableWordWrap(EditorGadget, #True)
  
  Repeat
    Event       = WaitWindowEvent()
    EventWindow = EventWindow()
    EventGadget = EventGadget()
    
    If EventWindow = Window
      Select Event
        Case #PB_Event_Gadget
          If EventGadget = OKButton
            Break
          EndIf
        Case #PB_Event_CloseWindow
          Break
        Case #WM_KEYDOWN
          If EventwParam() = #VK_RETURN
            Break
          EndIf
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(Window)
  ProcedureReturn #True
EndProcedure
Procedure.s EditMessage(Title.s, Message.s = "")
  Protected Window.i, EditorGadget.i, ApplyButton.i, CancelButton.i
  Protected Event.i, EventWindow.i, EventGadget.i
  
  Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, #Message_Width, #Message_Height + 30, Title, #PB_Window_ScreenCentered|#PB_Window_SystemMenu, WindowID(#ScreenWindow))
    EditorGadget = EditorGadget(#PB_Any, 0, 0, #Message_Width, #Message_Height)
    ApplyButton  = ButtonGadget(#PB_Any, 5, #Message_Height + 5, (#Message_Width - 10)/2, 20, "Apply")
    CancelButton = ButtonGadget(#PB_Any, 5 + (#Message_Width - 10)/2, #Message_Height + 5, (#Message_Width - 10)/2, 20, "Cancel")
  
  SetGadgetText(EditorGadget, Message)
  EditorGadgetEnableWordWrap(EditorGadget, #True)
  
  Repeat
    Event       = WaitWindowEvent()
    EventWindow = EventWindow()
    EventGadget = EventGadget()
    
    If EventWindow = Window
      Select Event
        Case #PB_Event_Gadget
          If EventGadget = ApplyButton
            Message = GetGadgetText(EditorGadget)
            Break
          ElseIf EventGadget = CancelButton
            Break
          EndIf
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(Window)
  ProcedureReturn Message
EndProcedure

Procedure.i EditInteger(Title.s, Text.s, Number.i, Min.i, Max.i)
  Protected Window.i, Event.i
  Protected TextGadget.i, NumberSpin.i, OKButton.i, CancelButton.i
  
  Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 320, 100, Title, #PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    TextGadget   = TextGadget(#PB_Any, 10, 10, 300, 40, Text)
    NumberSpin   = SpinGadget(#PB_Any, 10, 64, 150, 20, Min, Max, #PB_Spin_Numeric)
    OKButton     = ButtonGadget(#PB_Any, 170, 60, 70, 30, "OK")
    CancelButton = ButtonGadget(#PB_Any, 240, 60, 70, 30, "Cancel")
    
  _Lim(Number, Min, Max)
  SetGadgetState(NumberSpin, Number)
  
  Repeat
    Event = WaitWindowEvent()
    
    If EventWindow() = Window
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
            Case OKButton
              Number = GetGadgetState(NumberSpin)
              CloseWindow(Window)
              ProcedureReturn Number
            Case CancelButton
              Break
          EndSelect
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(Window)
  ProcedureReturn Number
EndProcedure
Procedure.s EditString(Title.s, Text.s, String.s)
  Protected Window.i, Event.i
  Protected TextGadget.i, StringGadget.i, OKButton.i, CancelButton.i
  
  Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 320, 100, Title, #PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    TextGadget   = TextGadget(#PB_Any, 10, 10, 300, 40, Text)
    StringGadget = StringGadget(#PB_Any, 10, 64, 150, 20, String)
    OKButton     = ButtonGadget(#PB_Any, 170, 60, 70, 30, "OK")
    CancelButton = ButtonGadget(#PB_Any, 240, 60, 70, 30, "Cancel")
  
  Repeat
    Event = WaitWindowEvent()
    
    If EventWindow() = Window
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
            Case OKButton
              String = GetGadgetText(StringGadget)
              CloseWindow(Window)
              ProcedureReturn String
            Case CancelButton
              Break
          EndSelect
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(Window)
  ProcedureReturn String
EndProcedure

CompilerIf #Mode = #Mode_Editor

Procedure.i SelectObjectAction(*Action.ObjectAction)
  Protected Window.i, SelectButton.i, CancelButton.i, DescriptionEditor.i, DescriptionFrame.i, ListGadget.i
  Protected Event.i, Index.i, Count.i
  Protected *Actions.Queue, *Item.QueueItem, SelectedAction.i = #None
  
  Count = ObjectActionCount(*Action\Registered)
  If Not Count
    MessageRequester("Warning", "No actions available for " + #Q + ObjectName(*Action\Registered\Entry) + #Q + ".", #MB_ICONWARNING)
    ProcedureReturn #None
  EndIf
  
  Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 400, 465, "Select Action (" + ObjectName(*Action\Registered\Entry) + ")", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    SelectButton      = ButtonGadget(#PB_Any, 10, 10, 50, 30, "Select")
    CancelButton      = ButtonGadget(#PB_Any, 340, 10, 50, 30, "Cancel")
    DescriptionEditor = EditorGadget(#PB_Any, 20, 380, 360, 70)
    DescriptionFrame  = Frame3DGadget(#PB_Any, 10, 360, 380, 100, "Description")
    ListGadget        = ListIconGadget(#PB_Any, 10, 50, 380, 300, "Action", 376)
  
  For Index = 0 To Count - 1
    AddGadgetItem(ListGadget, -1, ObjectActionName(*Action\Registered, Index))
  Next
  
  Repeat
    Event = WaitWindowEvent()
    
    If EventWindow() = Window
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
            Case SelectButton
              Break
            Case CancelButton
              SelectedAction = *Action\Action
              Break
            Case ListGadget
              Select EventType()
                Case #PB_EventType_LeftClick
                  Index = GetGadgetState(ListGadget)
                  If Index <> #None
                    SelectedAction = Index
                    SetGadgetText(DescriptionEditor, ObjectActionDescription(*Action\Registered, SelectedAction))
                  EndIf
                Case #PB_EventType_LeftDoubleClick
                  Break
              EndSelect
          EndSelect
        Case #PB_Event_CloseWindow
          SelectedAction = *Action\Action
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(Window)
  ProcedureReturn SelectedAction
EndProcedure
Procedure.i SelectAct(Title.s, Text.s, *DefaultAct.Act = #Null, AllowNoAct.i = #False, AllowNewAct.i = #False)
  Protected Window.i, Event.i, EventType.i
  Protected ListGadget.i, TextGadget.i, OKButton.i, NewButton.i, CancelButton.i
  Protected *Item.QueueItem, *Act.Act, *CurrentAct.Act, CurrentIndex.i, String.s
  
  Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 350, 370, Title, #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar, WindowID(#ScreenWindow))
    ListGadget   = ListIconGadget(#PB_Any, 10, 60, 330, 260, "Act", 325, #PB_ListIcon_AlwaysShowSelection)
    TextGadget   = TextGadget(#PB_Any, 10, 10, 330, 40, Text)
    OKButton     = ButtonGadget(#PB_Any, 10, 330, 70, 30, "OK")
    CancelButton = ButtonGadget(#PB_Any, 230, 330, 70, 30, "Cancel")
    
    If AllowNewAct : NewButton = ButtonGadget(#PB_Any, 80, 330, 70, 30, "New") : EndIf
  
  If AllowNoAct
    AddGadgetItem(ListGadget, -1, "<None>")
  EndIf
  
  *Item = *Acts\First
  While *Item
    *Act = *Item\Memory
    
    AddGadgetItem(ListGadget, -1, *Act\Name)
    SetGadgetItemData(ListGadget, CountGadgetItems(ListGadget) - 1, *Act)
    If *Act = *DefaultAct
      SetGadgetState(ListGadget, CountGadgetItems(ListGadget) - 1)
    EndIf
    
    _Move(*Item, N)
  Wend
  
  *CurrentAct = *DefaultAct
  
  Repeat
    Event = WaitWindowEvent()
    
    If EventWindow() = Window
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
            Case ListGadget
              EventType = EventType()
              If EventType = #PB_EventType_LeftClick
                CurrentIndex = GetGadgetState(ListGadget)
                If CurrentIndex <> #None
                  *CurrentAct = GetGadgetItemData(ListGadget, CurrentIndex)
                EndIf
              ElseIf EventType = #PB_EventType_LeftDoubleClick
                Editor\LeftClickAllowed = #False
                Break
              EndIf
            Case NewButton
              String = InputRequester("New Act", "Enter name, please:", "")
              If String
                *CurrentAct = CreateAct(String)
                Break
              EndIf
            Case OKButton
              Break
            Case CancelButton
              *CurrentAct = *DefaultAct
              Break
          EndSelect
        Case #PB_Event_CloseWindow
          *CurrentAct = *DefaultAct
          Break
      EndSelect
    EndIf
  ForEver
  
  CloseWindow(Window)
  ProcedureReturn *CurrentAct           
EndProcedure

CompilerEndIf

CompilerIf #Mode = #Mode_Game

Global FadeInOff_Sprite.i
Procedure.i FadeIn(Color.i = #Black, DisplayPlayer.i = #True)
  Protected Finish.i, Dim FadeTransparency.i(#SceneWidth - 1, #SceneHeight + 1)
  Protected X.i, Y.i
  
  If FadeInOff_Sprite
    FreeSprite(FadeInOff_Sprite)
  EndIf
  
  FadeInOff_Sprite = CreateSprite(#PB_Any, #FieldSize, #FieldSize, #PB_Sprite_Memory)
    TransparentSpriteColor(FadeInOff_Sprite, #Magenta)
  StartDrawing(SpriteOutput(FadeInOff_Sprite))
    Box(0, 0, #FieldSize, #FieldSize, Color)
  StopDrawing()
  
  For X = 0 To #SceneWidth - 1
    For Y = 0 To #SceneHeight + 1
      FadeTransparency(X, Y) = -Random(100)
    Next
  Next
  
  Repeat
    StartSpecialFX()
      ExaminePlayer()
      ExamineParticles()
      ExamineCamera()
      
      DisplayBackground(Player\Scene\Background)
      Start3D()
        DisplayScene(DisplayPlayer)
      Stop3D()
      
      DrawHUD()
      
      Finish = #True
      For X = 0 To #SceneWidth - 1
        For Y = 0 To #SceneHeight + 1
          If FadeTransparency(X, Y) > 0
            DisplayTranslucentSprite(FadeInOff_Sprite, X * #FieldSize, Y * #FieldSize, FadeTransparency(X, Y))
          EndIf
          FadeTransparency(X, Y) + 8
          If FadeTransparency(X, Y) => 255
            FadeTransparency(X, Y) = 255
          Else
            Finish = #False
          EndIf
        Next
      Next
    StopSpecialFX()
    
    FlipBuffers()
    
    OptimizeFPS()
  Until Finish
EndProcedure
Procedure.i FadeOff(DisplayPlayer.i = #True)
  Protected Finish.i, Dim FadeTransparency.i(#SceneWidth - 1, #SceneHeight + 1)
  Protected X.i, Y.i
  
  If Not FadeInOff_Sprite
    ProcedureReturn #False
  EndIf
  
  For X = 0 To #SceneWidth - 1
    For Y = 0 To #SceneHeight + 1
      FadeTransparency(X, Y) = 255 + Random(100)
    Next
  Next
  
  Repeat
    StartSpecialFX()
      ExaminePlayer()
      ExamineParticles()
      ExamineCamera()
      
      DisplayBackground(Player\Scene\Background)
      Start3D()
        DisplayScene(DisplayPlayer)
      Stop3D()
      
      DrawHUD()
      
      Finish = #True
      For X = 0 To #SceneWidth - 1
        For Y = 0 To #SceneHeight + 1
          If FadeTransparency(X, Y) > 0
            If FadeTransparency(X, Y) > 255
              DisplayTranslucentSprite(FadeInOff_Sprite, X * #FieldSize, Y * #FieldSize, 255)
            Else
              DisplayTranslucentSprite(FadeInOff_Sprite, X * #FieldSize, Y * #FieldSize, FadeTransparency(X, Y))
            EndIf
          EndIf
          FadeTransparency(X, Y) - 8
          If FadeTransparency(X, Y) <= 0
            FadeTransparency(X, Y) = 0
          Else
            Finish = #False
          EndIf
        Next
      Next
    StopSpecialFX()
    
    FlipBuffers()
    
    OptimizeFPS()
  Until Finish
EndProcedure

Procedure.i MakeScreenshot()
  Protected Sprite.i, Number.i
  
  Sprite = GrabSprite(#PB_Any, 0, 0, #ScreenWidth, #ScreenHeight)
  Repeat
    Number + 1
  Until FileSize("Screenshot " + Str(Number) + ".bmp") = -1
  SaveSprite(Sprite, "Screenshot " + Str(Number) + ".bmp", #PB_ImagePlugin_BMP)
  
  ProcedureReturn Number
EndProcedure
Procedure.i OpenScreenshotMode()
  Protected ScreenshotSprite.i, PushX.i, PushY.i
  Protected Event.i, EventwParam.i, IsPlaying.i, FixCamera.i
  Protected SlowPlayerPlaying.i, SlowObjectPlaying.i, FastPlaying.i
  Protected Time.i
  
  ScreenshotSprite = LoadSprite(#PB_Any, "Graphics\Menu\ScreenshotMode.bmp")
  TransparentSpriteColor(ScreenshotSprite, $FF00FF)
  
  Repeat
    Event       = WindowEvent()
    EventwParam = EventwParam()
    
    ; Kameraposition durch die mittlere Maustaste verndern:
    If Event = #WM_MBUTTONDOWN
      PushX     = GetMouseX()
      PushY     = GetMouseY()
      FixCamera = #True
    ElseIf Event = #WM_MOUSEMOVE And EventwParam & #MK_MBUTTON
      MoveCameraPosition(PushX - GetMouseX(), PushY - GetMouseY())
      PushX = GetMouseX()
      PushY = GetMouseY()
    ElseIf Event = #WM_MBUTTONUP
      FixCamera = #False
    EndIf
    
    If IsPlaying
      ; Spiel weiter spielen:
      If (SlowPlayerPlaying And Time % 10 = 0) Or Not SlowPlayerPlaying
        ExaminePlayer()
        ExamineParticles()
      EndIf
      
      If Not FixCamera
        ; Kamera soll weiter den Spieler verfolgen:
        ExamineCamera()
      Else
        ; Eigene Kameraposition wird verwendet:
        UpdateCamera()
      EndIf
      
      If (SlowObjectPlaying And Time % 10 = 0) Or Not SlowObjectPlaying
        StartSpecialFX()
          DisplayBackground(Player\Scene\Background)
          
          Start3D()
            PlayAndDisplayScene()
          Stop3D()
        StopSpecialFX()
      Else
        StartSpecialFX()
          DisplayBackground(Player\Scene\Background)
          
          Start3D()
            DisplayScene()
          Stop3D()
        StopSpecialFX()
      EndIf
    Else
      StartSpecialFX()
        DisplayBackground(Player\Scene\Background)
        
        Start3D()
          DisplayScene()
        Stop3D()
      StopSpecialFX()
      
      OptimizeFPS()
    EndIf
    
    DrawHUD()
    
    If KeyPressedDown(#VK_RETURN)
      MakeScreenshot()
    Else
      ; Symbol fr den Screenshot-Modus anzeigen:
      DisplayTransparentSprite(ScreenshotSprite, 5, 5)
      
      FlipBuffers()
    EndIf
    
    If KeyPressedDown(#VK_SPACE)
      IsPlaying = #True - IsPlaying
    ElseIf KeyPressedDown(#VK_F1)
      SlowPlayerPlaying = #True - SlowPlayerPlaying
    ElseIf KeyPressedDown(#VK_F2)
      SlowObjectPlaying = #True - SlowObjectPlaying
    ElseIf KeyPressedDown(#VK_F3)
      FastPlaying = #True - FastPlaying
    EndIf
    
    OptimizeFPS()
    
    Time + 1
  Until KeyPressedDown(#VK_F11)
EndProcedure

CompilerEndIf
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 491
; FirstLine = 131
; Folding = Q5
; EnableXP