Procedure.i GetItem(Name.s, *Callback = #Null)
  Protected *Item.Item, *QueueItem.QueueItem
  
  *QueueItem = *Items\First
  While *QueueItem
    *Item = *QueueItem\Memory
    
    If *Item\Name = Name
      ProcedureReturn *Item
    EndIf
    
    _Move(*QueueItem, N)
  Wend
  
  *Item = _New(Item)
  AppendQueueItem(*Items, *Item)
  
  *Item\Name     = Name
  *Item\Sprite3D = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, GetFile("Graphics\Items\" + Name + ".png"), #PB_Sprite_Texture|#PB_Sprite_Memory|#PB_Sprite_AlphaBlending))
  *Item\Callback = *Callback
  *Item\Count    = 0
  *Item\MaxCount = #None
  
  ProcedureReturn *Item
EndProcedure
Procedure.i AddItem(*Item.Item, Count.i = 1)
  *Item\Count + Count
  
  If *Item\Count < 0
    *Item\Count = 0
  EndIf
  
  ProcedureReturn *Item\Count
EndProcedure
Procedure.i UseItem(Index)
  With Player
  
  If \UsingItem[Index] And \UsingItem[Index]\Count
    If _Call(\UsingItem[Index]\Callback, \UsingItem[Index], #Item_Use, #Null)
      \UsingItem[Index]\Count - 1
      If \UsingItem[Index]\Count = 0
        \UsingItem[Index] = #Null
      EndIf
    EndIf
  EndIf
  
  EndWith
EndProcedure



Procedure.i Item_Coin(*Item.Item, Event.i, *Parameter)
  Select Event
    Case #Item_NamePlural
      ProcedureReturn @"Coins"
    Case #Item_NameSingular
      ProcedureReturn @"Coin"
    Case #Item_IsUseable
      ProcedureReturn #False
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i Item_SuperCoin(*Item.Item, Event.i, *Parameter)
  Select Event
    Case #Item_NamePlural
      ProcedureReturn @"Cyan coins"
    Case #Item_NameSingular
      ProcedureReturn @"Cyan coin"
    Case #Item_IsUseable
      ProcedureReturn #False
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

Procedure.i AddPredefinedItems()
  *CoinItem      = GetItem("Coin"     , @Item_Coin())
  *SuperCoinItem = GetItem("SuperCoin", @Item_SuperCoin())
  
  *CoinItem\MaxCount      = 0
  *SuperCoinItem\MaxCount = 0
EndProcedure



#Inventory_Width  = 9
#Inventory_Height = 5

#InventoryEntry_Width       = 46
#InventoryEntry_Height      = 48
#InventoryEntry_InnerWidth  = 44
#InventoryEntry_InnerHeight = 34

#Inventory_PixelWidth  = #Inventory_Width * #InventoryEntry_Width
#Inventory_PixelHeight = #Inventory_Height * #InventoryEntry_Height

Procedure.i OpenInventory()
  Protected BackgroundSprite.i, EntrySprite.i, EntryHoverSprite.i
  Protected Dim *Item.Item(#Inventory_Width - 1, #Inventory_Height - 1), X.i, Y.i, *QueueItem.QueueItem
  Protected Event.i, ItemX.i, ItemY.i, HUDItem.i
  
  BackgroundSprite = GrabSprite(#PB_Any, 0, 0, #ScreenWidth, #ScreenHeight, #PB_Sprite_Memory)
  EntrySprite      = LoadSprite(#PB_Any, "Graphics\Menu\InventoryEntry.bmp", #PB_Sprite_Memory)
  EntryHoverSprite = LoadSprite(#PB_Any, "Graphics\Menu\InventoryEntryHover.bmp", #PB_Sprite_Memory)
  
  *QueueItem = *Items\First
  For Y = 0 To #Inventory_Height - 1
    For X = 0 To #Inventory_Width - 1
      If *QueueItem
        If Not (*QueueItem\Memory = Player\UsingItem[0] Or *QueueItem\Memory = Player\UsingItem[1] Or *QueueItem\Memory = Player\UsingItem[2])
          *Item(X, Y) = *QueueItem\Memory
        Else
          X - 1
        EndIf
        _Move(*QueueItem, N)
      Else
        Break 2
      EndIf
    Next
  Next
  
  Repeat
    Event = WindowEvent()
    
    If Replay = 2
      ; Tastendrcke aus Replay lesen:
      ReplayKeys()
    Else
      ; Tastendrcke aus Tastatur oder Joystick lesen:
      ExamineControl()
      
      If Replay = 1
        ; Steuerung in ein neues Replay speichern:
        RecordKeys()
      EndIf
    EndIf
    
    StartSpecialFX()
      DisplaySprite(BackgroundSprite, 0, 0)
      
      DrawHUD()
      
      ; Hintergrund aller Zellen zeigen:
      For Y = 0 To #Inventory_Height - 1
        For X = 0 To #Inventory_Width - 1
          DisplaySprite(EntrySprite, #ScreenWidth/2 - #Inventory_PixelWidth/2 + X * #InventoryEntry_Width, #ScreenHeight/2 - #Inventory_PixelHeight/2 + Y * #InventoryEntry_Height)
        Next
      Next
      DisplaySprite(EntryHoverSprite, #ScreenWidth/2 - #Inventory_PixelWidth/2 + ItemX * #InventoryEntry_Width, #ScreenHeight/2 - #Inventory_PixelHeight/2 + ItemY * #InventoryEntry_Height)
      
      ; Anzahl der Items zeigen:
      For Y = 0 To #Inventory_Height - 1
        For X = 0 To #Inventory_Width - 1
          If *Item(X, Y)
            If *Item(X, Y)\MaxCount <> #None
              DisplayNumber(#ScreenWidth/2 - #Inventory_PixelWidth/2 + X * #InventoryEntry_Width + 2, #ScreenHeight/2 - #Inventory_PixelHeight/2 + (Y + 1) * #InventoryEntry_Height - 2 - 8, Str(*Item(X, Y)\Count) + "/" + Str(*Item(X, Y)\MaxCount), *TinyMessageCharSet)
            Else
              DisplayNumber(#ScreenWidth/2 - #Inventory_PixelWidth/2 + X * #InventoryEntry_Width + 2, #ScreenHeight/2 - #Inventory_PixelHeight/2 + (Y + 1) * #InventoryEntry_Height - 2 - 8, Str(*Item(X, Y)\Count), *TinyMessageCharSet)
            EndIf
          EndIf
        Next
      Next
      
      ; Name des Items zeigen, auf das gezeigt wird:
      If ItemX <> #None And ItemY <> #None And *Item(ItemX, ItemY)
        If *Item(ItemX, ItemY)\Count = 1
          DisplayText(5, #ScreenHeight - #FieldSize, UCase(PeekS(_Call(*Item(ItemX, ItemY)\Callback, *Item(ItemX, ItemY), #Item_NameSingular, #Null))), *StandardCharSet)
        Else
          DisplayText(5, #ScreenHeight - #FieldSize, UCase(PeekS(_Call(*Item(ItemX, ItemY)\Callback, *Item(ItemX, ItemY), #Item_NamePlural, #Null))), *StandardCharSet)
        EndIf
      EndIf
      
      Start3D()
        ; Symbole fr jedes Item darstellen:
        For Y = 0 To #Inventory_Height - 1
          For X = 0 To #Inventory_Width - 1
            If *Item(X, Y)
              DisplaySprite3D(*Item(X, Y)\Sprite3D, #ScreenWidth/2 - #Inventory_PixelWidth/2 + X * #InventoryEntry_Width + #InventoryEntry_InnerWidth/2 - #FieldSize/2, #ScreenHeight/2 - #Inventory_PixelHeight/2 + Y * #InventoryEntry_Height + #InventoryEntry_InnerHeight/2 - #FieldSize/2)
            EndIf
          Next
        Next
      Stop3D()
    StopSpecialFX()
    
    FlipBuffers()
    
    If Player\KeyPressed[#Player_Key_Left]
      If ItemX = 0
        ItemX = #Inventory_Width - 1
      Else
        ItemX - 1
      EndIf
    ElseIf Player\KeyPressed[#Player_Key_Right]
      If ItemX = #Inventory_Width - 1
        ItemX = 0
      Else
        ItemX + 1
      EndIf
    EndIf
    If Player\KeyPressed[#Player_Key_Up]
      If ItemY = 0
        ItemY = #Inventory_Height - 1
      Else
        ItemY - 1
      EndIf
    ElseIf Player\KeyPressed[#Player_Key_Down]
      If ItemY = #Inventory_Height - 1
        ItemY = 0
      Else
        ItemY + 1
      EndIf
    EndIf
    
    If Player\KeyPressed[#Player_Key_ItemA]
      HUDItem = 0
    ElseIf Player\KeyPressed[#Player_Key_ItemB]
      HUDItem = 1
    ElseIf Player\KeyPressed[#Player_Key_ItemC]
      HUDItem = 2
    Else
      HUDItem = #None
    EndIf
    
    If HUDItem <> #None And *Item(ItemX, ItemY) And *Item(ItemX, ItemY)\Count And _Call(*Item(ItemX, ItemY)\Callback, *Item(ItemX, ItemY), #Item_IsUseable, #Null) = #True
      Swap Player\UsingItem[HUDItem], *Item(ItemX, ItemY)
    EndIf
    
    OptimizeFPS(15)
  Until Player\KeyPressed[#Player_Key_Inventory]
  
  FreeSprite(BackgroundSprite)
  FreeSprite(EntrySprite)
  FreeSprite(EntryHoverSprite)
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 122
; FirstLine = 36
; Folding = A-
; EnableXP