Procedure.i ReadTilesets()
  Protected TilesetCount.i, TileCount.i, Index.i, Index2.i, Number.i
  Protected *Tileset.Tileset
  
  TilesetCount = ReadInteger(IO_InputFile)
  TileCount    = ReadInteger(IO_InputFile)
  
  If TileCount
    ReDim Tile(TileCount - 1)
  
    For Index = 1 To TilesetCount
      *Tileset  = LoadTileset(ReadNTString(IO_InputFile))
      TileCount = ReadCharacter(IO_InputFile)
      For Index2 = 1 To TileCount
        Tile(Number) = LoadTileByIndex(*Tileset, ReadWord(IO_InputFile))
        Number + 1
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadBanks()
  Protected BankCount.i, ObjectCount.i, Index.i, Index2.i, Number.i
  Protected *Bank.Bank
  
  BankCount   = ReadInteger(IO_InputFile)
  ObjectCount = ReadInteger(IO_InputFile)
  
  If ObjectCount
    ReDim *Object(ObjectCount - 1)
    
    For Index = 1 To BankCount
      *Bank = LoadBank(ReadNTString(IO_InputFile))
      CallBankLoadFunction(*Bank)
      
      ObjectCount = ReadCharacter(IO_InputFile)
      
      For Index2 = 1 To ObjectCount
        *Object(Number) = LoadObject(*Bank, ReadNTString(IO_InputFile))
        GlobalLoadObject(*Object(Number))
        Number + 1
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadBackgrounds()
  Protected BackgroundCount.i, Index.i, Number.i
  
  BackgroundCount = ReadInteger(IO_InputFile)
  
  If BackgroundCount
    ReDim Background(BackgroundCount - 1)
  
    For Index = 1 To BackgroundCount
      Background(Number) = LoadBackground(ReadNTString(IO_InputFile))
      Number + 1
    Next
  EndIf
EndProcedure
Procedure.i ReadEvents()
  Protected EventBankCount.i, EventCount.i, Index.i, Index2.i, Number.i
  Protected *EventBank.EventBank, Method.s, ID.i
  
  EventBankCount = ReadWord(IO_InputFile)
  EventCount     = ReadWord(IO_InputFile)
  
  If EventCount
    ReDim *Event(EventCount - 1)
    
    For Index = 1 To EventBankCount
      *EventBank = LoadEventBank(ReadNTString(IO_InputFile))
      EventCount = ReadWord(IO_InputFile)
      
      For Index2 = 1 To EventCount
        Method = ReadNTString(IO_InputFile)
        *Event(Number) = LoadEvent(*EventBank, Method, #True)
        
        ID = SpecialEventID(Method)
        If ID <> #None
          *SpecialEventCallback(ID) = *Event(Number)
        EndIf
        
        Number + 1
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadEffects()
  Protected EffectBankCount.i, EffectCount.i, Index.i, Index2.i, Number.i
  Protected *EffectBank.EffectBank
  
  EffectBankCount = ReadWord(IO_InputFile)
  EffectCount     = ReadWord(IO_InputFile)
  
  If EffectCount
    ReDim *Effect(EffectCount - 1)
    
    For Index = 1 To EffectBankCount
      *EffectBank = LoadEffectBank(ReadNTString(IO_InputFile))
      EffectCount = ReadWord(IO_InputFile)
      
      For Index2 = 1 To EffectCount
        *Effect(Number) = LoadEffect(*EffectBank, ReadNTString(IO_InputFile), #True)
        Number + 1
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadActs()
  Protected ActCount.i, EventCount.i, EffectCount.i, Index.i, Index2.i, Index3.i
  Protected *Act.Act, *Event.Event, *Effect.Effect
  
  ActCount = ReadWord(IO_InputFile)
  If ActCount
    ReDim *IO_Act(ActCount - 1)
    
    For Index = 1 To ActCount
      *Act               = CreateAct(ReadNTString(IO_InputFile))
      *Act\Description   = ReadNTString(IO_InputFile)
      *IO_Act(Index - 1) = *Act
      
      EventCount = ReadWord(IO_InputFile)
      For Index2 = 1 To EventCount
        *Event = CreateLoadEvent(*Act, *Event(ReadWord(IO_InputFile)))
        CheckSpecialEvent(*Act, *Event)
        
        EffectCount = ReadWord(IO_InputFile)
        ReadNTString(IO_InputFile) ;Kommentar ignorieren
        _Call(*Event\Callback, *Event, #Event_Load, #Null)
        
        For Index3 = 1 To EffectCount
          *Effect = CreateLoadEffect(*Event, *Effect(ReadWord(IO_InputFile)))
          ReadNTString(IO_InputFile) ;Kommentar ignorieren
          _Call(*Effect\Callback, *Effect, #Effect_Load, #Null)
        Next
      Next
    Next
  EndIf
EndProcedure
Procedure.i ReadScene(X.i, Y.i, *Main.Scene)
  Protected *Pointer.Integer, *Scene.Scene, Type.i
  Protected Integer.i, IndexX.i, IndexY.i
  Protected Width.i, Height.i
  
  *Pointer = Challange\Scenes + (Y * (Challange\Width + 1) + X) * _Sz(Integer)
  If *Pointer\i
    ProcedureReturn #False
  EndIf
  
  Type = ReadByte(IO_InputFile)
  If Type
    If *Main
      *Scene = *Main
      
      IO_X = (X - *Main\X) * #SceneWidth
      IO_Y = (Y - *Main\Y) * #SceneHeight
    Else
      Width  = ReadCharacter(IO_InputFile)
      Height = ReadCharacter(IO_InputFile)
      
      *Scene   = CreateScene(Width, Height)
      *Scene\X = X
      *Scene\Y = Y
      
      IO_X = 0
      IO_Y = 0
    EndIf
    
    *Pointer\i = *Scene
    
    If Type = 2
      ; Start Szene:
      Player\Scene  = *Scene
      Player\FieldX = ReadCharacter(IO_InputFile) + IO_X
      Player\FieldY = ReadCharacter(IO_InputFile) + IO_Y
      Player\X      = (Player\FieldX + 1) * #FieldSize - #FieldSize/2 - 11/2
      Player\Y      = (Player\FieldY + 1) * #FieldSize - 20
      
      Challange\StartScene = *Scene
      Challange\StartX     = Player\FieldX
      Challange\StartY     = Player\FieldY
    EndIf
    
    ; Tiles lesen:
    ReadTileGroup(*Scene, #BackgroundTile1)
    ReadTileGroup(*Scene, #BackgroundTile2)
    ReadTileGroup(*Scene, #BackgroundTile3)
    ReadTileGroup(*Scene, #Tile           )
    ReadTileGroup(*Scene, #Ground         )
    ReadTileGroup(*Scene, #ForegroundTile )
    
    ; Objekte lesen:
    ReadObjectGroup   (*Scene, #BackgroundObject1)
    ReadObjectGroup   (*Scene, #BackgroundObject2)
    ReadFixObjectGroup(*Scene                    )
    ReadObjectGroup   (*Scene, #ForegroundObject1)
    ReadObjectGroup   (*Scene, #ForegroundObject2)
    
    If Not *Main
      *Scene\Background = Background(ReadCharacter(IO_InputFile))
      
      ; Erlaubte Fhigkeiten:
      *Scene\AllowFly3       = ReadByte(IO_InputFile)
      *Scene\AllowLumiFlight = ReadByte(IO_InputFile)
      
      ; Effekte fr alle vier Rnder:
      Integer                = ReadByte(IO_InputFile)
      *Scene\HorinzontalLoop = Is(Integer & %01)
      *Scene\VerticalLoop    = Is(Integer & %10)
      *Scene\UnpassableTop   = ReadByte(IO_InputFile)
      
      ; Zugewiesenes Act:
      *Scene\Act = ReadInteger(IO_InputFile)
      
      ; Unterszenen einbinden:
      If *Scene\Width * *Scene\Height > 1
        For IndexY = Y To Y + *Scene\Height - 1
          For IndexX = X To X + *Scene\Width - 1
            If IndexX <> X Or IndexY <> Y
              ReadScene(IndexX, IndexY, *Scene)
            EndIf
          Next
        Next
      EndIf
    EndIf
  Else
    ProcedureReturn #False
  EndIf
EndProcedure
Procedure.i ReadTileGroup(*Scene.Scene, Group.i)
  Protected Size.i, Index.i, X.i, Y.i, *Group.Integer, TileIndex.i
  Protected *Tile.Tile, OldSize.i
  
  Size = ReadInteger(IO_InputFile)
  If Size
    *Group = *Scene + Group * _Sz(Integer)
    If *Group\i
      OldSize = MemorySize(*Group\i) - _Sz(Integer)
      *Group\i = ReallocateMemory(*Group\i, OldSize + (Size + 1) * _Sz(Integer))
      *Group   = *Group\i + OldSize - _Sz(Integer)
    Else
      *Group\i = AllocateMemory((Size + 2) * _Sz(Integer))
      *Group   = *Group\i
    EndIf
    
    Size - 1
    For Index = 0 To Size
      X         = ReadCharacter(IO_InputFile) + IO_X
      Y         = ReadCharacter(IO_InputFile) + IO_Y
      TileIndex = ReadWord(IO_InputFile)
      
      *Tile = CreateTile(Tile(TileIndex), X, Y)
      PokeI(*Group + Index * _Sz(Integer), *Tile)
    Next
    
    ProcedureReturn *Group
  Else
    ProcedureReturn #Null
  EndIf
EndProcedure
Procedure.i ReadObjectGroup(*Scene.Scene, Group.i)
  Protected Size.i, Index.i, Number.i
  Protected *SceneObject.Object
  
  Size = ReadInteger(IO_InputFile)
  If Size
    Size - 1
    For Index = 0 To Size
      Number = ReadWord(IO_InputFile)
      
      *SceneObject = CreateObject(*Object(Number), 0, 0, *Scene, Group)
      _Call(*Object(Number), *SceneObject, #Object_Load, #Null)
      
      *IO_SceneObject(IO_SceneObjectNumber) = *SceneObject
      IO_SceneObjectNumber + 1
    Next
  EndIf
EndProcedure
Procedure.i ReadFixObjectGroup(*Scene.Scene)
  Protected Size.i, Index.i, *Queue.Queue, Number.i
  Protected *SceneObject.Object, *Field.Field, X.i, Y.i
  
  Size = ReadInteger(IO_InputFile)
  If Size
    Size - 1
    For Index = 0 To Size
      Number = ReadWord(IO_InputFile)
      X      = ReadCharacter(IO_InputFile) + IO_X
      Y      = ReadCharacter(IO_InputFile) + IO_Y
      
      *SceneObject  = CreateObject(*Object(Number), X * #FieldSize, Y * #FieldSize, *Scene, #Object)
      _Call(*Object(Number), *SceneObject, #Object_Load, *Scene)
      
      *IO_SceneObject(IO_SceneObjectNumber) = *SceneObject
      IO_SceneObjectNumber + 1
    Next
  EndIf
EndProcedure
Procedure.i ReadScenes()
  Protected IndexY.i, IndexX.i
  
  Challange\Width  = ReadInteger(IO_InputFile) - 1
  Challange\Height = ReadInteger(IO_InputFile) - 1
  
  ; Array erstellen, dass fr Objekte als Basis zur Referenzierung dient:
  Challange\Scenes = AllocateMemory((Challange\Width + 1) * (Challange\Height + 1) * _Sz(Integer))
  
  IO_SceneObjectCount = ReadInteger(IO_InputFile)
  If IO_SceneObjectCount
    ReDim *IO_SceneObject(IO_SceneObjectCount - 1)
    
    IO_SceneObjectNumber = 0
  EndIf
  
  ; Ldt die Szenen aus dem Array (von links nach rechts und von oben nach unten):
  For IndexY = 0 To Challange\Height
    For IndexX = 0 To Challange\Width
      ReadScene(IndexX, IndexY, #Null)
    Next
  Next
EndProcedure

Procedure.i InitializeScenes()
  Protected IndexX.i, IndexY.i, *Cell.Integer, *Scene.Scene
  
  *Cell = Challange\Scenes
  For IndexY = 0 To Challange\Height
    For IndexX = 0 To Challange\Width
      *Scene = *Cell\i
      
      If *Scene And Not *Scene\Initialized
        If *Scene\Act <> #None
          *Scene\Act = *IO_Act(*Scene\Act)
        Else
          *Scene\Act = #Null
        EndIf
        
        *Scene\Initialized = #True
      EndIf
      
      *Cell + SizeOf(Integer)
    Next
  Next
EndProcedure
Procedure.i InitializeObjects()
  Protected Index.i, *Object.Object, *CurrentScene.Scene
  
  For Index = 0 To IO_SceneObjectCount - 1
    *Object = *IO_SceneObject(Index)
    If *Object\Scene <> *CurrentScene
      If *CurrentScene
        FreeTable()
      EndIf
      *CurrentScene = *Object\Scene
      CreateTable(*CurrentScene)
    EndIf
    
    _Call(*Object\Callback, *IO_SceneObject(Index), #Object_Initialize, #Null)
  Next
EndProcedure
Procedure.i InitializeActs()
  Protected *Item.QueueItem, *EventItem.QueueItem, *EffectItem.QueueItem
  Protected *Act.Act, *Event.Event, *Effect.Effect
  
  *Item = *Acts\First
  While *Item
    *Act        = *Item\Memory
    *EventItem = *Act\Events\First
    While *EventItem
      *Event = *EventItem\Memory
      
      *Event\IdleTime = #None
      
      _Call(*Event\Callback, *Event, #Event_Initialize, #Null)
      *EffectItem = *Event\Effects\First
      While *EffectItem
        *Effect = *EffectItem\Memory
        
        _Call(*Effect\Callback, *Effect, #Effect_Initialize, #Null)
        
        _Move(*EffectItem, N)
      Wend
      
      _Move(*EventItem, N)
    Wend
    
    _Move(*Item, N)
  Wend
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 347
; FirstLine = 97
; Folding = ow-
; EnableXP