Enumeration
  #ScreenGadget_Frame
  #ScreenGadget_Display3D
  #ScreenGadget_Display
  #ScreenGadget_IsMouseOver
  #ScreenGadget_Release3D
  #ScreenGadget_Release
  #ScreenGadget_MouseLeftDown
  #ScreenGadget_MouseLeftUp
EndEnumeration
Enumeration
  #ScreenText_AlignLeft
  #ScreenText_AlignCenter
  #ScreenText_AlignRight
EndEnumeration



Structure ScreenButtonSprite
  Width.i
  Height.i
  NormalSprite.i
  MouseOverSprite.i
  PressingSprite.i
EndStructure


Structure ScreenMenu
  *Gadgets.Queue
  Off.i
EndStructure

Structure ScreenButtonGadget
  *Sprite.ScreenButtonSprite
  Icon.i
EndStructure
Structure ScreenTextGadget
  Text.s
  *CharSet.CharSet
  Align.i
EndStructure
Structure ScreenGadget
  X.i
  Y.i
  
  *Callback
  StructureUnion
    *Button.ScreenButtonGadget
    *Text.ScreenTextGadget
    *Memory
  EndStructureUnion
  
  Hidden.i
EndStructure



Global ScreenMouseX.i, ScreenMouseY.i, MenuEvent.i

Global *CurrentScreenMenu.ScreenMenu, *PreviousScreenMenu.ScreenMenu

Global *ActiveScreenGadget.ScreenGadget, *LastActiveScreenGadget.ScreenGadget
Global *MouseOverScreenGadget.ScreenGadget
Global *PressedScreenGadget.ScreenGadget



Procedure.i ScreenGadget_Button(*Gadget.ScreenGadget, Event.i, *Parameter)
  Select Event
    Case #ScreenGadget_IsMouseOver
      If ScreenMouseX => *Gadget\X And ScreenMouseX < *Gadget\X + *Gadget\Button\Sprite\Width And ScreenMouseY => *Gadget\Y And ScreenMouseY < *Gadget\Y + *Gadget\Button\Sprite\Height
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #ScreenGadget_Display3D
      If *ActiveScreenGadget = *Gadget
        DisplaySprite3D(*Gadget\Button\Sprite\PressingSprite, *Gadget\X, *Gadget\Y)
        DisplaySprite3D(*Gadget\Button\Icon, *Gadget\X, *Gadget\Y)
      ElseIf *MouseOverScreenGadget = *Gadget
        DisplaySprite3D(*Gadget\Button\Sprite\MouseOverSprite, *Gadget\X, *Gadget\Y)
        DisplaySprite3D(*Gadget\Button\Icon, *Gadget\X, *Gadget\Y)
      Else
        DisplaySprite3D(*Gadget\Button\Sprite\NormalSprite, *Gadget\X, *Gadget\Y)
        DisplaySprite3D(*Gadget\Button\Icon, *Gadget\X, *Gadget\Y)
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ScreenGadget_Text(*Gadget.ScreenGadget, Event.i, *Parameter)
  Select Event
    Case #ScreenGadget_Display
      Select *Gadget\Text\Align
        Case #ScreenText_AlignLeft
          DisplayText(*Gadget\X, *Gadget\Y, UCase(*Gadget\Text\Text), *Gadget\Text\CharSet)
        Case #ScreenText_AlignCenter
          DisplayText(*Gadget\X - (Len(*Gadget\Text\Text) * (*Gadget\Text\CharSet\Width + 1) - 1)/2, *Gadget\Y, *Gadget\Text\Text, *Gadget\Text\CharSet)
        Case #ScreenText_AlignRight
          DisplayText(*Gadget\X - (Len(*Gadget\Text\Text) * (*Gadget\Text\CharSet\Width + 1) - 1), *Gadget\Y, *Gadget\Text\Text, *Gadget\Text\CharSet)
      EndSelect
  EndSelect
  
  ProcedureReturn #Null
EndProcedure



Procedure.i LoadScreenButtonSprite(Name.s)
  Protected *Sprite.ScreenButtonSprite
  Protected Image.i, GrabbedImage.i, Width.i, Height.i
  
  Image  = LoadImage(#PB_Any, "Graphics\" + Name + ".png")
  If Not Image
    MessageRequester("Error", "Can not load button sprite: " + #Q + "Graphics\" + Name + ".png" + #Q, #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  
  Width  = ImageWidth(Image)
  Height = ImageHeight(Image) / 3
  
  *Sprite        = _New(ScreenButtonSprite)
  *Sprite\Width  = Width
  *Sprite\Height = Height
  
  GrabbedImage = GrabImage(Image, #PB_Any, 0, 0, Width, Height)
  SaveImage(GrabbedImage, "Graphics\Temp.png", #PB_ImagePlugin_PNG)
  *Sprite\NormalSprite = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\Temp.png", #PB_Sprite_Texture|#PB_Sprite_Memory|#PB_Sprite_AlphaBlending))
  
  GrabbedImage = GrabImage(Image, #PB_Any, 0, Height, Width, Height)
  SaveImage(GrabbedImage, "Graphics\Temp.png", #PB_ImagePlugin_PNG)
  *Sprite\MouseOverSprite = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\Temp.png", #PB_Sprite_Texture|#PB_Sprite_Memory|#PB_Sprite_AlphaBlending))
  
  GrabbedImage = GrabImage(Image, #PB_Any, 0, Height * 2, Width, Height)
  SaveImage(GrabbedImage, "Graphics\Temp.png", #PB_ImagePlugin_PNG)
  *Sprite\PressingSprite = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\Temp.png", #PB_Sprite_Texture|#PB_Sprite_Memory|#PB_Sprite_AlphaBlending))

  ProcedureReturn *Sprite
EndProcedure
Procedure.i LoadScreenButtonIcon(Name.s)
  ProcedureReturn CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\" + Name + ".png", #PB_Sprite_Texture|#PB_Sprite_Memory|#PB_Sprite_AlphaBlending))
EndProcedure



Procedure.i CreateScreenMenu()
  Protected *Menu.ScreenMenu
  
  *Menu = _New(ScreenMenu)
  *CurrentScreenMenu = *Menu
  
  *Menu\Gadgets = CreateQueue()
  
  ProcedureReturn *Menu
EndProcedure
Procedure.i ChangeScreenMenu(*Menu.ScreenMenu)
  *PreviousScreenMenu = *CurrentScreenMenu
  *CurrentScreenMenu  = *Menu
EndProcedure

Procedure.i CreateScreenGadget(X.i, Y.i, *Callback, *Memory)
  Protected *Gadget.ScreenGadget
  
  *Gadget = _New(ScreenGadget)
  AppendQueueItem(*CurrentScreenMenu\Gadgets, *Gadget)
  
  *Gadget\X        = X * #FieldSize
  *Gadget\Y        = Y * #FieldSize
  *Gadget\Callback = *Callback
  *Gadget\Memory   = *Memory
  
  ProcedureReturn *Gadget
EndProcedure
Procedure.i ScreenGadgetX(*Gadget.ScreenGadget)
  ProcedureReturn *Gadget\X
EndProcedure
Procedure.i ScreenGadgetY(*Gadget.ScreenGadget)
  ProcedureReturn *Gadget\Y
EndProcedure
Procedure.i LocateScreenGadget(*Gadget.ScreenGadget, X.i, Y.i)
  *Gadget\X = X
  *Gadget\Y = Y
EndProcedure
Procedure.i HideScreenGadget(*Gadget.ScreenGadget, State.i)
  *Gadget\Hidden = State
EndProcedure

Procedure.i CreateScreenButton(X.i, Y.i, *Sprite.ScreenButtonSprite, Icon.i)
  Protected *Gadget.ScreenGadget, *Button.ScreenButtonGadget
  
  *Button = _New(ScreenButtonGadget)
  *Gadget = CreateScreenGadget(X, Y, @ScreenGadget_Button(), *Button)
  
  *Button\Sprite = *Sprite
  *Button\Icon   = Icon
  
  ProcedureReturn *Gadget
EndProcedure
Procedure.i CreateScreenText(X.i, Y.i, Text.s, *CharSet.CharSet, Align.i = #ScreenText_AlignLeft)
  Protected *Gadget.ScreenGadget, *Text.ScreenTextGadget
  
  *Text = _New(ScreenTextGadget)
  *Gadget = CreateScreenGadget(X, Y, @ScreenGadget_Text(), *Text)
  
  *Text\Text    = Text
  *Text\CharSet = *CharSet
  *Text\Align   = Align
  
  ProcedureReturn *Gadget
EndProcedure

Procedure.i ExamineScreenGadgets(Event.i)
  Protected *Item.QueueItem, *Gadget.ScreenGadget
  
  ScreenMouseX = GetMouseX()
  ScreenMouseY = GetMouseY()
  
  *PressedScreenGadget = #Null
  
  *Item = *CurrentScreenMenu\Gadgets\First
  While *Item
    *Gadget = *Item\Memory
    
    If Not *Gadget\Hidden
      _Call(*Gadget\Callback, *Gadget, #ScreenGadget_Frame, #Null)
    EndIf
    
    _Move(*Item, N)
  Wend
  
  Select Event
    Case #WM_MOUSEMOVE
      *MouseOverScreenGadget = #Null
      
      If *ActiveScreenGadget
        If _Call(*ActiveScreenGadget\Callback, *ActiveScreenGadget, #ScreenGadget_IsMouseOver, #Null)
          *MouseOverScreenGadget = *ActiveScreenGadget
        EndIf
      Else
        *Item = *CurrentScreenMenu\Gadgets\First
        While *Item
          *Gadget = *Item\Memory
          
          If Not *Gadget\Hidden
            If _Call(*Gadget\Callback, *Gadget, #ScreenGadget_IsMouseOver, #Null)
              *MouseOverScreenGadget = *Gadget
              Break
            EndIf
          EndIf
          
          _Move(*Item, N)
        Wend
      EndIf
    Case #WM_LBUTTONDOWN, #WM_LBUTTONDBLCLK
      If *MouseOverScreenGadget
        *ActiveScreenGadget     = *MouseOverScreenGadget
        *LastActiveScreenGadget = *MouseOverScreenGadget
      Else
        *ActiveScreenGadget     = #Null
        *LastActiveScreenGadget = #Null
      EndIf
    Case #WM_LBUTTONUP
      If *MouseOverScreenGadget And *MouseOverScreenGadget = *ActiveScreenGadget
        _Call(*MouseOverScreenGadget\Callback, *MouseOverScreenGadget, #ScreenGadget_MouseLeftUp, #Null)
        
        *PressedScreenGadget = *MouseOverScreenGadget
      EndIf
      
      *ActiveScreenGadget = #Null
  EndSelect
EndProcedure
Procedure.i DisplayScreenGadgets3D()
  Protected *Item.QueueItem, *Gadget.ScreenGadget
  
  *Item = *CurrentScreenMenu\Gadgets\First
  While *Item
    *Gadget = *Item\Memory
    
    If Not *Gadget\Hidden
      _Call(*Gadget\Callback, *Gadget, #ScreenGadget_Display3D, #Null)
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i DisplayScreenGadgets()
  Protected *Item.QueueItem, *Gadget.ScreenGadget
  
  *Item = *CurrentScreenMenu\Gadgets\First
  While *Item
    *Gadget = *Item\Memory
    
    If Not *Gadget\Hidden
      _Call(*Gadget\Callback, *Gadget, #ScreenGadget_Display, #Null)
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure

Procedure.i SetScreenButtonIcon(*Gadget.ScreenGadget, Icon.i)
  *Gadget\Button\Icon = Icon
EndProcedure
Procedure.i SetScreenText(*Gadget.ScreenGadget, Text.s)
  *Gadget\Text\Text = UCase(Text)
EndProcedure
; IDE Options = PureBasic 4.50 RC 2 (Windows - x86)
; CursorPosition = 294
; FirstLine = 37
; Folding = AAAm
; EnableXP