Procedure.i SetLightFadeOut(Speed.i)
  Menu\FadeOut = Speed
EndProcedure
Procedure.i DelayLightshow(Time.i)
  Menu\LightshowTime = Time
EndProcedure
Procedure.i TruncateLightshow()
  Menu\CurrentLightshow = #Null
EndProcedure

Procedure.i FlashPoint(X.i, Y.i, Color.i, Transparency.i = 255)
  Protected *Light.MenuLight
  
  Color = LightSprite(Color)
  
  *Light = @MenuLight(X, Y)
  *Light\Color        = Color
  *Light\Transparency = Transparency
EndProcedure
Procedure.i FlashAll(Color.i, Transparency.i = 255)
  Protected X.i, Y.i, *Light.MenuLight
  
  Color = LightSprite(Color)
  
  For X = 0 To #SceneWidth - 1
    For Y = 0 To #SceneHeight - 1
      *Light = @MenuLight(X, Y)
      *Light\Color        = Color
      *Light\Transparency = Transparency
    Next
  Next
EndProcedure
Procedure.i FlashRectangleOutline(AX.i, AY.i, BX.i, BY.i, Color.i, Transparency.i = 255)
  Protected Index.i, *Light.MenuLight
  
  Color = LightSprite(Color)
  
  For Index = AX To BX
    *Light = @MenuLight(Index, AY)
    *Light\Color        = Color
    *Light\Transparency = Transparency
    *Light = @MenuLight(Index, BY)
    *Light\Color        = Color
    *Light\Transparency = Transparency
  Next
  
  For Index = AY To BY
    *Light = @MenuLight(AX, Index)
    *Light\Color        = Color
    *Light\Transparency = Transparency
    *Light = @MenuLight(BX, Index)
    *Light\Color        = Color
    *Light\Transparency = Transparency
  Next
EndProcedure
Procedure.i FlashXLine(Y.i, Color.i, Transparency.i = 255)
  Protected Index.i, *Light.MenuLight
  
  Color = LightSprite(Color)
  
  For Index = 0 To #SceneWidth - 1
    *Light = @MenuLight(Index, Y)
    *Light\Color        = Color
    *Light\Transparency = Transparency
  Next
EndProcedure
Procedure.i FlashYLine(X.i, Color.i, Transparency.i = 255)
  Protected Index.i, *Light.MenuLight
  
  Color = LightSprite(Color)
  
  For Index = 0 To #SceneHeight - 1
    *Light = @MenuLight(X, Index)
    *Light\Color        = Color
    *Light\Transparency = Transparency
  Next
EndProcedure
Procedure.i FlashBaulks(Height.i, Color.i, Transparency.i = 255)
  Protected X.i, Y.i, MaxY.i, *Light.MenuLight
  
  Color = LightSprite(Color)
  
  For X = 0 To #SceneWidth - 1
    MaxY = #SceneHeight - (1 + Random(Height))
    
    For Y = #SceneHeight - 1 To MaxY Step -1
      *Light = @MenuLight(X, Y)
      *Light\Color        = Color
      *Light\Transparency = Transparency
    Next
  Next
EndProcedure
Procedure.i DisplayMenuLight()
  Protected X.i, Y.i, *Light.MenuLight
  
  For X = 0 To #SceneWidth - 1
    For Y = 0 To #SceneHeight - 1
      *Light = @MenuLight(X, Y)
      If *Light\Color
        DisplaySprite3D(*Light\Color, X*#FieldSize, Y*#FieldSize, *Light\Transparency)
      EndIf
      *Light\Transparency - Menu\FadeOut
      If *Light\Transparency < 50 : *Light\Transparency = 50 : EndIf
    Next
  Next
EndProcedure

Procedure.i MenuLightshow_Start(Time.i, Frame.i)
  #Menu_BigG_X = #SceneWidth/2 - 1
  #Menu_BigG_Y = #SceneHeight/2 - 2
  
  Select Frame
    Case 0
      SetLightFadeOut(5)
      DelayLightshow(150)
    Case 1 To 6
      FlashRectangleOutline(Frame, Frame, #SceneWidth - 1 - Frame, #SceneHeight - 1 - Frame, #WhiteLight, 200)
      DelayLightshow(5)
    Case 7
      SetLightFadeOut(1)
      FlashAll(#WhiteLight)
      DelayLightshow(5)
    Case 8 To 179
      FlashPoint(Random(#SceneWidth - 1), Random(#SceneHeight - 1), #WhiteLight)
    Case 180 To 191
      Select Frame - 180
        Case 0  : FlashPoint(#Menu_BigG_X + 2, #Menu_BigG_Y + 0, #BlueLight)
        Case 1  : FlashPoint(#Menu_BigG_X + 1, #Menu_BigG_Y + 0, #BlueLight)
        Case 2  : FlashPoint(#Menu_BigG_X + 0, #Menu_BigG_Y + 0, #BlueLight)
        Case 3  : FlashPoint(#Menu_BigG_X + 0, #Menu_BigG_Y + 1, #BlueLight)
        Case 4  : FlashPoint(#Menu_BigG_X + 0, #Menu_BigG_Y + 2, #BlueLight)
        Case 5  : FlashPoint(#Menu_BigG_X + 0, #Menu_BigG_Y + 3, #BlueLight)
        Case 6  : FlashPoint(#Menu_BigG_X + 0, #Menu_BigG_Y + 4, #BlueLight)
        Case 7  : FlashPoint(#Menu_BigG_X + 1, #Menu_BigG_Y + 4, #BlueLight)
        Case 8  : FlashPoint(#Menu_BigG_X + 2, #Menu_BigG_Y + 4, #BlueLight)
        Case 9  : FlashPoint(#Menu_BigG_X + 2, #Menu_BigG_Y + 3, #BlueLight)
        Case 10 : FlashPoint(#Menu_BigG_X + 2, #Menu_BigG_Y + 2, #YellowLight)
      EndSelect
      DelayLightshow(8)
    Case 192
      DelayLightshow(100)
    Case 193
      TruncateLightshow()
  EndSelect
EndProcedure
Procedure.i MenuLightshow_RandomPixels(Time.i, Frame.i)
  Select Frame
    Case 0
      SetLightFadeOut(1)
      FlashAll(#WhiteLight)
      DelayLightshow(20)
    Case 1 To 299
      FlashPoint(Random(#SceneWidth - 1), Random(#SceneHeight - 1), #WhiteLight)
      If Random(5) = 0
        FlashPoint(Random(#SceneWidth - 1), Random(#SceneHeight - 1), #BlueLight)
      EndIf
      If Random(5) = 0
        FlashPoint(Random(#SceneWidth - 1), Random(#SceneHeight - 1), #GreenLight)
      EndIf
    Case 300
      TruncateLightshow()
  EndSelect
EndProcedure



DataSection
  MenuLightshows:
    Data.i @MenuLightshow_RandomPixels()
  EndMenuLightshows:
EndDataSection
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 140
; FirstLine = 15
; Folding = Cw-
; EnableXP