IncludeFile "Menu\Gadget.pb"



Structure Menu
  LightshowTime.i
  LightshowFrame.i
  *CurrentLightshow
  FadeOut.i
  
  *CurrentMenu
EndStructure
Structure MenuLight
  Color.i
  Transparency.i
EndStructure



Global Menu.Menu
Global Dim MenuLight.MenuLight(#SceneWidth - 1, #SceneHeight - 1)

Global Quit.i


Enumeration
  #WhiteLight
  #BlueLight
  #YellowLight
  #GreenLight
  #RedLight
EndEnumeration

Global Dim LightSprite.i(4)



IncludeFile "Menu\Lightshow.pb"



Procedure.i LoadLights()
  LightSprite(#WhiteLight)  = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\Menu\WhiteLight.bmp" , #PB_Sprite_Memory|#PB_Sprite_Texture))
  LightSprite(#BlueLight)   = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\Menu\BlueLight.bmp"  , #PB_Sprite_Memory|#PB_Sprite_Texture))
  LightSprite(#YellowLight) = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\Menu\YellowLight.bmp", #PB_Sprite_Memory|#PB_Sprite_Texture))
  LightSprite(#GreenLight)  = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\Menu\GreenLight.bmp" , #PB_Sprite_Memory|#PB_Sprite_Texture))
  LightSprite(#RedLight)    = CreateSprite3D(#PB_Any, LoadSprite(#PB_Any, "Graphics\Menu\RedLight.bmp"   , #PB_Sprite_Memory|#PB_Sprite_Texture))
EndProcedure
Procedure.i BuildMenu()
  Protected Index.i
  
  LoadChallanges("Challanges\", *ChallangeFolder)
  
  ;{ Buttons
    Global *BlueButton.ButtonSprite = LoadScreenButtonSprite("Menu\Blue")
    Global *GreenButton.ButtonSprite = LoadScreenButtonSprite("Menu\Green")
    Global *RedButton.ButtonSprite = LoadScreenButtonSprite("Menu\Red")
    Global *GrayButton.ButtonSprite = LoadScreenButtonSprite("Menu\Gray")
  ;}
  
  ;{ Icons
    Global DoorIcon.i      = LoadScreenButtonIcon("Menu\Icons\Door")
    Global PlayIcon.i      = LoadScreenButtonIcon("Menu\Icons\Play")
    Global EditorIcon.i    = LoadScreenButtonIcon("Menu\Icons\Editor")
    Global LeftIcon.i      = LoadScreenButtonIcon("Menu\Icons\Left")
    Global RightIcon.i     = LoadScreenButtonIcon("Menu\Icons\Right")
    Global ChallangeIcon.i = LoadScreenButtonIcon("Menu\Icons\Challange")
    Global FolderIcon.i    = LoadScreenButtonIcon("Menu\Icons\Folder")
  ;}
  
  ;{ Menus
  Global *MainMenu = CreateScreenMenu()
    Global *MainMenu_Play   = CreateScreenButton(1, 1, *BlueButton, PlayIcon)
    Global *MainMenu_Editor = CreateScreenButton(1, 3, *BlueButton, EditorIcon)
    Global *MainMenu_Quit   = CreateScreenButton(1, #SceneHeight - 3, *RedButton, DoorIcon)
    Global *MainMenu_Tip    = CreateScreenText(#SceneWidth / 2, #SceneHeight - 1, "", *StandardCharSet, #ScreenText_AlignCenter)
  
  Global *PlayMenu = CreateScreenMenu()
    #PlayMenu_Challanges = 50
    
    Global *PlayMenu_Back = CreateScreenButton(1, #SceneHeight - 3, *RedButton, LeftIcon)
    Global *PlayMenu_CurrentEntry.Entry, PlayMenu_Initialized.i
    Global Dim *PlayMenu_EntryButton(#PlayMenu_Challanges)
    Global Dim *PlayMenu_EntryText(#PlayMenu_Challanges)
    Global Dim *PlayMenu_Entry.Entry(#PlayMenu_Challanges)
    
    For Index = 0 To #PlayMenu_Challanges
      *PlayMenu_EntryButton(Index) = CreateScreenButton(7, 1 + Index * 2, *GrayButton, #Null)
      *PlayMenu_EntryText(Index)   = CreateScreenText(10, 1 + Index * 2, "", *StandardCharSet)
    Next
  ;}
  
EndProcedure

Procedure.i ChangeMenu(*Menu, *ScreenMenu.ScreenMenu)
  Menu\CurrentMenu = *Menu
  ChangeScreenMenu(*ScreenMenu)
  _Call(*Menu)
EndProcedure
Procedure.i StartProgram(Name.s, Parameter.s = "")
  Protected Program.i
  
  Program = RunProgram(Name, Parameter, GetCurrentDirectory(), #PB_Program_Open)
  
  ClearScreen(#Black)
  FlipBuffers()
  
  While ProgramRunning(Program)
    WindowEvent()
    Delay(1)
  Wend
EndProcedure




Declare.i Menu_Main()
Declare.i Menu_Play()

Procedure.i Menu_Main()
  If *MouseOverScreenGadget
    Select *MouseOverScreenGadget
      Case *MainMenu_Play
        SetScreenText(*MainMenu_Tip, "Play")
      Case *MainMenu_Editor
        SetScreenText(*MainMenu_Tip, "Editor")
      Case *MainMenu_Quit
        SetScreenText(*MainMenu_Tip, "Quit")
    EndSelect
  Else
    SetScreenText(*MainMenu_Tip, "")
  EndIf
  
  If *PressedScreenGadget
    Select *PressedScreenGadget
      Case *MainMenu_Play
        PlayMenu_Initialized   = #False
        *PlayMenu_CurrentEntry = *ChallangeFolder
        ChangeMenu(@Menu_Play(), *PlayMenu)
      Case *MainMenu_Editor
        StartProgram("Editor.exe")
      Case *MainMenu_Quit
        Quit = #True
    EndSelect
  EndIf
EndProcedure

Procedure.i InitializePlayMenu()
  Protected Index.i, *Item.QueueItem, *Entry.Entry
  Protected Start.i
  
  If *PlayMenu_CurrentEntry\Parent
    HideScreenGadget(*PlayMenu_EntryButton(0), #False)
    HideScreenGadget(*PlayMenu_EntryText(0), #False)
    
    SetScreenButtonIcon(*PlayMenu_EntryButton(0), FolderIcon)
    SetScreenText(*PlayMenu_EntryText(0), "...")
    
    *PlayMenu_Entry(0) = *PlayMenu_CurrentEntry\Parent
    
    Start = 1
  Else
    Start = 0
  EndIf
  
  *Item = *PlayMenu_CurrentEntry\Entries\First
  For Index = Start To #PlayMenu_Challanges
    If *Item
      *Entry = *Item\Memory
      
      HideScreenGadget(*PlayMenu_EntryButton(Index), #False)
      HideScreenGadget(*PlayMenu_EntryText(Index), #False)
      
      Select *Entry\Type
        Case #Entry_File
          SetScreenButtonIcon(*PlayMenu_EntryButton(Index), ChallangeIcon)
          SetScreenText(*PlayMenu_EntryText(Index), *Entry\Name)
        Case #Entry_Folder
          SetScreenButtonIcon(*PlayMenu_EntryButton(Index), FolderIcon)
          SetScreenText(*PlayMenu_EntryText(Index), *Entry\Name + "...")
      EndSelect
      
      *PlayMenu_Entry(Index) = *Entry
      
      _Move(*Item, N)
    Else
      HideScreenGadget(*PlayMenu_EntryButton(Index), #True)
      HideScreenGadget(*PlayMenu_EntryText(Index), #True)
      *PlayMenu_Entry(Index) = #Null
    EndIf
  Next
  
  PlayMenu_Initialized = #True
EndProcedure
Procedure.i ScrollPlayMenu(Movement.i)
  Protected Index.i
  
  If (Movement > 0 And ScreenGadgetY(*PlayMenu_EntryButton(0)) < #FieldSize) Or (Movement < 0)
    For Index = 0 To #PlayMenu_Challanges
      If *PlayMenu_Entry(Index)
        LocateScreenGadget(*PlayMenu_EntryButton(Index), ScreenGadgetX(*PlayMenu_EntryButton(Index)), ScreenGadgetY(*PlayMenu_EntryButton(Index)) + Movement)
        LocateScreenGadget(*PlayMenu_EntryText(Index)  , ScreenGadgetX(*PlayMenu_EntryText(Index))  , ScreenGadgetY(*PlayMenu_EntryText(Index))   + Movement)
      Else
        Break
      EndIf
    Next
  EndIf
EndProcedure
Procedure.i GetPlayMenuEntry(*ButtonGadget.ScreenGadget)
  Protected Index.i
  
  For Index = 0 To #PlayMenu_Challanges
    If *PlayMenu_EntryButton(Index) = *ButtonGadget
      ProcedureReturn *PlayMenu_Entry(Index)
    EndIf
  Next
  
  ProcedureReturn #Null
EndProcedure
Procedure.i Menu_Play()
  Static *Entry.Entry, *SOGadget.ScreenGadget, *Screens.Queue, *ScreenItem.QueueItem, ScreenTime.i
  
  If Not PlayMenu_Initialized
    InitializePlayMenu()
  EndIf
  
  If *MouseOverScreenGadget <> *SOGadget
    If *Screens
      FreeChallangeScreens(*Screens)
      *Screens = #Null
    EndIf
    *SOGadget = *MouseOverScreenGadget
    If *SOGadget
      *Entry = GetPlayMenuEntry(*MouseOverScreenGadget)
      If *Entry And *Entry\Type = #Entry_File
        *Screens = LoadChallangeScreens(*Entry\Memory)
        If *Screens
          *ScreenItem = *Screens\First
          ScreenTime  = 150
        EndIf
      EndIf
    EndIf
  EndIf
  
  If *Screens And *ScreenItem
    Stop3D()
    
    DisplaySprite(*ScreenItem\Memory, 12, 12)
    If ScreenTime = 0
      If *ScreenItem\N
        _Move(*ScreenItem, N)
      Else
        *ScreenItem = *Screens\First
      EndIf
      ScreenTime = 150
    Else
      ScreenTime - 1
    EndIf
    
    Start3D()
  EndIf
  
  If *PressedScreenGadget
    Select *PressedScreenGadget
      Case *PlayMenu_Back
        ChangeMenu(@Menu_Main(), *MainMenu)
      Default
        *Entry = GetPlayMenuEntry(*PressedScreenGadget)
        If *Entry
          Select *Entry\Type
            Case #Entry_File
              StartProgram("Engine.exe", "load " + #Q + ChallangeFilename(*Entry\Memory) + #Q)
            Case #Entry_Folder
              *PlayMenu_CurrentEntry = *Entry
              InitializePlayMenu()
          EndSelect
        EndIf
    EndSelect
  EndIf
  
  If IsKeyPressing(#VK_DOWN)
    ScrollPlayMenu(-4)
  ElseIf IsKeyPressing(#VK_UP)
    ScrollPlayMenu( 4)
  EndIf
EndProcedure



Procedure.i Menu()
  Protected Event.i, *Light.MenuLight
  
  With Menu
  
  LoadLights()
  BuildMenu()
  
  \CurrentLightshow = @MenuLightshow_Start()
  _Call(\CurrentLightshow, \LightshowTime, \LightshowFrame)
  
  ChangeMenu(@Menu_Main(), *MainMenu)
  
  Repeat
    Event = WindowEvent()
    
    StartSpecialFX()
      ClearScreen(#Black)
      
      Start3D()
        DisplayMenuLight()
      
        If Not \CurrentLightshow
          \CurrentLightshow = PeekI(?MenuLightshows + Random((?EndMenuLightshows - ?MenuLightshows)/SizeOf(Integer) - 1) * SizeOf(Integer))
          \LightshowFrame   = 0
          \LightshowTime    = 0
          _Call(\CurrentLightshow, \LightshowTime, \LightshowFrame)
        ElseIf \LightshowTime = 0
          \LightshowFrame + 1
          _Call(\CurrentLightshow, \LightshowTime, \LightshowFrame)
        Else
          \LightshowTime - 1
        EndIf
        
        _Call(\CurrentMenu)
        
        ExamineScreenGadgets(Event)
        
        DisplayScreenGadgets3D()
      Stop3D()
      
      DisplayScreenGadgets()
    StopSpecialFX()
    
    FlipBuffers()
    
    OptimizeFPS(15)
  Until KeyPressedDown(#VK_ESCAPE) Or Quit
  
  EndWith
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 235
; FirstLine = 229
; Folding = ---
; EnableXP