;**************************************************************
;     New Game
;**************************************************************
;   Copyright (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Global IO_InputFile.i



IncludeFile "Load.pb"
Procedure.i NewGame(*Challange.Challange)
  Protected Path.s
  
  Challange\Header = *Challange
  Path             = ChallangePath(*Challange)
  Namespace(0)     = Path
  
  OpenLoadingScreen(#True)
  
  ;{ Settings
    LoadChallangeSettings(*Challange)
  ;}
  ;{ Load library
    ; Hier werden Funktionen gewrappt:
    With Challange\Script
      \Library = OpenLibrary(#PB_Any, GetFile("Engine.dll"))
      If \Library
        CallFunction(\Library, "GM_Init", ?Functions, RandomSeed)
        
        \Frame    = GetFunction(\Library, "Call_Frame")
        
        \Start    = GetFunction(\Library, "Call_Start")
        \GameOver = GetFunction(\Library, "Call_GameOver")
        \Won      = GetFunction(\Library, "Call_Won")
        
        \Score              = GetFunction(\Library, "Call_Score")
        \MultiplierEnhanced = GetFunction(\Library, "Call_MultiplierEnhanced")
        
        \LostLive     = GetFunction(\Library, "Call_LostLive")
        \Hit          = GetFunction(\Library, "Call_Hit")
        \SceneChanged = GetFunction(\Library, "Call_SceneChanged")
      EndIf
    EndWith
  ;}
  ;{ Unpack map
    If Not UnpackMap(*Challange)
      ProcedureReturn #False
    EndIf
  ;}
  ;{ Load map
    IO_InputFile = ReadFile(#PB_Any, Path + "UnpackedMap.bin")
    If Not IO_InputFile
      MessageRequester("Error", "Can not load challange map:" + #Q + Path + "UnpackedMap.bin" + #Q, #MB_ICONERROR)
      ProcedureReturn #False
    EndIf
    
    PassChecksums(IO_InputFile)
    
    ;{ Predefinitions
      AddPredefinedItems()
    ;}
    
    ;{ Load
      ReadTilesets()
      ReadBanks()
      ReadBackgrounds()
      ReadEvents()
      ReadEffects()
      ReadScenes()
      ReadActs()
      
      InitializeScenes()
      InitializeObjects()
      InitializeActs()
    ;}
    
    CloseFile(IO_InputFile)
    DeleteFile(Path + "UnpackedMap.bin")
  ;}
  
  ; Initialize first objects:
  CreateTable(Player\Scene)
  
  ; Start acts:
  CallStartEvents()
  If *Acts\First
    ChangeAct(*Acts\First\Memory)
  EndIf
  
  ProcedureReturn #True
EndProcedure



Procedure.i SaveGame()
EndProcedure
Procedure.i LoadGame()
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 44
; FirstLine = 25
; Folding = --
; EnableXP