CompilerSelect #Mode
  CompilerCase #Mode_Game ;{
;******************************************
; Game
;******************************************

Procedure.i ReadObjectAction()
  Protected *Action.ObjectAction
  
  *Action = _New(ObjectAction)
  
  *Action\Selection = ReadObjectSelection()
  *Action\Callback  = *Object(ReadInteger(IO_InputFile))
  *Action\Action    = ReadAsciiCharacter(IO_InputFile)
  
  _Call(*Action\Callback, #Null, #Object_LoadAction, *Action)
  
  ProcedureReturn *Action
EndProcedure
Procedure.i InitializeObjectAction(*Action.ObjectAction)
  InitializeObjectSelection(*Action\Selection)
  
  _Call(*Action\Callback, #Null, #Object_InitializeAction, *Action)
  
  ProcedureReturn *Action
EndProcedure

Procedure.i CallObjectAction(*Action.ObjectAction)
  Protected Index.i, *Selected.SelectedObject
  
  For Index = 0 To *Action\Selection\Size - 1
    *Selected = PeekI(*Action\Selection\Selected + _Sz(Integer) * Index)
    
    _Call(*Action\Callback, *Selected\Object, #Object_CallAction, *Action)
  Next
EndProcedure

;}
  CompilerCase #Mode_Editor ;{
;******************************************
; Editor
;******************************************

Procedure.i ObjectActionCount(*Registered.RegisteredObject)
  ProcedureReturn _Call(*Registered\Entry\Callback, #Null, #Object_ActionCount, #Null)
EndProcedure
Procedure.s ObjectActionName(*Registered.RegisteredObject, ID.i)
  ProcedureReturn PeekS(_Call(*Registered\Entry\Callback, #Null, #Object_ActionName, ID))
EndProcedure
Procedure.s ObjectActionDescription(*Registered.RegisteredObject, ID.i)
  Protected *Result
  
  *Result = _Call(*Registered\Entry\Callback, #Null, #Object_ActionDescription, ID)
  If *Result
    ProcedureReturn PeekS(*Result)
  Else
    ProcedureReturn "No description"
  EndIf
EndProcedure

Procedure.i CreateObjectAction()
  Protected *Action.ObjectAction
  
  *Action = _New(ObjectAction)
  
  *Action\Selection = CreateSelection()
  *Action\Action    = #None
  
  ProcedureReturn *Action
EndProcedure
Procedure.i EditObjectAction(*Action.ObjectAction)
  Protected *Selected.Selected, *Object.Object
  
  SelectionMode(*Action\Selection, @Selection_Callback_SameObjects(), "Select objects")
  If *Action\Selection\Queue\Count
    If *Action\Registered
      _Call(*Action\Registered\Entry\Callback, #Null, #Object_EditorFreeAction, *Action)
      *Action\Action = #None
      *Action\Memory = #Null
    EndIf
    
    *Selected          = *Action\Selection\Queue\First\Memory
    *Object            = GetSelectedField(*Selected)
    *Action\Registered = *Object\Registered
    
    *Action\Action = SelectObjectAction(*Action)
    
    _Call(*Action\Registered\Entry\Callback, #Null, #Object_EditorInitializeAction, *Action)
  EndIf
EndProcedure
Procedure.i FreeObjectAction(*Action.ObjectAction)
  FreeSelection(*Action\Selection)
  If *Action\Registered
    _Call(*Action\Registered\Entry\Callback, #Null, #Object_EditorFreeAction, *Action)
  EndIf
  _Free(*Action)
  
  ProcedureReturn #True
EndProcedure

Procedure.i WriteObjectAction(*Action.ObjectAction)
  WriteObjectSelection(*Action\Selection)
  WriteInteger(IO_OutputFile, *Action\Registered\Number)
  WriteAsciiCharacter(IO_OutputFile, *Action\Action)
  
  _Call(*Action\Registered\Entry\Callback, #Null, #Object_EditorSaveAction, *Action)
EndProcedure
Procedure.i ReadObjectAction()
  Protected *Action.ObjectAction
  
  *Action = _New(ObjectAction)
  
  *Action\Selection  = ReadObjectSelection()
  *Action\Registered = *IO_Object(ReadInteger(IO_InputFile))
  *Action\Action     = ReadAsciiCharacter(IO_InputFile)
  
  _Call(*Action\Registered\Entry\Callback, #Null, #Object_EditorLoadAction, *Action)
  
  ProcedureReturn *Action
EndProcedure
Procedure.i InitializeObjectAction(*Action.ObjectAction)
  InitializeObjectSelection(*Action\Selection)
  
  _Call(*Action\Registered\Entry\Callback, #Null, #Object_EditorInitializeAction, *Action)
  
  ProcedureReturn *Action
EndProcedure

;}
CompilerEndSelect
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 82
; FirstLine = 45
; Folding = -L9
; EnableXP