IncludeFile "..\Import.pbi"
IncludeFile "Templates\Animation.pb"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Scenery")
        GM_Folder("Fire")
          GM_File("TinyFire")
          GM_File("TinyFireL")
          GM_End()
        GM_Folder("Tech")
          GM_File("Rotor1")
          GM_File("Rotor2")
          GM_File("Rotor3")
          GM_End()
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



Global TinyFireFrameset.i
ProcedureDLL.i Obj_TinyFire(*Object.GM_Object, Event.i, *Parameter)
  Global TinyFire.AnimationParameter
  
  With TinyFire
    If Not \Initialized
      \Name = "Tiny Fire"
      \File = "Animations\TinyFire"
      
      \FrameWidth    = #GM_FieldSize
      \FrameHeight   = #GM_FieldSize
      \FrameDuration = 4
      
      \Frameset = @TinyFireFrameset
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn AnimationTemplate(*Object, Event, *Parameter, @TinyFire)
EndProcedure
ProcedureDLL.i Obj_TinyFireL(*Object.GM_Object, Event.i, *Parameter)
  Global TinyFireL.AnimationParameter
  
  With TinyFireL
    If Not \Initialized
      \Name = "Tiny Fire (with light)"
      \File = "Animations\TinyFire"
      
      \FrameWidth    = #GM_FieldSize
      \FrameHeight   = #GM_FieldSize
      \FrameDuration = 4
      
      \Frameset = @TinyFireFrameset
      
      \Initialized = #True
    EndIf
  EndWith
  
  If Event = #GM_Object_Display
    GM_DisplayYellowLight(*Object\X + #GM_FieldSize/2, *Object\Y + #GM_FieldSize - 4, 50 + Random(80))
  EndIf
  
  ProcedureReturn AnimationTemplate(*Object, Event, *Parameter, @TinyFireL)
EndProcedure



Global Rotor_Sprite.i

Procedure.i RotorTemplate(*Object.GM_Object, Event.i, *Parameter, Speed.i, Name.s)
  Protected *EditorObject.GM_EditorObject
  
  Select Event
    Case #GM_Object_Display
      GM_RotateSprite3D(*Object\Sprite, *Object\Memory)
      GM_DisplaySprite3D(*Object\Sprite, *Object\X, *Object\Y)
    Case #GM_Object_Frame
      *Object\Memory + Speed
      If *Object\Memory => 360
        *Object\Memory - 360
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not Rotor_Sprite
        Rotor_Sprite = GM_LoadSprite("Animations\Rotor")
      EndIf
    Case #GM_Object_Initialize
      *Object\Sprite = GM_CreateSprite3D(Rotor_Sprite)
      *Object\Memory = Random(359)
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      String = "Animations\Rotor"
      ProcedureReturn @String
    Case #GM_Object_ViewRegion
      ViewRegion\Width  = #GM_FieldSize*2
      ViewRegion\Height = #GM_FieldSize*2
      ProcedureReturn @ViewRegion
    
    Case #GM_Object_Name
      String = Name
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_Rotor1(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn RotorTemplate(*Object, Event, *Parameter, 0, "Still Standing Rotor")
EndProcedure
ProcedureDLL.i Obj_Rotor2(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn RotorTemplate(*Object, Event, *Parameter, 4, "Slow Rotor")
EndProcedure
ProcedureDLL.i Obj_Rotor3(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn RotorTemplate(*Object, Event, *Parameter, 11, "Fast Rotor")
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 67
; FirstLine = 38
; Folding = H+
; EnableXP