Enumeration
  #HitBlock_Unused
  #HitBlock_Hit
  #HitBlock_Used
EndEnumeration

Structure HitBlockParameter
  *CoinCallback
  CoinIndex.i
  
  Initialized.i
EndStructure
Structure HitBlockMemory
  Action.i
  Time.i
  YMotion.f
  
  *Coin.GM_Object
  Coin_FieldX.i
  Coin_YMotion.f
EndStructure

Global HitBlock_Frameset.i

Procedure.i HitBlockTemplate(*Object.GM_Object, Event.i, *Parameter, *HitBlockParameter.HitBlockParameter)
  Static *Memory.HitBlockMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      Select *Memory\Action
        Case #HitBlock_Unused
          GM_DisplayFramesetFrame(HitBlock_Frameset, 0, 0, *Object\X, *Object\Y)
        Case #HitBlock_Hit
          GM_DisplayFramesetFrame(HitBlock_Frameset, 1, 0, *Object\X, *Object\Y)
        Case #HitBlock_Used
          GM_DisplayFramesetFrame(HitBlock_Frameset, 2, 0, *Object\X, *Object\Y)
      EndSelect
    Case #GM_Object_Frame
      Select *Memory\Action
        Case #HitBlock_Hit
          If *Memory\Time < 4
            *Memory\YMotion = -2
          ElseIf *Memory\Time < 8
            *Memory\YMotion = 2
          Else
            *Memory\YMotion = 0
            *Memory\Action = #HitBlock_Used
          EndIf
          *Object\Y + *Memory\YMotion
          *Memory\Time + 1
      EndSelect
      
      If *Memory\Coin And Not (GM_IsObjectDestroyed(*Memory\Coin) Or IsCoinCollected(*Memory\Coin))
        *Memory\Coin\Y + *Memory\Coin_YMotion
        If GM_FieldCollision(*Memory\Coin, 0, *Memory\Coin_YMotion, 0, Sign(*Memory\Coin_YMotion))
          If *Memory\Coin_YMotion > 1
            *Memory\Coin_YMotion * -0.65
          Else
            *Memory\Coin = #Null
          EndIf
        EndIf
        *Memory\Coin_YMotion + 0.15
      EndIf
    Case #GM_Object_Collision
      *Parameter = GM_PlayerCollision(*Object, 0, *Memory\YMotion)
      GM_DoWallCollision(*Object, *Parameter)
      If *Memory\Action = #HitBlock_Unused And *Parameter = #GM_Collision_Bottom
        *Memory\Coin         = GM_CreateObject(#GM_Layer_ForegroundObject1, *HitBlockParameter\CoinCallback, *Object\X, *Object\Y)
        *Memory\Coin_FieldX  = *Memory\Coin\X / #GM_FieldSize
        *Memory\Coin_YMotion = -5
        
        *Memory\Action = #HitBlock_Hit
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Memory        = AllocateMemory(SizeOf(HitBlockMemory))
      *Object\Memory = *Memory
      
      *Memory\Action = #HitBlock_Unused
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      If *HitBlockParameter\CoinIndex = 5
        GM_CountSuperCoin()
      Else
        GM_CountCoin()
      EndIf
    Case #GM_Object_GlobalLoad
      If Not HitBlock_Frameset
        HitBlock_Frameset = GM_LoadAnimationFrameset("Coin\HitBlock", #GM_FieldSize, #GM_FieldSize)
      EndIf
      LoadCoin(*HitBlockParameter\CoinIndex)
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Coin\HitBlock-View"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(*HitBlockParameter\CoinIndex, 0, 1, 1)
    Case #GM_Object_Name
      ReturnString("Hit Block - " + PeekS(CallFunctionFast(*HitBlockParameter\CoinCallback, 0, #GM_Object_Name, 0)))
  EndSelect
EndProcedure

ProcedureDLL.i Obj_HitBlock1(*Object.GM_Object, Event.i, *Parameter)
  Global HitBlock1.HitBlockParameter
  
  With HitBlock1
    If Not \Initialized
      \CoinCallback = @Obj_Coin1()
      \CoinIndex    = 0
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn HitBlockTemplate(*Object, Event, *Parameter, @HitBlock1)
EndProcedure
ProcedureDLL.i Obj_HitBlock2(*Object.GM_Object, Event.i, *Parameter)
  Global HitBlock2.HitBlockParameter
  
  With HitBlock2
    If Not \Initialized
      \CoinCallback = @Obj_Coin2()
      \CoinIndex    = 1
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn HitBlockTemplate(*Object, Event, *Parameter, @HitBlock2)
EndProcedure
ProcedureDLL.i Obj_HitBlock3(*Object.GM_Object, Event.i, *Parameter)
  Global HitBlock3.HitBlockParameter
  
  With HitBlock3
    If Not \Initialized
      \CoinCallback = @Obj_Coin3()
      \CoinIndex    = 2
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn HitBlockTemplate(*Object, Event, *Parameter, @HitBlock3)
EndProcedure
ProcedureDLL.i Obj_HitBlock4(*Object.GM_Object, Event.i, *Parameter)
  Global HitBlock4.HitBlockParameter
  
  With HitBlock4
    If Not \Initialized
      \CoinCallback = @Obj_Coin4()
      \CoinIndex    = 3
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn HitBlockTemplate(*Object, Event, *Parameter, @HitBlock4)
EndProcedure
ProcedureDLL.i Obj_HitBlock5(*Object.GM_Object, Event.i, *Parameter)
  Global HitBlock5.HitBlockParameter
  
  With HitBlock5
    If Not \Initialized
      \CoinCallback = @Obj_Coin5()
      \CoinIndex    = 4
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn HitBlockTemplate(*Object, Event, *Parameter, @HitBlock5)
EndProcedure
ProcedureDLL.i Obj_HitBlock6(*Object.GM_Object, Event.i, *Parameter)
  Global HitBlock6.HitBlockParameter
  
  With HitBlock6
    If Not \Initialized
      \CoinCallback = @Obj_Coin6()
      \CoinIndex    = 5
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn HitBlockTemplate(*Object, Event, *Parameter, @HitBlock6)
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 88
; FirstLine = 63
; Folding = --
; EnableXP