#LaserEffectCount  = 10
#LaserSwitchPeriod = 75*3
#KillingEnergy     = 0

Structure LaserParameter
  Name.s
  File.s
  Energy.i
  OuterWidth.i
  OuterHeight.i
  Frameset.i
  Switching.i
  
  Initialized.i
EndStructure

Procedure.i LaserTemplate(*Object.GM_Object, Event.i, *Parameter, *LaserParameter.LaserParameter)
  Protected Integer.i
  
  Select Event
    Case #GM_Object_Display
      If *Object\Memory < #LaserSwitchPeriod/3
        GM_DisplayAnimation(*Object\Animation, *Object\X - *LaserParameter\OuterWidth, *Object\Y - *LaserParameter\OuterHeight, *Object\Transparency)
      EndIf
    Case #GM_Object_Frame
      If *Object\Memory => #LaserSwitchPeriod
        *Object\Memory = 0
      ElseIf *Object\Memory < #LaserSwitchPeriod/3
        If GM_PlayAnimation(*Object\Animation)
          GM_SetAnimationDuration(*Object\Animation, PeekI(?LaserEffect +  (*Object\Memory % #LaserEffectCount)*SizeOf(Integer)))
        EndIf
      EndIf
      If *LaserParameter\Switching
        *Object\Memory + 1
      EndIf
    Case #GM_Object_Collision
      If *Object\Memory < #LaserSwitchPeriod/3
        If *LaserParameter\Energy > 0
          GM_HitPlayer(*LaserParameter\Energy)
        Else
          If Not *GM_Player\Shield
            GM_LoseLife()
          EndIf
        EndIf
      EndIf
    Case #GM_Object_Hit
      If *Object\Memory < #LaserSwitchPeriod/3
        If *LaserParameter\Energy = #KillingEnergy
          ProcedureReturn #GM_Object_DoCollision
        EndIf
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not *LaserParameter\Frameset
        *LaserParameter\Frameset = GM_LoadAnimationFrameset("Electric\" + *LaserParameter\File, #GM_FieldSize, #GM_FieldSize)
      EndIf
    Case #GM_Object_Initialize
      If *LaserParameter\Switching
        If *LaserParameter\OuterWidth
          Integer = *Object\X/#GM_FieldSize
        ElseIf *LaserParameter\OuterHeight
          Integer = *Object\Y/#GM_FieldSize
        EndIf
        *Object\Memory = (Integer % 3) * (#LaserSwitchPeriod/3)
      EndIf
      
      *Object\X         + *LaserParameter\OuterWidth
      *Object\Y         + *LaserParameter\OuterHeight
      *Object\Width     = #GM_FieldSize - *LaserParameter\OuterWidth*2
      *Object\Height    = #GM_FieldSize - *LaserParameter\OuterHeight*2
      *Object\Animation = GM_CreateAnimation(*LaserParameter\Frameset)
    
    Case #GM_Object_ViewSprite
      String = "Electric\" + *LaserParameter\File
      ProcedureReturn @String
    Case #GM_Object_ViewRegion
      ViewRegion\X      = 0
      ViewRegion\Y      = 0
      ViewRegion\Width  = #GM_FieldSize
      ViewRegion\Height = #GM_FieldSize
      ProcedureReturn @ViewRegion
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_Name
      ProcedureReturn @*LaserParameter\Name
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_VLaser1(*Object.GM_Object, Event.i, *Parameter)
  Global VLaser1.LaserParameter
  
  With VLaser1
    If Not \Initialized
      \Name        = "Weak Laser(V)"
      \File        = "VLaser1"
      \Energy      = 5
      \OuterWidth  = 10
      \OuterHeight = 0
      \Switching   = #False
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn LaserTemplate(*Object, Event, *Parameter, @VLaser1)
EndProcedure
ProcedureDLL.i Obj_VLaser2(*Object.GM_Object, Event.i, *Parameter)
  Global VLaser2.LaserParameter
  
  With VLaser2
    If Not \Initialized
      \Name        = "Strong Laser (V)"
      \File        = "VLaser2"
      \Energy      = #KillingEnergy
      \OuterWidth  = 10
      \OuterHeight = 0
      \Switching   = #False
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn LaserTemplate(*Object, Event, *Parameter, @VLaser2)
EndProcedure
ProcedureDLL.i Obj_HLaser1(*Object.GM_Object, Event.i, *Parameter)
  Global HLaser1.LaserParameter
  
  With HLaser1
    If Not \Initialized
      \Name        = "Weak Laser (H)"
      \File        = "HLaser1"
      \Energy      = 5
      \OuterWidth  = 0
      \OuterHeight = 10
      \Switching   = #False
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn LaserTemplate(*Object, Event, *Parameter, @HLaser1)
EndProcedure
ProcedureDLL.i Obj_HLaser2(*Object.GM_Object, Event.i, *Parameter)
  Global HLaser2.LaserParameter
  
  With HLaser2
    If Not \Initialized
      \Name        = "Strong Laser (H)"
      \File        = "HLaser2"
      \Energy      = #KillingEnergy
      \OuterWidth  = 0
      \OuterHeight = 10
      \Switching   = #False
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn LaserTemplate(*Object, Event, *Parameter, @HLaser2)
EndProcedure

ProcedureDLL.i Obj_VLaser1S(*Object.GM_Object, Event.i, *Parameter)
  Global VLaser1.LaserParameter
  
  With VLaser1
    If Not \Initialized
      \Name        = "Switching Weak Laser(V)"
      \File        = "VLaser1"
      \Energy      = 5
      \OuterWidth  = 10
      \OuterHeight = 0
      \Switching   = #True
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn LaserTemplate(*Object, Event, *Parameter, @VLaser1)
EndProcedure
ProcedureDLL.i Obj_VLaser2S(*Object.GM_Object, Event.i, *Parameter)
  Global VLaser2.LaserParameter
  
  With VLaser2
    If Not \Initialized
      \Name        = "Switching Strong Laser (V)"
      \File        = "VLaser2"
      \Energy      = #KillingEnergy
      \OuterWidth  = 10
      \OuterHeight = 0
      \Switching   = #True
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn LaserTemplate(*Object, Event, *Parameter, @VLaser2)
EndProcedure
ProcedureDLL.i Obj_HLaser1S(*Object.GM_Object, Event.i, *Parameter)
  Global HLaser1.LaserParameter
  
  With HLaser1
    If Not \Initialized
      \Name        = "Switching Weak Laser (H)"
      \File        = "HLaser1"
      \Energy      = 5
      \OuterWidth  = 0
      \OuterHeight = 10
      \Switching   = #True
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn LaserTemplate(*Object, Event, *Parameter, @HLaser1)
EndProcedure
ProcedureDLL.i Obj_HLaser2S(*Object.GM_Object, Event.i, *Parameter)
  Global HLaser2.LaserParameter
  
  With HLaser2
    If Not \Initialized
      \Name        = "Switching Strong Laser (H)"
      \File        = "HLaser2"
      \Energy      = #KillingEnergy
      \OuterWidth  = 0
      \OuterHeight = 10
      \Switching   = #True
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn LaserTemplate(*Object, Event, *Parameter, @HLaser2)
EndProcedure



#MovingLaser_Speed = 1

Structure MovingLaserMemory
  X.f
  Y.f
  Direction.i
  Stopped.i
  
  Height.i
  Array *Laser.GM_Object(0)
  StartX.i
  EndX.i
EndStructure

Global MovingLaser_TopSprite.i, MovingLaser_TopSprite3D.i
Global MovingLaser_BottomSprite.i, MovingLaser_BottomSprite3D.i
Global MovingLaser_TrackSprite.i, MovingLaser_TrackSprite3D.i

ProcedureDLL.i Obj_MovingLaserH(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.MovingLaserMemory, Index.i
  
  If *Object : *Memory = *Object\Memory : EndIf
  
  Select Event
    Case #GM_Object_Display
      ; Fhrung darstellen:
      For Index = *Memory\StartX To *Memory\EndX
        GM_DisplaySprite3D(MovingLaser_TrackSprite3D, Index * #GM_FieldSize, *Object\Y + 1)
        GM_DisplaySprite3D(MovingLaser_TrackSprite3D, Index * #GM_FieldSize, *Object\Y + #GM_FieldSize * *Memory\Height - 4)
      Next
      ; Laser-Kanonen zeigen:
      GM_DisplaySprite3D(MovingLaser_TopSprite3D, *Memory\X, *Object\Y)
      GM_DisplaySprite3D(MovingLaser_BottomSprite3D, *Memory\X, *Object\Y + #GM_FieldSize * (*Memory\Height - 1))
    Case #GM_Object_Frame
      If Not *Memory\Stopped
        If *Memory\X / #GM_FieldSize <= *Memory\StartX
          *Memory\Direction = 1
        ElseIf *Memory\X / #GM_FieldSize => *Memory\EndX
          *Memory\Direction = -1
        EndIf
        
        *Memory\X + *Memory\Direction * #MovingLaser_Speed
        For Index = 0 To *Memory\Height - 1
          *Memory\Laser(Index)\X + *Memory\Direction * #MovingLaser_Speed
        Next
      EndIf
    Case #GM_Object_Initialize
      *Memory        = AllocateMemory(SizeOf(MovingLaserMemory))
      *Object\Memory = *Memory
      InitializeStructure(*Memory, MovingLaserMemory)
      
      *Memory\Direction = 1
      
      *Memory\Height = GM_DetectNextBarrier(*Object\X / #GM_FieldSize, *Object\Y / #GM_FieldSize, 0, 1, #False)
      ReDim *Memory\Laser(*Memory\Height - 1)
      
      For Index = 0 To *Memory\Height - 1
        *Memory\Laser(Index) = GM_CreateObject(#GM_Layer_ForegroundObject1, @Obj_VLaser2(), *Object\X, *Object\Y + Index * #GM_FieldSize)
      Next
      
      *Memory\StartX = (*Object\X / #GM_FieldSize) - GM_DetectNextBarrier(*Object\X / #GM_FieldSize, *Object\Y / #GM_FieldSize, -1, 0) + 1
      *Memory\EndX   = (*Object\X / #GM_FieldSize) + GM_DetectNextBarrier(*Object\X / #GM_FieldSize, *Object\Y / #GM_FieldSize, 1, 0) - 1
      
      *Memory\X = *Object\X
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not MovingLaser_TopSprite
        MovingLaser_TopSprite   = GM_LoadSprite("Electric\MovingLaser-Top")
        MovingLaser_TopSprite3D = GM_CreateSprite3D(MovingLaser_TopSprite)
      EndIf
      If Not MovingLaser_BottomSprite
        MovingLaser_BottomSprite   = GM_LoadSprite("Electric\MovingLaser-Bottom")
        MovingLaser_BottomSprite3D = GM_CreateSprite3D(MovingLaser_BottomSprite)
      EndIf
      If Not MovingLaser_TrackSprite
        MovingLaser_TrackSprite   = GM_LoadSprite("Electric\MovingLaser-Track")
        MovingLaser_TrackSprite3D = GM_CreateSprite3D(MovingLaser_TrackSprite)
      EndIf
      Obj_VLaser2(#Null, #GM_Object_GlobalLoad, #Null)
    
    Case #GM_Object_ActionName
      Select *Parameter
        Case 0
          ProcedureReturn @"Stop"
        Case 1
          ProcedureReturn @"Continue"
        Case 2
          ProcedureReturn @"Activate Laser"
        Case 3
          ProcedureReturn @"Deactivate Laser"
      EndSelect
    Case #GM_Object_CallAction
      Select GM_ObjectActionID(*Parameter)
        Case 0 ;Stop
          *Memory\Stopped = #True
        Case 1 ;Continue
          *Memory\Stopped = #False
        Case 2 ;Activate Laser
          For Index = 0 To *Memory\Height - 1
            *Memory\Laser(Index)\Hidden = #False
          Next
        Case 3 ;Deactivate Laser
          For Index = 0 To *Memory\Height - 1
            *Memory\Laser(Index)\Hidden = #True
          Next
      EndSelect
    Case #GM_Object_ActionCount
      ProcedureReturn 4
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Electric\MovingLaser-View"
    Case #GM_Object_Name
      ProcedureReturn @"Moving Laser (H)"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure


DataSection
  LaserEffect:
    Data.i 3
    Data.i 1
    Data.i 8
    Data.i 4
    Data.i 3
    Data.i 10
    Data.i 5
    Data.i 1
    Data.i 8
    Data.i 2
  EndLaserEffect:
EndDataSection
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 42
; FirstLine = 12
; Folding = ---
; EnableXP