#Bouncer_Radius      = 9
#Bouncer_OuterRadius = #GM_FieldSize/2 - #Bouncer_Radius

Structure BouncerParameter
  Initialized.i
  Sprite.i
  Sprite3D.i
  Energy.i
  Destroyable.i
  File.s
  Name.s
EndStructure
Structure BouncerMemory
  Bounced.i
  Speed.f
  Energy.f
EndStructure

Procedure.i BouncerTemplate(*Object.GM_Object, Event.i, *Parameter, *BouncerParameter.BouncerParameter)
  Protected *Memory.BouncerMemory, OldY.i
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      If *Memory\Bounced
        GM_ZoomSprite3D(*BouncerParameter\Sprite3D, #GM_FieldSize, #GM_FieldSize - 8)
        GM_DisplaySprite3D(*BouncerParameter\Sprite3D, *Object\X - #Bouncer_OuterRadius, *Object\Y - #Bouncer_OuterRadius + 8)
      Else
        GM_ZoomSprite3D(*BouncerParameter\Sprite3D, #GM_FieldSize, #GM_FieldSize)
        GM_DisplaySprite3D(*BouncerParameter\Sprite3D, *Object\X - #Bouncer_OuterRadius, *Object\Y - #Bouncer_OuterRadius)
      EndIf
    Case #GM_Object_Frame  
      *Memory\Speed + 0.1
      OldY          = *Object\Y
      *Object\Y     + *Memory\Speed
      
      If *Memory\Bounced
        *Memory\Bounced - 1
      EndIf
      
      Select GM_FieldCollision(*Object, 0, *Memory\Speed, 0, Sgn(*Memory\Speed))
        Case #GM_Collision_Top
          *Memory\Speed   = -*Memory\Speed
          *Object\Y       = OldY
          *Memory\Bounced = 8
      EndSelect
    Case #GM_Object_Collision
      If *GM_Player\Action <> #GM_Player_Action_LumiFlight
        GM_HitPlayer(*BouncerParameter\Energy)
      Else
        GM_AddScoreTM(*BouncerParameter\Energy * 25, *Object)
        GM_EmitKilledEnemyParticle(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
        ProcedureReturn #GM_Object_DoDelete
      EndIf
    Case #GM_Object_Hit
      *Shot = *Parameter
      If *BouncerParameter\Destroyable
        GM_Damage(@*Memory\Energy, @*Shot\Power)
        If *Memory\Energy <= 0
          GM_AddScoreTM(*BouncerParameter\Energy * 25, *Object)
          GM_EmitKilledEnemyParticle(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
          ProcedureReturn #GM_Object_DoDelete
        EndIf
      EndIf
      ProcedureReturn #GM_Object_DoCollision
    Case #GM_Object_Delete
      FreeMemory(*Memory)
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not *BouncerParameter\Sprite
        *BouncerParameter\Sprite   = GM_LoadSprite("Enemies\Bouncer" + *BouncerParameter\File)
        *BouncerParameter\Sprite3D = GM_CreateSprite3D(*BouncerParameter\Sprite)
      EndIf
    Case #GM_Object_Initialize
      *Object\X      + #Bouncer_OuterRadius
      *Object\Y      + #Bouncer_OuterRadius
      *Object\Width  = #Bouncer_Radius*2
      *Object\Height = #Bouncer_Radius*2
      
      *Memory        = AllocateMemory(SizeOf(BouncerMemory))
      *Object\Memory = *Memory
      *Memory\Energy = *BouncerParameter\Energy
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    
    Case #GM_Object_ViewSprite
      String = "Enemies\Bouncer" + *BouncerParameter\File
      ProcedureReturn @String
    Case #GM_Object_Name
      String = *BouncerParameter\Name + " Bouncer"
      If Not *BouncerParameter\Destroyable
        String + " (strong)"
      EndIf
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_Bouncer1(*Object.GM_Object, Event.i, *Parameter)
  Global Bouncer1.BouncerParameter
  
  With Bouncer1
    If Not \Initialized
      \Energy      = 1
      \Destroyable = #True
      \Name        = "Blue"
      \File        = "1"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn BouncerTemplate(*Object, Event, *Parameter, @Bouncer1)
EndProcedure
ProcedureDLL.i Obj_Bouncer2(*Object.GM_Object, Event.i, *Parameter)
  Global Bouncer2.BouncerParameter
  
  With Bouncer2
    If Not \Initialized
      \Energy      = 3
      \Destroyable = #True
      \Name        = "Magenta"
      \File        = "2"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn BouncerTemplate(*Object, Event, *Parameter, @Bouncer2)
EndProcedure
ProcedureDLL.i Obj_Bouncer3(*Object.GM_Object, Event.i, *Parameter)
  Global Bouncer3.BouncerParameter
  
  With Bouncer3
    If Not \Initialized
      \Energy      = 5
      \Destroyable = #False
      \Name        = "Red"
      \File        = "3"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn BouncerTemplate(*Object, Event, *Parameter, @Bouncer3)
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 29
; FirstLine = 10
; Folding = --
; EnableXP