#Cannon_FireDuration = 90
#Cannon_Top          = 4
#Cannon_Height       = #GM_FieldSize - #Cannon_Top
#Cannon_OuterRadius  = 2
#Cannon_Width        = #GM_FieldSize - #Cannon_OuterRadius * 2

#CannonBullet_Speed       = 3
#CannonBullet_Power       = 5
#CannonBullet_OuterWidth  = 4
#CannonBullet_Width       = #GM_FieldSize - #CannonBullet_OuterWidth * 2
#CannonBullet_OuterHeight = 5
#CannonBullet_Height      = #GM_FieldSize - #CannonBullet_OuterHeight * 2

Global CannonBullet_Frameset.i
Global CannonL_Sprite.i, CannonL_Sprite3D.i
Global CannonR_Sprite.i, CannonR_Sprite3D.i

Procedure.i LoadCannonBullet()
  If Not CannonBullet_Frameset
    CannonBullet_Frameset = GM_LoadAnimationFrameset("Enemies\CannonBullet", #GM_FieldSize, #GM_FieldSize)
  EndIf
EndProcedure

ProcedureDLL.i Obj_CannonBullet(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      If *Object\Memory > 0
        GM_DisplayFramesetFrame(CannonBullet_Frameset, 1, 0, *Object\X - #CannonBullet_OuterWidth, *Object\Y - #CannonBullet_OuterHeight)
      Else
        GM_DisplayFramesetFrame(CannonBullet_Frameset, 0, 0, *Object\X - #CannonBullet_OuterWidth, *Object\Y - #CannonBullet_OuterHeight)
      EndIf
    Case #GM_Object_Frame
      *Object\X + *Object\Memory
      If GM_FieldCollision(*Object, *Object\Memory, 0, Sgn(*Object\Memory), 0, #False)
        GM_EmitKilledEnemyParticle(*Object\X + *Object\Width / 2, *Object\Y + *Object\Height / 2)
        ProcedureReturn #GM_Object_DoDelete
      EndIf
    Case #GM_Object_Collision
      If GM_PlayerCollision(*Object, *Object\Memory, 0) <> #GM_Collision_Top
        GM_HitPlayer(#CannonBullet_Power)
      Else
        ; Ein Aufprall von Oben zerstrt die Bombe ohne Energieverlust:
        GM_SetPlayerMoveY(-4)
      EndIf
      GM_EmitKilledEnemyParticle(*Object\X + *Object\Width / 2, *Object\Y + *Object\Height / 2) 
      ProcedureReturn #GM_Object_DoDelete
    Case #GM_Object_Initialize
      *Object\Memory = *Parameter
      *Object\Width  = #CannonBullet_Width
      *Object\Height = #CannonBullet_Height
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_CannonL(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(CannonL_Sprite3D, *Object\X, *Object\Y - #Cannon_Top)
    Case #GM_Object_Frame
      If *Object\Memory = 1
        GM_CreateObject(#GM_Layer_BackgroundObject2, @Obj_CannonBullet(), *Object\X + #Cannon_OuterRadius, *Object\Y + 1, -#CannonBullet_Speed)
        *Object\Memory = #Cannon_FireDuration
      Else
        *Object\Memory - 1
      EndIf
    Case #GM_Object_Collision
      *Parameter = GM_PlayerCollision(*Object, 0, 0)
      GM_DoGroundCollision(*Object, *Parameter)
    Case #GM_Object_Initialize
      *Object\Memory = 1 + Random(#Cannon_FireDuration)
      *Object\X      + #Cannon_OuterRadius
      *Object\Y      + #Cannon_Top
      *Object\Width  = #Cannon_Width
      *Object\Height = #Cannon_Height
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      CannonL_Sprite   = GM_LoadSprite("Enemies\CannonL")
      CannonL_Sprite3D = GM_CreateSprite3D(CannonL_Sprite)
      LoadCannonBullet()
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Enemies\CannonL"
    Case #GM_Object_Name
      ProcedureReturn @"Cannon (left)"
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_CannonR(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(CannonR_Sprite3D, *Object\X, *Object\Y - #Cannon_Top)
    Case #GM_Object_Frame
      If *Object\Memory = 1
        GM_CreateObject(#GM_Layer_BackgroundObject2, @Obj_CannonBullet(), *Object\X + #Cannon_OuterRadius + #Cannon_Width - #CannonBullet_Width, *Object\Y + 1, #CannonBullet_Speed)
        *Object\Memory = #Cannon_FireDuration
      Else
        *Object\Memory - 1
      EndIf
    Case #GM_Object_Collision
      *Parameter = GM_PlayerCollision(*Object, 0, 0)
      GM_DoGroundCollision(*Object, *Parameter)
    Case #GM_Object_Initialize
      *Object\Memory = 1 + Random(#Cannon_FireDuration)
      *Object\X      + #Cannon_OuterRadius
      *Object\Y      + #Cannon_Top
      *Object\Width  = #Cannon_Width
      *Object\Height = #Cannon_Height
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      CannonR_Sprite   = GM_LoadSprite("Enemies\CannonR")
      CannonR_Sprite3D = GM_CreateSprite3D(CannonR_Sprite)
      LoadCannonBullet()
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Enemies\CannonR"
    Case #GM_Object_Name
      ProcedureReturn @"Cannon (right)"
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 152
; FirstLine = 101
; Folding = -
; EnableXP