#PathCopter_Width       = 18
#PathCopter_Height      = 18
#PathCopter_OuterWidth  = (#GM_FieldSize - #PathCopter_Width ) / 2
#PathCopter_OuterHeight = (#GM_FieldSize - #PathCopter_Height) / 2



Structure PathCopterParameter
  File.s
  Name.s
  
  Energy.i
  
  Frameset.i
  
  Initialized.i
EndStructure
Structure PathCopterMemory
  *Path.Path
  Energy.i
EndStructure



Procedure.i PathCopterTemplate(*Object.GM_Object, Event.i, *Parameter, *PathCopterParameter.PathCopterParameter)
  Static *Memory.PathCopterMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplayAnimation(*Object\Animation, *Object\X - #PathCopter_OuterWidth, *Object\Y - #PathCopter_OuterHeight)
    Case #GM_Object_Frame
      ExaminePath(*Object, *Memory\Path, #PathCopter_OuterWidth, #PathCopter_OuterHeight)
      If GM_PlayAnimation(*Object\Animation)
        GM_SetAnimationDuration(*Object\Animation, 5)
      EndIf
    Case #GM_Object_Collision
      GM_HitPlayer(*PathCopterParameter\Energy)
    Case #GM_Object_Hit
      *Shot = *Parameter
      GM_Damage(*Memory\Energy, *Shot\Power)
      If *Memory\Energy = 0
        ProcedureReturn #GM_Object_DoDelete
      EndIf
    
    Case #GM_Object_Initialize
      *Object\X      + #PathCopter_OuterWidth
      *Object\Y      + #PathCopter_OuterHeight
      *Object\Width  = #PathCopter_Width
      *Object\Height = #PathCopter_Height
      
      *Object\Animation = GM_CreateAnimation(*PathCopterParameter\Frameset)
      
      *Memory\Path\Speed = 1
      InitializePath(*Object, *Memory\Path)
    Case #GM_Object_Load
      *Memory        = AllocateMemory(SizeOf(PathCopterMemory))
      *Object\Memory = *Memory
      
      *Memory\Path = LoadPath()
    Case #GM_Object_GlobalLoad
      If Not *PathCopterParameter\Frameset
        *PathCopterParameter\Frameset = GM_LoadAnimationFrameset(*PathCopterParameter\File, #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveSelection(*EditorObject\Memory)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      *EditorObject\Memory = GM_LoadSelection()
    Case #GM_Object_EditorInitialize
      *EditorObject = *Parameter
      If *EditorObject\Memory
        *EditorObject\X = GM_SelectedX(*EditorObject\Memory, 0)
        *EditorObject\Y = GM_SelectedY(*EditorObject\Memory, 0)
      Else
        *EditorObject\Memory = GM_CreateSelection()
      EndIf
    Case #GM_Object_EditorConfigure
      *EditorObject = *Parameter
      GM_EditSelection(*EditorObject\Memory, "Build path")
    Case #GM_Object_EditorFree
      *EditorObject = *Parameter
      GM_FreeSelection(*EditorObject\Memory)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_ViewSprite
      ProcedureReturn @*PathCopterParameter\File
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_Name
      ProcedureReturn @*PathCopterParameter\Name
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_PathCopter1(*Object.GM_Object, Event.i, *Parameter)
  Global PathCopter1.PathCopterParameter
  
  With PathCopter1
    If Not \Initialized
      \Name = "Path Copter"
      \File = "Enemies\Copter1"
      
      \Energy = 4
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PathCopterTemplate(*Object, Event, *Parameter, @PathCopter1)
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 56
; FirstLine = 29
; Folding = -
; EnableXP