Structure SFanceParameter
  Initialized.i
  Name.s
  Sprite.i
  Sprite3D.i
  Index.i
  Energy.i
  Destroyable.i
  Killing.i
  Size.i
  OuterSize.i
EndStructure
Structure SFanceMemory
  Energy.f
  Movement.f
EndStructure

Procedure.i SFanceTemplate(*Object.GM_Object, Event.i, *Parameter, *SFanceParameter.SFanceParameter) ;Static Fance
  Protected *Memory.SFanceMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(*SFanceParameter\Sprite3D, *Object\X - *SFanceParameter\OuterSize, *Object\Y - *SFanceParameter\OuterSize + Cos(*Memory\Movement))
    Case #GM_Object_Frame
      *Memory\Movement + 0.05
      If *Memory\Movement => 2 * #PI
        *Memory\Movement - 2 * #PI
      EndIf
    Case #GM_Object_Collision
      If *GM_Player\Action <> #GM_Player_Action_LumiFlight
        If *SFanceParameter\Killing
          GM_LoseLife()
        Else
          GM_HitPlayer(*Memory\Energy)
        EndIf
      Else
        If *SFanceParameter\Destroyable
          GM_EmitKilledEnemyParticle(*Object\X + *Object\Width / 2, *Object\Y + *Object\Height / 2)
          ProcedureReturn #GM_Object_DoDelete
        Else
          If *SFanceParameter\Killing
            GM_LoseLife()
          Else
            GM_HitPlayer(*Memory\Energy)
          EndIf
        EndIf
      EndIf
    Case #GM_Object_Hit
      If *SFanceParameter\Destroyable
        *Shot = *Parameter
        GM_Damage(@*Memory\Energy, @*Shot\Power)
        If *Memory\Energy <= 0
          GM_EmitKilledEnemyParticle(*Object\X + *Object\Width / 2, *Object\Y + *Object\Height / 2)
          ProcedureReturn #GM_Object_DoDelete
        EndIf
      EndIf
      ProcedureReturn #GM_Object_DoCollision
    Case #GM_Object_Initialize
      *Object\X      + *SFanceParameter\OuterSize
      *Object\Y      + *SFanceParameter\OuterSize
      *Object\Width  = *SFanceParameter\Size
      *Object\Height = *SFanceParameter\Size
      
      *Memory          = AllocateMemory(SizeOf(SFanceMemory))
      *Object\Memory   = *Memory
      *Memory\Movement = Random(360 - 1) / 180.0 * #PI
      *Memory\Energy   = *SFanceParameter\Energy
    
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      *SFanceParameter\Sprite    = GM_LoadSprite("Enemies\StaticFance" + Str(*SFanceParameter\Index))
      *SFanceParameter\Sprite3D  = GM_CreateSprite3D(*SFanceParameter\Sprite)
      *SFanceParameter\OuterSize = (#GM_FieldSize - *SFanceParameter\Size) / 2
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
      
    Case #GM_Object_ViewSprite
      String = "Enemies\StaticFance" + Str(*SFanceParameter\Index)
      ProcedureReturn @String
    Case #GM_Object_Name
      String = *SFanceParameter\Name + " Fance"
      If Not *SFanceParameter\Destroyable
        String + " (strong)"
      EndIf
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_SFance1(*Object.GM_Object, Event.i, *Parameter)
  Global SFance1.SFanceParameter
  
  With SFance1
    If Not \Initialized
      \Index       = 1
      \Name        = "Medium"
      \Energy      = 3
      \Destroyable = #True
      \Killing     = #False
      \Size        = 22
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn SFanceTemplate(*Object, Event, *Parameter, @SFance1)
EndProcedure
ProcedureDLL.i Obj_SFance2(*Object.GM_Object, Event.i, *Parameter)
  Global SFance2.SFanceParameter
  
  With SFance2
    If Not \Initialized
      \Index       = 2
      \Name        = "Killing"
      \Energy      = 5
      \Destroyable = #True
      \Killing     = #True
      \Size        = 22
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn SFanceTemplate(*Object, Event, *Parameter, @SFance2)
EndProcedure
ProcedureDLL.i Obj_SFance3(*Object.GM_Object, Event.i, *Parameter)
  Global SFance3.SFanceParameter
  
  With SFance3
    If Not \Initialized
      \Index       = 3
      \Name        = "Killing"
      \Energy      = 0
      \Destroyable = #False
      \Killing     = #True
      \Size        = 22
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn SFanceTemplate(*Object, Event, *Parameter, @SFance3)
EndProcedure
ProcedureDLL.i Obj_SFance4(*Object.GM_Object, Event.i, *Parameter)
  Global SFance4.SFanceParameter
  
  With SFance4
    If Not \Initialized
      \Index       = 4
      \Name        = "Small"
      \Energy      = 3
      \Destroyable = #True
      \Killing     = #False
      \Size        = 16
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn SFanceTemplate(*Object, Event, *Parameter, @SFance4)
EndProcedure
ProcedureDLL.i Obj_SFance5(*Object.GM_Object, Event.i, *Parameter)
  Global SFance5.SFanceParameter
  
  With SFance5
    If Not \Initialized
      \Index       = 5
      \Name        = "Little"
      \Energy      = 2
      \Destroyable = #True
      \Killing     = #False
      \Size        = 12
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn SFanceTemplate(*Object, Event, *Parameter, @SFance5)
EndProcedure
ProcedureDLL.i Obj_SFance6(*Object.GM_Object, Event.i, *Parameter)
  Global SFance6.SFanceParameter
  
  With SFance6
    If Not \Initialized
      \Index       = 6
      \Name        = "Small"
      \Energy      = 4
      \Destroyable = #False
      \Killing     = #False
      \Size        = 16
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn SFanceTemplate(*Object, Event, *Parameter, @SFance6)
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 53
; FirstLine = 36
; Folding = --
; EnableXP