Enumeration
  #TrapT_Action_Waiting
  #TrapT_Action_Falling
  #TrapT_Action_Replete
EndEnumeration

Structure TrapT
  Action.i
  Y.i
  Reach.i
  YMotion.f
EndStructure

Global TrapT_Frameset.i

ProcedureDLL.i Obj_TrapT(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.TrapT
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplayAnimation(*Object\Animation, *Object\X, *Object\Y)
    Case #GM_Object_Frame
      Select *Memory\Action
        Case #TrapT_Action_Waiting
          If *GM_Player\FieldY <= *Memory\Y + *Memory\Reach And *GM_Player\FieldY => *Memory\Y
            If *GM_Player\X + *GM_Player\Width > *Object\X - 5 And *GM_Player\X < *Object\X + #GM_FieldSize + 5
              *Memory\Action  = #TrapT_Action_Falling
              *Memory\YMotion = 1
            EndIf
          EndIf
        Case #TrapT_Action_Falling
          If *Memory\YMotion < 3.6
            *Memory\YMotion + 0.2
          EndIf
          *Object\Y + *Memory\YMotion
          If *Object\Y > (*Memory\Y + *Memory\Reach + 1) * #GM_FieldSize
            *Object\Hidden = #True
          EndIf
        Case #TrapT_Action_Replete
          If *Memory\YMotion < 3.6
            *Memory\YMotion + 0.08
          EndIf
          *Object\Y + *Memory\YMotion
          If GM_AnimationFrame(*Object\Animation) < 2
            If GM_PlayAnimation(*Object\Animation)
              GM_SetAnimationDuration(*Object\Animation, 3)
            EndIf
          EndIf
          If *Object\Y > (*Memory\Y + *Memory\Reach + 1) * #GM_FieldSize
            *Object\Hidden = #True
          EndIf
      EndSelect
    Case #GM_Object_Collision
      If GM_PlayerCollision(*Object, 0, *Memory\YMotion) = #GM_Collision_Bottom
        GM_LoseLife()
        *Memory\Action  = #TrapT_Action_Replete
        GM_SetAnimationDuration(*Object\Animation, 3)
      EndIf
    Case #GM_Object_PlayerEnteredScene
      *Object\Y = *Memory\Y * #GM_FieldSize + 2
      GM_SetAnimationFrame(*Object\Animation, 0)
      *Memory\Action = #TrapT_Action_Waiting
      *Object\Hidden = #False
      
    Case #GM_Object_Initialize
      *Object\Y      + 2
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Object\Animation = GM_CreateAnimation(TrapT_Frameset)
      
      *Memory        = AllocateMemory(SizeOf(TrapT))
      *Object\Memory = *Memory
      
      *Memory\Action = #TrapT_Action_Waiting
      *Memory\Y      = (*Object\Y - 2) / #GM_FieldSize
      
      *Memory\Reach = GM_DetectNextBarrier(*Object\X / #GM_FieldSize, *Memory\Y + 1, 0, 1, #False)
      If *Memory\Reach = -1
        *Memory\Reach = GM_SceneHeight(*Object\Scene) - *Memory\Y
      EndIf
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not TrapT_Frameset
        TrapT_Frameset = GM_LoadAnimationFrameset("Enemies\TrapT", #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Enemies\TrapT-View"
    Case #GM_Object_Name
      ProcedureReturn @"Trap Monster (top)"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 75
; FirstLine = 51
; Folding = -
; EnableXP