IncludeFile "..\Import.pbi"



EnableExplicit



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Items")
        GM_Folder("Powers")
          GM_File("DoubleJump")
          GM_File("Climb")
          GM_File("Fly1")
          GM_File("Fly2")
          GM_File("Fly3")
          GM_File("Shoot1")
          GM_File("Shoot2")
          GM_File("Shoot3")
          GM_File("LoadShot")
          GM_File("LumiFlight")
          GM_End()
        GM_Folder("Energy")
          GM_File("Energy1")
          GM_File("Energy2")
          GM_File("Energy3")
          GM_File("Life")
          GM_File("PlusMaxEnergy")
          GM_End()
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



Global PowerSprites.i, EnergySprites.i



;******************************************
; Template
;******************************************


Structure LumMemory
  *Target.GM_Object
  Direction.i
  Angle.f
  Radius.f
  RadiusAngle.f
  MoveX.f
  MoveY.f
EndStructure

#Lum_RotationSpeed = 2 * #PI / 50.0

Global LumSprite.i, LumSprite3D.i

Procedure.i Obj_Lum(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.LumMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(LumSprite3D, *Object\X - *Object\Width/2, *Object\Y - *Object\Height/2)
    Case #GM_Object_Frame
      If *Memory\Target And GM_IsObjectDestroyed(*Memory\Target)
        *Memory\Target = #Null
      EndIf
      
      If *Memory\Target
        *Memory\Angle + #Lum_RotationSpeed * *Memory\Direction
        If *Memory\Angle => 2 * #PI
          *Memory\Angle - 2 * #PI
        ElseIf *Memory\Angle <= -2 * #PI
          *Memory\Angle + 2 * #PI
        EndIf
        *Memory\RadiusAngle + 0.08 + Random(40) / 100.0
        If *Memory\RadiusAngle = 2 * #PI
          *Memory\RadiusAngle - 2 * #PI
        EndIf
        *Memory\MoveX = *Memory\Target\X + *Memory\Target\Width/2  + Cos(*Memory\Angle) * (*Memory\Radius + Sin(*Memory\RadiusAngle) * 3.0) - *Object\X
        *Memory\MoveY = *Memory\Target\Y + *Memory\Target\Height/2 + Sin(*Memory\Angle) * (*Memory\Radius + Sin(*Memory\RadiusAngle) * 3.0) - *Object\Y
        
        *Object\X + *Memory\MoveX
        *Object\Y + *Memory\MoveY
      Else
        If Random(3) = 0
          GM_EmitGlitter(*Object\X + Random(4) - 2, *Object\Y)
        EndIf
        
        *Memory\RadiusAngle + 0.1 + Random(40) / 100.0
        If *Memory\RadiusAngle = 2 * #PI
          *Memory\RadiusAngle - 2 * #PI
        EndIf
        
        *Object\X + *Memory\MoveX * 2 + Sin(*Memory\RadiusAngle) * 1.0
        *Object\Y + *Memory\MoveY
        
        If *Object\Y < 10
          ProcedureReturn #GM_Object_DoDelete
        EndIf
        
        *Memory\MoveX * 0.95
        *Memory\MoveY - 0.08
        
        If *Memory\MoveY < -8.0
          *Memory\MoveY = -8.0
        EndIf
      EndIf
      
    Case #GM_Object_Initialize
      *Object\Width  = 6
      *Object\Height = 6
      
      *Object\Memory = AllocateMemory(SizeOf(LumMemory))
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i CreateLum(*Target.GM_Object)
  Static *Object.GM_Object, *Memory.LumMemory, Angle.f
  
  If Not LumSprite
    LumSprite = GM_LoadSprite("Items\Lum")
    LumSprite3D = GM_CreateSprite3D(LumSprite)
  EndIf
  
  *Object = GM_CreateObject(#GM_Layer_ForegroundObject2, @Obj_Lum(), 0, 0) 
  *Memory = *Object\Memory
  
  *Memory\Target = *Target
  *Memory\Radius = 10.0 + Random(50) / 10.0
  *Memory\Angle  = Angle
  Angle + (2.0 * #PI) / 4.0
  
  Select Random(1)
    Case 0 : *Memory\Direction = -1
    Case 1 : *Memory\Direction =  1
  EndSelect
  
  *Object\X = *Target\X + *Target\Width/2  + Cos(*Memory\Angle) * *Memory\Radius
  *Object\Y = *Target\Y + *Target\Height/2 + Sin(*Memory\Angle) * *Memory\Radius
  
  ProcedureReturn *Object
EndProcedure

Global Lum2Sprite.i, Lum2Sprite3D.i

Procedure.i Obj_Lum2(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.LumMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(Lum2Sprite3D, *Object\X - *Object\Width/2, *Object\Y - *Object\Height/2)
    Case #GM_Object_Frame
      If *Memory\Target And GM_IsObjectDestroyed(*Memory\Target)
        *Memory\Target = #Null
      EndIf
      
      If *Memory\Target
        *Memory\Angle + #Lum_RotationSpeed * *Memory\Direction
        If *Memory\Angle => 2 * #PI
          *Memory\Angle - 2 * #PI
        ElseIf *Memory\Angle <= -2 * #PI
          *Memory\Angle + 2 * #PI
        EndIf
        *Memory\RadiusAngle + 0.08 + Random(40) / 100.0
        If *Memory\RadiusAngle = 2 * #PI
          *Memory\RadiusAngle - 2 * #PI
        EndIf
        *Memory\MoveX = *Memory\Target\X + *Memory\Target\Width/2  + Cos(*Memory\Angle) * (*Memory\Radius + Sin(*Memory\RadiusAngle) * 3.0) - *Object\X
        *Memory\MoveY = *Memory\Target\Y + *Memory\Target\Height/2 + Sin(*Memory\Angle) * (*Memory\Radius + Sin(*Memory\RadiusAngle) * 3.0) - *Object\Y
        
        *Object\X + *Memory\MoveX
        *Object\Y + *Memory\MoveY
      Else
        
        *Object\X + *Memory\MoveX * 2
        *Object\Y + *Memory\MoveY
        
        If *Object\Y < 10
          ProcedureReturn #GM_Object_DoDelete
        EndIf
        
        *Memory\MoveX * 0.95
        *Memory\MoveY - 0.08
        
        If *Memory\MoveY < -8.0
          *Memory\MoveY = -8.0
        EndIf
      EndIf
      
    Case #GM_Object_Initialize
      *Object\Width  = 4
      *Object\Height = 4
      
      *Object\Memory = AllocateMemory(SizeOf(LumMemory))
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i CreateLum2(*Target.GM_Object)
  Static *Object.GM_Object, *Memory.LumMemory, Angle.f
  
  If Not Lum2Sprite
    Lum2Sprite = GM_LoadSprite("Items\Lum2")
    Lum2Sprite3D = GM_CreateSprite3D(Lum2Sprite)
  EndIf
  
  *Object = GM_CreateObject(#GM_Layer_ForegroundObject2, @Obj_Lum2(), 0, 0) 
  *Memory = *Object\Memory
  
  *Memory\Target = *Target
  *Memory\Radius = 10.0 + Random(50) / 10.0
  *Memory\Angle  = Angle
  Angle + #PI
  
  Select Random(1)
    Case 0 : *Memory\Direction = -1
    Case 1 : *Memory\Direction =  1
  EndSelect
  
  *Object\X = *Target\X + *Target\Width/2  + Cos(*Memory\Angle) * *Memory\Radius
  *Object\Y = *Target\Y + *Target\Height/2 + Sin(*Memory\Angle) * *Memory\Radius
  
  ProcedureReturn *Object
EndProcedure




Structure PowerParameter
  Name.s
  Description.s
  
  *Callback
  Index.i
  
  Sprite.i
  
  Initialized.i
EndStructure
Structure EnergyParameter
  Name.s
  Description.i
  
  *Callback
  Index.i
  
  Sprite.i
  
  Initialized.i
EndStructure
Structure PowerMemory
  *Lum1.GM_Object
  *Lum2.GM_Object
  *Lum3.GM_Object
  *Lum4.GM_Object
EndStructure
Structure EnergyMemory
  *Lum1.GM_Object
  *Lum2.GM_Object
EndStructure

#Item_Radius = 10

Procedure.i PowerTemplate(*Object.GM_Object, Event.i, *Parameter, *Power.PowerParameter)
  Static Angle.i, *Memory.PowerMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplayCyanLight(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2, 200)
      GM_DisplaySprite3D(*Power\Sprite, *Object\X, *Object\Y)
    Case #GM_Object_Collision
      If GM_DistanceToPlayer(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2) < #Item_Radius
        For Angle = 0 To 320 Step 40
          GM_EmitGlitter(*Object\X + *Object\Width/2 + Cos(Radian(Angle)) * 10, *Object\Y + *Object\Height/2 + Sin(Radian(Angle)) * 10)
        Next
        For Angle = 20 To 340 Step 40
          GM_EmitGlitter(*Object\X + *Object\Width/2 + Cos(Radian(Angle)) * 14, *Object\Y + *Object\Height/2 + Sin(Radian(Angle)) * 14)
        Next
        GM_EmitAirExplosion(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
        CallFunctionFast(*Power\Callback)
        ProcedureReturn #GM_Object_DoDelete
      EndIf
    Case #GM_Object_Hide
      GM_HideObject(*Memory\Lum1, #True)
      GM_HideObject(*Memory\Lum2, #True)
      GM_HideObject(*Memory\Lum3, #True)
      GM_HideObject(*Memory\Lum4, #True)
    Case #GM_Object_Unhide
      GM_HideObject(*Memory\Lum1, #False)
      GM_HideObject(*Memory\Lum2, #False)
      GM_HideObject(*Memory\Lum3, #False)
      GM_HideObject(*Memory\Lum4, #False)
      
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Memory        = AllocateMemory(SizeOf(PowerMemory))
      *Object\Memory = *Memory
      
      *Memory\Lum1 = CreateLum(*Object)
      *Memory\Lum2 = CreateLum(*Object)
      *Memory\Lum3 = CreateLum(*Object)
      *Memory\Lum4 = CreateLum(*Object)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not PowerSprites
        PowerSprites = GM_LoadAnimationFrameset("Items\Powers", #GM_FieldSize, #GM_FieldSize)
      EndIf
      If Not *Power\Sprite
        *Power\Sprite = GM_FramesetSprite(PowerSprites, *Power\Index, 0)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Items\Powers"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(*Power\Index, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @*Power\Name
    Case #GM_Object_Description
      If *Power\Description
        ProcedureReturn @*Power\Description
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i EnergyTemplate(*Object.GM_Object, Event.i, *Parameter, *Energy.EnergyParameter)
  Static *Memory.EnergyMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(*Energy\Sprite, *Object\X, *Object\Y)
    Case #GM_Object_Collision
      If GM_DistanceToPlayer(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2) < #Item_Radius
        GM_EmitAirExplosion(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
        CallFunctionFast(*Energy\Callback)
        ProcedureReturn #GM_Object_DoDelete
      EndIf
    Case #GM_Object_Hide
      GM_HideObject(*Memory\Lum1, #True)
      GM_HideObject(*Memory\Lum2, #True)
    Case #GM_Object_Unhide
      GM_HideObject(*Memory\Lum1, #False)
      GM_HideObject(*Memory\Lum2, #False)
      
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Memory        = AllocateMemory(SizeOf(EnergyMemory))
      *Object\Memory = *Memory
      
      *Memory\Lum1 = CreateLum2(*Object)
      *Memory\Lum2 = CreateLum2(*Object)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not EnergySprites
        EnergySprites = GM_LoadAnimationFrameset("Items\Energy", #GM_FieldSize, #GM_FieldSize)
      EndIf
      If Not *Energy\Sprite
        *Energy\Sprite = GM_FramesetSprite(EnergySprites, *Energy\Index, 0)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Items\Energy"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(*Energy\Index, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @*Energy\Name
    Case #GM_Object_Description
      If *Energy\Description
        ProcedureReturn @*Energy\Description
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure



;******************************************
; Powers
;******************************************

Procedure.i DoubleJump_Callback()
  *GM_Player\CanDoubleJump = #True
EndProcedure
ProcedureDLL.i Obj_DoubleJump(*Object.GM_Object, Event.i, *Parameter)
  Global DoubleJump.PowerParameter
  
  With DoubleJump
    If Not \Initialized
      \Callback     = @DoubleJump_Callback()
      \Index        = 0
      \Name         = "Double Jump"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @DoubleJump)
EndProcedure
Procedure.i Climb_Callback()
  *GM_Player\CanClimb = #True
EndProcedure
ProcedureDLL.i Obj_Climb(*Object.GM_Object, Event.i, *Parameter)
  Global Climb.PowerParameter
  
  With Climb
    If Not \Initialized
      \Callback     = @Climb_Callback()
      \Index        = 1
      \Name         = "Climb"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @Climb)
EndProcedure
Procedure.i Fly1_Callback()
  If *GM_Player\CanFly < 1
    *GM_Player\CanFly = 1
  EndIf
EndProcedure
ProcedureDLL.i Obj_Fly1(*Object.GM_Object, Event.i, *Parameter)
  Global Fly1.PowerParameter
  
  With Fly1
    If Not \Initialized
      \Callback     = @Fly1_Callback()
      \Index        = 2
      \Name         = "Fly (lvl. 1)"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @Fly1)
EndProcedure
Procedure.i Fly2_Callback()
  If *GM_Player\CanFly < 2
    *GM_Player\CanFly = 2
  EndIf
EndProcedure
ProcedureDLL.i Obj_Fly2(*Object.GM_Object, Event.i, *Parameter)
  Global Fly2.PowerParameter
  
  With Fly2
    If Not \Initialized
      \Callback     = @Fly2_Callback()
      \Index        = 3
      \Name         = "Fly (lvl. 2)"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @Fly2)
EndProcedure
Procedure.i Fly3_Callback()
  If *GM_Player\CanFly < 3
    *GM_Player\CanFly = 3
  EndIf
EndProcedure
ProcedureDLL.i Obj_Fly3(*Object.GM_Object, Event.i, *Parameter)
  Global Fly3.PowerParameter
  
  With Fly3
    If Not \Initialized
      \Callback     = @Fly3_Callback()
      \Index        = 4
      \Name         = "Fly (lvl. 3)"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @Fly3)
EndProcedure
Procedure.i Shoot1_Callback()
  If *GM_Player\CanShoot < 1
    *GM_Player\CanShoot = 1
  EndIf
EndProcedure
ProcedureDLL.i Obj_Shoot1(*Object.GM_Object, Event.i, *Parameter)
  Global Shoot1.PowerParameter
  
  With Shoot1
    If Not \Initialized
      \Callback     = @Shoot1_Callback()
      \Index        = 5
      \Name         = "Shoot (lvl. 1)"
      
      \Description = "This item allows, that you can shoot"        + #GM_N
      \Description + "with white bullets. The white bullet is the" + #GM_N
      \Description + "weakest of all (white, blue & green)."
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @Shoot1)
EndProcedure
Procedure.i Shoot2_Callback()
  If *GM_Player\CanShoot < 2
    *GM_Player\CanShoot = 2
  EndIf
EndProcedure
ProcedureDLL.i Obj_Shoot2(*Object.GM_Object, Event.i, *Parameter)
  Global Shoot2.PowerParameter
  
  With Shoot2
    If Not \Initialized
      \Callback     = @Shoot2_Callback()
      \Index        = 6
      \Name         = "Shoot (lvl. 2)"
      
      \Description = "This item allows, that you can shoot"   + #GM_N
      \Description + "with blue bullets. Blue bullets are as" + #GM_N
      \Description + "strong as three white bullets."
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @Shoot2)
EndProcedure
Procedure.i Shoot3_Callback()
  If *GM_Player\CanShoot < 3
    *GM_Player\CanShoot = 3
  EndIf
EndProcedure
ProcedureDLL.i Obj_Shoot3(*Object.GM_Object, Event.i, *Parameter)
  Global Shoot3.PowerParameter
  
  With Shoot3
    If Not \Initialized
      \Callback     = @Shoot3_Callback()
      \Index        = 7
      \Name         = "Shoot (lvl. 3)"
      
      \Description = "This item allows, that you can shoot"     + #GM_N
      \Description + "with green bullets. Green bullets are as" + #GM_N
      \Description + "strong as five white bullets."
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @Shoot3)
EndProcedure
Procedure.i LoadShot_Callback()
  *GM_Player\CanLoadShot = #True
EndProcedure
ProcedureDLL.i Obj_LoadShot(*Object.GM_Object, Event.i, *Parameter)
  Global LoadShot.PowerParameter
  
  With LoadShot
    If Not \Initialized
      \Callback     = @LoadShot_Callback()
      \Index        = 8
      \Name         = "Load Shot"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @LoadShot)
EndProcedure
Procedure.i LumiFlight_Callback()
  *GM_Player\CanLumiFlight = #True
EndProcedure
ProcedureDLL.i Obj_LumiFlight(*Object.GM_Object, Event.i, *Parameter)
  Global LumiFlight.PowerParameter
  
  With LumiFlight
    If Not \Initialized
      \Callback     = @LumiFlight_Callback()
      \Index        = 9
      \Name         = "Lumi Flight"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn PowerTemplate(*Object, Event, *Parameter, @LumiFlight)
EndProcedure



;******************************************
; Energy
;******************************************

Procedure.i Energy1_Callback()
  *GM_Player\Energy + 1
  If *GM_Player\Energy => *GM_Player\MaxEnergy
    *GM_Player\Energy = *GM_Player\MaxEnergy
  EndIf
EndProcedure
ProcedureDLL.i Obj_Energy1(*Object.GM_Object, Event.i, *Parameter)
  Global Energy1.EnergyParameter
  
  With Energy1
    If Not \Initialized
      \Callback    = @Energy1_Callback()
      \Index       = 0
      \Name        = "Energy (1P)"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn EnergyTemplate(*Object, Event, *Parameter, @Energy1)
EndProcedure
Procedure.i Energy2_Callback()
  *GM_Player\Energy + 3
  If *GM_Player\Energy => *GM_Player\MaxEnergy
    *GM_Player\Energy = *GM_Player\MaxEnergy
  EndIf
EndProcedure
ProcedureDLL.i Obj_Energy2(*Object.GM_Object, Event.i, *Parameter)
  Global Energy2.EnergyParameter
  
  With Energy2
    If Not \Initialized
      \Callback    = @Energy2_Callback()
      \Index       = 1
      \Name        = "Energy (3P)"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn EnergyTemplate(*Object, Event, *Parameter, @Energy2)
EndProcedure
Procedure.i Energy3_Callback()
  *GM_Player\Energy = *GM_Player\MaxEnergy
EndProcedure
ProcedureDLL.i Obj_Energy3(*Object.GM_Object, Event.i, *Parameter)
  Global Energy3.EnergyParameter
  
  With Energy3
    If Not \Initialized
      \Callback    = @Energy3_Callback()
      \Index       = 2
      \Name        = "Energy (full)"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn EnergyTemplate(*Object, Event, *Parameter, @Energy3)
EndProcedure
Procedure.i Life_Callback()
  *GM_Player\Lives + 1
EndProcedure
ProcedureDLL.i Obj_Life(*Object.GM_Object, Event.i, *Parameter)
  Global Life.EnergyParameter
  
  With Life
    If Not \Initialized
      \Callback    = @Life_Callback()
      \Index       = 3
      \Name        = "Life"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn EnergyTemplate(*Object, Event, *Parameter, @Life)
EndProcedure
Procedure.i PlusMaxEnergy_Callback()
  *GM_Player\MaxEnergy + 1
  If *GM_Player\MaxEnergy = 16
    *GM_Player\MaxEnergy = 16
  EndIf
EndProcedure
ProcedureDLL.i Obj_PlusMaxEnergy(*Object.GM_Object, Event.i, *Parameter)
  Global PlusMaxEnergy.EnergyParameter
  
  With PlusMaxEnergy
    If Not \Initialized
      \Callback    = @PlusMaxEnergy_Callback()
      \Index       = 4
      \Name        = "Plus Max Energy"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn EnergyTemplate(*Object, Event, *Parameter, @PlusMaxEnergy)
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 380
; FirstLine = 172
; Folding = D-------
; EnableXP