IncludeFile "..\Import.pbi"
IncludeFile "Templates\Item.pb"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Items")
        GM_Folder("Extra Powers")
          GM_File("HighJump")
          GM_File("EnergyCapsule")
          GM_File("Shield")
          GM_File("SuperShield")
          GM_End()
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



Procedure.i Item_HighJump(*Item.GM_Item, Event.i, *Parameter)
  Select Event
    Case #GM_Item_Use
      If *GM_Player\Action <> #GM_Player_Action_Jump And *GM_Player\Action <> #GM_Player_Action_DoubleJump
        GM_ChangePlayerAction(#GM_Player_Action_Jump)
        *GM_Player\MoveY = -10
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Item_IsUseable
      ProcedureReturn #True
    Case #GM_Item_NamePlural, #GM_Item_NameSingular
      ProcedureReturn @"High Jump"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_HighJump(*Object.GM_Object, Event.i, *Parameter)
  Global HighJump.ItemParameter
  
  With HighJump
    If Not \Initialized
      \Name        = "High Jump"
      \File        = "..\Items\HighJump"
      \EnableCount = #False
      
      \ItemName     = "HighJump"
      \ItemCallback = @Item_HighJump()
      
      \Width  = 16
      \Height = 16
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn ItemTemplate(*Object, Event, *Parameter, @HighJump)
EndProcedure

Procedure.i Item_EnergyCapsule(*Item.GM_Item, Event.i, *Parameter)
  Select Event
    Case #GM_Item_Use
      *GM_Player\Energy = *GM_Player\MaxEnergy
      ProcedureReturn #True
    Case #GM_Item_IsUseable
      ProcedureReturn #True
    Case #GM_Item_NameSingular
      ProcedureReturn @"Energy Capsule"
    Case #GM_Item_NamePlural
      ProcedureReturn @"Energy Capsules"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_EnergyCapsule(*Object.GM_Object, Event.i, *Parameter)
  Global EnergyCapsule.ItemParameter
  
  With EnergyCapsule
    If Not \Initialized
      \Name        = "Energy Capsule"
      \File        = "..\Items\EnergyCapsule"
      \EnableCount = #False
      
      \ItemName     = "EnergyCapsule"
      \ItemCallback = @Item_EnergyCapsule()
      
      \Width  = 10
      \Height = 18
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn ItemTemplate(*Object, Event, *Parameter, @EnergyCapsule)
EndProcedure

Procedure.i Item_Shield(*Item.GM_Item, Event.i, *Parameter)
  Select Event
    Case #GM_Item_Use
      *GM_Player\Shield = 150
      ProcedureReturn #True
    Case #GM_Item_IsUseable
      ProcedureReturn #True
    Case #GM_Item_NameSingular
      ProcedureReturn @"Shield"
    Case #GM_Item_NamePlural
      ProcedureReturn @"Shields"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_Shield(*Object.GM_Object, Event.i, *Parameter)
  Global Shield.ItemParameter
  
  With Shield
    If Not \Initialized
      \Name        = "Shield"
      \File        = "..\Items\Shield"
      \EnableCount = #False
      
      \ItemName     = "Shield"
      \ItemCallback = @Item_Shield()
      
      \Width  = 12
      \Height = 12
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn ItemTemplate(*Object, Event, *Parameter, @Shield)
EndProcedure

Procedure.i Item_SuperShield(*Item.GM_Item, Event.i, *Parameter)
  Select Event
    Case #GM_Item_Use
      *GM_Player\Shield = 450
      ProcedureReturn #True
    Case #GM_Item_IsUseable
      ProcedureReturn #True
    Case #GM_Item_NameSingular
      ProcedureReturn @"Super Shield"
    Case #GM_Item_NamePlural
      ProcedureReturn @"Super Shields"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_SuperShield(*Object.GM_Object, Event.i, *Parameter)
  Global SuperShield.ItemParameter
  
  With SuperShield
    If Not \Initialized
      \Name        = "Super Shield"
      \File        = "..\Items\SuperShield"
      \EnableCount = #False
      
      \ItemName     = "SuperShield"
      \ItemCallback = @Item_SuperShield()
      
      \Width  = 12
      \Height = 12
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn ItemTemplate(*Object, Event, *Parameter, @SuperShield)
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 33
; FirstLine = 10
; Folding = --
; EnableXP