#Drop_Speed          = 6.0
#Drop_SpeedAmplitude = 1.5
#Drop_RipplingSpeed  = 4
#Drop_RipplingFrames = 4

#Rain_EmitterFrequency = 75

Structure Drop
  Speed.f
  X.f
  Y.f
  Time.i
EndStructure
Structure LittleDrop
  Speed.f
  X.f
  Y.f
EndStructure
Structure RainMemory
  List Drop.Drop()
  List LittleDrop.LittleDrop()
  Height.i
EndStructure

Global Drop_Sprite.i, Drop_Sprite3D.i, Drop_RipplingFrameset.i
Global LittleDrop_Sprite.i, LittleDrop_Sprite3D.i

Procedure.i LoadDrop()
  If Not Drop_Sprite
    Drop_Sprite           = GM_LoadSprite("Liquid\Drop")
    Drop_Sprite3D         = GM_CreateSprite3D(Drop_Sprite)
    Drop_RipplingFrameset = GM_LoadAnimationFrameset("Liquid\RipplingDrop", 11, 5)
  EndIf
EndProcedure
Procedure.i LoadLittleDrop()
  If Not LittleDrop_Sprite
    LittleDrop_Sprite   = GM_LoadSprite("Liquid\LittleDrop")
    LittleDrop_Sprite3D = GM_CreateSprite3D(LittleDrop_Sprite)
  EndIf
EndProcedure
Procedure.i CreateDrop(X.f, Y.f, List Drop.Drop())
  Static *Drop.Drop
  
  *Drop = AddElement(Drop())
  
  *Drop\X     = X
  *Drop\Y     = Y
  *Drop\Speed = #Drop_Speed - #Drop_SpeedAmplitude + Random(2 * 10 * #Drop_SpeedAmplitude)/10.0
  *Drop\Time  = 0
  
  ProcedureReturn *Drop
EndProcedure
Procedure.i CreateLittleDrop(X.f, Y.f, List Drop.LittleDrop())
  Static *Drop.LittleDrop
  
  *Drop = AddElement(Drop())
  
  *Drop\X     = X
  *Drop\Y     = Y
  *Drop\Speed = (#Drop_Speed - #Drop_SpeedAmplitude + Random(2 * 10 * #Drop_SpeedAmplitude)/10.0) * 0.8
  
  ProcedureReturn *Drop
EndProcedure


ProcedureDLL.i Obj_Rain(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.RainMemory, *Drop.Drop, *LittleDrop.LittleDrop, Count.i, Index.i
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      ForEach *Memory\LittleDrop()
        *LittleDrop = @*Memory\LittleDrop()
        GM_DisplaySprite3D(LittleDrop_Sprite3D, *LittleDrop\X, *LittleDrop\Y)
      Next
      ForEach *Memory\Drop()
        *Drop = @*Memory\Drop()
        If *Drop\Time
          GM_DisplayFramesetFrame(Drop_RipplingFrameset, (#Drop_RipplingFrames * #Drop_RipplingSpeed - *Drop\Time) / #Drop_RipplingSpeed, 0, *Drop\X, *Drop\Y)
        Else
          GM_DisplaySprite3D(Drop_Sprite3D, *Drop\X, *Drop\Y)
        EndIf
      Next
    Case #GM_Object_Frame
      If Random(#Rain_EmitterFrequency) = 0
        CreateDrop(*Object\X + Random(#GM_FieldSize), *Object\Y - 5, *Memory\Drop())
      EndIf
      If Random(#Rain_EmitterFrequency * 0.8) = 0
        CreateLittleDrop(*Object\X + Random(#GM_FieldSize), *Object\Y - 3, *Memory\LittleDrop())
      EndIf
      
      ForEach *Memory\Drop()
        *Drop = @*Memory\Drop()
        
        If *Drop\Time
          *Drop\Time - 1
          If *Drop\Time = 0
            DeleteElement(*Memory\Drop())
          EndIf
        Else
          *Drop\Y + *Drop\Speed
          If *Drop\Y > *Memory\Height * #GM_FieldSize + 5
            If *Memory\Height > GM_SceneHeight(*Object\Scene)
              DeleteElement(*Memory\Drop())
            Else
              *Drop\Y    = *Memory\Height * #GM_FieldSize - 5
              *Drop\Time = #Drop_RipplingFrames * #Drop_RipplingSpeed
            EndIf
          EndIf
        EndIf
      Next
      
      ForEach *Memory\LittleDrop()
        *LittleDrop = @*Memory\LittleDrop()
        
        *LittleDrop\Y + *LittleDrop\Speed
        If *LittleDrop\Y > *Memory\Height * #GM_FieldSize + 3
          DeleteElement(*Memory\LittleDrop())
        EndIf
      Next
    Case #GM_Object_Initialize
      *Memory        = AllocateMemory(SizeOf(RainMemory))
      *Object\Memory = *Memory
      InitializeStructure(*Memory, RainMemory)
      
      *Memory\Height = GM_DetectNextBarrier(*Object\X / #GM_FieldSize, *Object\Y / #GM_FieldSize, 0, 1, #False)
      If *Memory\Height = -1
        *Memory\Height = GM_SceneHeight(*Object\Scene) + 1
      Else
        *Memory\Height + (*Object\Y / #GM_FieldSize)
      EndIf
      
      Count = *Memory\Height * #GM_FieldSize / #Rain_EmitterFrequency / 10
      For Index = 1 To Count
        CreateDrop(*Object\X + Random(#GM_FieldSize), *Object\Y + Random(*Memory\Height * #GM_FieldSize) - 5, *Memory\Drop())
      Next
      Count = *Memory\Height * #GM_FieldSize / (#Rain_EmitterFrequency * 0.8)
      For Index = 1 To Count
        CreateLittleDrop(*Object\X + Random(#GM_FieldSize), *Object\Y + Random(*Memory\Height * #GM_FieldSize) - 5, *Memory\LittleDrop())
      Next
      
    Case #GM_Object_GlobalLoad
      LoadDrop()
      LoadLittleDrop()
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Liquid\Rain"
    Case #GM_Object_Name
      ProcedureReturn @"Rain"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure



Global Rainbow_Sprite.i, Rainbow_Sprite3D.i

ProcedureDLL.i Obj_Rainbow(*Object.GM_Object, Event.i, *Parameter)
  Static Transparency.f, Distance.f
  
  Select Event
    Case #GM_Object_Frame
      Distance = GM_DistanceToPlayer(*Object\X + #GM_FieldSize * 3, *Object\Y + #GM_FieldSize)
      If Distance < #GM_FieldSize * 10
        Transparency = *Object\Transparency - (*Object\Transparency / (#GM_FieldSize * 10.0) * Distance)
      Else
        Transparency = 0
      EndIf
      GM_DisplaySprite3D(Rainbow_Sprite3D, *Object\X, *Object\Y, Transparency)
    Case #GM_Object_PlayerEnteredScene, #GM_Object_Initialize
      *Object\Transparency = 75 + Random(255 - 75)
    
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      *Object\Width  = #GM_FieldSize * 6
      *Object\Height = #GM_FieldSize * 2
    Case #GM_Object_GlobalLoad
      Rainbow_Sprite   = GM_LoadSprite("Nature\Rainbow")
      Rainbow_Sprite3D = GM_CreateSprite3D(Rainbow_Sprite)
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_Name
      ProcedureReturn @"Rainbow"
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Nature\Rainbow"
    Case #GM_Object_ViewRegion
      ViewRegion\X = 0
      ViewRegion\Y = 0
      ViewRegion\Width  = #GM_FieldSize * 6
      ViewRegion\Height = #GM_FieldSize * 2
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 151
; FirstLine = 134
; Folding = -8
; EnableXP