Structure WaterParameter
  Name.s
  File.s
  Frameset.i
  Initialized.i
EndStructure

Procedure.i WaterTemplate(*Object.GM_Object, Event.i, *Parameter, *WaterParameter.WaterParameter)
  If Not *Object
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplayAnimation(*Object\Animation, *Object\X, *Object\Y)
    Case #GM_Object_Frame
      If *Object\Memory
        If GM_PlayAnimation(*Object\Animation)
          If GM_AnimationFrame(*Object\Animation) = 0
            *Object\Memory = 0
          Else
            GM_SetAnimationDuration(*Object\Animation, 3)
          EndIf
        EndIf
      ElseIf Random(800) = 0
        *Object\Memory = 1
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Animation = GM_CreateAnimation(*WaterParameter\Frameset)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not *WaterParameter\Frameset
        *WaterParameter\Frameset = GM_LoadAnimationFrameset("Liquid\" + *WaterParameter\File, #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorLoad
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_EditorSave
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      String = "Liquid\" + *WaterParameter\File
      ProcedureReturn @String
    Case #GM_Object_ViewRegion
      ViewRegion\X      = 0
      ViewRegion\Y      = 0
      ViewRegion\Width  = #GM_FieldSize
      ViewRegion\Height = #GM_FieldSize
      ProcedureReturn @ViewRegion
    
    Case #GM_Object_Name
      ProcedureReturn @*WaterParameter\Name
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_W1(*Object.GM_Object, Event.i, *Parameter)
  Global W1.WaterParameter
  
  With W1
    If Not \Initialized
      \Name = "Natural Water"
      \File = "W1"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WaterTemplate(*Object, Event, *Parameter, @W1)
EndProcedure
ProcedureDLL.i Obj_W2(*Object.GM_Object, Event.i, *Parameter)
  Global W2.WaterParameter
  
  With W2
    If Not \Initialized
      \Name = "Befouled Water"
      \File = "W2"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WaterTemplate(*Object, Event, *Parameter, @W2)
EndProcedure
ProcedureDLL.i Obj_W3(*Object.GM_Object, Event.i, *Parameter)
  Global W3.WaterParameter
  
  With W3
    If Not \Initialized
      \Name = "Dark Water"
      \File = "W3"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WaterTemplate(*Object, Event, *Parameter, @W3)
EndProcedure
ProcedureDLL.i Obj_W4(*Object.GM_Object, Event.i, *Parameter)
  Global W4.WaterParameter
  
  With W4
    If Not \Initialized
      \Name = "Lava"
      \File = "W4"
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WaterTemplate(*Object, Event, *Parameter, @W4)
EndProcedure



Structure WaterSurfaceParameter
  Name.s
  File.s
  Speed.i
  Frameset.i
  Initialized.i
EndStructure

Procedure.i WaterSurfaceTemplate(*Object.GM_Object, Event.i, *Parameter, *WaterSurfaceParameter.WaterSurfaceParameter)
  Select Event
    Case #GM_Object_Display
      GM_DisplayAnimation(*Object\Animation, *Object\X, *Object\Y, *Object\Transparency)
    Case #GM_Object_Frame
      Select *Object\Memory
        Case 0
          If GM_PlayAnimation(*Object\Animation)
            GM_SetAnimationDuration(*Object\Animation, *WaterSurfaceParameter\Speed + Random(4) - 2)
            If GM_AnimationFrame(*Object\Animation) = 4
              GM_SetAnimationFrame(*Object\Animation, 3)
              *Object\Memory + 1
            EndIf
          EndIf
        Case 1
          If GM_PlayAnimationBack(*Object\Animation)
            GM_SetAnimationDuration(*Object\Animation, *WaterSurfaceParameter\Speed + Random(4) - 2)
            If GM_AnimationFrame(*Object\Animation) = 6
              GM_SetAnimationFrame(*Object\Animation, 4)
              *Object\Memory + 1
            EndIf
          EndIf
        Case 2
          If GM_PlayAnimation(*Object\Animation)
            GM_SetAnimationDuration(*Object\Animation, *WaterSurfaceParameter\Speed + Random(4) - 2)
            If GM_AnimationFrame(*Object\Animation) = 0
              GM_SetAnimationFrame(*Object\Animation, 6)
              *Object\Memory + 1
            EndIf
          EndIf
        Case 3
          If GM_PlayAnimationBack(*Object\Animation)
            GM_SetAnimationDuration(*Object\Animation, *WaterSurfaceParameter\Speed + Random(4) - 2)
            If GM_AnimationFrame(*Object\Animation) = 3
              GM_SetAnimationFrame(*Object\Animation, 0)
              *Object\Memory = 0
            EndIf
          EndIf
      EndSelect
    Case #GM_Object_Collision
      If *Object\Y - (*GM_Player\Y + *GM_Player\Height) < -12
        GM_LoseLife()
      EndIf
    
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not *WaterSurfaceParameter\Frameset
        *WaterSurfaceParameter\Frameset = GM_LoadAnimationFrameset("Liquid\" + *WaterSurfaceParameter\File, #GM_FieldSize, #GM_FieldSize)
      EndIf
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Object\Animation = GM_CreateAnimation(*WaterSurfaceParameter\Frameset)
      Select Int(*Object\X) % (#GM_FieldSize * 2)
        Case 0
          *Object\Memory = 0
        Case #GM_FieldSize
          *Object\Memory = 1
      EndSelect
      GM_SetNextAnimationFrame(*Object\Animation, 0, *WaterSurfaceParameter\Speed + Random(4) - 2)
      
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      
    Case #GM_Object_Name
      ; Name des Objekts zurckgeben:
      String = *WaterSurfaceParameter\Name + " Surface"
      ProcedureReturn @String
    Case #GM_Object_ViewSprite
      ; Name des Anzeige-Sprites fr den Editor zurckgeben:
      String = "Liquid\" + *WaterSurfaceParameter\File
      ProcedureReturn @String
    Case #GM_Object_ViewRegion
      ViewRegion\X      = #GM_FieldSize*3
      ViewRegion\Y      = 0
      ViewRegion\Width  = #GM_FieldSize
      ViewRegion\Height = #GM_FieldSize
      ProcedureReturn @ViewRegion
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_WS1(*Object.GM_Object, Event.i, *Parameter)
  Global WS1.WaterSurfaceParameter
  
  With WS1
    If Not \Initialized
      \Name  = "Natural"
      \File  = "WS1"
      \Speed = 6
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WaterSurfaceTemplate(*Object, Event, *Parameter, @WS1)
EndProcedure
ProcedureDLL.i Obj_WS2(*Object.GM_Object, Event.i, *Parameter)
  Global WS2.WaterSurfaceParameter
  
  With WS2
    If Not \Initialized
      \Name  = "Befouled"
      \File  = "WS2"
      \Speed = 8
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WaterSurfaceTemplate(*Object, Event, *Parameter, @WS2)
EndProcedure
ProcedureDLL.i Obj_WS3(*Object.GM_Object, Event.i, *Parameter)
  Global WS3.WaterSurfaceParameter
  
  With WS3
    If Not \Initialized
      \Name  = "Dark"
      \File  = "WS3"
      \Speed = 6
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WaterSurfaceTemplate(*Object, Event, *Parameter, @WS3)
EndProcedure
ProcedureDLL.i Obj_WS4(*Object.GM_Object, Event.i, *Parameter)
  Global WS4.WaterSurfaceParameter
  
  With WS4
    If Not \Initialized
      \Name  = "Lava"
      \File  = "WS4"
      \Speed = 4
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WaterSurfaceTemplate(*Object, Event, *Parameter, @WS4)
EndProcedure



#Flood_Height = #GM_SceneHeight
#Flood_Width  = #GM_SceneWidth

Structure FloodParameter
  Name.s
  File.s
  *Water
  *Surface
  Speed.f
  
  Initialized.i
EndStructure
Structure FloodMemory
  Stopped.i
  Killed.i
  *SurfaceArray
  *WaterArray
EndStructure

Procedure.i FloodTemplate(*Object.GM_Object, Event.i, *Parameter, *FloodParameter.FloodParameter)
  ; Dieses Objekt lsst ein Wasserflche in einer bestimmten Geschwindigkeit
  ; aufsteigen. Dadurch lsst sich ein Zeitdruck in Szenen einbauen, da man
  ; als Spieler vor dem steigenden Wasser fliehen muss.
  
  Static *Memory.FloodMemory, X.i, Y.i, *Surface.GM_Object, *Water.GM_Object, *Cell.Integer
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  ;HINWEIS: Die Darstellung wird von den erstellten Objekten bernommen.
  
  Select Event
    Case #GM_Object_Frame
      If *Memory\Killed And *GM_Player\LostLiveTime = 0 And *GM_Player\Lives > 0
        *Object\Y      = GM_ScenePixelHeight(*Object\Scene) + #GM_FieldSize * 2
        *Memory\Killed = #False
      Else
        If Not *Memory\Stopped
          *Object\Y - *FloodParameter\Speed
        EndIf
      EndIf
      
      ; Die Oberflche muss aufsteigen:
      *Cell = *Memory\SurfaceArray
      For X = 0 To #Flood_Width - 1
        *Surface = *Cell\i
        *Surface\Y = *Object\Y
        *Cell + SizeOf(Integer)
      Next
      
      ; Das Gleiche gilt auch fr das Wasser unter der Oberflche:
      *Cell = *Memory\WaterArray
      For Y = 0 To #Flood_Height - 1
        For X = 0 To #Flood_Width - 1
          *Water = *Cell\i
          *Water\Y = *Object\Y + (Y + 1) * #GM_FieldSize
          *Cell + SizeOf(Integer)
        Next
      Next
      
      If *GM_Player\Y + *GM_Player\Height - *Object\Y > #GM_FieldSize/2
        GM_LoseLife()
        *Memory\Killed = #True
      EndIf
    Case #GM_Object_PlayerEnteredScene
      *Object\Y = GM_ScenePixelHeight(*Object\Scene) + #GM_FieldSize * 2
    
    Case #GM_Object_Initialize
      *Memory = AllocateMemory(SizeOf(FloodMemory))
      *Object\Memory = *Memory
      
      *Object\Y      = GM_ScenePixelHeight(*Object\Scene) + #GM_FieldSize * 2
      *Object\X      = 0
      *Object\Width  = #GM_FieldSize * #Flood_Width
      *Object\Height = 10
      
      *Memory\SurfaceArray = AllocateMemory(SizeOf(Integer) * #Flood_Width)
      *Memory\WaterArray   = AllocateMemory(SizeOf(Integer) * #Flood_Width * #Flood_Height)
      
      For X = 0 To #Flood_Width - 1
        PokeI(*Memory\SurfaceArray + X * SizeOf(Integer), GM_CreateObject(#GM_Layer_ForegroundObject1, *FloodParameter\Surface, X * #GM_FieldSize, *Object\Y, #Null, *Object\Scene))
      Next
      For Y = 0 To #Flood_Height - 1
        For X = 0 To #Flood_Width - 1
          PokeI(*Memory\WaterArray + (Y * #Flood_Width + X) * SizeOf(Integer), GM_CreateObject(#GM_Layer_ForegroundObject1, *FloodParameter\Water, X * #GM_FieldSize, *Object\Y + (Y + 1) * #GM_FieldSize, #Null, *Object\Scene))
        Next
      Next
    Case #GM_Object_GlobalLoad
      CallFunctionFast(*FloodParameter\Surface, #Null, #GM_Object_GlobalLoad, #Null)
      CallFunctionFast(*FloodParameter\Water  , #Null, #GM_Object_GlobalLoad, #Null)
    
    Case #GM_Object_EditorLoad
      *EditorObject\X = 0
      *EditorObject\Y = 0
    
    Case #GM_Object_CallAction
      Select GM_ObjectActionID(*Parameter)
        Case 0 ;Stop Flood:
          *Memory\Stopped = #True
        Case 1 ;Continue Flood:
          *Memory\Stopped = #False
      EndSelect
    Case #GM_Object_ActionName
      Select *Parameter
        Case 0
          ProcedureReturn @"Stop Flood"
        Case 1
          ProcedureReturn @"Continue Flood"
      EndSelect
    Case #GM_Object_ActionCount
      ProcedureReturn 2
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      String = "Liquid\" + *FloodParameter\File
      ProcedureReturn @String
    Case #GM_Object_Name
      ProcedureReturn @*FloodParameter\Name
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_Flood1(*Object.GM_Object, Event.i, *Parameter)
  Global Flood1.FloodParameter
  
  With Flood1
    If Not \Initialized
      \Name  = "Natural Flood"
      \File  = "Flood1"
      
      \Surface = @Obj_WS1()
      \Water   = @Obj_W1()
      \Speed   = 0.5
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn FloodTemplate(*Object, Event, *Parameter, @Flood1)
EndProcedure
ProcedureDLL.i Obj_Flood4(*Object.GM_Object, Event.i, *Parameter)
  Global Flood4.FloodParameter
  
  With Flood4
    If Not \Initialized
      \Name  = "Lava Flood"
      \File  = "Flood4"
      
      \Surface = @Obj_WS4()
      \Water   = @Obj_W4()
      \Speed   = 0.75
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn FloodTemplate(*Object, Event, *Parameter, @Flood4)
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 402
; FirstLine = 93
; Folding = AA+
; EnableXP