IncludeFile "..\Import.pbi"



ProcedureDLL.i GM_Build()
  DataSection
    Entries:
      GM_Folder("Misc")
        GM_File("TurnAroundBox")
        GM_End()
      GM_End()
  EndDataSection
  
  ProcedureReturn ?Entries
EndProcedure



Enumeration
  #TurnAroundBox_Action_Inactive
  #TurnAroundBox_Action_Active
  #TurnAroundBox_Action_Opened
EndEnumeration

#TurnAroundBox_Radius  = #GM_FieldSize * 2.5
#TurnAroundBox_Sectors = 8

Structure TurnAroundBoxMemory
  Action.i
  Time.i
  Array Passed.i(#TurnAroundBox_Sectors - 1)
EndStructure

Global TurnAroundBox_Frameset.i

ProcedureDLL.i Obj_TurnAroundBox(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.TurnAroundBoxMemory, PlayerX.f, PlayerY.f, ObjectX.f, ObjectY.f
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      Select *Memory\Action
        Case #TurnAroundBox_Action_Inactive
          GM_DisplaySprite3D(GM_FramesetSprite(TurnAroundBox_Frameset, 0, 0), *Object\X, *Object\Y)
        Case #TurnAroundBox_Action_Active
          GM_DisplaySprite3D(GM_FramesetSprite(TurnAroundBox_Frameset, 1, 0), *Object\X, *Object\Y)
        Case #TurnAroundBox_Action_Opened
          If *Memory\Time % 20 < 10
            GM_DisplaySprite3D(GM_FramesetSprite(TurnAroundBox_Frameset, 2, 0), *Object\X, *Object\Y)
          Else
            GM_DisplaySprite3D(GM_FramesetSprite(TurnAroundBox_Frameset, 1, 0), *Object\X, *Object\Y)
          EndIf
      EndSelect
    Case #GM_Object_Frame
      Select *Memory\Action
        Case #TurnAroundBox_Action_Inactive
          If GM_DistanceToPlayer(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2) <= #TurnAroundBox_Radius
            *Memory\Action = #TurnAroundBox_Action_Active
          EndIf
        Case #TurnAroundBox_Action_Active
          If GM_DistanceToPlayer(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2) > #TurnAroundBox_Radius
            *Memory\Action = #TurnAroundBox_Action_Inactive
            *Memory\Passed(0) = #False
            *Memory\Passed(1) = #False
            *Memory\Passed(2) = #False
            *Memory\Passed(3) = #False
          EndIf 
          
          PlayerX = *GM_Player\X + *GM_Player\Width/2
          PlayerY = *GM_Player\Y + *GM_Player\Height/2
          ObjectX = *Object\X + *Object\Width/2
          ObjectY = *Object\Y + *Object\Height/2
          
          If PlayerX < ObjectX And PlayerY < ObjectY
            *Memory\Passed(0) = #True
          ElseIf PlayerX < ObjectX And PlayerY > ObjectY
            *Memory\Passed(1) = #True
          ElseIf PlayerX > ObjectX And PlayerY < ObjectY
            *Memory\Passed(2) = #True
          ElseIf PlayerX > ObjectX And PlayerY > ObjectY
            *Memory\Passed(3) = #True
          EndIf
          
          If *Memory\Passed(0) And *Memory\Passed(1) And *Memory\Passed(2) And *Memory\Passed(3)
            *Memory\Action = #TurnAroundBox_Action_Opened
            GM_AddScoreTM(60, *Object)
          EndIf
        Case #TurnAroundBox_Action_Opened
          If *Memory\Time = 140
            GM_EmitAirExplosion(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
            ProcedureReturn #GM_Object_DoDelete
          Else
            *Memory\Time + 1
          EndIf
      EndSelect
    Case #GM_Object_Initialize
      *Object\Width = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Memory = AllocateMemory(SizeOf(TurnAroundBoxMemory))
      *Object\Memory = *Memory
      InitializeStructure(*Memory, TurnAroundBoxMemory)
      
      *Memory\Action = #TurnAroundBox_Action_Inactive
    
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      TurnAroundBox_Frameset = GM_LoadAnimationFrameset("Misc\TurnAroundBox", #GM_FieldSize, #GM_FieldSize)
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Misc\TurnAroundBox"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @"Turn Around Box"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 25
; Folding = -
; EnableXP