#Barrel_Width        = 23
#Barrel_Height       = 24
#Barrel_Speed        = 2
#Barrel_FallingSpeed = 3

Enumeration
  #Barrel_Action_Falling
  #Barrel_Action_Rolling
EndEnumeration



Structure BarrelMemory
  Action.i
  Direction.i
EndStructure



Global Barrel_Frameset.i



Procedure.i Obj_Barrel(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.BarrelMemory, FieldX.i, FieldY.i
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplayAnimation(*Object\Animation, *Object\X, *Object\Y)
    Case #GM_Object_Frame
      Select *Memory\Action
        Case #Barrel_Action_Falling
          *Object\Y + #Barrel_FallingSpeed
          If *Object\Y > GM_ScenePixelHeight()
            ProcedureReturn #GM_Object_DoDelete
          ElseIf GM_FieldCollision(*Object, 0, #Barrel_FallingSpeed, 0, 1)
            *Memory\Action = #Barrel_Action_Rolling
            FieldX = (*Object\X + *Object\Width/2 - #GM_FieldSize/2) / #GM_FieldSize
            FieldY = (*Object\Y + *Object\Height/2 - #GM_FieldSize/2) / #GM_FieldSize
            If GM_GetWall(FieldX - 1, FieldY)
              *Memory\Direction = 1
            ElseIf GM_GetWall(FieldX + 1, FieldY)
              *Memory\Direction = -1
            Else
              If Random(1)
                *Memory\Direction = 1
              Else
                *Memory\Direction = -1
              EndIf
            EndIf
          EndIf
        Case #Barrel_Action_Rolling
          *Object\X + #Barrel_Speed * *Memory\Direction
          If *Memory\Direction = -1
            FieldX = (*Object\X + #Barrel_Speed*2) / #GM_FieldSize
            If GM_PlayAnimation(*Object\Animation)
              GM_SetAnimationDuration(*Object\Animation, 4)
            EndIf
          Else
            FieldX = (*Object\X) / #GM_FieldSize
            If GM_PlayAnimationBack(*Object\Animation)
              GM_SetAnimationDuration(*Object\Animation, 4)
            EndIf
          EndIf
          FieldY = (*Object\Y + *Object\Height/2 - #GM_FieldSize/2) / #GM_FieldSize
          If Not (GM_GetWall(FieldX, FieldY + 1) Or GM_GetGround(FieldX, FieldY + 1))
            *Object\X = FieldX * #GM_FieldSize
            *Memory\Action = #Barrel_Action_Falling
          ElseIf GM_GetWall(FieldX + *Memory\Direction, FieldY)
            *Object\X = FieldX * #GM_FieldSize
            *Memory\Direction = -*Memory\Direction
          EndIf
      EndSelect
    Case #GM_Object_Collision
      GM_HitPlayer(3)
    Case #GM_Object_Delete
      FreeMemory(*Memory)
    
    Case #GM_Object_Initialize
      *Object\Width  = #Barrel_Width
      *Object\Height = #Barrel_Height
      
      *Object\Animation = GM_CreateAnimation(Barrel_Frameset)
      
      *Memory        = AllocateMemory(SizeOf(BarrelMemory))
      *Object\Memory = *Memory
      
      *Memory\Action    = #Barrel_Action_Falling
      *Memory\Direction = 0
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_BarrelEmitter(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Frame
      If *Object\Memory = 0
        GM_CreateObject(#GM_Layer_ForegroundObject1, @Obj_Barrel(), *Object\X, *Object\Y)
        GM_EmitAirExplosion(*Object\X + #GM_FieldSize/2, *Object\Y + #GM_FieldSize/2)
        *Object\Memory = 100
      Else
        *Object\Memory - 1
      EndIf
      
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Object\Memory = Random(100)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not Barrel_Frameset
        Barrel_Frameset = GM_LoadAnimationFrameset("Obstacles\Barrel", #Barrel_Width, #Barrel_Height)
      EndIf
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Obstacles\BarrelEmitter"
    Case #GM_Object_Name
      ProcedureReturn @"Barrel Emitter"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 19
; FirstLine = 9
; Folding = -
; EnableXP