Structure UDWallMemory
  Mode.i
  Time.i
EndStructure



Enumeration
  #UDWall_TopHalt
  #UDWall_Down
  #UDWall_BottomHalt
  #UDWall_Up
EndEnumeration

#UDWall_TopHaltDuration    = 25.0
#UDWall_BottomHaltDuration = 8.0
#UDWall_MoveDuration       = 28.0



ProcedureDLL.i Obj_UDWall1(*Object.GM_Object, Event.i, *Parameter)
  Global UDWall1_Sprite.i, UDWall1_Sprite3D.i
  Protected *Memory.UDWallMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(UDWall1_Sprite3D, *Object\X, *Object\Y)
    Case #GM_Object_Frame
      Select *Memory\Mode
        Case #UDWall_TopHalt
          If *Memory\Time = 0
            *Memory\Mode = #UDWall_Down
            *Memory\Time = #UDWall_MoveDuration
          Else
            *Memory\Time - 1
          EndIf
        Case #UDWall_Down
          ; Der Klotz sinkt zu Boden (kann gegebenfalls den Spieler zerquetschen):
          If *Memory\Time = 0
            *Memory\Mode = #UDWall_BottomHalt
            *Memory\Time = #UDWall_BottomHaltDuration
          Else
            *Memory\Time - 1
            *Object\Y + (*Object\Height/#UDWall_MoveDuration)
          EndIf
        Case #UDWall_BottomHalt
          If *Memory\Time = 0
            *Memory\Mode = #UDWall_Up
            *Memory\Time = #UDWall_MoveDuration
          Else
            *Memory\Time - 1
          EndIf
        Case #UDWall_Up
          If *Memory\Time = 0
            *Memory\Mode = #UDWall_TopHalt
            *Memory\Time = #UDWall_TopHaltDuration
          Else
            *Memory\Time - 1
            *Object\Y - (*Object\Height/#UDWall_MoveDuration)
          EndIf
      EndSelect
    Case #GM_Object_Collision
      Select *Memory\Mode
        Case #UDWall_Down
          *Parameter = GM_PlayerCollision(*Object, 0, (*Object\Height/#UDWall_MoveDuration))
        Case #UDWall_Up
          *Parameter = GM_PlayerCollision(*Object, 0, -(*Object\Height/#UDWall_MoveDuration))
        Default
          *Parameter = GM_PlayerCollision(*Object, 0, 0)
      EndSelect
      If *Parameter = #GM_Collision_Bottom And *GM_Player\Action = #GM_Player_Action_Standing
        ; Der Spieler verliert ein Leben, da dieser "zerquetscht" wird:
        GM_LoseLife()
      Else
        GM_DoWallCollision(*Object, *Parameter)
      EndIf
    Case #GM_Object_Delete
      FreeMemory(*Object\Memory)
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      UDWall1_Sprite   = GM_LoadSprite("Obstacles\UpDownWall1")
      UDWall1_Sprite3D = GM_CreateSprite3D(UDWall1_Sprite)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize*2
      *Object\Y      - *Object\Height
      
      *Memory        = AllocateMemory(SizeOf(UDWallMemory))
      *Object\Memory = *Memory
      *Memory\Mode   = #UDWall_TopHalt
      *Memory\Time   = #UDWall_TopHaltDuration
    
    Case #GM_Object_ViewSprite
      String = "Obstacles\UpDownWall1"
      ProcedureReturn @String
    Case #GM_Object_ViewRegion
      ViewRegion\Width  = #GM_FieldSize
      ViewRegion\Height = #GM_FieldSize*2
      ProcedureReturn @ViewRegion
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    Case #GM_Object_Name
      String = "Moving Wall (1x2, vertical)"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 13
; FirstLine = 80
; Folding = -
; EnableXP