#AstableGround_StableDuration  = 45
#AstableGround_FallingDuration = 50

Global AstableGround1_Sprite.i, AstableGround1_Sprite3D.i
Global AstableGround2_Sprite.i, AstableGround2_Sprite3D.i

ProcedureDLL.i Obj_AstGround1(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      If *Object\Memory > #AstableGround_StableDuration
        If *Object\Memory - #AstableGround_StableDuration = #AstableGround_FallingDuration
        Else
          GM_DisplaySprite3D(AstableGround1_Sprite3D, *Object\X, *Object\Y + Pow(1.08, *Object\Memory - #AstableGround_StableDuration), 255 - 255.0/#AstableGround_FallingDuration*(*Object\Memory - #AstableGround_StableDuration))
        EndIf
      ElseIf *Object\Memory
        If *Object\Memory % 10 < 5
          GM_DisplaySprite3D(AstableGround1_Sprite3D, *Object\X, *Object\Y)
        Else
          GM_DisplaySprite3D(AstableGround1_Sprite3D, *Object\X, *Object\Y + 1)
        EndIf
      Else
        GM_DisplaySprite3D(AstableGround1_Sprite3D, *Object\X, *Object\Y)
      EndIf
    Case #GM_Object_Frame
      If *Object\Memory > #AstableGround_StableDuration
        If *Object\Memory - #AstableGround_StableDuration = #AstableGround_FallingDuration
          ProcedureReturn #GM_Object_DoDelete
        Else
          *Object\Memory + 1
        EndIf
      ElseIf *Object\Memory
        *Object\Memory + 1
      EndIf
    Case #GM_Object_Collision
      If *Object\Memory < #AstableGround_StableDuration
        If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, 0))
          If *Object\Memory = 0
            *Object\Memory = 1
          EndIf
        EndIf
      ElseIf *Object\Memory = #AstableGround_StableDuration
        If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, 0))
          *GM_Player\MoveY = 0
        EndIf
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      AstableGround1_Sprite   = GM_LoadSprite("Platforms\AstableGround1")
      AstableGround1_Sprite3D = GM_CreateSprite3D(AstableGround1_Sprite)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      String = "Platforms\AstableGround1"
      ProcedureReturn @String
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
      ProcedureReturn @ViewRegion
    Case #GM_Object_Name
      String = "Small Astable Ground"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_AstGround2(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      If *Object\Memory > #AstableGround_StableDuration
        If *Object\Memory - #AstableGround_StableDuration = #AstableGround_FallingDuration
        Else
          GM_DisplaySprite3D(AstableGround2_Sprite3D, *Object\X, *Object\Y + Pow(1.08, *Object\Memory - #AstableGround_StableDuration), 255 - 255.0/#AstableGround_FallingDuration*(*Object\Memory - #AstableGround_StableDuration))
        EndIf
      ElseIf *Object\Memory
        If *Object\Memory % 10 < 5
          GM_DisplaySprite3D(AstableGround2_Sprite3D, *Object\X, *Object\Y)
        Else
          GM_DisplaySprite3D(AstableGround2_Sprite3D, *Object\X, *Object\Y + 1)
        EndIf
      Else
        GM_DisplaySprite3D(AstableGround2_Sprite3D, *Object\X, *Object\Y)
      EndIf
    Case #GM_Object_Frame
      If *Object\Memory > #AstableGround_StableDuration
        If *Object\Memory - #AstableGround_StableDuration = #AstableGround_FallingDuration
          ProcedureReturn #GM_Object_DoDelete
        Else
          *Object\Memory + 1
        EndIf
      ElseIf *Object\Memory
        *Object\Memory + 1
      EndIf
    Case #GM_Object_Collision
      If *Object\Memory < #AstableGround_StableDuration
        If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, 0))
          If *Object\Memory = 0
            *Object\Memory = 1
          EndIf
        EndIf
      ElseIf *Object\Memory = #AstableGround_StableDuration
        If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, 0))
          *GM_Player\MoveY = 0
        EndIf
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      AstableGround2_Sprite   = GM_LoadSprite("Platforms\AstableGround2")
      AstableGround2_Sprite3D = GM_CreateSprite3D(AstableGround2_Sprite)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize*2
      *Object\Height = #GM_FieldSize
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      String = "Platforms\AstableGround2"
      ProcedureReturn @String
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 2, 1)
    Case #GM_Object_Name
      String = "Long Astable Ground"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 151
; FirstLine = 108
; Folding = -
; EnableXP