#Ballon_Normal            = 40
#Ballon_Cracked           = #Ballon_Normal    + 9
#Ballon_Invisible         = #Ballon_Cracked   + 500
#Ballon_Respawn           = #Ballon_Invisible + 40
#Ballon_Width             = 14
#Ballon_Height            = 22
#Ballon_OuterWidth        = (#GM_FieldSize - #Ballon_Width) / 2
#Ballon_OuterHeight       = (2 * #GM_FieldSize - #Ballon_Height) / 2
#Ballon_AnimationDuration = 9

Global Ballon_Frameset.i

ProcedureDLL.i Obj_Ballon(*Object.GM_Object, Event.i, *Parameter)
  Static Transparency.f, Movement.i, Factor.f, Sprite3D.i
  
  Select Event
    Case #GM_Object_Frame
      If *Object\Memory < #Ballon_Normal
        Movement = (*Object\Memory / (#Ballon_Normal / 2)) - 1
        GM_DisplayAnimation(*Object\Animation, *Object\X - #Ballon_OuterWidth, *Object\Y - #Ballon_OuterHeight + Movement)
        
        If GM_PlayAnimation(*Object\Animation)
          GM_SetAnimationDuration(*Object\Animation, #Ballon_AnimationDuration)
        EndIf
        
        *Object\Memory + 1
        If *Object\Memory = #Ballon_Normal
          *Object\Memory = 0
        EndIf
      ElseIf *Object\Memory < #Ballon_Cracked
        Sprite3D = GM_AnimationSprite3D(*Object\Animation)
        Factor   = 1.0 + (*Object\Memory - #Ballon_Normal) / 15.0
        GM_ZoomSprite3D(Sprite3D, 24.0 * Factor, 28.0 * Factor)
        
        GM_DisplayAnimation(*Object\Animation, *Object\X - #Ballon_OuterWidth + (24 - 24.0 * Factor)/2, *Object\Y - #Ballon_OuterHeight + (28 - 28.0 * Factor)/2)
        If GM_PlayAnimation(*Object\Animation)
          GM_SetAnimationDuration(*Object\Animation, (#Ballon_Cracked - #Ballon_Normal)/3)
        EndIf
        
        *Object\Memory + 1
      ElseIf *Object\Memory < #Ballon_Invisible
        *Object\Memory + 1
        If *Object\Memory = #Ballon_Invisible
          GM_SetAnimationRow(*Object\Animation, 0)
          GM_SetNextAnimationFrame(*Object\Animation, 0, #Ballon_AnimationDuration)
        EndIf
      ElseIf *Object\Memory => #Ballon_Invisible And *Object\Memory < #Ballon_Respawn
        If *Object\Memory % 10 < 5
          Transparency = 200
        Else
          Transparency = 0
        EndIf
        Movement = ((*Object\Memory - #Ballon_Invisible) / (#Ballon_Respawn / 2)) - 1
        GM_DisplayAnimation(*Object\Animation, *Object\X - #Ballon_OuterWidth, *Object\Y - #Ballon_OuterHeight + Movement, Transparency)
        
        If GM_PlayAnimation(*Object\Animation)
          GM_SetAnimationDuration(*Object\Animation, #Ballon_AnimationDuration)
        EndIf
        
        *Object\Memory + 1
        If *Object\Memory = #Ballon_Respawn
          *Object\Memory = 0
        EndIf
      EndIf
    Case #GM_Object_Collision
      If *Object\Memory < #Ballon_Normal
        If GM_PlayerGroundCollision(*Object, 0, 0)
          *Object\Memory = #Ballon_Normal
          GM_SetAnimationRow(*Object\Animation, 1)
          GM_SetNextAnimationFrame(*Object\Animation, 0, (#Ballon_Cracked - #Ballon_Normal)/3)
          
          GM_ChangePlayerAction(#GM_Player_Action_Jump)
          *GM_Player\ActionTime = 50
          GM_SetPlayerMoveY(-6.4)
        EndIf
      EndIf
    Case #GM_Object_Hit
      If *Object\Memory < #Ballon_Normal
        *Object\Memory = #Ballon_Normal
        GM_SetAnimationRow(*Object\Animation, 1)
        GM_SetNextAnimationFrame(*Object\Animation, 0, (#Ballon_Cracked - #Ballon_Normal)/3)
        ProcedureReturn #GM_Object_DoCollision
      EndIf
    
    Case #GM_Object_Initialize
      *Object\X      + #Ballon_OuterWidth
      *Object\Y      + #Ballon_OuterHeight
      *Object\Width  = #Ballon_Width
      *Object\Height = #Ballon_Height
      
      *Object\Animation = GM_CreateAnimation(Ballon_Frameset)
      GM_SetNextAnimationFrame(*Object\Animation, Random(2), Random(#Ballon_AnimationDuration))
      *Object\Memory = Random(#Ballon_Normal - 1)
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      Ballon_Frameset = GM_LoadAnimationFrameset("Platforms\Ballon", 24, 28)
      
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\Ballon"
    Case #GM_Object_ViewRegion
      ViewRegion\X      = 0
      ViewRegion\Y      = 0
      ViewRegion\Width  = 24
      ViewRegion\Height = 28
      ProcedureReturn @ViewRegion
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
      
    Case #GM_Object_Name
      ProcedureReturn @"Ballon"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 74
; FirstLine = 69
; Folding = -
; EnableXP