#Cloud_Depth = 4

Enumeration
  #Cloud_Action_Visible
  #Cloud_Action_GetInvisible
  #Cloud_Action_Invisible
  #Cloud_Action_GetVisible
EndEnumeration

Structure CloudMemory
  Y.i
  MoveY.f
  Angle.f
  MoveDown.f
EndStructure
Structure WeakCloudMemory Extends CloudMemory
  Action.i
  Time.i
EndStructure

Global Cloud_Frameset.i
Global WeakCloud_Frameset.i

ProcedureDLL.i Obj_Cloud(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.CloudMemory, PreviousY.f, MoveDown.f
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplayFramesetFrame(Cloud_Frameset, 0, 0, *Object\X, *Object\Y - #Cloud_Depth)
    Case #GM_Object_Frame
      PreviousY = *Object\Y
      If *Memory\MoveDown > 1 ;Wenn ein Gewicht auf die Wolke einwirkt:
        ; Konstante Winkelgeschwindigkeit:
        *Memory\Angle + 0.08
        
        ; Die Amplitude nimmt linear ab (bei w = 2pi ist a = 0):
        *Object\Y = *Memory\Y + Sin(*Memory\Angle) * (*Memory\MoveDown / (2 * #PI) * ((2 * #PI) - *Memory\Angle))
        
        ; Bei einer vollen Schwingung wieder "beruihgen":
        If *Memory\Angle => 2 * #PI
          *Memory\MoveDown = 1
        EndIf
      Else
        *Memory\Angle + 0.1
        If *Memory\Angle => 2 * #PI
          *Memory\Angle - 2 * #PI
        EndIf
        
        ; Bewegt sich langsam hoch und runter:
        *Object\Y = *Memory\Y + Sin(*Memory\Angle)
      EndIf
      
      ; DeltaY muss berechnet werden, damit diese bei der Kollisionsberprfung verwendet werden kann:
      *Memory\MoveY = *Object\Y - PreviousY
    Case #GM_Object_Collision
      MoveDown = *GM_Player\MoveY
      If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, *Memory\MoveY))
        GM_StickPlayerOn(*Object)
        If *Memory\MoveDown = 1 And MoveDown > 1 ;Gewicht soll einwirken...
          *Memory\MoveDown = MoveDown * 8
          *Memory\Angle    = 0
        EndIf
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = 15
      
      *Memory        = AllocateMemory(SizeOf(CloudMemory))
      *Object\Memory = *Memory
      
      *Memory\Angle    = 0
      *Memory\Y        = *Object\Y
      *Memory\MoveDown = 1
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not Cloud_Frameset
        Cloud_Frameset = GM_LoadAnimationFrameset("Platforms\Cloud", #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorSave
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\Cloud"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @"Cloud"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_WeakCloud(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.WeakCloudMemory, PreviousY.f, MoveDown.f
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      Select *Memory\Action
        Case #Cloud_Action_Visible, #Cloud_Action_GetInvisible, #Cloud_Action_GetVisible
          GM_DisplayAnimation(*Object\Animation, *Object\X, *Object\Y - #Cloud_Depth)
      EndSelect
    Case #GM_Object_Frame
      PreviousY = *Object\Y
      
      Select *Memory\Action
        Case #Cloud_Action_Visible
          If *Memory\MoveDown > 1 ;Wenn ein Gewicht auf die Wolke einwirkt:
            ; Konstante Winkelgeschwindigkeit:
            *Memory\Angle + 0.08
            
            ; Die Amplitude nimmt linear ab (bei w = 2pi ist a = 0):
            *Object\Y = *Memory\Y + Sin(*Memory\Angle) * (*Memory\MoveDown / (2 * #PI) * ((2 * #PI) - *Memory\Angle))
            
            ; Bei einer vollen Schwingung wieder "beruihgen":
            If *Memory\Angle => 2 * #PI
              *Memory\MoveDown = 1
              *Memory\Action   = #Cloud_Action_GetInvisible
            EndIf
          Else
            *Memory\Angle + 0.1
            If *Memory\Angle => 2 * #PI
              *Memory\Angle - 2 * #PI
            EndIf
            
            ; Bewegt sich langsam hoch und runter:
            *Object\Y = *Memory\Y + Sin(*Memory\Angle)
          EndIf
        Case #Cloud_Action_GetInvisible
          *Memory\Angle + 0.1
          If *Memory\Angle => 2 * #PI
            *Memory\Angle - 2 * #PI
          EndIf
          
          ; Bewegt sich langsam hoch und runter:
          *Object\Y = *Memory\Y + Sin(*Memory\Angle)
          
          If GM_PlayAnimation(*Object\Animation)
            If GM_AnimationFrame(*Object\Animation) = 0
              *Memory\Action = #Cloud_Action_Invisible
              *Memory\Time   = 300
            Else
              GM_SetAnimationDuration(*Object\Animation, 3)
            EndIf
          EndIf
        Case #Cloud_Action_Invisible
          *Memory\Time - 1
          If *Memory\Time = 0
            *Memory\Action = #Cloud_Action_GetVisible
            GM_SetNextAnimationFrame(*Object\Animation, 2, 3)
          EndIf
        Case #Cloud_Action_GetVisible
          *Memory\Angle + 0.1
          If *Memory\Angle => 2 * #PI
            *Memory\Angle - 2 * #PI
          EndIf
          
          ; Bewegt sich langsam hoch und runter:
          *Object\Y = *Memory\Y + Sin(*Memory\Angle)
          
          If GM_PlayAnimationBack(*Object\Animation)
            If GM_AnimationFrame(*Object\Animation) = 0
              *Memory\Action = #Cloud_Action_Visible
            Else
              GM_SetAnimationDuration(*Object\Animation, 3)
            EndIf
          EndIf
      EndSelect
      
      ; DeltaY muss berechnet werden, damit diese bei der Kollisionsberprfung verwendet werden kann:
      *Memory\MoveY = *Object\Y - PreviousY
    Case #GM_Object_Collision
      If *Memory\Action = #Cloud_Action_Visible
        MoveDown = *GM_Player\MoveY
        If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, *Memory\MoveY))
          GM_StickPlayerOn(*Object)
          If *Memory\MoveDown = 1 And MoveDown > 1 ;Gewicht soll einwirken...
            *Memory\MoveDown = MoveDown * 8
            *Memory\Angle    = 0
          EndIf
        EndIf
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Width     = #GM_FieldSize
      *Object\Height    = 10
      *Object\Animation = GM_CreateAnimation(WeakCloud_Frameset)
      
      *Memory        = AllocateMemory(SizeOf(WeakCloudMemory))
      *Object\Memory = *Memory
      
      *Memory\Action   = #Cloud_Action_Visible
      *Memory\Angle    = 0
      *Memory\Y        = *Object\Y
      *Memory\MoveDown = 1
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not WeakCloud_Frameset
        WeakCloud_Frameset = GM_LoadAnimationFrameset("Platforms\WeakCloud", #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorSave
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\WeakCloud"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @"Weak Cloud"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 248
; FirstLine = 205
; Folding = -
; EnableXP