Global HiddenWall_Sprite.i, HiddenWall_Sprite3D.i

ProcedureDLL.i Obj_HiddenWall(*Object.GM_Object, Event.i, *Parameter)
  Static Distance.f
  
  Select Event
    Case #GM_Object_Display
      Distance = GM_DistanceToPlayer(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
      If Distance < #GM_FieldSize*4
        GM_DisplaySprite3D(HiddenWall_Sprite3D, *Object\X, *Object\Y, 255 - (Distance/(#GM_FieldSize*4)*255.0))
      EndIf
    Case #GM_Object_Collision
      GM_DoWallCollision(*Object, GM_PlayerCollision(*Object, 0, 0))
      ProcedureReturn #GM_Object_DoCollision
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not HiddenWall_Sprite
        HiddenWall_Sprite   = GM_LoadSprite("Platforms\HiddenWall")
        HiddenWall_Sprite3D = GM_CreateSprite3D(HiddenWall_Sprite)
      EndIf
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_StaticObject
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      String = "Platforms\HiddenWall"
      ProcedureReturn @String
    Case #GM_Object_Name
      String = "Hidden Wall"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_InvHiddenWall(*Object.GM_Object, Event.i, *Parameter)
  Static Distance.f
  
  Select Event
    Case #GM_Object_Display
      Distance = GM_DistanceToPlayer(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
      If Distance < #GM_FieldSize*8
        If Distance > #GM_FieldSize*4
          GM_DisplaySprite3D(HiddenWall_Sprite3D, *Object\X, *Object\Y, ((Distance - #GM_FieldSize*4)/(#GM_FieldSize*4)*255.0))
        EndIf
      Else
        GM_DisplaySprite3D(HiddenWall_Sprite3D, *Object\X, *Object\Y)
      EndIf
    Case #GM_Object_Collision
      GM_DoWallCollision(*Object, GM_PlayerCollision(*Object, 0, 0))
      ProcedureReturn #GM_Object_DoCollision
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not HiddenWall_Sprite
        HiddenWall_Sprite   = GM_LoadSprite("Platforms\HiddenWall")
        HiddenWall_Sprite3D = GM_CreateSprite3D(HiddenWall_Sprite)
      EndIf
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_StaticObject
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      String = "Platforms\HiddenWallInv"
      ProcedureReturn @String
    Case #GM_Object_Name
      String = "Hidden Wall (inverted)"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 96
; Folding = -
; EnableXP