Enumeration
  #JumpBoard_Action_Default
  #JumpBoard_Action_Down
EndEnumeration

#JumpBoard_StartY = 4
#JumpBoard_DeltaY = 2

Structure JumpBoardMemory
  Action.i
  Time.i
  MoveY.f
  DeltaY.f
EndStructure

Global JumpBoard_Frameset.i

ProcedureDLL.i Obj_JumpBoard(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.JumpBoardMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplayAnimation(*Object\Animation, *Object\X, *Object\Y - *Memory\DeltaY - #JumpBoard_StartY)
    Case #GM_Object_Frame
      Select *Memory\Action
        Case #JumpBoard_Action_Default
          *Memory\MoveY = 0
          GM_SetAnimationFrame(*Object\Animation, 0)
        Case #JumpBoard_Action_Down
          *Memory\MoveY = 0
          Select *Memory\Time
            Case 0
              GM_SetAnimationFrame(*Object\Animation, 1)
              *Memory\MoveY = #JumpBoard_DeltaY
            Case 2
              GM_SetAnimationFrame(*Object\Animation, 2)
              *Memory\MoveY = #JumpBoard_DeltaY
            Case 4
              GM_SetAnimationFrame(*Object\Animation, 3)
              *Memory\MoveY = #JumpBoard_DeltaY
            Case 8
              GM_SetAnimationFrame(*Object\Animation, 4)
              *Memory\MoveY = -#JumpBoard_DeltaY * 4
              If *GM_Player\StickedObject = *Object ;Steht der Spieler auf dem Board?
                GM_ChangePlayerAction(#GM_Player_Action_Jump)
                *GM_Player\ActionTime    = 100
                *GM_Player\MoveY         =  -6.8
                *GM_Player\StickedObject = #Null
                *GM_Player\Y             - #JumpBoard_DeltaY * 4
              EndIf
            Case 12
              GM_SetAnimationFrame(*Object\Animation, 0)
              *Memory\MoveY  = #JumpBoard_DeltaY
            Case 16
              GM_SetAnimationFrame(*Object\Animation, 1)
              *Memory\MoveY  = #JumpBoard_DeltaY
            Case 20
              GM_SetAnimationFrame(*Object\Animation, 0)
              *Memory\MoveY  = -#JumpBoard_DeltaY
              *Memory\Action = #JumpBoard_Action_Default
          EndSelect
          *Memory\DeltaY + *Memory\MoveY
          *Object\Y      + *Memory\MoveY
          
          *Memory\Time + 1
      EndSelect
    Case #GM_Object_Collision
      If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, *Memory\MoveY))
        GM_StickPlayerOn(*Object)
        If *Memory\Action <> #JumpBoard_Action_Down
          *Memory\Action = #JumpBoard_Action_Down
          *Memory\Time   = 0
        EndIf
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Y + #JumpBoard_StartY
      
      *Object\Width  = #GM_FieldSize
      *Object\Height = 10
      
      *Object\Animation = GM_CreateAnimation(JumpBoard_Frameset)
      
      *Memory        = AllocateMemory(SizeOf(JumpBoardMemory))
      *Object\Memory = *Memory
      
      *Memory\Action = #JumpBoard_Action_Default
      *Memory\Time   = 0
      *Memory\DeltaY = 0
      *Memory\MoveY  = 0
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not JumpBoard_Frameset
        JumpBoard_Frameset = GM_LoadAnimationFrameset("Platforms\JumpBoard", #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\JumpBoard"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @"Jump Board"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 49
; FirstLine = 34
; Folding = -
; EnableXP