#Lift_Speed     = 2
#Lift_TopHeight = 6

Structure LiftMemory
  *Top.GM_Object
  Y.i
  MoveY.i
EndStructure

Global Lift_BottomSprite.i, Lift_BottomSprite3D.i
Global Lift_TopSprite.i, Lift_TopSprite3D.i

Global *Lift_DisabledClimb.GM_Object

Procedure.i Obj_LiftTop(*Object.GM_Object, Event.i, *Parameter)
  Static *Bottom.GM_Object, *BottomMemory.LiftMemory
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(Lift_TopSprite3D, *Object\X, *Object\Y)
    Case #GM_Object_Collision
      *Bottom       = *Object\Memory
      *BottomMemory = *Bottom\Memory
      GM_DoWallCollision(*Object, GM_PlayerCollision(*Object, 0, *BottomMemory\MoveY))
    
    Case #GM_Object_Initialize
      If Not *Object\Memory
        *Object\Memory = *Parameter
        *Object\Width  = #GM_FieldSize
        *Object\Height = 6
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_Lift(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.LiftMemory
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(Lift_BottomSprite3D, *Object\X, *Object\Y)
    Case #GM_Object_Frame
      If *Object\Y < *Memory\Y * #GM_FieldSize
        ; Aufzug hat das obere Feld noch nicht erreicht:
        *Memory\MoveY = #Lift_Speed
      ElseIf *Object\Y > *Memory\Y * #GM_FieldSize
        ; Aufzug hat das untere Feld noch nicht erreicht:
        *Memory\MoveY = -#Lift_Speed
      Else
        ; Hier befindet sich der Aufzug genau auf dem Feld:
        *Memory\MoveY = 0
      EndIf
      *Object\Y + *Memory\MoveY
      
      ; Die Decke mitbewegen:
      *Memory\Top\Y = *Object\Y - #GM_FieldSize - #Lift_TopHeight
      
      If *GM_Player\StickedObject = *Object ;Befindet sich der Spieler im Aufzug (steht auf dem Boden)?
        If *Object\Y = *Memory\Y * #GM_FieldSize
          If *GM_Player\KeyPressing[#GM_Player_Key_Up]
            If Not GM_GetWall(*Object\X / #GM_FieldSize, *Object\Y / #GM_FieldSize - 3) ;Kein Hindernis oben?
              ; Aufzug ein Feld hochbewegen:
              *Memory\Y - 1
            EndIf
          ElseIf *GM_Player\KeyPressing[#GM_Player_Key_Down]
            If Not GM_GetWall(*Object\X / #GM_FieldSize, *Object\Y / #GM_FieldSize + 1) ;Kein Hindernis unten?
              ; Aufzug ein Feld runterbewegen:
              *Memory\Y + 1
            EndIf
          EndIf
        EndIf
      ElseIf *Lift_DisabledClimb = *Object
        ; Falls der Spieler den Aufzug verlassen hat und die
        ; Fhigkeit zum Klettern deaktiviert wurde, wird diese
        ; wieder aktiviert:
        
        *GM_Player\CanClimb = #True
        *Lift_DisabledClimb = #Null
      EndIf
    Case #GM_Object_Collision
      *Parameter = GM_PlayerCollision(*Object, 0, *Memory\MoveY)
      GM_DoWallCollision(*Object, *Parameter)
      If *Parameter = #GM_Collision_Top
        GM_StickPlayerOn(*Object)
        
        ; Damit der Spieler nicht an der Wand klettern kann (was
        ; im Aufzug nervig ist) wird das klettern deaktiviert:
        If *GM_Player\CanClimb
          *GM_Player\CanClimb = #False
          *Lift_DisabledClimb = *Object
        EndIf
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = 6
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      *Object\Y + (#GM_FieldSize * 2)
      
      *Memory = AllocateMemory(SizeOf(LiftMemory))
      *Object\Memory = *Memory
      
      *Memory\Y   = *Object\Y / #GM_FieldSize
      
      ; Die Decke wird als ein zweites Objekt erstellt, damit auch
      ; diese ihre eigene Kollisionsberprfung besitzen kann:
      *Memory\Top = GM_CreateObject(#GM_Layer_BackgroundObject2, @Obj_LiftTop(), *Object\X, *Object\Y - #GM_FieldSize - #Lift_TopHeight, *Object, *Object\Scene)
    Case #GM_Object_GlobalLoad
      Lift_BottomSprite   = GM_LoadSprite("Platforms\LiftBottom")
      Lift_BottomSprite3D = GM_CreateSprite3D(Lift_BottomSprite)
      Lift_TopSprite      = GM_LoadSprite("Platforms\LiftTop")
      Lift_TopSprite3D    = GM_CreateSprite3D(Lift_TopSprite)
    
    Case #GM_Object_EditorLoad
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_EditorSave
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\Lift-View"
    Case #GM_Object_Name
      ProcedureReturn @"Lift"
    Case #GM_Object_Description
      ProcedureReturn @"You can control this lift by the arrow keys [UP] and [DOWN]."
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 138
; FirstLine = 98
; Folding = -
; EnableXP