#PathGround_Speed = 1.0

Structure PathGroundMemory
  *Selection
  Index.i
  Time.i
  NewWay.i
  Direction.i
  MoveX.f
  MoveY.f
EndStructure

Global PathGround_Sprite.i, PathGround_Sprite3D.i

ProcedureDLL.i Obj_PathGround1(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.PathGroundMemory, DX.f, DY.f
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(PathGround_Sprite3D, *Object\X, *Object\Y)
    Case #GM_Object_Frame
      *Memory\Time - 1
      If *Memory\Time
        If *Memory\NewWay
          ; Distanz berechenn und daraus die bentigte Zeit fr den Weg:
          DX            = GM_SelectedX(*Memory\Selection, *Memory\Index) * #GM_FieldSize - *Object\X
          DY            = GM_SelectedY(*Memory\Selection, *Memory\Index) * #GM_FieldSize - *Object\Y
          *Memory\Time  = Sqr(DX * DX + DY * DY) / #PathGround_Speed
          *Memory\MoveX = DX / *Memory\Time
          *Memory\MoveY = DY / *Memory\Time
          
          *Memory\NewWay = #False
        EndIf
        ; Weiterbewegen:
        *Object\X + *Memory\MoveX
        *Object\Y + *Memory\MoveY
      Else
        ; Das Objekt genau auf die Zielposition setzen:
        *Object\X = GM_SelectedX(*Memory\Selection, *Memory\Index) * #GM_FieldSize
        *Object\Y = GM_SelectedY(*Memory\Selection, *Memory\Index) * #GM_FieldSize
        
        ; Nchstes Feld als Zielpunkt whlen:
        If *Memory\Index = GM_SelectionSize(*Memory\Selection) - 1
          *Memory\Index = 0
        Else
          *Memory\Index + 1
        EndIf
        
        *Memory\MoveX  = 0
        *Memory\MoveY  = 0
        *Memory\NewWay = #True
        
        ; Bewegung wird noch nicht berechnet (siehe oben), da noch eine
        ; weitere Kollisionsabfrage fr die letzte Verschiebung durchgefhrt
        ; wird.
      EndIf
    Case #GM_Object_Collision
      If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, *Memory\MoveX, *Memory\MoveY))
        GM_StickPlayerOn(*Object)
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = 6
      
      GM_InitializeSelection(*Memory\Selection)
      
      *Object\X = GM_SelectedX(*Memory\Selection, 0) * #GM_FieldSize
      *Object\Y = GM_SelectedY(*Memory\Selection, 0) * #GM_FieldSize
    Case #GM_Object_Load
      *Memory = AllocateMemory(SizeOf(PathGroundMemory))
      *Object\Memory = *Memory
      
      *Memory\Selection = GM_LoadSelection()
      *Memory\Index     = 0
      *Memory\Time      = 1
    Case #GM_Object_GlobalLoad
      If Not PathGround_Sprite
        PathGround_Sprite   = GM_LoadSprite("Platforms\PathGround")
        PathGround_Sprite3D = GM_CreateSprite3D(PathGround_Sprite)
      EndIf
    
    Case #GM_Object_EditorLoad
      *EditorObject\Memory = GM_CreateSelection()
      GM_LoadSelection(*EditorObject\Memory)
      
      *EditorObject\X = GM_SelectedX(*EditorObject\Memory, 0)
      *EditorObject\Y = GM_SelectedY(*EditorObject\Memory, 0)
    Case #GM_Object_EditorSave
      GM_SaveSelection(*EditorObject\Memory)
    Case #GM_Object_EditorInitialize
      If Not *EditorObject\Memory
        *EditorObject\Memory = GM_CreateSelection()
      EndIf
    Case #GM_Object_EditorConfigure
      GM_EditSelection(*EditorObject\Memory, "Build path")
    Case #GM_Object_EditorFree
      GM_FreeSelection(*EditorObject\Memory)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\PathGround-View"
    Case #GM_Object_ViewRegion
      ViewRegion\X      = #GM_FieldSize
      ViewRegion\Y      = 0
      ViewRegion\Width  = #GM_FieldSize
      ViewRegion\Height = #GM_FieldSize
      ProcedureReturn @ViewRegion
    Case #GM_Object_Name
      ProcedureReturn @"Path Ground (circular)"
    Case #GM_Object_Description
      ProcedureReturn @"This platform follows a sequence of specified fields."
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_PathGround2(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.PathGroundMemory, DX.f, DY.f
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(PathGround_Sprite3D, *Object\X, *Object\Y)
    Case #GM_Object_Frame
      *Memory\Time - 1
      If *Memory\Time
        If *Memory\NewWay
          ; Distanz berechenn und daraus die bentigte Zeit fr den Weg:
          DX            = GM_SelectedX(*Memory\Selection, *Memory\Index) * #GM_FieldSize - *Object\X
          DY            = GM_SelectedY(*Memory\Selection, *Memory\Index) * #GM_FieldSize - *Object\Y
          *Memory\Time  = Sqr(DX * DX + DY * DY) / #PathGround_Speed
          *Memory\MoveX = DX / *Memory\Time
          *Memory\MoveY = DY / *Memory\Time
          
          *Memory\NewWay = #False
        EndIf
        ; Weiterbewegen:
        *Object\X + *Memory\MoveX
        *Object\Y + *Memory\MoveY
      Else
        ; Das Objekt genau auf die Zielposition setzen:
        *Object\X = GM_SelectedX(*Memory\Selection, *Memory\Index) * #GM_FieldSize
        *Object\Y = GM_SelectedY(*Memory\Selection, *Memory\Index) * #GM_FieldSize
        
        ; Nchstes Feld als Zielpunkt whlen:
        Select *Memory\Direction
          Case 1
            If *Memory\Index = GM_SelectionSize(*Memory\Selection) - 1
              *Memory\Direction = -1
            EndIf
          Case -1
            If *Memory\Index = 0
              *Memory\Direction = 1
            EndIf
        EndSelect
        *Memory\Index + *Memory\Direction
        
        *Memory\MoveX  = 0
        *Memory\MoveY  = 0
        *Memory\NewWay = #True
        
        ; Bewegung wird noch nicht berechnet (siehe oben), da noch eine
        ; weitere Kollisionsabfrage fr die letzte Verschiebung durchgefhrt
        ; wird.
      EndIf
    Case #GM_Object_Collision
      If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, *Memory\MoveX, *Memory\MoveY))
        GM_StickPlayerOn(*Object)
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      GM_InitializeSelection(*Memory\Selection)
      
      *Object\X = GM_SelectedX(*Memory\Selection, 0) * #GM_FieldSize
      *Object\Y = GM_SelectedY(*Memory\Selection, 0) * #GM_FieldSize
    Case #GM_Object_Load
      *Memory = AllocateMemory(SizeOf(PathGroundMemory))
      *Object\Memory = *Memory
      
      *Memory\Selection = GM_LoadSelection()
      *Memory\Index     = 0
      *Memory\Time      = 1
      *Memory\Direction = 1
    Case #GM_Object_GlobalLoad
      If Not PathGround_Sprite
        PathGround_Sprite   = GM_LoadSprite("Platforms\PathGround")
        PathGround_Sprite3D = GM_CreateSprite3D(PathGround_Sprite)
      EndIf
    
    Case #GM_Object_EditorLoad
      *EditorObject\Memory = GM_CreateSelection()
      GM_LoadSelection(*EditorObject\Memory)
      
      *EditorObject\X = GM_SelectedX(*EditorObject\Memory, 0)
      *EditorObject\Y = GM_SelectedY(*EditorObject\Memory, 0)
    Case #GM_Object_EditorSave
      GM_SaveSelection(*EditorObject\Memory)
    Case #GM_Object_EditorInitialize
      If Not *EditorObject\Memory
        *EditorObject\Memory = GM_CreateSelection()
      EndIf
    Case #GM_Object_EditorConfigure
      GM_EditSelection(*EditorObject\Memory, "Build path")
    Case #GM_Object_EditorFree
      GM_FreeSelection(*EditorObject\Memory)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
      
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\PathGround-View"
    Case #GM_Object_ViewRegion
      ViewRegion\X      = 0
      ViewRegion\Y      = 0
      ViewRegion\Width  = #GM_FieldSize
      ViewRegion\Height = #GM_FieldSize
      ProcedureReturn @ViewRegion
    Case #GM_Object_Name
      ProcedureReturn @"Path Ground (line)"
    Case #GM_Object_Description
      ProcedureReturn @"This platform follows a sequence of specified fields."
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 253
; FirstLine = 207
; Folding = -
; EnableXP