#SlidingGround_Frames         = 6
#SlidingGround_AnimationSpeed = 3
#SlidingGround_PeriodLength   = #SlidingGround_AnimationSpeed * #SlidingGround_Frames + 55

Global SlidingGround_Frameset.i

ProcedureDLL.i SlidingGroundTemplate(*Object.GM_Object, Event.i, *Parameter, Period.f)
  Select Event
    Case #GM_Object_Display
      GM_DisplayAnimation(*Object\Animation, *Object\X + 1, *Object\Y - 4)
    Case #GM_Object_Frame
      If *Object\Memory => Period * #SlidingGround_PeriodLength And *Object\Memory < (Period + 1) * #SlidingGround_PeriodLength
        If GM_AnimationFrame(*Object\Animation) < #SlidingGround_Frames - 1
          If GM_PlayAnimation(*Object\Animation)
            GM_SetAnimationDuration(*Object\Animation, #SlidingGround_AnimationSpeed)
          EndIf
        EndIf
      Else
        If GM_AnimationFrame(*Object\Animation) > 0
          If GM_PlayAnimationBack(*Object\Animation)
            GM_SetAnimationDuration(*Object\Animation, #SlidingGround_AnimationSpeed)
          EndIf
        EndIf
      EndIf
      If *Object\Memory = #SlidingGround_PeriodLength * 3
        *Object\Memory = 0
      Else
        *Object\Memory + 1
      EndIf
    Case #GM_Object_Collision
      If *Object\Memory => (Period - 0.15) * #SlidingGround_PeriodLength And *Object\Memory < (Period + 1.20) * #SlidingGround_PeriodLength
        GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, 0))
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Y      + 4
      *Object\X      + 1
      *Object\Width  = #GM_FieldSize - 2
      *Object\Height = #GM_FieldSize
      
      *Object\Animation = GM_CreateAnimation(SlidingGround_Frameset)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not SlidingGround_Frameset
        SlidingGround_Frameset = GM_LoadAnimationFrameset("Platforms\SlidingGround", #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"Platforms\SlidingGround-View"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(Period, 0, 1, 1)
    Case #GM_Object_Name
      ReturnString("Sliding Platform (" + Str(Period + 1) + ")")
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_SlidingGround1(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn SlidingGroundTemplate(*Object, Event, *Parameter, 0)
EndProcedure
ProcedureDLL.i Obj_SlidingGround2(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn SlidingGroundTemplate(*Object, Event, *Parameter, 1)
EndProcedure
ProcedureDLL.i Obj_SlidingGround3(*Object.GM_Object, Event.i, *Parameter)
  ProcedureReturn SlidingGroundTemplate(*Object, Event, *Parameter, 2)
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 30
; FirstLine = 3
; Folding = -
; EnableXP