#Checkpoint_MaxRotation = 28.0

Structure CheckpointMemory
  Passed.i
  RotationSpeed.f
  Rotation.f
  TransparencyState.f
EndStructure

Global Checkpoint_Frameset.i

ProcedureDLL.i Obj_Check(*Object.GM_Object, Event.i, *Parameter)
  Protected *Memory.CheckpointMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      If *Memory\Passed
        GM_BlendingMode(5, 2)
        GM_DisplayFramesetFrame(Checkpoint_Frameset, 3.0/#Checkpoint_MaxRotation * *Memory\Rotation, 0, *Object\X, *Object\Y)
        GM_BlendingMode(5, 6)
      Else
        GM_BlendingMode(5, 2)
        GM_DisplayFramesetFrame(Checkpoint_Frameset, 0, 0, *Object\X, *Object\Y, Cos(*Memory\TransparencyState)*100 + 155)
        GM_BlendingMode(5, 6)
      EndIf
    Case #GM_Object_Frame
      If *Memory\Passed
        *Memory\Rotation + *Memory\RotationSpeed
        If *Memory\Rotation => #Checkpoint_MaxRotation
          *Memory\Rotation - #Checkpoint_MaxRotation
        EndIf
        *Memory\RotationSpeed * 0.972
        
        *Memory\TransparencyState + 0.05 + *Memory\RotationSpeed*0.85
        If *Memory\TransparencyState => #PI/2.0
          *Memory\TransparencyState - #PI
        EndIf
        
        If *Memory\RotationSpeed <= 0.08
          *Memory\Passed            = #False
          *Memory\Rotation          = 0
          *Memory\RotationSpeed     = 0
          *Memory\TransparencyState = 0
        EndIf
      Else
        *Memory\TransparencyState + 0.035
        If *Memory\TransparencyState => #PI/2
          *Memory\TransparencyState - #PI
        EndIf
      EndIf
    Case #GM_Object_Collision
      If Not *Memory\Passed And *GM_Player\Action = #GM_Player_Action_Standing And *GM_Player\KeyPressed[#GM_Player_Key_Down]
        *Memory\Passed        = #True
        *Memory\RotationSpeed = 4.8
        
        *GM_Player\LastCheckpointScene = *Object\Scene
        *GM_Player\LastCheckpointX     = *Object\X / #GM_FieldSize
        *GM_Player\LastCheckpointY     = *Object\Y / #GM_FieldSize
      EndIf
      GM_ShowComment("Checkpoint", 1)
      *Memory\TransparencyState + 0.08
    Case #GM_Object_PlayerLeftScene
      *Memory\Passed            = #False
      *Memory\Rotation          = 0
      *Memory\RotationSpeed     = 0
      *Memory\TransparencyState = 0
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      Checkpoint_Frameset  = GM_LoadAnimationFrameset("System\Checkpoint", #GM_FieldSize, #GM_FieldSize)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Memory = AllocateMemory(SizeOf(CheckpointMemory))
      *Object\Memory = *Memory
      
      *Memory\Passed            = #False
      *Memory\TransparencyState = -#PI/2
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
     
    Case #GM_Object_ViewSprite
      String = "System\Checkpoint"
      ProcedureReturn @String
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @"Checkpoint"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 60
; FirstLine = 37
; Folding = -
; EnableXP