Global Springboard_EffectSprite.i, Springboard_EffectSprite3D.i

ProcedureDLL.i Obj_SpringBoard(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Display
      If *Object\Memory
        GM_BlendingMode(5, 2)
        GM_DisplaySprite3D(Springboard_EffectSprite3D, *Object\X, *Object\Y - 8, 255 - (28 - *Object\Memory)/28.0*255.0)
        GM_BlendingMode(5, 6)
      EndIf
    Case #GM_Object_Frame
      If *Object\Memory
        *Object\Memory - 1
      EndIf
    Case #GM_Object_Collision
      ; Der Spieler wird nur ab einer bestimmten Fallgeschwindigkeit
      ; (hier 3 Pixel/Frame) in die Luft geschleudert:
      If GM_PlayerGroundCollision(*Object, 0, 0)
        If *GM_Player\MoveY > 3
          GM_SetPlayerMoveY(-7)
          ; In den Sprungmodus wechseln:
          GM_ChangePlayerAction(#GM_Player_Action_Jump)
          ; Einen Absprung vermerken:
          *Object\Memory = 28
        Else
          GM_DoGroundCollision(*Object, #GM_Collision_Top)
        EndIf
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Y      + 3
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not Springboard_EffectSprite
        Springboard_EffectSprite   = GM_LoadSprite("System\Springboard-Effect")
        Springboard_EffectSprite3D = GM_CreateSprite3D(Springboard_EffectSprite)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
      
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\Springboard"
    Case #GM_Object_Name
      ProcedureReturn @"Springboard"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_Ladder(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_AllowClambering
      ProcedureReturn #True
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_StaticObject
    Case #GM_Object_CheckLayer
      If #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\Ladder"
    Case #GM_Object_Name
      ProcedureReturn @"Ladder"
    Case #GM_Object_Description
      String = "You can clamber on this object, if you" + #GM_N
      String + "press [UP] in fornt of it."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_IWall(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_Collision
      GM_DoWallCollision(*Object, *Parameter)
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_StaticObject
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\InvisibleWall"
    Case #GM_Object_Name
      ProcedureReturn @"Invisible Wall"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_SkewR(*Object.GM_Object, Event.i, *Parameter)
  Protected A.f
  
  Select Event
    Case #GM_Object_Collision
      If *GM_Player\MoveX > 0
        A = *GM_Player\MoveX
      Else
        A = 0
      EndIf
      If *GM_Player\X + *GM_Player\Width <= *Object\X + *Object\Width + A
        If *GM_Player\Y + *GM_Player\Height => *Object\Y + *Object\Height - (*GM_Player\X + *GM_Player\Width - *Object\X)
          *GM_Player\Y = *Object\Y + *Object\Height - (*GM_Player\X + *GM_Player\Width - *Object\X) - *GM_Player\Height
          GM_ChangePlayerAction(#GM_Player_Action_Standing)
          GM_SetPlayerMoveY(2)
          *GM_Player\BottomObject = *Object
          *GM_Player\Speed = 1.25
        EndIf
      EndIf
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      String = "System\SkewnessR"
      ProcedureReturn @String
    Case #GM_Object_Name
      String = "Skewness (right)"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_SkewL(*Object.GM_Object, Event.i, *Parameter)
  Protected A.f
  
  Select Event
    Case #GM_Object_Collision
      If *GM_Player\MoveX < 0
        A = *GM_Player\MoveX
      Else
        A = 0
      EndIf
      If *GM_Player\X => *Object\X + A
        If *GM_Player\Y + *GM_Player\Height => *Object\Y + *Object\Height - (*Object\X + *Object\Width - *GM_Player\X)
          *GM_Player\Y = *Object\Y + *Object\Height - (*Object\X + *Object\Width - *GM_Player\X) - *GM_Player\Height
          GM_ChangePlayerAction(#GM_Player_Action_Standing)
          *GM_Player\BottomObject = *Object
          GM_SetPlayerMoveY(2)
          *GM_Player\Speed = 1.25
        EndIf
      EndIf
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
    
    Case #GM_Object_ViewSprite
      String = "System\SkewnessL"
      ProcedureReturn @String
    Case #GM_Object_Name
      String = "Skewness (left)"
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_NoClimb(*Object.GM_Object, Event.i, *Parameter)
  Select Event
    Case #GM_Object_ForbidClimbing
      ProcedureReturn #True
    Case #GM_Object_Collision
      GM_DoWallCollision(*Object, GM_PlayerCollision(*Object, 0, 0))
      ProcedureReturn 2
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_StaticObject
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
      
    Case #GM_Object_ViewSprite
      String = "System\NoClimb"
      ProcedureReturn @String
      
    Case #GM_Object_Name
      ProcedureReturn @"Forbid Climbing"
    Case #GM_Object_Description
      String = "Forbids climbing on the wall behind" + #GM_N
      String + "this object."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

Structure MessageMemory
  Text.s
EndStructure
ProcedureDLL.i Obj_Msg(*Object.GM_Object, Event.i, *Parameter)
  Protected *Memory.MessageMemory
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Collision
      GM_ShowComment("Message", 1)
      If *GM_Player\KeyPressed[#GM_Player_Key_Down]
        GM_ShowMessage("Message", *Memory\Text)
      EndIf
    
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      *Object\Memory = AllocateMemory(SizeOf(MessageMemory))
      *Memory        = *Object\Memory
      *Memory\Text   = GM_LoadText()
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
      *Memory = *EditorObject\Memory
      GM_SaveText(*Memory\Text)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      *Memory              = AllocateMemory(SizeOf(MessageMemory))
      *EditorObject\Memory = *Memory
      
      *Memory\Text = GM_LoadText()
    Case #GM_Object_EditorInitialize
      *EditorObject = *Parameter
      If Not *EditorObject\Memory
        *EditorObject\Memory = AllocateMemory(SizeOf(MessageMemory))
      EndIf
    Case #GM_Object_EditorConfigure
      *EditorObject = *Parameter
      *Memory       = *EditorObject\Memory
      *Memory\Text  = GM_EditMessage("Message", *Memory\Text)
    Case #GM_Object_EditorFree
      *EditorObject = *Parameter
      ClearStructure(*EditorObject\Memory, MessageMemory)
      FreeMemory(*EditorObject\Memory)
      
    Case #GM_Object_ViewSprite
      String = "System\Message"
      ProcedureReturn @String
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      ProcedureReturn #True
      
    Case #GM_Object_Name
      String = "Message"
      ProcedureReturn @String
    Case #GM_Object_Description
      String = "You can read your specified text by [DOWN]," + #GM_N
      String + "if you stay in front of this object."
      ProcedureReturn @String
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 79
; FirstLine = 67
; Folding = --
; EnableXP