#Star_OuterWidth  = 8
#Star_OuterHeight = 8

Structure StarMemory
  *Selection
  Angle.f
EndStructure
Structure StarEditorMemory
  *Selection
EndStructure

Global Star_Sprite.i, Star_Sprite3D.i

Procedure.i Star_UnhideObjects(*Object.GM_Object, Index.i, *Parameter)
  If GM_HideObject(*Object, #False) And *Object\Scene = *GM_Player\Scene
    GM_EmitTinyFlash(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
  EndIf
EndProcedure
Procedure.i Star_HideObjects(*Object.GM_Object, Index.i, *Parameter)
  If GM_HideObject(*Object, #True) And *Object\Scene = *GM_Player\Scene
    GM_EmitTinyFlash(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
  EndIf
EndProcedure

ProcedureDLL.i Obj_Genstar(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.StarMemory, *EditorMemory.StarEditorMemory
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(Star_Sprite3D, *Object\X - #Star_OuterWidth, *Object\Y - #Star_OuterHeight + Sin(*Memory\Angle))
    Case #GM_Object_Frame
      *Memory\Angle + 0.075
      If *Memory\Angle => 2 * #PI
        *Memory\Angle - 2 * #PI
      EndIf
    Case #GM_Object_Collision
      GM_ForEachSelectedObject(*Memory\Selection, @Star_UnhideObjects())
      GM_EmitTinyFlash(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
      ProcedureReturn #GM_Object_DoDelete
    
    Case #GM_Object_Initialize
      *Object\Width  = 8
      *Object\Height = 8
      *Object\X      + #Star_OuterWidth
      *Object\Y      + #Star_OuterHeight
      
      *Memory\Angle = Random(2 * #PI * 100)/100.0
      
      GM_InitializeObjectSelection(*Memory\Selection)
      GM_HideSelectedObjects(*Memory\Selection, #True)
    Case #GM_Object_Load
      *Memory        = AllocateMemory(SizeOf(StarMemory))
      *Object\Memory = *Memory
      
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      *Memory\Selection = GM_LoadObjectSelection()
    Case #GM_Object_GlobalLoad
      If Not Star_Sprite
        Star_Sprite   = GM_LoadSprite("System\Star")
        Star_Sprite3D = GM_CreateSprite3D(Star_Sprite)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorMemory = *EditorObject\Memory
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
      GM_SaveObjectSelection(*EditorMemory\Selection)
    Case #GM_Object_EditorLoad
      *EditorMemory        = AllocateMemory(SizeOf(StarEditorMemory))
      *EditorObject\Memory = *EditorMemory
      
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      *EditorMemory\Selection = GM_CreateSelection()
      GM_LoadObjectSelection(*EditorMemory\Selection)
    Case #GM_Object_EditorInitialize
      If *EditorObject\Memory
        *EditorMemory = *EditorObject\Memory
        
        GM_InitializeObjectSelection(*EditorMemory\Selection)
      Else
        *EditorMemory = AllocateMemory(SizeOf(StarEditorMemory))
        *EditorObject\Memory = *EditorMemory
        
        *EditorMemory\Selection = GM_CreateSelection()
      EndIf
    Case #GM_Object_EditorConfigure
      *EditorMemory = *EditorObject\Memory
      GM_SelectObjects(*EditorMemory\Selection, "Select objects to unhide")
    Case #GM_Object_EditorFree
      *EditorMemory = *EditorObject\Memory
      GM_FreeSelection(*EditorMemory\Selection)
      FreeMemory(*EditorMemory)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\Star-View"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(0, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @"Genstar"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
ProcedureDLL.i Obj_Killstar(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.StarMemory, *EditorMemory.StarEditorMemory
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(Star_Sprite3D, *Object\X - #Star_OuterWidth, *Object\Y - #Star_OuterHeight + Sin(*Memory\Angle))
    Case #GM_Object_Frame
      *Memory\Angle + 0.075
      If *Memory\Angle => 2 * #PI
        *Memory\Angle - 2 * #PI
      EndIf
    Case #GM_Object_Collision
      GM_ForEachSelectedObject(*Memory\Selection, @Star_HideObjects())
      GM_EmitTinyFlash(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
      ProcedureReturn #GM_Object_DoDelete
    
    Case #GM_Object_Initialize
      *Object\Width  = 8
      *Object\Height = 8
      *Object\X      + #Star_OuterWidth
      *Object\Y      + #Star_OuterHeight
      
      *Memory\Angle = Random(2 * #PI * 100)/100.0
      
      GM_InitializeObjectSelection(*Memory\Selection)
    Case #GM_Object_Load
      *Memory        = AllocateMemory(SizeOf(StarMemory))
      *Object\Memory = *Memory
      
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      *Memory\Selection = GM_LoadObjectSelection()
    Case #GM_Object_GlobalLoad
      If Not Star_Sprite
        Star_Sprite   = GM_LoadSprite("System\Star")
        Star_Sprite3D = GM_CreateSprite3D(Star_Sprite)
      EndIf
    
    Case #GM_Object_EditorSave
      *EditorMemory = *EditorObject\Memory
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
      GM_SaveObjectSelection(*EditorMemory\Selection)
    Case #GM_Object_EditorLoad
      *EditorMemory        = AllocateMemory(SizeOf(StarEditorMemory))
      *EditorObject\Memory = *EditorMemory
      
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      *EditorMemory\Selection = GM_CreateSelection()
      GM_LoadObjectSelection(*EditorMemory\Selection)
    Case #GM_Object_EditorInitialize
      If *EditorObject\Memory
        *EditorMemory = *EditorObject\Memory
        
        GM_InitializeObjectSelection(*EditorMemory\Selection)
      Else
        *EditorMemory = AllocateMemory(SizeOf(StarEditorMemory))
        *EditorObject\Memory = *EditorMemory
        
        *EditorMemory\Selection = GM_CreateSelection()
      EndIf
    Case #GM_Object_EditorConfigure
      *EditorMemory = *EditorObject\Memory
      GM_SelectObjects(*EditorMemory\Selection, "Select objects to hide")
    Case #GM_Object_EditorFree
      *EditorMemory = *EditorObject\Memory
      GM_FreeSelection(*EditorMemory\Selection)
      FreeMemory(*EditorMemory)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\Star-View"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(1, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @"Killstar"
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 14
; Folding = --
; EnableXP