Structure TeleporterMemory
  *Selection
  *OtherTeleporter.GM_Object
  *ArrivedFrom.GM_Object
EndStructure
Structure TeleporterEditorMemory
  *Selection
EndStructure

Global Teleporter_Frameset.i

ProcedureDLL.i Obj_Teleporter(*Object.GM_Object, Event.i, *Parameter)
  Static *Memory.TeleporterMemory, *EditorMemory.TeleporterEditorMemory
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_BlendingMode(5, 2)
      GM_DisplayAnimation(*Object\Animation, *Object\X, *Object\Y)
      GM_BlendingMode(5, 6)
    Case #GM_Object_Frame
      If *Memory\OtherTeleporter And *Memory\OtherTeleporter\Hidden = #False
        GM_SetAnimationRow(*Object\Animation, 0)
      Else
        GM_SetAnimationRow(*Object\Animation, 1)
      EndIf
      
      If GM_PlayAnimation(*Object\Animation)
        GM_SetAnimationDuration(*Object\Animation, 2)
        If GM_AnimationFrame(*Object\Animation) = 4
          GM_SetAnimationFrame(*Object\Animation, 0)
        EndIf
      EndIf
      
      If *Memory\ArrivedFrom And Not *GM_Player\SceneToLocate
        ; Kommt der Spieler am Teleporter an und wurde bereits positioniert, dann...
        GM_EmitTinyFlash(*GM_Player\X + *GM_Player\Width/2, *GM_Player\Y + *GM_Player\Height/2)
        *Memory\ArrivedFrom = #Null
      EndIf
    Case #GM_Object_Collision
      If *GM_Player\KeyReleased[#GM_Player_Key_Up]
        ; Teleporter wird verwendet (falls mglich):
        If *Memory\OtherTeleporter And *Memory\OtherTeleporter\Hidden = #False ;Existiert ein Schwester-Objekt?
          GM_LocatePlayer(*Memory\OtherTeleporter\X / #GM_FieldSize, *Memory\OtherTeleporter\Y / #GM_FieldSize, *Memory\OtherTeleporter\Scene)
          GM_EmitTinyFlash(*GM_Player\X + *GM_Player\Width/2, *GM_Player\Y + *GM_Player\Height/2)
          ; Ursprungs-Teleporter mitteilen (damit auch der andere Teleporter reagieren kann):
          CallFunctionFast(*Memory\OtherTeleporter\Callback, *Memory\OtherTeleporter, -1, *Object)
        EndIf
      ElseIf *GM_Player\KeyPressing[#GM_Player_Key_Up]
        GM_SetAnimationFrame(*Object\Animation, 4)
        GM_SetAnimationDuration(*Object\Animation, 2)
      EndIf
    
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Object\Animation = GM_CreateAnimation(Teleporter_Frameset)
      
      GM_InitializeObjectSelection(*Memory\Selection)
      If GM_SelectionSize(*Memory\Selection)
        ; Ein Ziel-Teleporter wurde im Editor gewhlt:
        *Memory\OtherTeleporter = GM_SelectedObject(*Memory\Selection, 0)
      EndIf
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      
      *Memory        = AllocateMemory(SizeOf(TeleporterMemory))
      *Object\Memory = *Memory
      
      *Memory\Selection = GM_LoadObjectSelection()
    Case #GM_Object_GlobalLoad
      If Not Teleporter_Frameset
        Teleporter_Frameset = GM_LoadAnimationFrameset("System\Teleporter", #GM_FieldSize, #GM_FieldSize)
      EndIf
    
    Case #GM_Object_EditorSave
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
      
      *EditorMemory = *EditorObject\Memory
      GM_SaveObjectSelection(*EditorMemory\Selection)
    Case #GM_Object_EditorLoad
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      
      *EditorMemory        = AllocateMemory(SizeOf(TeleporterEditorMemory))
      *EditorObject\Memory = *EditorMemory
      
      *EditorMemory\Selection = GM_CreateSelection()
      GM_LoadObjectSelection(*EditorMemory\Selection)
    Case #GM_Object_EditorInitialize
      If *EditorObject\Memory
        *EditorMemory = *EditorObject\Memory
        
        GM_InitializeObjectSelection(*EditorMemory\Selection)
      Else
        *EditorMemory        = AllocateMemory(SizeOf(TeleporterEditorMemory))
        *EditorObject\Memory = *EditorMemory
        
        *EditorMemory\Selection = GM_CreateSelection()
      EndIf
    Case #GM_Object_EditorConfigure
      *EditorMemory = *EditorObject\Memory
      
      GM_SelectSingleObject(*EditorMemory\Selection, "Select target teleporter")
    Case #GM_Object_EditorFree
      *EditorMemory = *EditorObject\Memory
      
      GM_FreeSelection(*EditorMemory\Selection)
      FreeMemory(*EditorMemory)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\Teleporter"
    Case #GM_Object_ViewRegion
      ViewRegion\X      = 0
      ViewRegion\Y      = 0
      ViewRegion\Width  = #GM_FieldSize
      ViewRegion\Height = #GM_FieldSize
      ProcedureReturn @ViewRegion
    Case #GM_Object_Name
      ProcedureReturn @"Teleporter"
    
    Case -1
      *Memory\ArrivedFrom = *Parameter
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 68
; FirstLine = 56
; Folding = -
; EnableXP