Structure WindParameter
  Name.s
  Index.i
  
  MoveX.i
  MoveY.i
  
  Initialized.i
EndStructure
Structure WindMemory
  X1.i
  X2.i
  Y1.i
  Y2.i
EndStructure

Procedure.i WindTemplate(*Object.GM_Object, Event.i, *Parameter, *WindParameter.WindParameter)
  Static *Memory.WindMemory, FieldX.i, FieldY.i, Range.i
  
  If *Object
    *Memory = *Object\Memory
  Else
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Frame
      If *GM_Player\Action = #GM_Player_Action_Flying
        If *GM_Player\FieldX => *Memory\X1 And *GM_Player\FieldX <= *Memory\X2 And *GM_Player\FieldY => *Memory\Y1 And *GM_Player\FieldY <= *Memory\Y2
          *GM_Player\MoveX + *WindParameter\MoveX * 0.1
          *GM_Player\MoveY + *WindParameter\MoveY * 0.1
          GM_ExaminePlayerCollisions()
        EndIf
      EndIf
      
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      
      *Memory        = AllocateMemory(SizeOf(WindMemory))
      *Object\Memory = *Memory
      
      FieldX = *Object\X / #GM_FieldSize
      FieldY = *Object\Y / #GM_FieldSize
      
      Range = GM_DetectNextBarrier(FieldX + *WindParameter\MoveX, FieldY + *WindParameter\MoveY, *WindParameter\MoveX, *WindParameter\MoveY, *Object\Scene)
      
      If *WindParameter\MoveX
        *Memory\Y1 = FieldY
        *Memory\Y2 = FieldY
        If *WindParameter\MoveX < 0
          *Memory\X1 = FieldX - Range
          *Memory\X2 = FieldX
        Else
          *Memory\X1 = FieldX
          *Memory\X2 = FieldX + Range
        EndIf
      ElseIf *WindParameter\MoveY
        *Memory\X1 = FieldX
        *Memory\X2 = FieldX
        If *WindParameter\MoveY < 0
          *Memory\Y1 = FieldY - Range
          *Memory\Y2 = FieldY
        Else
          *Memory\Y1 = FieldY
          *Memory\Y2 = FieldY + Range
        EndIf
      EndIf
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    
    Case #GM_Object_EditorSave
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_ForegroundObject1
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @"System\Wind"
    Case #GM_Object_ViewRegion
      ReturnViewRegion(*WindParameter\Index, 0, 1, 1)
    Case #GM_Object_Name
      ProcedureReturn @*WindParameter\Name
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

ProcedureDLL.i Obj_WindR(*Object.GM_Object, Event.i, *Parameter)
  Global WindR.WindParameter
  
  With WindR
    If Not \Initialized
      \Name  = "Wind (right)"
      \Index = 0
      
      \MoveX = 1
      \MoveY = 0
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WindTemplate(*Object, Event, *Parameter, @WindR)
EndProcedure
ProcedureDLL.i Obj_WindL(*Object.GM_Object, Event.i, *Parameter)
  Global WindL.WindParameter
  
  With WindL
    If Not \Initialized
      \Name  = "Wind (left)"
      \Index = 1
      
      \MoveX = -1
      \MoveY = 0
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WindTemplate(*Object, Event, *Parameter, @WindL)
EndProcedure
ProcedureDLL.i Obj_WindU(*Object.GM_Object, Event.i, *Parameter)
  Global WindU.WindParameter
  
  With WindU
    If Not \Initialized
      \Name  = "Wind (up)"
      \Index = 2
      
      \MoveX = 0
      \MoveY = -1
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WindTemplate(*Object, Event, *Parameter, @WindU)
EndProcedure
ProcedureDLL.i Obj_WindD(*Object.GM_Object, Event.i, *Parameter)
  Global WindD.WindParameter
  
  With WindD
    If Not \Initialized
      \Name  = "Wind (down)"
      \Index = 3
      
      \MoveX = 0
      \MoveY = 1
      
      \Initialized = #True
    EndIf
  EndWith
  
  ProcedureReturn WindTemplate(*Object, Event, *Parameter, @WindD)
EndProcedure
; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 45
; FirstLine = 25
; Folding = --
; EnableXP