Structure AnimationParameter
  Name.s
  File.s
  FrameWidth.i
  FrameHeight.i
  FrameDuration.i
  *Callback
  *Frameset.Integer
  
  Initialized.i
EndStructure



Procedure.i AnimationTemplate(*Object.GM_Object, Event.i, *Parameter, *AnimationParameter.AnimationParameter)
  Protected *EditorObject.GM_EditorObject
  
  Select Event
    Case #GM_Object_Display
      GM_DisplayAnimation(*Object\Animation, *Object\X, *Object\Y, *Object\Transparency)
    Case #GM_Object_Frame
      If GM_PlayAnimation(*Object\Animation)
        If *AnimationParameter\Callback
          CallFunctionFast(*AnimationParameter\Callback, *Object)
        Else
          GM_SetAnimationDuration(*Object\Animation, *AnimationParameter\FrameDuration)
        EndIf
      EndIf
      
    Case #GM_Object_Initialize
      *Object\Animation = GM_CreateAnimation(*AnimationParameter\Frameset\i)
      If *AnimationParameter\Callback
        CallFunctionFast(*AnimationParameter\Callback, *Object)
      Else
        GM_SetNextAnimationFrame(*Object\Animation, Random(GM_FramesetFrames(*AnimationParameter\Frameset\i) - 1), *AnimationParameter\FrameDuration)
      EndIf
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_GlobalLoad
      If Not *AnimationParameter\Frameset\i
        *AnimationParameter\Frameset\i = GM_LoadAnimationFrameset(*AnimationParameter\File, *AnimationParameter\FrameWidth, *AnimationParameter\FrameHeight)
      EndIf
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    
    Case #GM_Object_ViewSprite
      ProcedureReturn @*AnimationParameter\File
    Case #GM_Object_ViewRegion
      ViewRegion\X      = 0
      ViewRegion\Y      = 0
      ViewRegion\Width  = *AnimationParameter\FrameWidth
      ViewRegion\Height = *AnimationParameter\FrameHeight
      ProcedureReturn @ViewRegion
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_Name
      ProcedureReturn @*AnimationParameter\Name
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 34
; FirstLine = 15
; Folding = -
; EnableXP