Structure BoxParameter
  Name.s
  File.s
  Energy.i
  TreadingAllowed.i
  Sprite.i
  *DestroyedCallback
  *TreadedCallback
  Description.s
  
  Initialized.i
EndStructure
Structure BoxMemory
  Energy.f
EndStructure

#BoxExplosionDuration = 5

Procedure.i SquashBox(*Object.GM_Object)
  ; Die Kiste wird kleiner gedrckt:
  
  *Object\Height - 1
  *Object\Y      + 1
  GM_SetPlayerY(*Object\Y - *GM_Player\Height)
EndProcedure
Procedure.i BoxTemplate(*Object.GM_Object, Event.i, *Parameter, *BoxParameter.BoxParameter)
  Static *Memory.BoxMemory, MoveY.f, Energy.f
  
  If *Object
    *Memory = *Object\Memory
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_ZoomSprite3D(*Object\Sprite, *Object\Width, *Object\Height)
      GM_DisplaySprite3D(*Object\Sprite, *Object\X, *Object\Y, *Object\Transparency)
    Case #GM_Object_Frame
      If *Memory\Energy <= 0
        If *Memory\Energy < -#BoxExplosionDuration
          ; Explosion wurde entgltig gerendert - das Objekt wird gelscht:
          ProcedureReturn #GM_Object_DoDelete
        Else
          ; Die Explosion muss animiert werden:
          *Object\Transparency = 255.0 - (255.0/#BoxExplosionDuration * (-*Memory\Energy))
          
          *Object\X      - 3
          *Object\Y      - 3
          *Object\Width  + 6
          *Object\Height + 6
          
          *Memory\Energy - 1
        EndIf
      EndIf
    Case #GM_Object_Collision
      If *Memory\Energy > 0
        MoveY = *GM_Player\MoveY
        If GM_DoGroundCollision(*Object, GM_PlayerGroundCollision(*Object, 0, 0)) And *BoxParameter\TreadingAllowed And MoveY > 3
          *Memory\Energy - 1
          If *Memory\Energy <= 0
            ; Die Kiste wurde durch Tritte geffnet:
            *Memory\Energy = 0
            CallFunctionFast(*BoxParameter\DestroyedCallback, *Object)
            GM_ChangePlayerAction(#GM_Player_Action_Jump)
            GM_SetPlayerMoveY(-3.0)
          Else
            CallFunctionFast(*BoxParameter\TreadedCallback, *Object)
            GM_SetPlayerMoveY(0)
          EndIf
        EndIf
      EndIf
    Case #GM_Object_Hit
      *Shot = *Parameter
      If *Memory\Energy > 0
        Energy = *Memory\Energy / 3.0
        GM_Damage(@Energy, @*Shot\Power)
        *Memory\Energy = Energy * 3.0
        If *Memory\Energy <= 0
          *Memory\Energy = 0
          CallFunctionFast(*BoxParameter\DestroyedCallback, *Object)
        EndIf
        ProcedureReturn #GM_Object_DoCollision
      EndIf
    Case #GM_Object_Delete
      GM_FreeSprite3D(*Object\Sprite)
      
    Case #GM_Object_EditorSave
      *EditorObject = *Parameter
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      *EditorObject = *Parameter
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
    Case #GM_Object_Initialize
      *Object\Width  = #GM_FieldSize
      *Object\Height = #GM_FieldSize
      *Object\Sprite = GM_CreateSprite3D(*BoxParameter\Sprite)
      
      *Memory        = AllocateMemory(SizeOf(BoxMemory))
      *Object\Memory = *Memory
      *Memory\Energy = *BoxParameter\Energy * 3
    Case #GM_Object_GlobalLoad
      If Not *BoxParameter\Sprite
        *BoxParameter\Sprite = GM_LoadSprite(*BoxParameter\File)
      EndIf
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_BackgroundObject2
    Case #GM_Object_CheckLayer
      If *Parameter = #GM_Layer_BackgroundObject2
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    
    Case #GM_Object_ViewSprite
      ProcedureReturn @*BoxParameter\File
    Case #GM_Object_Name
      ProcedureReturn @*BoxParameter\Name
    Case #GM_Object_Description
      If *BoxParameter\Description
        ProcedureReturn @*BoxParameter\Description
      EndIf
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 72
; FirstLine = 39
; Folding = -
; EnableXP