Structure ItemParameter
  Name.s
  File.s
  Description.s
    
  ItemName.s
  EnableCount.i
  *ItemCallback
  
  Width.i
  Height.i
  
  OuterWidth.i
  OuterHeight.i
  *Item.GM_Item
  Sprite.i
  Sprite3D.i
  
  Initialized.i
EndStructure



Procedure.i ItemTemplate(*Object.GM_Object, Event.i, *Parameter, *ItemParameter.ItemParameter)
  If Not *Object
    *EditorObject = *Parameter
  EndIf
  
  Select Event
    Case #GM_Object_Display
      GM_DisplaySprite3D(*ItemParameter\Sprite3D, *Object\X - *ItemParameter\OuterWidth, *Object\Y - *ItemParameter\OuterHeight)
    Case #GM_Object_Collision
      GM_AddItem(*ItemParameter\Item)
      GM_EmitTinyFlash(*Object\X + *Object\Width/2, *Object\Y + *Object\Height/2)
      ProcedureReturn #GM_Object_DoDelete
    
    Case #GM_Object_Initialize
      *Object\Width  = *ItemParameter\Width
      *Object\Height = *ItemParameter\Height
      *Object\X      + *ItemParameter\OuterWidth
      *Object\Y      + *ItemParameter\OuterHeight
    Case #GM_Object_Load
      GM_LoadPixelPosition(@*Object\X, @*Object\Y)
      If *ItemParameter\EnableCount
        *ItemParameter\Item\MaxCount + 1
      EndIf
    Case #GM_Object_GlobalLoad
      *ItemParameter\Item = GM_GetItem(*ItemParameter\ItemName, *ItemParameter\ItemCallback)
      If *ItemParameter\EnableCount
        *ItemParameter\Item\MaxCount = 0
      Else
        *ItemParameter\Item\MaxCount = -1
      EndIf
      If Not *ItemParameter\Sprite
        *ItemParameter\Sprite   = GM_LoadSprite(*ItemParameter\File)
        *ItemParameter\Sprite3D = GM_CreateSprite3D(*ItemParameter\Sprite)
      EndIf
      *ItemParameter\OuterWidth  = #GM_FieldSize/2 - *ItemParameter\Width/2
      *ItemParameter\OuterHeight = #GM_FieldSize/2 - *ItemParameter\Height/2
      
    Case #GM_Object_EditorSave
      GM_SaveFieldPosition(*EditorObject\X, *EditorObject\Y)
    Case #GM_Object_EditorLoad
      GM_LoadFieldPosition(@*EditorObject\X, @*EditorObject\Y)
      
    Case #GM_Object_PreferedLayer
      ProcedureReturn #GM_Layer_ForegroundObject1
    Case #GM_Object_CheckLayer
      If *Parameter <> #GM_Layer_StaticObject
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    Case #GM_Object_ViewSprite
      ProcedureReturn @*ItemParameter\File
    Case #GM_Object_Name
      ProcedureReturn @*ItemParameter\Name
    Case #GM_Object_Description
      ProcedureReturn @*ItemParameter\Description
  EndSelect
  
  ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 27
; Folding = -
; EnableXP