Structure Path
  *Selection.Selection
  Length.i
  ComputeWay.i
  Index.i
  Direction.i
  Speed.f
  XMotion.f
  YMotion.f
  Circular.i
EndStructure

Procedure.i LoadPath()
  Protected *Path.Path
  
  *Path = AllocateMemory(SizeOf(Path))
  
  *Path\Selection = GM_LoadSelection()
  *Path\Length    = 1 
  
  ProcedureReturn *Path
EndProcedure
Procedure.i InitializePath(*Object.GM_Object, *Path.Path)
  GM_InitializeSelection(*Path\Selection)
  
  *Object\X = GM_SelectedX(*Path\Selection, 0) * #GM_FieldSize
  *Object\Y = GM_SelectedY(*Path\Selection, 0) * #GM_FieldSize
  
  *Path\Direction = 1
EndProcedure
Procedure.i InitializeCircularPath(*Object.GM_Object, *Path.Path)
  GM_InitializeSelection(*Path\Selection)
  
  *Object\X = GM_SelectedX(*Path\Selection, 0) * #GM_FieldSize
  *Object\Y = GM_SelectedY(*Path\Selection, 0) * #GM_FieldSize
  
  *Path\Circular = #True
EndProcedure
Procedure.i ExaminePath(*Object.GM_Object, *Path.Path, OuterWidth.i = 0, OuterHeight.i = 0)
  Static DX.f, DY.f
  
  *Path\Length - 1
  If *Path\Length
    If *Path\ComputeWay
      ; Distanz berechnen, um daraus die Bewegung auf der X- und Y-Achse zu ermitteln:
      DX             = GM_SelectedX(*Path\Selection, *Path\Index) * #GM_FieldSize - (*Object\X - OuterWidth)
      DY             = GM_SelectedY(*Path\Selection, *Path\Index) * #GM_FieldSize - (*Object\Y - OuterHeight)
      *Path\Length   = Sqr(DX * DX + DY * DY) / *Path\Speed
      *Path\XMotion  = DX / *Path\Length
      *Path\YMotion  = DY / *Path\Length
      
      *Path\ComputeWay = #False
    EndIf
    ; Weiterbewegen:
    *Object\X + *Path\XMotion
    *Object\Y + *Path\YMotion
  Else
    ; Das Objekt genau auf die Zielposition setzen:
    *Object\X = GM_SelectedX(*Path\Selection, *Path\Index) * #GM_FieldSize + OuterWidth
    *Object\Y = GM_SelectedY(*Path\Selection, *Path\Index) * #GM_FieldSize + OuterHeight
    
    ; Nchstes Feld als Zielpunkt whlen:
    If *Path\Circular
      If *Path\Index = GM_SelectionSize(*Path\Selection) - 1
        *Path\Index = 0
      Else
        *Path\Index + 1
      EndIf
    Else
      If *Path\Direction = 1
        If *Path\Index = GM_SelectionSize(*Path\Selection) - 1
          *Path\Index = GM_SelectionSize(*Path\Selection) - 2
          *Path\Direction = -1
        Else
          *Path\Index + 1
        EndIf
      Else
        If *Path\Index = 0
          *Path\Index = 1
          *Path\Direction = 1
        Else
          *Path\Index - 1
        EndIf
      EndIf
    EndIf
    
    *Path\XMotion    = 0
    *Path\YMotion    = 0
    *Path\ComputeWay = #True
    
    ; Bewegung wird noch nicht berechnet (siehe oben), da noch eine
    ; weitere Kollisionsabfrage fr die letzte Verschiebung durchgefhrt
    ; wird.
  EndIf
EndProcedure
Procedure.i PathTargetX(*Path.Path)
  ProcedureReturn GM_SelectedX(*Path\Selection, *Path\Index)
EndProcedure
Procedure.i PathTargetY(*Path.Path)
  ProcedureReturn GM_SelectedY(*Path\Selection, *Path\Index)
EndProcedure

; IDE Options = PureBasic 4.51 RC 1 (Windows - x86)
; CursorPosition = 59
; FirstLine = 43
; Folding = --
; EnableXP