Procedure.i CreateParticle(*Frameset.AnimationFrameset, X.i, Y.i, AnimationSpeed.f, *Callback = #Null)
  Protected *Particle.Particle
  
  *Particle      = _New(Particle)
  *Particle\Item = AppendQueueItem(*Particles, *Particle)
  
  *Particle\Animation      = CreateAnimation(*Frameset)
  *Particle\X              = X
  *Particle\Y              = Y
  *Particle\AnimationSpeed = AnimationSpeed
  *Particle\Transparency   = 255
  *Particle\Callback       = *Callback
  
  ProcedureReturn *Particle
EndProcedure
Procedure.i FreeParticle(*Particle.Particle)
  FreeAnimation(*Particle\Animation)
  _Free(*Particle)
  
  ProcedureReturn #True
EndProcedure
Procedure.i ExamineParticles()
  Protected *Item.QueueItem, *Particle.Particle
  
  *Item = *Particles\First
  While *Item
    *Particle = *Item\Memory
    
    If *Particle\Callback
      _Call(*Particle\Callback, *Particle, #Particle_Frame, #Null)
    EndIf
    
    If ExamineAnimation(*Particle\Animation)
      *Particle\Animation\Duration = *Particle\AnimationSpeed
      If *Particle\Callback
        If _Call(*Particle\Callback, *Particle, #Particle_NextFrame, #Null)
          *Item = FreeQueueItem(*Particles, *Item)
          Continue
        EndIf
      ElseIf *Particle\Animation\Frame = 0
        *Item = FreeQueueItem(*Particles, *Item)
        Continue
      EndIf
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure

Procedure.i EmitParticle_TinyExplosion(X.i, Y.i)
  ProcedureReturn CreateParticle(Particle\ShotHit, X - 9, Y - 9, 4)
EndProcedure
Procedure.i EmitParticle_AirExplosion(X.i, Y.i)
  ProcedureReturn CreateParticle(Particle\AirExplosion, X - 15, Y - 15, 1)
EndProcedure
Procedure.i EmitParticle_KilledEnemy(X.i, Y.i)
  ProcedureReturn CreateParticle(Particle\KilledEnemy, X - 18, Y - 18, 5)
EndProcedure
Procedure.i EmitParticle_Glitter(X.i, Y.i)
  Static Frameset.i
  
  If Not Frameset
    Frameset = LoadAnimationFrameset("Particles\Glitter", 9, 9)
  EndIf
  ProcedureReturn CreateParticle(Frameset, X - 4, Y - 4, 10)
EndProcedure
Procedure.i EmitParticle_TinyFlash(X.i, Y.i)
  Static Frameset.i
  
  If Not Frameset
    Frameset = LoadAnimationFrameset("Particles\TinyFlash", #FieldSize, #FieldSize)
  EndIf
  ProcedureReturn CreateParticle(Frameset, X - #FieldSize/2, Y - #FieldSize/2, 1)
EndProcedure

Procedure.i Particle_Ghost(*Particle.Particle, Event.i, *Parameter)
  Select Event
    Case #Particle_Frame
      *Particle\Y - 2.5
      If *Particle\Animation\Frame = 5
        *Particle\Transparency - 15
      EndIf
    Case #Particle_NextFrame
      Select *Particle\Animation\Frame
        Case 0
          EmitParticle_TinyFlash(*Particle\X + 10, *Particle\Y + 10)
          ProcedureReturn #True
        Case 5
          *Particle\Animation\Duration = 17
      EndSelect
  EndSelect
  
  ProcedureReturn #Null
EndProcedure
Procedure.i EmitParticle_Ghost(X.i, Y.i)
  Static Frameset.i
  
  If Not Frameset
    Frameset = LoadAnimationFrameset("Particles\Ghost", 20, 20)
  EndIf
  ProcedureReturn CreateParticle(Frameset, X - 20/2, Y - 20/2, 6, @Particle_Ghost())
EndProcedure

Procedure.i DisplayWhiteLight(X.i, Y.i, Transparency.i = 255)
  Sprite3DBlendingMode(5, 2)
  DisplaySprite3D(WhiteLight\Sprite3D, X - #FieldSize - Camera\X, Y - #FieldSize - Camera\Y, Transparency)
  Sprite3DBlendingMode(5, 6)
EndProcedure
Procedure.i DisplayYellowLight(X.i, Y.i, Transparency.i = 255)
  Sprite3DBlendingMode(5, 2)
  DisplaySprite3D(YellowLight\Sprite3D, X - #FieldSize - Camera\X, Y - #FieldSize - Camera\Y, Transparency)
  Sprite3DBlendingMode(5, 6)
EndProcedure
Procedure.i DisplayCyanLight(X.i, Y.i, Transparency.i = 255)
  Sprite3DBlendingMode(5, 2)
  DisplaySprite3D(CyanLight\Sprite3D, X - #FieldSize - Camera\X, Y - #FieldSize - Camera\Y, Transparency)
  Sprite3DBlendingMode(5, 6)
EndProcedure
Procedure.i DisplaySmallWhiteLight(X.i, Y.i, Transparency.i = 255)
  Sprite3DBlendingMode(5, 2)
  DisplaySprite3D(SmallWhiteLight\Sprite3D, X - 10 - Camera\X, Y - 10 - Camera\Y, Transparency)
  Sprite3DBlendingMode(5, 6)
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 78
; FirstLine = 48
; Folding = HO9
; EnableXP