Procedure.i ReplayKeys()
  Protected Key.i, Binary.i, Pos.i, State.i
  
  If Eof(ReplayFile)
    Replay = 0
    CloseFile(ReplayFile)
  EndIf
  
  Binary = ReadWord(ReplayFile)
  
  Pos = 1
  For Key = 0 To #Player_KeyCount - 1
    State = Binary & Pos
    
    Player\KeyPressed[Key] = #False
    Player\KeyReleased[Key] = #False
    If State
      If Not Player\KeyPressing[Key]
        Player\KeyPressed[Key]  = #True
        Player\KeyPressing[Key] = #True
      EndIf
    Else
      If Player\KeyPressing[Key]
        Player\KeyReleased[Key] = #True
      EndIf
      Player\KeyPressing[Key] = #False
    EndIf
    
    Pos * 2
  Next
EndProcedure
Procedure.i RecordKeys()
  Protected Key.i, Binary.i, Pos.i
  
  Pos = 1
  For Key = 0 To #Player_KeyCount - 1
    Binary | (Player\KeyPressing[Key] * Pos)
    Pos * 2
  Next
  
  WriteWord(RecordFile, Binary)
EndProcedure



Procedure.i PackReplay()
  CloseFile(RecordFile)
  
  CreatePack(RecordFilename + ".gm_r")
    AddPackFile("Unpacked.dat", 9)
  ClosePack()
  
  DeleteFile("Unpacked.dat")
  
  ProcedureReturn #True
EndProcedure
Procedure.i UnpackReplay(Filename.s)
  Protected File.i, *Memory
  
  File = CreateFile(#PB_Any, "Unpacked.dat")
  
  OpenPack(Filename + ".gm_r")
    *Memory = NextPackFile()
    WriteData(File, *Memory, PackFileSize())
  ClosePack()
  
  CloseFile(File)
  
  ReplayFile = ReadFile(#PB_Any, "Unpacked.dat")
  If Not ReplayFile
    MessageRequester("Error", "Can not extract replay: " + #Q + Filename + ".gm_r" + #Q, #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  
  RandomSeed = ReadInteger(ReplayFile)
  
  ProcedureReturn ReplayFile
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 74
; FirstLine = 33
; Folding = -
; EnableXP