Procedure.i SetScreenSettings(Width.i ,Height.i, BitsPerPel.i ,Frequency.i ,TestMode.i = #Disabled)
  Protected DevMode.DEVMODE
  
  DevMode\dmSize             = _Sz(DEVMODE)
  DevMode\dmFields           = #DM_BITSPERPEL | #DM_PELSWIDTH | #DM_PELSHEIGHT | #DM_DISPLAYFREQUENCY
  DevMode\dmBitsPerPel       = BitsPerPel
  DevMode\dmPelsWidth        = Width
  DevMode\dmPelsHeight       = Height
  DevMode\dmDisplayFrequency = Frequency
  
  ProcedureReturn ChangeDisplaySettings_(@DevMode, TestMode)
EndProcedure
Procedure.i GetScreenSettings(*Width.Integer, *Height.Integer, *BitsPerPel.Integer, *Frequency.Integer)
  Protected DevMode.DEVMODE
  
  EnumDisplaySettings_(0, #ENUM_CURRENT_SETTINGS, @DevMode)
  *Width\I      = DevMode\dmPelsWidth
  *Height\I     = DevMode\dmPelsHeight
  *BitsPerPel\I = DevMode\dmBitsPerPel
  *Frequency\I  = DevMode\dmDisplayFrequency
EndProcedure
Procedure.i OpenGMetricaScreen(Width.i, Height.i)
  GetScreenSettings(@PreviousScreen\Width, @PreviousScreen\Height, @PreviousScreen\BPP, @PreviousScreen\Frequency)
  
  Select ScreenMode
    Case #ScreenMode_Fullscreen
      Screen\Width  = 800
      Screen\Height = 600
       
      InnerScreen\X      = Screen\Width/2 - Width/2
      InnerScreen\Y      = Screen\Height/2 - Height/2
      InnerScreen\Width  = Width
      InnerScreen\Height = Height
      
      SetScreenSettings(Screen\Width, Screen\Height, PreviousScreen\BPP, PreviousScreen\Frequency)
      OpenWindow(#ScreenWindow, 0, 0, Screen\Width, Screen\Height, "GMetrica", #PB_Window_ScreenCentered|#PB_Window_BorderLess)
      SetWindowColor(#ScreenWindow, #Black)
      
      OpenWindowedScreen(WindowID(#ScreenWindow), InnerScreen\X, InnerScreen\Y, InnerScreen\Width, InnerScreen\Height, 0, 0, 0)
    Case #ScreenMode_Windowed
      OpenWindow(#ScreenWindow, #PB_Ignore, #PB_Ignore, Width, Height, "GMetrica", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
      
      Screen\Width  = Width
      Screen\Height = Height
      OpenWindowedScreen(WindowID(#ScreenWindow), 0, 0, Width, Height, 0, 0, 0)
  EndSelect
EndProcedure
Procedure.i CloseGMetricaScreen()
  CloseScreen()
  CloseWindow(#ScreenWindow)
  
  If PreviousScreen\Width <> Screen\Width And PreviousScreen\Height <> Screen\Height
    Select ScreenMode
      Case #ScreenMode_Fullscreen
        SetScreenSettings(PreviousScreen\Width, PreviousScreen\Height, PreviousScreen\BPP, PreviousScreen\Frequency)
    EndSelect
  EndIf
EndProcedure

Procedure.i GetMouseX()
  ProcedureReturn WindowMouseX(#ScreenWindow) - InnerScreen\X
EndProcedure
Procedure.i GetMouseY()
  ProcedureReturn WindowMouseY(#ScreenWindow) - InnerScreen\Y
EndProcedure


; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 22
; FirstLine = 5
; Folding = --
; EnableXP