Structure Selected_Memory
  X.i
  Y.i
EndStructure
Structure SelectedObject_Memory
  Number.i
EndStructure

Procedure.i CreateSelection(Size.i)
  Protected *Selection.Selection
  
  *Selection = _New(Selection)
  
  *Selection\Size = Size
  If *Selection\Size
    *Selection\Selected = _Dim(Size * _Sz(Integer))
  EndIf
  
  ProcedureReturn *Selection
EndProcedure
Procedure.i ReadTileSelection()
EndProcedure
Procedure.i ReadObjectSelection()
  Protected Index.i, *Selected.SelectedObject
  Protected *Selection.Selection, *Memory.SelectedObject_Memory
  
  *Selection = CreateSelection(ReadInteger(IO_InputFile))
  
  For Index = 0 To *Selection\Size - 1
    *Selected = _New(SelectedObject)
    PokeI(*Selection\Selected + _Sz(Integer) * Index, *Selected)
    
    *Memory = _New(SelectedObject_Memory)
    
    *Memory\Number = ReadInteger(IO_InputFile)
    
    *Selected\Object = *Memory
  Next
  
  ProcedureReturn *Selection
EndProcedure
Procedure.i ReadSelection()
  Protected Index.i, *Selected.Selected, SceneX.i, SceneY.i
  Protected *Selection.Selection, *Memory.Selected_Memory
  
  *Selection = CreateSelection(ReadInteger(IO_InputFile))
  
  For Index = 0 To *Selection\Size - 1
    *Selected = _New(Selected)
    PokeI(*Selection\Selected + _Sz(Integer) * Index, *Selected)
    
    *Memory = _New(Selected_Memory)
    
    *Memory\X = ReadCharacter(IO_InputFile)
    *Memory\Y = ReadCharacter(IO_InputFile)
    
    *Selected\Scene = *Memory
    *Selected\X = ReadCharacter(IO_InputFile)
    *Selected\Y = ReadCharacter(IO_InputFile)
  Next
  
  ProcedureReturn *Selection
EndProcedure

Procedure.i InitializeSelection(*Selection.Selection)
  Protected Index.i, *Selected.Selected, *Memory.Selected_Memory
  
  For Index = 0 To *Selection\Size - 1
    *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
    *Memory   = *Selected\Scene
    
    *Selected\Scene = GetScene(*Memory\X, *Memory\Y)
    *Selected\X + (*Memory\X - *Selected\Scene\X) * #SceneWidth
    *Selected\Y + (*Memory\Y - *Selected\Scene\Y) * #SceneHeight
    
    _Free(*Memory)
  Next
  
  ProcedureReturn *Selection
EndProcedure
Procedure.i InitializeObjectSelection(*Selection.Selection)
  Protected Index.i, *Selected.SelectedObject, *Memory.SelectedObject_Memory
  
  For Index = 0 To *Selection\Size - 1
    *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
    *Memory   = *Selected\Object
    
    *Selected\Object = *IO_SceneObject(*Memory\Number)
    
    _Free(*Memory)
  Next
  
  ProcedureReturn *Selection
EndProcedure

Procedure.i HideSelectedObjects(*Selection.Selection, State)
  Protected Index.i, *Selected.SelectedObject
  
  For Index = 0 To *Selection\Size - 1
    *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
    HideObject(*Selected\Object, State)
  Next
  
  ProcedureReturn *Selection
EndProcedure
Procedure.i ForEachSelectedObject(*Selection.Selection, *Callback, *Parameter = #Null)
  Protected Index.i, *Selected.SelectedObject
  
  For Index = 0 To *Selection\Size - 1
    *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
    _Call(*Callback, *Selected\Object, Index, *Parameter)
  Next
  
  ProcedureReturn *Selection
EndProcedure

Procedure.i IsPlayerInSelection(*Selection.Selection)
  Protected Index.i, *Selected.Selected
  
  For Index = 0 To *Selection\Size - 1
    *Selected = PeekI(*Selection\Selected + _Sz(Integer) * Index)
    
    If *Selected\Scene = Player\Scene And *Selected\X = Player\FieldX And *Selected\Y = Player\FieldY
      ProcedureReturn #True
    EndIf
  Next
  
  ProcedureReturn #False
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 100
; FirstLine = 29
; Folding = 1k
; EnableXP