Procedure.i EmitShot(Direction.i, Speed.f = #Player_ShotSpeed)
  Protected *Shot.Shot
  
  With Player
  
  *Shot      = _New(Shot)
  *Shot\Item = AppendQueueItem(\Shots, *Shot)
  
  *Shot\X     = \X + \Width/2  - #ShotSize/2
  *Shot\Y     = \Y + \Height/2 - #ShotSize/2
  *Shot\MoveX = Speed * Direction
  
  *Shot\Animation = CreateAnimation(\ShotFrameset[\CanShoot - 1])
  Select Direction
    Case 1
      *Shot\Animation\Set = 0
    Case -1
      *Shot\Animation\Set = 1
  EndSelect
  
  *Shot\Power = \ShotPower + (\CanShoot - 1) * #Player_MaximalShotPower
  
  ProcedureReturn *Shot
  
  EndWith
EndProcedure
Procedure.i FreeShot(*Shot.Shot)
  FreeAnimation(*Shot\Animation)
  _Free(*Shot)
  
  ProcedureReturn #True
EndProcedure

Procedure.i Shoot(Direction.i)
  Protected Shoot.i
  
  With Player
  
  If \KeyPressing[#Player_Key_Shoot]
    If \CanLoadShot
      If Not \ShotPower
        \ShotPower = 1
      Else
        \ShotPower + #Player_AdditionalShotPower
        If \ShotPower > #Player_MaximalShotPower
          \ShotPower = #Player_MaximalShotPower
        EndIf
      EndIf
    ElseIf \ShotDuration = 0
      Shoot      = #True
      \ShotPower = 1
    EndIf
  ElseIf \KeyReleased[#Player_Key_Shoot] And \CanLoadShot
    If Not \ShotPower
      \ShotPower = 1
    EndIf
    Shoot = #True
  EndIf
  
  If Shoot
    EmitShot(Direction)
    \ShotPower    = 0
    \ShotDuration = 11
  EndIf
  
  EndWith
EndProcedure
Procedure.i ShotCollision(*Shot.Shot, DeltaX.i, DeltaY.i)
  Protected FieldX.i, FieldY.i, Collision.i
  Protected Result.i, *Object.Object
  
  FieldX = ((*Shot\X) - (#FieldSize - #ShotSize/2.0)) / #FieldSize
  FieldY = ((*Shot\Y) - (#FieldSize - #ShotSize/2.0)) / #FieldSize
  
  FieldX + DeltaX
  FieldY + DeltaY
  
  If FieldX => 0 And FieldX < Player\Scene\Width * #SceneWidth And FieldY => 0 And FieldY < Player\Scene\Height * #SceneHeight
    *Object = GetObject(FieldX, FieldY)
    If *Object
      Collision = Collision(*Shot\X, *Shot\Y, #ShotSize, #ShotSize, *Shot\MoveX, *Shot\MoveY, FieldX * #FieldSize, FieldY * #FieldSize, #FieldSize, #FieldSize)
      If Collision
        Result = _Call(*Object\Callback, *Object, #Object_Hit, *Shot\Power)
        If Result = #ObjectDo_Delete
          ReleaseObject(*Object)
          ; Aus dem Table lschen:
          PokeI(Table\Objects + (FieldY * Player\Scene\Height * #SceneHeight + FieldX) * SizeOf(Integer), #Null)
        ElseIf Result
          ProcedureReturn Result
        EndIf
      EndIf
    EndIf
    If GetWall(FieldX, FieldY)
      Collision = Collision(*Shot\X, *Shot\Y, #ShotSize, #ShotSize, *Shot\MoveX, *Shot\MoveY, FieldX * #FieldSize, FieldY * #FieldSize, #FieldSize, #FieldSize)
      If Collision
        ProcedureReturn Collision
      EndIf
    ElseIf *Shot\MoveY > 0 And GetGround(FieldX, FieldY)
      Collision = Collision(*Shot\X, *Shot\Y, #ShotSize, #ShotSize, *Shot\MoveX, *Shot\MoveY, FieldX * #FieldSize, FieldY * #FieldSize, #FieldSize, #FieldSize)
      If Collision = #Collision_Top
        ProcedureReturn Collision
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn #False
EndProcedure
Procedure.i EmitShotParticle(*Shot.Shot)
  ProcedureReturn CreateParticle(Particle\ShotHit, *Shot\X + #ShotSize/2 - 9, *Shot\Y + #ShotSize/2 - 9, 4)
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 16
; Folding = -
; EnableXP