;**************************************************************
;     Tiny Message
;**************************************************************
;   Copyright (c) 2010 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i CreateTinyMessage(X.f, Y.f, Text.s)
  Protected *Message.TinyMessage
  
  *Message = _New(TinyMessage)
  AppendQueueItem(*TinyMessages, *Message)
  
  *Message\X    = X - (Len(Text) * (*TinyMessageCharSet\Width + 1) - 1)/2
  *Message\Y    = Y - *TinyMessageCharSet\Height/2
  *Message\Text = Text
  *Message\Time = #TinyMessage_Duration
  
  ProcedureReturn *Message
EndProcedure
Procedure.i FreeTinyMessage(*Message.TinyMessage)
  ClearStructure(*Message, TinyMessage)
  _Free(*Message)
  
  ProcedureReturn #True
EndProcedure
Procedure.i ExamineTinyMessages()
  Static *Item.QueueItem, *Message.TinyMessage
  
  *Item = *TinyMessages\First
  While *Item
    *Message = *Item\Memory
    
    If *Message\Time = 0
      *Item = FreeQueueItem(*TinyMessages, *Item)
      Continue
    ElseIf *Message\Time > #TinyMessage_Halt
      *Message\Y - #TinyMessage_Speed
    EndIf
    
    *Message\Time - 1
    
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i DisplayTinyMessages(Move.i = #True)
  Static *Item.QueueItem, *Message.TinyMessage
  
  *Item = *TinyMessages\First
  While *Item
    *Message = *Item\Memory
    
    DisplayNumber(*Message\X - Camera\X, *Message\Y - Camera\Y, *Message\Text, *TinyMessageCharSet)
    
    If Move
      If *Message\Time = 0
        *Item = FreeQueueItem(*TinyMessages, *Item)
        Continue
      ElseIf *Message\Time > #TinyMessage_Halt
        *Message\Y - #TinyMessage_Speed
      EndIf
      
      *Message\Time - 1
    EndIf
    
    _Move(*Item, N)
  Wend
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 46
; FirstLine = 17
; Folding = 9
; EnableXP